# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.4
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.


"""
The `modshogun` module gathers all modules available in the SHOGUN toolkit.
"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_modshogun', [dirname(__file__)])
        except ImportError:
            import _modshogun
            return _modshogun
        if fp is not None:
            try:
                _mod = imp.load_module('_modshogun', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _modshogun = swig_import_helper()
    del swig_import_helper
else:
    import _modshogun
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


STRING_LEN = _modshogun.STRING_LEN
STRING_LEN_STR = _modshogun.STRING_LEN_STR

def init_shogun_with_defaults():
  """
    init_shogun_with_defaults()

    init shogun with defaults 
    """
  return _modshogun.init_shogun_with_defaults()

def exit_shogun():
  """
    exit_shogun()

    This function must be called when one stops using libshogun. It will
    perform a number of cleanups 
    """
  return _modshogun.exit_shogun()

def set_global_io(*args):
  """
    set_global_io(io)

    set the global io object

    Parameters:
    -----------

    io:  io object to use 
    """
  return _modshogun.set_global_io(*args)

def get_global_io():
  """
    get_global_io() -> SGIO

    get the global io object

    io object 
    """
  return _modshogun.get_global_io()

def set_global_parallel(*args):
  """
    set_global_parallel(parallel)

    set the global parallel object

    Parameters:
    -----------

    parallel:  parallel object to use 
    """
  return _modshogun.set_global_parallel(*args)

def get_global_parallel():
  """
    get_global_parallel() -> Parallel

    get the global parallel object

    parallel object 
    """
  return _modshogun.get_global_parallel()

def set_global_version(*args):
  """
    set_global_version(version)

    set the global version object

    Parameters:
    -----------

    version:  version object to use 
    """
  return _modshogun.set_global_version(*args)

def get_global_version():
  """
    get_global_version() -> Version

    get the global version object

    version object 
    """
  return _modshogun.get_global_version()

def set_global_math(*args):
  """
    set_global_math(math)

    set the global math object

    Parameters:
    -----------

    math:  math object to use 
    """
  return _modshogun.set_global_math(*args)

def get_global_math():
  """
    get_global_math() -> Math

    get the global math object

    math object 
    """
  return _modshogun.get_global_math()
MSG_GCDEBUG = _modshogun.MSG_GCDEBUG
MSG_DEBUG = _modshogun.MSG_DEBUG
MSG_INFO = _modshogun.MSG_INFO
MSG_NOTICE = _modshogun.MSG_NOTICE
MSG_WARN = _modshogun.MSG_WARN
MSG_ERROR = _modshogun.MSG_ERROR
MSG_CRITICAL = _modshogun.MSG_CRITICAL
MSG_ALERT = _modshogun.MSG_ALERT
MSG_EMERGENCY = _modshogun.MSG_EMERGENCY
MSG_MESSAGEONLY = _modshogun.MSG_MESSAGEONLY
class SGIO(_object):
    """
    Class SGIO, used to do input output operations throughout shogun.

    Any debug or error or progress message is passed through the functions
    of this class to be in the end written to the screen. Note that
    messages don't have to be written to stdout or stderr, but can be
    redirected to a file.

    C++ includes: SGIO.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SGIO, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SGIO, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SGIO
        __init__(self, orig) -> SGIO

        copy constructor 
        """
        this = _modshogun.new_SGIO(*args)
        try: self.this.append(this)
        except: self.this = this
    def set_loglevel(self, *args):
        """
        set_loglevel(self, level)

        set loglevel

        Parameters:
        -----------

        level:  level of log messages 
        """
        return _modshogun.SGIO_set_loglevel(self, *args)

    def get_loglevel(self):
        """
        get_loglevel(self) -> EMessageType

        get loglevel

        level of log messages 
        """
        return _modshogun.SGIO_get_loglevel(self)

    def get_show_progress(self):
        """
        get_show_progress(self) -> bool

        get show_progress

        if progress bar is shown 
        """
        return _modshogun.SGIO_get_show_progress(self)

    def get_show_file_and_line(self):
        """
        get_show_file_and_line(self) -> bool

        get show file and line

        if file and line should prefix messages 
        """
        return _modshogun.SGIO_get_show_file_and_line(self)

    def get_syntax_highlight(self):
        """
        get_syntax_highlight(self) -> bool

        get syntax highlight

        if syntax highlighting is enabled 
        """
        return _modshogun.SGIO_get_syntax_highlight(self)

    def message(self, *args):
        """
        message(self, prio, file, line, fmt, *args)

        print a message

        optionally prefixed with file name and line number from (use -1 in
        line to disable this)

        Parameters:
        -----------

        prio:  message priority

        file:  file name from where the message is called

        line:  line number from where the message is called

        fmt:  format string 
        """
        return _modshogun.SGIO_message(self, *args)

    def progress(self, *args):
        """
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1)
        progress(self, current_val, min_val = 0.0, max_val = 1.0)
        progress(self, current_val, min_val = 0.0)
        progress(self, current_val)

        print progress bar

        Parameters:
        -----------

        current_val:  current value

        min_val:  minimum value

        max_val:  maximum value

        decimals:  decimals

        prefix:  message prefix 
        """
        return _modshogun.SGIO_progress(self, *args)

    def absolute_progress(self, *args):
        """
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1)
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0)
        absolute_progress(self, current_val, val, min_val = 0.0)
        absolute_progress(self, current_val, val)

        print absolute progress bar

        Parameters:
        -----------

        current_val:  current value

        val:  value

        min_val:  minimum value

        max_val:  maximum value

        decimals:  decimals

        prefix:  message prefix 
        """
        return _modshogun.SGIO_absolute_progress(self, *args)

    def done(self):
        """
        done(self)

        print 'done' with priority INFO, but only if progress bar is enabled

        """
        return _modshogun.SGIO_done(self)

    def not_implemented(self, *args):
        """
        not_implemented(self, file, line)

        print error message 'not implemented' 
        """
        return _modshogun.SGIO_not_implemented(self, *args)

    def deprecated(self, *args):
        """
        deprecated(self, file, line)

        print warning message 'function deprecated' 
        """
        return _modshogun.SGIO_deprecated(self, *args)

    def buffered_message(self, *args):
        """
        buffered_message(self, prio, fmt, *args)

        print a buffered message

        Parameters:
        -----------

        prio:  message priority

        fmt:  format string 
        """
        return _modshogun.SGIO_buffered_message(self, *args)

    def skip_spaces(*args):
        """skip_spaces(str) -> str"""
        return _modshogun.SGIO_skip_spaces(*args)

    if _newclass:skip_spaces = staticmethod(skip_spaces)
    __swig_getmethods__["skip_spaces"] = lambda x: skip_spaces
    def skip_blanks(*args):
        """skip_blanks(str) -> str"""
        return _modshogun.SGIO_skip_blanks(*args)

    if _newclass:skip_blanks = staticmethod(skip_blanks)
    __swig_getmethods__["skip_blanks"] = lambda x: skip_blanks
    def get_target(self):
        """
        get_target(self) -> FILE

        get target

        file descriptor for target 
        """
        return _modshogun.SGIO_get_target(self)

    def set_target(self, *args):
        """
        set_target(self, target)

        set target

        Parameters:
        -----------

        target:  file descriptor for target 
        """
        return _modshogun.SGIO_set_target(self, *args)

    def set_target_to_stderr(self):
        """
        set_target_to_stderr(self)

        set target to stderr 
        """
        return _modshogun.SGIO_set_target_to_stderr(self)

    def set_target_to_stdout(self):
        """
        set_target_to_stdout(self)

        set target to stdout 
        """
        return _modshogun.SGIO_set_target_to_stdout(self)

    def enable_progress(self):
        """
        enable_progress(self)

        enable progress bar 
        """
        return _modshogun.SGIO_enable_progress(self)

    def disable_progress(self):
        """
        disable_progress(self)

        disable progress bar 
        """
        return _modshogun.SGIO_disable_progress(self)

    def enable_file_and_line(self):
        """
        enable_file_and_line(self)

        enable displaying of file and line when printing messages 
        """
        return _modshogun.SGIO_enable_file_and_line(self)

    def disable_file_and_line(self):
        """
        disable_file_and_line(self)

        disable displaying of file and line when printing messages 
        """
        return _modshogun.SGIO_disable_file_and_line(self)

    def enable_syntax_highlighting(self):
        """
        enable_syntax_highlighting(self)

        enable syntax highlighting 
        """
        return _modshogun.SGIO_enable_syntax_highlighting(self)

    def disable_syntax_highlighting(self):
        """
        disable_syntax_highlighting(self)

        disable syntax highlighting 
        """
        return _modshogun.SGIO_disable_syntax_highlighting(self)

    def set_dirname(*args):
        """set_dirname(dirname)"""
        return _modshogun.SGIO_set_dirname(*args)

    if _newclass:set_dirname = staticmethod(set_dirname)
    __swig_getmethods__["set_dirname"] = lambda x: set_dirname
    def concat_filename(*args):
        """concat_filename(filename) -> str"""
        return _modshogun.SGIO_concat_filename(*args)

    if _newclass:concat_filename = staticmethod(concat_filename)
    __swig_getmethods__["concat_filename"] = lambda x: concat_filename
    def filter(*args):
        """filter(d) -> int"""
        return _modshogun.SGIO_filter(*args)

    if _newclass:filter = staticmethod(filter)
    __swig_getmethods__["filter"] = lambda x: filter
    def ref_count(self):
        """
        ref_count(self) ->  int

        display reference counter

        reference count 
        """
        return _modshogun.SGIO_ref_count(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _modshogun.SGIO_get_name(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.SGIO_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.SGIO_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_SGIO
    __del__ = lambda self : None;
SGIO_swigregister = _modshogun.SGIO_swigregister
SGIO_swigregister(SGIO)

def init_shogun(print_message = None, print_warning = None, print_error = None, 
    cancel_computations = None):
  """
    init_shogun(print_message = None, print_warning = None, print_error = None, 
        cancel_computations = None)
    init_shogun(print_message = None, print_warning = None, print_error = None)
    init_shogun(print_message = None, print_warning = None)
    init_shogun(print_message = None)
    init_shogun()

    This function must be called before libshogun is used. Usually shogun
    does not provide any output messages (neither debugging nor error;
    apart from exceptions). This function allows one to specify customized
    output callback functions and a callback function to check for
    exceptions:

    Parameters:
    -----------

    print_message:  function pointer to print a message

    print_warning:  function pointer to print a warning message

    print_error:  function pointer to print an error message (this will be
    printed before shogun throws an exception)

    cancel_computations:  function pointer to check for exception 
    """
  return _modshogun.init_shogun(print_message, print_warning, print_error, cancel_computations)
cvar = _modshogun.cvar

def SGIO_skip_spaces(*args):
  """SGIO_skip_spaces(str) -> str"""
  return _modshogun.SGIO_skip_spaces(*args)

def SGIO_skip_blanks(*args):
  """SGIO_skip_blanks(str) -> str"""
  return _modshogun.SGIO_skip_blanks(*args)

def SGIO_set_dirname(*args):
  """SGIO_set_dirname(dirname)"""
  return _modshogun.SGIO_set_dirname(*args)

def SGIO_concat_filename(*args):
  """SGIO_concat_filename(filename) -> str"""
  return _modshogun.SGIO_concat_filename(*args)

def SGIO_filter(*args):
  """SGIO_filter(d) -> int"""
  return _modshogun.SGIO_filter(*args)


def c_string_of_substring(*args):
  """
    c_string_of_substring(s) -> str

    Return a C string from the substring

    Parameters:
    -----------

    s:  substring

    new C string representation 
    """
  return _modshogun.c_string_of_substring(*args)

def print_substring(*args):
  """
    print_substring(s)

    Print the substring

    Parameters:
    -----------

    s:  substring 
    """
  return _modshogun.print_substring(*args)

def float_of_substring(*args):
  """
    float_of_substring(s) -> float

    Get value of substring as float (if possible)

    Parameters:
    -----------

    s:  substring

    float value of substring 
    """
  return _modshogun.float_of_substring(*args)

def float_of_substring(*args):
  """
    float_of_substring(s) -> float

    Return value of substring as float

    Parameters:
    -----------

    s:  substring

    substring as float 
    """
  return _modshogun.double_of_substring(*args)

def int_of_substring(*args):
  """
    int_of_substring(s) ->  int

    Integer value of substring

    Parameters:
    -----------

    s:  substring

    int value of substring 
    """
  return _modshogun.int_of_substring(*args)

def ulong_of_substring(*args):
  """
    ulong_of_substring(s) -> int

    Unsigned long value of substring

    Parameters:
    -----------

    s:  substring

    unsigned long value of substring 
    """
  return _modshogun.ulong_of_substring(*args)

def ss_length(*args):
  """
    ss_length(s) -> int

    Length of substring

    Parameters:
    -----------

    s:  substring

    length of substring 
    """
  return _modshogun.ss_length(*args)
MS_NOT_AVAILABLE = _modshogun.MS_NOT_AVAILABLE
MS_AVAILABLE = _modshogun.MS_AVAILABLE
class SGObject(_object):
    """
    Class SGObject is the base class of all shogun objects.

    Apart from dealing with reference counting that is used to manage
    shogung objects in memory (erase unused object, avoid cleaning objects
    when they are still in use), it provides interfaces for:

    parallel - to determine the number of used CPUs for a method (cf.
    Parallel)

    io - to output messages and general i/o (cf. IO)

    version - to provide version information of the shogun version used
    (cf. Version)

    C++ includes: SGObject.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SGObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SGObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SGObject
    __del__ = lambda self : None;
    def ref_count(self):
        """ref_count(self) ->  int"""
        return _modshogun.SGObject_ref_count(self)

    def get_name(self):
        """
        get_name(self) -> str

        Returns the name of the SGSerializable instance. It MUST BE the CLASS
        NAME without the prefixed `C'.

        name of the SGSerializable 
        """
        return _modshogun.SGObject_get_name(self)

    def is_generic(self, *args):
        """
        is_generic(self, generic) -> bool

        If the SGSerializable is a class template then TRUE will be returned
        and GENERIC is set to the type of the generic.

        Parameters:
        -----------

        generic:  set to the type of the generic if returning TRUE

        TRUE if a class template. 
        """
        return _modshogun.SGObject_is_generic(self, *args)

    def unset_generic(self):
        """
        unset_generic(self)

        unset generic type

        this has to be called in classes specializing a template class 
        """
        return _modshogun.SGObject_unset_generic(self)

    def print_serializable(self, prefix = ""):
        """
        print_serializable(self, prefix = "")
        print_serializable(self)

        prints registered parameters out

        Parameters:
        -----------

        prefix:  prefix for members 
        """
        return _modshogun.SGObject_print_serializable(self, prefix)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.SGObject_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.SGObject_load_serializable(self, *args)

    def set_global_io(self, *args):
        """
        set_global_io(self, io)

        set the io object

        Parameters:
        -----------

        io:  io object to use 
        """
        return _modshogun.SGObject_set_global_io(self, *args)

    def get_global_io(self):
        """
        get_global_io(self) -> SGIO

        get the io object

        io object 
        """
        return _modshogun.SGObject_get_global_io(self)

    def set_global_parallel(self, *args):
        """
        set_global_parallel(self, parallel)

        set the parallel object

        Parameters:
        -----------

        parallel:  parallel object to use 
        """
        return _modshogun.SGObject_set_global_parallel(self, *args)

    def get_global_parallel(self):
        """
        get_global_parallel(self) -> Parallel

        get the parallel object

        parallel object 
        """
        return _modshogun.SGObject_get_global_parallel(self)

    def set_global_version(self, *args):
        """
        set_global_version(self, version)

        set the version object

        Parameters:
        -----------

        version:  version object to use 
        """
        return _modshogun.SGObject_set_global_version(self, *args)

    def get_global_version(self):
        """
        get_global_version(self) -> Version

        get the version object

        version object 
        """
        return _modshogun.SGObject_get_global_version(self)

    def get_modelsel_names(self):
        """
        get_modelsel_names(self) -> SGVector<(p.char)>

        vector of names of all parameters which are registered for model
        selection 
        """
        return _modshogun.SGObject_get_modelsel_names(self)

    def get_modsel_param_descr(self, *args):
        """
        get_modsel_param_descr(self, param_name) -> str

        Returns description of a given parameter string, if it exists.
        SG_ERROR otherwise

        Parameters:
        -----------

        param_name:  name of the parameter

        description of the parameter 
        """
        return _modshogun.SGObject_get_modsel_param_descr(self, *args)

    def get_modsel_param_index(self, *args):
        """
        get_modsel_param_index(self, param_name) -> index_t

        Returns index of model selection parameter with provided index

        Parameters:
        -----------

        param_name:  name of model selection parameter

        index of model selection parameter with provided name, -1 if there is
        no such 
        """
        return _modshogun.SGObject_get_modsel_param_index(self, *args)

    __swig_setmethods__["io"] = _modshogun.SGObject_io_set
    __swig_getmethods__["io"] = _modshogun.SGObject_io_get
    if _newclass:io = _swig_property(_modshogun.SGObject_io_get, _modshogun.SGObject_io_set)
    __swig_setmethods__["parallel"] = _modshogun.SGObject_parallel_set
    __swig_getmethods__["parallel"] = _modshogun.SGObject_parallel_get
    if _newclass:parallel = _swig_property(_modshogun.SGObject_parallel_get, _modshogun.SGObject_parallel_set)
    __swig_setmethods__["version"] = _modshogun.SGObject_version_set
    __swig_getmethods__["version"] = _modshogun.SGObject_version_get
    if _newclass:version = _swig_property(_modshogun.SGObject_version_get, _modshogun.SGObject_version_set)
    __swig_setmethods__["m_parameters"] = _modshogun.SGObject_m_parameters_set
    __swig_getmethods__["m_parameters"] = _modshogun.SGObject_m_parameters_get
    if _newclass:m_parameters = _swig_property(_modshogun.SGObject_m_parameters_get, _modshogun.SGObject_m_parameters_set)
    __swig_setmethods__["m_model_selection_parameters"] = _modshogun.SGObject_m_model_selection_parameters_set
    __swig_getmethods__["m_model_selection_parameters"] = _modshogun.SGObject_m_model_selection_parameters_get
    if _newclass:m_model_selection_parameters = _swig_property(_modshogun.SGObject_m_model_selection_parameters_get, _modshogun.SGObject_m_model_selection_parameters_set)
SGObject_swigregister = _modshogun.SGObject_swigregister
SGObject_swigregister(SGObject)

class Version(_object):
    """
    Class Version provides version information.

    It provides information of the version of shogun that is currently
    used, for example the svn revision, time and date of compile and
    compilation and the linkflags used.

    C++ includes: Version.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Version, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Version, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Version

        constructor 
        """
        this = _modshogun.new_Version()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Version
    __del__ = lambda self : None;
    def print_version():
        """print_version()"""
        return _modshogun.Version_print_version()

    if _newclass:print_version = staticmethod(print_version)
    __swig_getmethods__["print_version"] = lambda x: print_version
    def get_version_extra():
        """get_version_extra() -> str"""
        return _modshogun.Version_get_version_extra()

    if _newclass:get_version_extra = staticmethod(get_version_extra)
    __swig_getmethods__["get_version_extra"] = lambda x: get_version_extra
    def get_version_release():
        """get_version_release() -> str"""
        return _modshogun.Version_get_version_release()

    if _newclass:get_version_release = staticmethod(get_version_release)
    __swig_getmethods__["get_version_release"] = lambda x: get_version_release
    def get_version_revision():
        """get_version_revision() ->  int"""
        return _modshogun.Version_get_version_revision()

    if _newclass:get_version_revision = staticmethod(get_version_revision)
    __swig_getmethods__["get_version_revision"] = lambda x: get_version_revision
    def get_version_year():
        """get_version_year() ->  int"""
        return _modshogun.Version_get_version_year()

    if _newclass:get_version_year = staticmethod(get_version_year)
    __swig_getmethods__["get_version_year"] = lambda x: get_version_year
    def get_version_month():
        """get_version_month() ->  int"""
        return _modshogun.Version_get_version_month()

    if _newclass:get_version_month = staticmethod(get_version_month)
    __swig_getmethods__["get_version_month"] = lambda x: get_version_month
    def get_version_day():
        """get_version_day() ->  int"""
        return _modshogun.Version_get_version_day()

    if _newclass:get_version_day = staticmethod(get_version_day)
    __swig_getmethods__["get_version_day"] = lambda x: get_version_day
    def get_version_hour():
        """get_version_hour() ->  int"""
        return _modshogun.Version_get_version_hour()

    if _newclass:get_version_hour = staticmethod(get_version_hour)
    __swig_getmethods__["get_version_hour"] = lambda x: get_version_hour
    def get_version_minute():
        """get_version_minute() ->  int"""
        return _modshogun.Version_get_version_minute()

    if _newclass:get_version_minute = staticmethod(get_version_minute)
    __swig_getmethods__["get_version_minute"] = lambda x: get_version_minute
    def get_version_parameter():
        """get_version_parameter() ->  int"""
        return _modshogun.Version_get_version_parameter()

    if _newclass:get_version_parameter = staticmethod(get_version_parameter)
    __swig_getmethods__["get_version_parameter"] = lambda x: get_version_parameter
    def get_version_in_minutes():
        """get_version_in_minutes() -> int"""
        return _modshogun.Version_get_version_in_minutes()

    if _newclass:get_version_in_minutes = staticmethod(get_version_in_minutes)
    __swig_getmethods__["get_version_in_minutes"] = lambda x: get_version_in_minutes
    def ref_count(self):
        """
        ref_count(self) ->  int

        ref count ref count 
        """
        return _modshogun.Version_ref_count(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.Version_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.Version_load_serializable(self, *args)

Version_swigregister = _modshogun.Version_swigregister
Version_swigregister(Version)

def Version_print_version():
  """Version_print_version()"""
  return _modshogun.Version_print_version()

def Version_get_version_extra():
  """Version_get_version_extra() -> str"""
  return _modshogun.Version_get_version_extra()

def Version_get_version_release():
  """Version_get_version_release() -> str"""
  return _modshogun.Version_get_version_release()

def Version_get_version_revision():
  """Version_get_version_revision() ->  int"""
  return _modshogun.Version_get_version_revision()

def Version_get_version_year():
  """Version_get_version_year() ->  int"""
  return _modshogun.Version_get_version_year()

def Version_get_version_month():
  """Version_get_version_month() ->  int"""
  return _modshogun.Version_get_version_month()

def Version_get_version_day():
  """Version_get_version_day() ->  int"""
  return _modshogun.Version_get_version_day()

def Version_get_version_hour():
  """Version_get_version_hour() ->  int"""
  return _modshogun.Version_get_version_hour()

def Version_get_version_minute():
  """Version_get_version_minute() ->  int"""
  return _modshogun.Version_get_version_minute()

def Version_get_version_parameter():
  """Version_get_version_parameter() ->  int"""
  return _modshogun.Version_get_version_parameter()

def Version_get_version_in_minutes():
  """Version_get_version_in_minutes() -> int"""
  return _modshogun.Version_get_version_in_minutes()

class Parallel(_object):
    """
    Class Parallel provides helper functions for multithreading.

    For example it can be used to determine the number of CPU cores in
    your computer and is the place where you define the number of CPUs
    that shall be used in computations.

    C++ includes: Parallel.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parallel, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Parallel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Parallel
        __init__(self, orig) -> Parallel

        copy constructor 
        """
        this = _modshogun.new_Parallel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Parallel
    __del__ = lambda self : None;
    def get_num_cpus(self):
        """
        get_num_cpus(self) ->  int

        get num of cpus number of CPUs 
        """
        return _modshogun.Parallel_get_num_cpus(self)

    def set_num_threads(self, *args):
        """
        set_num_threads(self, n)

        set number of threads

        Parameters:
        -----------

        n:  number of threads 
        """
        return _modshogun.Parallel_set_num_threads(self, *args)

    def get_num_threads(self):
        """
        get_num_threads(self) ->  int

        get number of threads number of threads 
        """
        return _modshogun.Parallel_get_num_threads(self)

    def ref_count(self):
        """
        ref_count(self) ->  int

        get ref count current ref counter 
        """
        return _modshogun.Parallel_ref_count(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.Parallel_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.Parallel_load_serializable(self, *args)

Parallel_swigregister = _modshogun.Parallel_swigregister
Parallel_swigregister(Parallel)

import tempfile, random, os, exceptions

import modshogun

def __SGgetstate__(self):
    fname = tempfile.gettempdir() + "/" + tempfile.gettempprefix() \
        + str(random.randint(0, 1e15))

    try:
        fstream = modshogun.SerializableAsciiFile(fname, "w") \
            if self.__pickle_ascii__ \
            else modshogun.SerializableHDF5File(fname, "w")
    except exceptions.AttributeError:
        fstream = modshogun.SerializableAsciiFile(fname, "w")
        self.__pickle_ascii__ = True

    if not self.save_serializable(fstream):
        fstream.close(); os.remove(fname)
        raise exceptions.IOError("Could not dump Shogun object!")
    fstream.close()
    fstream = open(fname, "r"); result = fstream.read();
    fstream.close()

    os.remove(fname)
    return (self.__pickle_ascii__, result)

def __SGsetstate__(self, state_tuple):
    self.__init__()

    fname = tempfile.gettempdir() + "/" + tempfile.gettempprefix() \
        + str(random.randint(0, 1e15))

    fstream = open(fname, "w"); fstream.write(state_tuple[1]);
    fstream.close()

    try:
        fstream = modshogun.SerializableAsciiFile(fname, "r") \
            if state_tuple[0] \
            else modshogun.SerializableHDF5File(fname, "r")
    except exceptions.AttributeError:
        raise exceptions.IOError("File contains an HDF5 stream but " \
                                 "Shogun was not compiled with HDF5" \
                                 " support!")

    if not self.load_serializable(fstream):
        fstream.close(); os.remove(fname)
        raise exceptions.IOError("Could not load Shogun object!")
    fstream.close()

    os.remove(fname)

def __SGreduce_ex__(self, protocol):
    self.__pickle_ascii__ = True if protocol == 0 else False
    return super(self.__class__, self).__reduce__()

def __SGstr__(self):
    fname = tempfile.gettempdir() + "/" + tempfile.gettempprefix() \
        + str(random.randint(0, 1e15))

    fstream = modshogun.SerializableAsciiFile(fname, "w")
    if not self.save_serializable(fstream):
        fstream.close(); os.remove(fname)
        raise exceptions.IOError("Could not dump Shogun object!")
    fstream.close()

    fstream = open(fname, "r"); result = fstream.read();
    fstream.close()

    os.remove(fname)
    return result

def __SGeq__(self, other):
    return self.__str__() == str(other)

def __SGneq__(self, other):
    return self.__str__() != str(other)

SGObject.__setstate__ = __SGsetstate__
SGObject.__getstate__ = __SGgetstate__
SGObject.__reduce_ex__ = __SGreduce_ex__
SGObject.__str__ = __SGstr__
SGObject.__eq__ = __SGeq__
SGObject.__neq__ = __SGneq__

class File(SGObject):
    """
    A File access base class.

    A file is assumed to be a seekable raw data stream.

    See:   CAsciiFile

    CBinaryFile

    CHDF5File

    C++ includes: File.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, File, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, File, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_File
    __del__ = lambda self : None;
    def close(self):
        """
        close(self)

        close 
        """
        return _modshogun.File_close(self)

    def get_file_descriptor(self):
        """
        get_file_descriptor(self) -> FILE

        get the file descriptor

        FILE ptr 
        """
        return _modshogun.File_get_file_descriptor(self)

    def set_variable_name(self, *args):
        """
        set_variable_name(self, name)

        set the path to the variable to be accessed

        only supported by some file interfaces like CHDF5File

        Parameters:
        -----------

        name:  variable path & name 
        """
        return _modshogun.File_set_variable_name(self, *args)

    def get_variable_name(self):
        """
        get_variable_name(self) -> str

        get the path to the variable to be accessed

        only supported by some file interfaces like CHDF5File

        name variable path & name 
        """
        return _modshogun.File_get_variable_name(self)

    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        """
        return _modshogun.File_get_vector(self, *args)

    def get_int8_matrix(self, *args):
        """get_int8_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_int8_matrix(self, *args)

    def get_uint_matrix(self, *args):
        """get_uint_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_uint_matrix(self, *args)

    def get_long_matrix(self, *args):
        """get_long_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_long_matrix(self, *args)

    def get_ulong_matrix(self, *args):
        """get_ulong_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_ulong_matrix(self, *args)

    def get_longreal_matrix(self, *args):
        """get_longreal_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_longreal_matrix(self, *args)

    def get_matrix(self, *args):
        """
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.File_get_matrix(self, *args)

    def get_ndarray(self, *args):
        """
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.File_get_ndarray(self, *args)

    def get_int8_sparsematrix(self, *args):
        """get_int8_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_int8_sparsematrix(self, *args)

    def get_uint_sparsematrix(self, *args):
        """get_uint_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_uint_sparsematrix(self, *args)

    def get_long_sparsematrix(self, *args):
        """get_long_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_long_sparsematrix(self, *args)

    def get_ulong_sparsematrix(self, *args):
        """get_ulong_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_ulong_sparsematrix(self, *args)

    def get_sparse_matrix(self, *args):
        """
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.File_get_sparse_matrix(self, *args)

    def get_longreal_sparsematrix(self, *args):
        """get_longreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_get_longreal_sparsematrix(self, *args)

    def get_int8_string_list(self, *args):
        """get_int8_string_list(self, strings, num_str, max_string_len)"""
        return _modshogun.File_get_int8_string_list(self, *args)

    def get_uint_string_list(self, *args):
        """get_uint_string_list(self, strings, num_str, max_string_len)"""
        return _modshogun.File_get_uint_string_list(self, *args)

    def get_long_string_list(self, *args):
        """get_long_string_list(self, strings, num_str, max_string_len)"""
        return _modshogun.File_get_long_string_list(self, *args)

    def get_ulong_string_list(self, *args):
        """get_ulong_string_list(self, strings, num_str, max_string_len)"""
        return _modshogun.File_get_ulong_string_list(self, *args)

    def get_string_list(self, *args):
        """
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        """
        return _modshogun.File_get_string_list(self, *args)

    def get_longreal_string_list(self, *args):
        """get_longreal_string_list(self, strings, num_str, max_string_len)"""
        return _modshogun.File_get_longreal_string_list(self, *args)

    def set_vector(self, *args):
        """
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        """
        return _modshogun.File_set_vector(self, *args)

    def set_int8_matrix(self, *args):
        """set_int8_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_int8_matrix(self, *args)

    def set_uint_matrix(self, *args):
        """set_uint_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_uint_matrix(self, *args)

    def set_long_matrix(self, *args):
        """set_long_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_long_matrix(self, *args)

    def set_ulong_matrix(self, *args):
        """set_ulong_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_ulong_matrix(self, *args)

    def set_longreal_matrix(self, *args):
        """set_longreal_matrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_longreal_matrix(self, *args)

    def set_matrix(self, *args):
        """
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.File_set_matrix(self, *args)

    def set_int8_sparsematrix(self, *args):
        """set_int8_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_int8_sparsematrix(self, *args)

    def set_uint_sparsematrix(self, *args):
        """set_uint_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_uint_sparsematrix(self, *args)

    def set_long_sparsematrix(self, *args):
        """set_long_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_long_sparsematrix(self, *args)

    def set_ulong_sparsematrix(self, *args):
        """set_ulong_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_ulong_sparsematrix(self, *args)

    def set_sparse_matrix(self, *args):
        """
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.File_set_sparse_matrix(self, *args)

    def set_longreal_sparsematrix(self, *args):
        """set_longreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _modshogun.File_set_longreal_sparsematrix(self, *args)

    def set_int8_string_list(self, *args):
        """set_int8_string_list(self, strings, num_str)"""
        return _modshogun.File_set_int8_string_list(self, *args)

    def set_uint_string_list(self, *args):
        """set_uint_string_list(self, strings, num_str)"""
        return _modshogun.File_set_uint_string_list(self, *args)

    def set_long_string_list(self, *args):
        """set_long_string_list(self, strings, num_str)"""
        return _modshogun.File_set_long_string_list(self, *args)

    def set_ulong_string_list(self, *args):
        """set_ulong_string_list(self, strings, num_str)"""
        return _modshogun.File_set_ulong_string_list(self, *args)

    def set_string_list(self, *args):
        """
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        """
        return _modshogun.File_set_string_list(self, *args)

    def set_longreal_string_list(self, *args):
        """set_longreal_string_list(self, strings, num_str)"""
        return _modshogun.File_set_longreal_string_list(self, *args)

File_swigregister = _modshogun.File_swigregister
File_swigregister(File)

class StreamingFile(SGObject):
    """
    A Streaming File access class.

    Vectors are read as one vector per line

    NOT YET IMPLEMENTED:

    Matrices are written out as one column per line

    Sparse Matrices are written out as one column per line
    (libsvm/svmlight style format)

    Strings are written out as one string per line

    C++ includes: StreamingFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFile, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFile
        __init__(self, fname, rw = 'r') -> StreamingFile
        __init__(self, fname) -> StreamingFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w' 
        """
        this = _modshogun.new_StreamingFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFile
    __del__ = lambda self : None;
    def close(self):
        """
        close(self)

        Closes the file 
        """
        return _modshogun.StreamingFile_close(self)

    def is_seekable(self):
        """
        is_seekable(self) -> bool

        Whether the stream is seekable/resettable

        false by default, unless overloaded 
        """
        return _modshogun.StreamingFile_is_seekable(self)

    def reset_stream(self):
        """
        reset_stream(self)

        Reset the stream, should be overloaded if possible 
        """
        return _modshogun.StreamingFile_reset_stream(self)

    def get_string(self, *args):
        """
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        """
        return _modshogun.StreamingFile_get_string(self, *args)

    def get_string_and_label(self, *args):
        """
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        """
        return _modshogun.StreamingFile_get_string_and_label(self, *args)

    def get_sparse_vector(self, *args):
        """
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        """
        return _modshogun.StreamingFile_get_sparse_vector(self, *args)

    def get_sparse_vector_and_label(self, *args):
        """
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        """
        return _modshogun.StreamingFile_get_sparse_vector_and_label(self, *args)

    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, ex, len)

        Function to read VW examples without labels

        Parameters:
        -----------

        ex:  example

        len:  length of feature vector 
        """
        return _modshogun.StreamingFile_get_vector(self, *args)

    def get_vector_and_label(self, *args):
        """
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, ex, len, label)

        Function to read VW examples with labels

        Parameters:
        -----------

        ex:  example

        len:  length of feature vector

        label:  label 
        """
        return _modshogun.StreamingFile_get_vector_and_label(self, *args)

StreamingFile_swigregister = _modshogun.StreamingFile_swigregister
StreamingFile_swigregister(StreamingFile)

class StreamingFileFromFeatures(StreamingFile):
    """
    Class StreamingFileFromFeatures to read vector-by-vector from a
    CFeatures object.

    The object must be initialized with another CFeatures object. It is
    upto the derived class to implement specialized functions to return
    the vector.

    Only a subset of the functions defined in StreamingFile.h need to be
    implemented, as appropriate for the CFeatures object which the class
    works with.

    For example, a derived class based on SimpleFeatures should only
    implement the get_(type)*_vector() functions, and a class based on
    StringFeatures should only implement the get_(type)*_string()
    functions.

    C++ includes: StreamingFileFromFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromFeatures
        __init__(self, feat) -> StreamingFileFromFeatures
        __init__(self, feat, lab) -> StreamingFileFromFeatures

        Constructor taking a CFeatures object and labels as arguments

        Parameters:
        -----------

        feat:  features object

        lab:  labels as float* 
        """
        this = _modshogun.new_StreamingFileFromFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromFeatures
    __del__ = lambda self : None;
    def set_features(self, *args):
        """
        set_features(self, feat)

        Set the features object

        Parameters:
        -----------

        feat:  features object as argument 
        """
        return _modshogun.StreamingFileFromFeatures_set_features(self, *args)

    def set_labels(self, *args):
        """
        set_labels(self, lab)

        Set the labels

        Parameters:
        -----------

        lab:  array of labels 
        """
        return _modshogun.StreamingFileFromFeatures_set_labels(self, *args)

StreamingFileFromFeatures_swigregister = _modshogun.StreamingFileFromFeatures_swigregister
StreamingFileFromFeatures_swigregister(StreamingFileFromFeatures)

class StreamingFileFromSparseBoolFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseBoolFeatures
        __init__(self, feat) -> StreamingFileFromSparseBoolFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseBoolFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseBoolFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseBoolFeatures_swigregister = _modshogun.StreamingFileFromSparseBoolFeatures_swigregister
StreamingFileFromSparseBoolFeatures_swigregister(StreamingFileFromSparseBoolFeatures)

class StreamingFileFromSparseCharFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseCharFeatures
        __init__(self, feat) -> StreamingFileFromSparseCharFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseCharFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseCharFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseCharFeatures_swigregister = _modshogun.StreamingFileFromSparseCharFeatures_swigregister
StreamingFileFromSparseCharFeatures_swigregister(StreamingFileFromSparseCharFeatures)

class StreamingFileFromSparseByteFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseByteFeatures
        __init__(self, feat) -> StreamingFileFromSparseByteFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseByteFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseByteFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseByteFeatures_swigregister = _modshogun.StreamingFileFromSparseByteFeatures_swigregister
StreamingFileFromSparseByteFeatures_swigregister(StreamingFileFromSparseByteFeatures)

class StreamingFileFromSparseWordFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseWordFeatures
        __init__(self, feat) -> StreamingFileFromSparseWordFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseWordFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseWordFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseWordFeatures_swigregister = _modshogun.StreamingFileFromSparseWordFeatures_swigregister
StreamingFileFromSparseWordFeatures_swigregister(StreamingFileFromSparseWordFeatures)

class StreamingFileFromSparseIntFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseIntFeatures
        __init__(self, feat) -> StreamingFileFromSparseIntFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseIntFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseIntFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseIntFeatures_swigregister = _modshogun.StreamingFileFromSparseIntFeatures_swigregister
StreamingFileFromSparseIntFeatures_swigregister(StreamingFileFromSparseIntFeatures)

class StreamingFileFromSparseLongFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseLongFeatures
        __init__(self, feat) -> StreamingFileFromSparseLongFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseLongFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseLongFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseLongFeatures_swigregister = _modshogun.StreamingFileFromSparseLongFeatures_swigregister
StreamingFileFromSparseLongFeatures_swigregister(StreamingFileFromSparseLongFeatures)

class StreamingFileFromSparseUlongFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseUlongFeatures
        __init__(self, feat) -> StreamingFileFromSparseUlongFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseUlongFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseUlongFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseUlongFeatures_swigregister = _modshogun.StreamingFileFromSparseUlongFeatures_swigregister
StreamingFileFromSparseUlongFeatures_swigregister(StreamingFileFromSparseUlongFeatures)

class StreamingFileFromSparseShortRealFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseShortRealFeatures
        __init__(self, feat) -> StreamingFileFromSparseShortRealFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseShortRealFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseShortRealFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseShortRealFeatures_swigregister = _modshogun.StreamingFileFromSparseShortRealFeatures_swigregister
StreamingFileFromSparseShortRealFeatures_swigregister(StreamingFileFromSparseShortRealFeatures)

class StreamingFileFromSparseRealFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSparseFeatures is derived from CStreamingFile
    and provides an input source for the online framework. It uses an
    existing CSparseFeatures object to generate online examples.

    C++ includes: StreamingFileFromSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromSparseRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromSparseRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromSparseRealFeatures
        __init__(self, feat) -> StreamingFileFromSparseRealFeatures
        __init__(self, feat, lab) -> StreamingFileFromSparseRealFeatures

        Constructor taking a SparseFeatures object as arg

        Parameters:
        -----------

        feat:  SparseFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromSparseRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromSparseRealFeatures
    __del__ = lambda self : None;
StreamingFileFromSparseRealFeatures_swigregister = _modshogun.StreamingFileFromSparseRealFeatures_swigregister
StreamingFileFromSparseRealFeatures_swigregister(StreamingFileFromSparseRealFeatures)

class StreamingFileFromBoolFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromBoolFeatures
        __init__(self, feat) -> StreamingFileFromBoolFeatures
        __init__(self, feat, lab) -> StreamingFileFromBoolFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromBoolFeatures
    __del__ = lambda self : None;
StreamingFileFromBoolFeatures_swigregister = _modshogun.StreamingFileFromBoolFeatures_swigregister
StreamingFileFromBoolFeatures_swigregister(StreamingFileFromBoolFeatures)

class StreamingFileFromCharFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromCharFeatures
        __init__(self, feat) -> StreamingFileFromCharFeatures
        __init__(self, feat, lab) -> StreamingFileFromCharFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromCharFeatures
    __del__ = lambda self : None;
StreamingFileFromCharFeatures_swigregister = _modshogun.StreamingFileFromCharFeatures_swigregister
StreamingFileFromCharFeatures_swigregister(StreamingFileFromCharFeatures)

class StreamingFileFromByteFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromByteFeatures
        __init__(self, feat) -> StreamingFileFromByteFeatures
        __init__(self, feat, lab) -> StreamingFileFromByteFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromByteFeatures
    __del__ = lambda self : None;
StreamingFileFromByteFeatures_swigregister = _modshogun.StreamingFileFromByteFeatures_swigregister
StreamingFileFromByteFeatures_swigregister(StreamingFileFromByteFeatures)

class StreamingFileFromWordFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromWordFeatures
        __init__(self, feat) -> StreamingFileFromWordFeatures
        __init__(self, feat, lab) -> StreamingFileFromWordFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromWordFeatures
    __del__ = lambda self : None;
StreamingFileFromWordFeatures_swigregister = _modshogun.StreamingFileFromWordFeatures_swigregister
StreamingFileFromWordFeatures_swigregister(StreamingFileFromWordFeatures)

class StreamingFileFromIntFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromIntFeatures
        __init__(self, feat) -> StreamingFileFromIntFeatures
        __init__(self, feat, lab) -> StreamingFileFromIntFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromIntFeatures
    __del__ = lambda self : None;
StreamingFileFromIntFeatures_swigregister = _modshogun.StreamingFileFromIntFeatures_swigregister
StreamingFileFromIntFeatures_swigregister(StreamingFileFromIntFeatures)

class StreamingFileFromLongFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromLongFeatures
        __init__(self, feat) -> StreamingFileFromLongFeatures
        __init__(self, feat, lab) -> StreamingFileFromLongFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromLongFeatures
    __del__ = lambda self : None;
StreamingFileFromLongFeatures_swigregister = _modshogun.StreamingFileFromLongFeatures_swigregister
StreamingFileFromLongFeatures_swigregister(StreamingFileFromLongFeatures)

class StreamingFileFromUlongFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromUlongFeatures
        __init__(self, feat) -> StreamingFileFromUlongFeatures
        __init__(self, feat, lab) -> StreamingFileFromUlongFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromUlongFeatures
    __del__ = lambda self : None;
StreamingFileFromUlongFeatures_swigregister = _modshogun.StreamingFileFromUlongFeatures_swigregister
StreamingFileFromUlongFeatures_swigregister(StreamingFileFromUlongFeatures)

class StreamingFileFromShortRealFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromShortRealFeatures
        __init__(self, feat) -> StreamingFileFromShortRealFeatures
        __init__(self, feat, lab) -> StreamingFileFromShortRealFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromShortRealFeatures
    __del__ = lambda self : None;
StreamingFileFromShortRealFeatures_swigregister = _modshogun.StreamingFileFromShortRealFeatures_swigregister
StreamingFileFromShortRealFeatures_swigregister(StreamingFileFromShortRealFeatures)

class StreamingFileFromRealFeatures(StreamingFileFromFeatures):
    """
    Class CStreamingFileFromSimpleFeatures is a derived class of
    CStreamingFile which creates an input source for the online framework
    from a CSimpleFeatures object.

    This kind of input is seekable, and hence can be used for making
    multiple passes over data.

    It is useful for testing/comparison purposes.

    C++ includes: StreamingFileFromSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFileFromRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFileFromFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFileFromRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingFileFromRealFeatures
        __init__(self, feat) -> StreamingFileFromRealFeatures
        __init__(self, feat, lab) -> StreamingFileFromRealFeatures

        Constructor taking a SimpleFeatures object as arg

        Parameters:
        -----------

        feat:  SimpleFeatures object

        lab:  Labels as float* 
        """
        this = _modshogun.new_StreamingFileFromRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingFileFromRealFeatures
    __del__ = lambda self : None;
StreamingFileFromRealFeatures_swigregister = _modshogun.StreamingFileFromRealFeatures_swigregister
StreamingFileFromRealFeatures_swigregister(StreamingFileFromRealFeatures)

class AsciiFile(File):
    """
    A Ascii File access class.

    Vectors are written out as one number per line

    Matrices are written out as one column per line

    Sparse Matrices are written out as one column per line
    (libsvm/svmlight style format)

    Strings are written out as one string per line

    C++ includes: AsciiFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AsciiFile, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AsciiFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> AsciiFile
        __init__(self, f, name = None) -> AsciiFile
        __init__(self, f) -> AsciiFile
        __init__(self, fname, rw = 'r', name = None) -> AsciiFile
        __init__(self, fname, rw = 'r') -> AsciiFile
        __init__(self, fname) -> AsciiFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w'

        name:  variable name (e.g. "x" or "/path/to/x") 
        """
        this = _modshogun.new_AsciiFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_AsciiFile
    __del__ = lambda self : None;
    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        """
        return _modshogun.AsciiFile_get_vector(self, *args)

    def get_matrix(self, *args):
        """
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.AsciiFile_get_matrix(self, *args)

    def get_int8_ndarray(self, *args):
        """get_int8_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_get_int8_ndarray(self, *args)

    def get_uint_ndarray(self, *args):
        """get_uint_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_get_uint_ndarray(self, *args)

    def get_long_ndarray(self, *args):
        """get_long_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_get_long_ndarray(self, *args)

    def get_ulong_ndarray(self, *args):
        """get_ulong_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_get_ulong_ndarray(self, *args)

    def get_longreal_ndarray(self, *args):
        """get_longreal_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_get_longreal_ndarray(self, *args)

    def get_ndarray(self, *args):
        """
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.AsciiFile_get_ndarray(self, *args)

    def get_sparse_matrix(self, *args):
        """
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.AsciiFile_get_sparse_matrix(self, *args)

    def get_string_list(self, *args):
        """
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        """
        return _modshogun.AsciiFile_get_string_list(self, *args)

    def set_vector(self, *args):
        """
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        """
        return _modshogun.AsciiFile_set_vector(self, *args)

    def set_matrix(self, *args):
        """
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.AsciiFile_set_matrix(self, *args)

    def set_int8_ndarray(self, *args):
        """set_int8_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_set_int8_ndarray(self, *args)

    def set_uint_ndarray(self, *args):
        """set_uint_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_set_uint_ndarray(self, *args)

    def set_long_ndarray(self, *args):
        """set_long_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_set_long_ndarray(self, *args)

    def set_ulong_ndarray(self, *args):
        """set_ulong_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_set_ulong_ndarray(self, *args)

    def set_longreal_ndarray(self, *args):
        """set_longreal_ndarray(self, array, dims, num_dims)"""
        return _modshogun.AsciiFile_set_longreal_ndarray(self, *args)

    def set_ndarray(self, *args):
        """
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.AsciiFile_set_ndarray(self, *args)

    def set_sparse_matrix(self, *args):
        """
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.AsciiFile_set_sparse_matrix(self, *args)

    def set_string_list(self, *args):
        """
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        """
        return _modshogun.AsciiFile_set_string_list(self, *args)

    def getdelim(*args):
        """getdelim(lineptr, n, delimiter, stream) -> ssize_t"""
        return _modshogun.AsciiFile_getdelim(*args)

    if _newclass:getdelim = staticmethod(getdelim)
    __swig_getmethods__["getdelim"] = lambda x: getdelim
    def getline(*args):
        """getline(lineptr, n, stream) -> ssize_t"""
        return _modshogun.AsciiFile_getline(*args)

    if _newclass:getline = staticmethod(getline)
    __swig_getmethods__["getline"] = lambda x: getline
    def tokenize(*args):
        """tokenize(delim, s, ret)"""
        return _modshogun.AsciiFile_tokenize(*args)

    if _newclass:tokenize = staticmethod(tokenize)
    __swig_getmethods__["tokenize"] = lambda x: tokenize
AsciiFile_swigregister = _modshogun.AsciiFile_swigregister
AsciiFile_swigregister(AsciiFile)

def AsciiFile_getdelim(*args):
  """AsciiFile_getdelim(lineptr, n, delimiter, stream) -> ssize_t"""
  return _modshogun.AsciiFile_getdelim(*args)

def AsciiFile_getline(*args):
  """AsciiFile_getline(lineptr, n, stream) -> ssize_t"""
  return _modshogun.AsciiFile_getline(*args)

def AsciiFile_tokenize(*args):
  """AsciiFile_tokenize(delim, s, ret)"""
  return _modshogun.AsciiFile_tokenize(*args)

class StreamingAsciiFile(StreamingFile):
    """
    Class StreamingAsciiFile to read vector-by-vector from ASCII files.

    The object must be initialized like a CAsciiFile.

    C++ includes: StreamingAsciiFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingAsciiFile, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingAsciiFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingAsciiFile
        __init__(self, fname, rw = 'r') -> StreamingAsciiFile
        __init__(self, fname) -> StreamingAsciiFile

        Constructor taking file name argument

        Parameters:
        -----------

        fname:  file name

        rw:  read/write mode 
        """
        this = _modshogun.new_StreamingAsciiFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingAsciiFile
    __del__ = lambda self : None;
    def str_to_bool(self, *args):
        """
        str_to_bool(self, str) -> bool

        Utility function to convert a string to a boolean value

        Parameters:
        -----------

        str:  string to convert

        boolean value 
        """
        return _modshogun.StreamingAsciiFile_str_to_bool(self, *args)

    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)

        Function to read VW examples without labels

        Parameters:
        -----------

        ex:  example

        len:  length of feature vector 
        """
        return _modshogun.StreamingAsciiFile_get_vector(self, *args)

    def get_vector_and_label(self, *args):
        """
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)
        get_vector_and_label(self, vector, len, label)

        Function to read VW examples with labels

        Parameters:
        -----------

        ex:  example

        len:  length of feature vector

        label:  label 
        """
        return _modshogun.StreamingAsciiFile_get_vector_and_label(self, *args)

    def get_string(self, *args):
        """
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        get_string(self, vector, len)
        """
        return _modshogun.StreamingAsciiFile_get_string(self, *args)

    def get_string_and_label(self, *args):
        """
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        get_string_and_label(self, vector, len, label)
        """
        return _modshogun.StreamingAsciiFile_get_string_and_label(self, *args)

    def get_sparse_vector(self, *args):
        """
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        get_sparse_vector(self, vector, len)
        """
        return _modshogun.StreamingAsciiFile_get_sparse_vector(self, *args)

    def get_sparse_vector_and_label(self, *args):
        """
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        get_sparse_vector_and_label(self, vector, len, label)
        """
        return _modshogun.StreamingAsciiFile_get_sparse_vector_and_label(self, *args)

StreamingAsciiFile_swigregister = _modshogun.StreamingAsciiFile_swigregister
StreamingAsciiFile_swigregister(StreamingAsciiFile)

T_VW = _modshogun.T_VW
T_SVMLIGHT = _modshogun.T_SVMLIGHT
T_DENSE = _modshogun.T_DENSE
class VwParser(SGObject):
    """
    CVwParser is the object which provides the functions to parse examples
    from buffered input.

    An instance of this class can be created in CStreamingVwFile and the
    appropriate read_*_features function called to parse examples from
    different formats.

    It also encapsulates a CVwCacheWriter object which may be used in case
    a cache file is to be generated simultaneously with parsing.

    C++ includes: VwParser.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VwParser, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VwParser, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> VwParser
        __init__(self, env_to_use) -> VwParser

        Constructor taking environment as parameter.

        Parameters:
        -----------

        env_to_use:   CVwEnvironment to use 
        """
        this = _modshogun.new_VwParser(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_VwParser
    __del__ = lambda self : None;
    def get_env(self):
        """
        get_env(self) -> CVwEnvironment

        Get the environment

        environment as CVwEnvironment* 
        """
        return _modshogun.VwParser_get_env(self)

    def set_env(self, *args):
        """
        set_env(self, env_to_use)

        Set the environment

        Parameters:
        -----------

        env_to_use:  environment as CVwEnvironment* 
        """
        return _modshogun.VwParser_set_env(self, *args)

    def set_cache_parameters(self, *args):
        """
        set_cache_parameters(self, fname, type = C_NATIVE)
        set_cache_parameters(self, fname)

        Set the cache parameters

        Parameters:
        -----------

        fname:  name of the cache file

        type:  type of cache as one in EVwCacheType 
        """
        return _modshogun.VwParser_set_cache_parameters(self, *args)

    def get_cache_type(self):
        """
        get_cache_type(self) -> EVwCacheType

        Return the type of cache

        cache type as EVwCacheType 
        """
        return _modshogun.VwParser_get_cache_type(self)

    def set_write_cache(self, *args):
        """
        set_write_cache(self, wr_cache)

        Set whether to write cache file or not

        Parameters:
        -----------

        wr_cache:  write cache or not 
        """
        return _modshogun.VwParser_set_write_cache(self, *args)

    def get_write_cache(self):
        """
        get_write_cache(self) -> bool

        Return whether cache will be written or not

        will cache be written? 
        """
        return _modshogun.VwParser_get_write_cache(self)

    def set_mm(self, *args):
        """
        set_mm(self, label)

        Update min and max labels seen in the environment

        Parameters:
        -----------

        label:  current label based on which to update 
        """
        return _modshogun.VwParser_set_mm(self, *args)

    def noop_mm(self, *args):
        """
        noop_mm(self, label)

        A dummy function performing no operation in case training is not to be
        performed.

        Parameters:
        -----------

        label:  label 
        """
        return _modshogun.VwParser_noop_mm(self, *args)

    def set_minmax(self, *args):
        """
        set_minmax(self, label)

        Function which is actually called to update min and max labels Should
        be set to one of the functions implemented for this.

        Parameters:
        -----------

        label:  label based on which to update 
        """
        return _modshogun.VwParser_set_minmax(self, *args)

    def read_features(self, *args):
        """
        read_features(self, buf, ex) ->  int

        Reads input from the buffer and parses it into a VwExample

        Parameters:
        -----------

        buf:  IOBuffer which contains input

        ex:  parsed example

        number of stracters read for this example 
        """
        return _modshogun.VwParser_read_features(self, *args)

    def read_svmlight_features(self, *args):
        """
        read_svmlight_features(self, buf, ae) ->  int

        Read an example from an SVMLight file

        Parameters:
        -----------

        buf:  IOBuffer which contains input

        ae:  parsed example

        number of stracters read for this example 
        """
        return _modshogun.VwParser_read_svmlight_features(self, *args)

    def read_dense_features(self, *args):
        """
        read_dense_features(self, buf, ae) ->  int

        Read an example from a file with dense vectors

        Parameters:
        -----------

        buf:  IOBuffer which contains input

        ae:  parsed example

        number of stracters read for this example 
        """
        return _modshogun.VwParser_read_dense_features(self, *args)

    __swig_setmethods__["hasher"] = _modshogun.VwParser_hasher_set
    __swig_getmethods__["hasher"] = _modshogun.VwParser_hasher_get
    if _newclass:hasher = _swig_property(_modshogun.VwParser_hasher_get, _modshogun.VwParser_hasher_set)
VwParser_swigregister = _modshogun.VwParser_swigregister
VwParser_swigregister(VwParser)

class StreamingVwFile(StreamingFile):
    """
    Class StreamingVwFile to read vector-by-vector from Vowpal Wabbit data
    files. It reads the example and label into one object of VwExample
    type.

    C++ includes: StreamingVwFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingVwFile, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingVwFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingVwFile
        __init__(self, fname, rw = 'r') -> StreamingVwFile
        __init__(self, fname) -> StreamingVwFile

        Constructor taking file name argument

        Parameters:
        -----------

        fname:  file name

        rw:  read/write mode 
        """
        this = _modshogun.new_StreamingVwFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingVwFile
    __del__ = lambda self : None;
    def set_parser_type(self, *args):
        """
        set_parser_type(self, type = T_VW)
        set_parser_type(self)

        Set the type of parser, i.e., T_VW, T_SVMLIGHT or T_DENSE.

        Parameters:
        -----------

        type:  parser type as enum 
        """
        return _modshogun.StreamingVwFile_set_parser_type(self, *args)

    def set_env(self, *args):
        """
        set_env(self, env_to_use)

        Set environment for vw

        Parameters:
        -----------

        env_to_use:  CVwEnvironment* environment 
        """
        return _modshogun.StreamingVwFile_set_env(self, *args)

    def get_env(self):
        """
        get_env(self) -> CVwEnvironment

        Return the environment

        environment as CVwEnvironment* 
        """
        return _modshogun.StreamingVwFile_get_env(self)

    def set_write_to_cache(self, *args):
        """
        set_write_to_cache(self, write_cache)

        Set whether cache will be written

        Parameters:
        -----------

        write_cache:  whether to write to cache 
        """
        return _modshogun.StreamingVwFile_set_write_to_cache(self, *args)

    def get_write_to_cache(self):
        """
        get_write_to_cache(self) -> bool

        Get whether cache will be written

        whether to write to cache 
        """
        return _modshogun.StreamingVwFile_get_write_to_cache(self)

    __swig_setmethods__["parse_example"] = _modshogun.StreamingVwFile_parse_example_set
    __swig_getmethods__["parse_example"] = _modshogun.StreamingVwFile_parse_example_get
    if _newclass:parse_example = _swig_property(_modshogun.StreamingVwFile_parse_example_get, _modshogun.StreamingVwFile_parse_example_set)
StreamingVwFile_swigregister = _modshogun.StreamingVwFile_swigregister
StreamingVwFile_swigregister(StreamingVwFile)

class StreamingVwCacheFile(StreamingFile):
    """
    Class StreamingVwCacheFile to read vector-by-vector from VW cache
    files.

    The cache file is usually generated either by VW or by enabling the
    cache writing option in a CStreamingVwFile object.

    This class reads the example and label into one object of VwExample
    type.

    C++ includes: StreamingVwCacheFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingVwCacheFile, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingVwCacheFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingVwCacheFile
        __init__(self, cache_type) -> StreamingVwCacheFile
        __init__(self, fname, rw = 'r', cache_type = C_NATIVE) -> StreamingVwCacheFile
        __init__(self, fname, rw = 'r') -> StreamingVwCacheFile
        __init__(self, fname) -> StreamingVwCacheFile

        Constructor taking file name and cache type as arguments

        Parameters:
        -----------

        fname:  file name

        rw:  read/write mode

        cache_type:  type of cache - C_NATIVE or C_PROTOBUF 
        """
        this = _modshogun.new_StreamingVwCacheFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingVwCacheFile
    __del__ = lambda self : None;
    def set_env(self, *args):
        """
        set_env(self, env_to_use)

        Set environment for vw

        Parameters:
        -----------

        env_to_use:  CVwEnvironment* environment 
        """
        return _modshogun.StreamingVwCacheFile_set_env(self, *args)

    def get_env(self):
        """
        get_env(self) -> CVwEnvironment

        Return the environment

        environment as CVwEnvironment* 
        """
        return _modshogun.StreamingVwCacheFile_get_env(self)

StreamingVwCacheFile_swigregister = _modshogun.StreamingVwCacheFile_swigregister
StreamingVwCacheFile_swigregister(StreamingVwCacheFile)

class BinaryFile(File):
    """
    A Binary file access class.

    A file consists of a SG00 fourcc header then an alternation of a type
    header and data. The current implementation is capable of storing only
    a single header/data type. Multiple headers are currently not
    implemented.

    C++ includes: BinaryFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BinaryFile, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BinaryFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BinaryFile
        __init__(self, f, name = None) -> BinaryFile
        __init__(self, f) -> BinaryFile
        __init__(self, fname, rw = 'r', name = None) -> BinaryFile
        __init__(self, fname, rw = 'r') -> BinaryFile
        __init__(self, fname) -> BinaryFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w'

        name:  variable name (e.g. "x" or "/path/to/x") 
        """
        this = _modshogun.new_BinaryFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BinaryFile
    __del__ = lambda self : None;
    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        """
        return _modshogun.BinaryFile_get_vector(self, *args)

    def get_matrix(self, *args):
        """
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.BinaryFile_get_matrix(self, *args)

    def get_ndarray(self, *args):
        """
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.BinaryFile_get_ndarray(self, *args)

    def get_sparse_matrix(self, *args):
        """
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.BinaryFile_get_sparse_matrix(self, *args)

    def get_string_list(self, *args):
        """
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        """
        return _modshogun.BinaryFile_get_string_list(self, *args)

    def set_vector(self, *args):
        """
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        """
        return _modshogun.BinaryFile_set_vector(self, *args)

    def set_matrix(self, *args):
        """
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.BinaryFile_set_matrix(self, *args)

    def set_ndarray(self, *args):
        """
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        set_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.BinaryFile_set_ndarray(self, *args)

    def set_sparse_matrix(self, *args):
        """
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.BinaryFile_set_sparse_matrix(self, *args)

    def set_string_list(self, *args):
        """
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        """
        return _modshogun.BinaryFile_set_string_list(self, *args)

BinaryFile_swigregister = _modshogun.BinaryFile_swigregister
BinaryFile_swigregister(BinaryFile)

class HDF5File(File):
    """Proxy of C++ shogun::CHDF5File class"""
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HDF5File, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HDF5File, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HDF5File
        __init__(self, fname, rw = 'r', name = None) -> HDF5File
        __init__(self, fname, rw = 'r') -> HDF5File
        __init__(self, fname) -> HDF5File
        """
        this = _modshogun.new_HDF5File(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HDF5File
    __del__ = lambda self : None;
    def get_vector(self, *args):
        """
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        get_vector(self, vector, len)
        """
        return _modshogun.HDF5File_get_vector(self, *args)

    def get_matrix(self, *args):
        """
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        get_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.HDF5File_get_matrix(self, *args)

    def get_ndarray(self, *args):
        """
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        get_ndarray(self, array, dims, num_dims)
        """
        return _modshogun.HDF5File_get_ndarray(self, *args)

    def get_sparse_matrix(self, *args):
        """
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        get_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.HDF5File_get_sparse_matrix(self, *args)

    def get_string_list(self, *args):
        """
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        get_string_list(self, strings, num_str, max_string_len)
        """
        return _modshogun.HDF5File_get_string_list(self, *args)

    def set_vector(self, *args):
        """
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        set_vector(self, vector, len)
        """
        return _modshogun.HDF5File_set_vector(self, *args)

    def set_matrix(self, *args):
        """
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        set_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.HDF5File_set_matrix(self, *args)

    def set_sparse_matrix(self, *args):
        """
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        set_sparse_matrix(self, matrix, num_feat, num_vec)
        """
        return _modshogun.HDF5File_set_sparse_matrix(self, *args)

    def set_string_list(self, *args):
        """
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        set_string_list(self, strings, num_str)
        """
        return _modshogun.HDF5File_set_string_list(self, *args)

HDF5File_swigregister = _modshogun.HDF5File_swigregister
HDF5File_swigregister(HDF5File)

class SerializableFile(SGObject):
    """
    serializable file

    C++ includes: SerializableFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializableFile, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializableFile, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SerializableFile
    __del__ = lambda self : None;
    def close(self):
        """
        close(self)

        close 
        """
        return _modshogun.SerializableFile_close(self)

    def is_opened(self):
        """
        is_opened(self) -> bool

        is opened 
        """
        return _modshogun.SerializableFile_is_opened(self)

SerializableFile_swigregister = _modshogun.SerializableFile_swigregister
SerializableFile_swigregister(SerializableFile)

CHAR_CONT_BEGIN = _modshogun.CHAR_CONT_BEGIN
CHAR_CONT_END = _modshogun.CHAR_CONT_END
CHAR_ITEM_BEGIN = _modshogun.CHAR_ITEM_BEGIN
CHAR_ITEM_END = _modshogun.CHAR_ITEM_END
CHAR_SGSERIAL_BEGIN = _modshogun.CHAR_SGSERIAL_BEGIN
CHAR_SGSERIAL_END = _modshogun.CHAR_SGSERIAL_END
CHAR_STRING_BEGIN = _modshogun.CHAR_STRING_BEGIN
CHAR_STRING_END = _modshogun.CHAR_STRING_END
CHAR_SPARSE_BEGIN = _modshogun.CHAR_SPARSE_BEGIN
CHAR_SPARSE_END = _modshogun.CHAR_SPARSE_END
CHAR_TYPE_END = _modshogun.CHAR_TYPE_END
STR_SGSERIAL_NULL = _modshogun.STR_SGSERIAL_NULL
class SerializableAsciiFile(SerializableFile):
    """
    serializable ascii file

    C++ includes: SerializableAsciiFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [SerializableFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializableAsciiFile, name, value)
    __swig_getmethods__ = {}
    for _s in [SerializableFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializableAsciiFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SerializableAsciiFile
        __init__(self, fstream, rw) -> SerializableAsciiFile
        __init__(self, fname, rw = 'r') -> SerializableAsciiFile
        __init__(self, fname) -> SerializableAsciiFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w' 
        """
        this = _modshogun.new_SerializableAsciiFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SerializableAsciiFile
    __del__ = lambda self : None;
SerializableAsciiFile_swigregister = _modshogun.SerializableAsciiFile_swigregister
SerializableAsciiFile_swigregister(SerializableAsciiFile)

STR_IS_SGSERIALIZABLE = _modshogun.STR_IS_SGSERIALIZABLE
STR_IS_SPARSE = _modshogun.STR_IS_SPARSE
STR_IS_CONT = _modshogun.STR_IS_CONT
STR_IS_NULL = _modshogun.STR_IS_NULL
STR_INSTANCE_NAME = _modshogun.STR_INSTANCE_NAME
STR_GENERIC_NAME = _modshogun.STR_GENERIC_NAME
STR_CTYPE_NAME = _modshogun.STR_CTYPE_NAME
STR_LENGTH_X = _modshogun.STR_LENGTH_X
STR_LENGTH_Y = _modshogun.STR_LENGTH_Y
STR_GROUP_PREFIX = _modshogun.STR_GROUP_PREFIX
STR_SPARSE_VINDEX = _modshogun.STR_SPARSE_VINDEX
STR_SPARSE_FPTR = _modshogun.STR_SPARSE_FPTR
STR_SPARSEENTRY_FINDEX = _modshogun.STR_SPARSEENTRY_FINDEX
STR_SPARSEENTRY_ENTRY = _modshogun.STR_SPARSEENTRY_ENTRY
class SerializableHdf5File(SerializableFile):
    """Proxy of C++ shogun::CSerializableHdf5File class"""
    __swig_setmethods__ = {}
    for _s in [SerializableFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializableHdf5File, name, value)
    __swig_getmethods__ = {}
    for _s in [SerializableFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializableHdf5File, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SerializableHdf5File
        __init__(self, fname, rw = 'r') -> SerializableHdf5File
        __init__(self, fname) -> SerializableHdf5File
        """
        this = _modshogun.new_SerializableHdf5File(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SerializableHdf5File
    __del__ = lambda self : None;
SerializableHdf5File_swigregister = _modshogun.SerializableHdf5File_swigregister
SerializableHdf5File_swigregister(SerializableHdf5File)

STR_KEY_TYPE = _modshogun.STR_KEY_TYPE
STR_KEY_DATA = _modshogun.STR_KEY_DATA
STR_KEY_INSTANCE_NAME = _modshogun.STR_KEY_INSTANCE_NAME
STR_KEY_INSTANCE = _modshogun.STR_KEY_INSTANCE
STR_KEY_GENERIC_NAME = _modshogun.STR_KEY_GENERIC_NAME
STR_KEY_SPARSE_VECINDEX = _modshogun.STR_KEY_SPARSE_VECINDEX
STR_KEY_SPARSE_FEATURES = _modshogun.STR_KEY_SPARSE_FEATURES
STR_KEY_SPARSE_FEATINDEX = _modshogun.STR_KEY_SPARSE_FEATINDEX
STR_KEY_SPARSE_ENTRY = _modshogun.STR_KEY_SPARSE_ENTRY
class SerializableJsonFile(SerializableFile):
    """Proxy of C++ shogun::CSerializableJsonFile class"""
    __swig_setmethods__ = {}
    for _s in [SerializableFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializableJsonFile, name, value)
    __swig_getmethods__ = {}
    for _s in [SerializableFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializableJsonFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SerializableJsonFile
        __init__(self, fname, rw = 'r') -> SerializableJsonFile
        __init__(self, fname) -> SerializableJsonFile
        """
        this = _modshogun.new_SerializableJsonFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SerializableJsonFile
    __del__ = lambda self : None;
SerializableJsonFile_swigregister = _modshogun.SerializableJsonFile_swigregister
SerializableJsonFile_swigregister(SerializableJsonFile)

STR_TRUE = _modshogun.STR_TRUE
STR_FALSE = _modshogun.STR_FALSE
STR_ITEM = _modshogun.STR_ITEM
STR_STRING = _modshogun.STR_STRING
STR_SPARSE = _modshogun.STR_SPARSE
STR_PROP_TYPE = _modshogun.STR_PROP_TYPE
STR_PROP_IS_NULL = _modshogun.STR_PROP_IS_NULL
STR_PROP_INSTANCE_NAME = _modshogun.STR_PROP_INSTANCE_NAME
STR_PROP_GENERIC_NAME = _modshogun.STR_PROP_GENERIC_NAME
STR_PROP_VECINDEX = _modshogun.STR_PROP_VECINDEX
STR_PROP_FEATINDEX = _modshogun.STR_PROP_FEATINDEX
class SerializableXmlFile(SerializableFile):
    """Proxy of C++ shogun::CSerializableXmlFile class"""
    __swig_setmethods__ = {}
    for _s in [SerializableFile]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializableXmlFile, name, value)
    __swig_getmethods__ = {}
    for _s in [SerializableFile]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializableXmlFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SerializableXmlFile
        __init__(self, fname, rw = 'r', format = False) -> SerializableXmlFile
        __init__(self, fname, rw = 'r') -> SerializableXmlFile
        __init__(self, fname) -> SerializableXmlFile
        """
        this = _modshogun.new_SerializableXmlFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SerializableXmlFile
    __del__ = lambda self : None;
SerializableXmlFile_swigregister = _modshogun.SerializableXmlFile_swigregister
SerializableXmlFile_swigregister(SerializableXmlFile)

CT_SCALAR = _modshogun.CT_SCALAR
CT_VECTOR = _modshogun.CT_VECTOR
CT_MATRIX = _modshogun.CT_MATRIX
CT_NDARRAY = _modshogun.CT_NDARRAY
CT_SGVECTOR = _modshogun.CT_SGVECTOR
CT_SGMATRIX = _modshogun.CT_SGMATRIX
ST_NONE = _modshogun.ST_NONE
ST_STRING = _modshogun.ST_STRING
ST_SPARSE = _modshogun.ST_SPARSE
PT_BOOL = _modshogun.PT_BOOL
PT_CHAR = _modshogun.PT_CHAR
PT_INT8 = _modshogun.PT_INT8
PT_UINT8 = _modshogun.PT_UINT8
PT_INT16 = _modshogun.PT_INT16
PT_UINT16 = _modshogun.PT_UINT16
PT_INT32 = _modshogun.PT_INT32
PT_UINT32 = _modshogun.PT_UINT32
PT_INT64 = _modshogun.PT_INT64
PT_UINT64 = _modshogun.PT_UINT64
PT_FLOAT32 = _modshogun.PT_FLOAT32
PT_FLOAT64 = _modshogun.PT_FLOAT64
PT_FLOATMAX = _modshogun.PT_FLOATMAX
PT_SGOBJECT = _modshogun.PT_SGOBJECT
class BoolSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> BoolSparseVector
        __init__(self, feats, num_entries, index) -> BoolSparseVector
        __init__(self, num_entries, index, free_v = False) -> BoolSparseVector
        __init__(self, num_entries, index) -> BoolSparseVector
        __init__(self, orig) -> BoolSparseVector

        copy constructor 
        """
        this = _modshogun.new_BoolSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.BoolSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.BoolSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.BoolSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.BoolSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.BoolSparseVector_vec_index_get, _modshogun.BoolSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.BoolSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.BoolSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.BoolSparseVector_num_feat_entries_get, _modshogun.BoolSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.BoolSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.BoolSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.BoolSparseVector_do_free_get, _modshogun.BoolSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_BoolSparseVector
    __del__ = lambda self : None;
BoolSparseVector_swigregister = _modshogun.BoolSparseVector_swigregister
BoolSparseVector_swigregister(BoolSparseVector)

class CharSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> CharSparseVector
        __init__(self, feats, num_entries, index) -> CharSparseVector
        __init__(self, num_entries, index, free_v = False) -> CharSparseVector
        __init__(self, num_entries, index) -> CharSparseVector
        __init__(self, orig) -> CharSparseVector

        copy constructor 
        """
        this = _modshogun.new_CharSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.CharSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.CharSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.CharSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.CharSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.CharSparseVector_vec_index_get, _modshogun.CharSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.CharSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.CharSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.CharSparseVector_num_feat_entries_get, _modshogun.CharSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.CharSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.CharSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.CharSparseVector_do_free_get, _modshogun.CharSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_CharSparseVector
    __del__ = lambda self : None;
CharSparseVector_swigregister = _modshogun.CharSparseVector_swigregister
CharSparseVector_swigregister(CharSparseVector)

class ByteSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> ByteSparseVector
        __init__(self, feats, num_entries, index) -> ByteSparseVector
        __init__(self, num_entries, index, free_v = False) -> ByteSparseVector
        __init__(self, num_entries, index) -> ByteSparseVector
        __init__(self, orig) -> ByteSparseVector

        copy constructor 
        """
        this = _modshogun.new_ByteSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ByteSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ByteSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.ByteSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.ByteSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.ByteSparseVector_vec_index_get, _modshogun.ByteSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.ByteSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.ByteSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.ByteSparseVector_num_feat_entries_get, _modshogun.ByteSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.ByteSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ByteSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ByteSparseVector_do_free_get, _modshogun.ByteSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ByteSparseVector
    __del__ = lambda self : None;
ByteSparseVector_swigregister = _modshogun.ByteSparseVector_swigregister
ByteSparseVector_swigregister(ByteSparseVector)

class WordSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> WordSparseVector
        __init__(self, feats, num_entries, index) -> WordSparseVector
        __init__(self, num_entries, index, free_v = False) -> WordSparseVector
        __init__(self, num_entries, index) -> WordSparseVector
        __init__(self, orig) -> WordSparseVector

        copy constructor 
        """
        this = _modshogun.new_WordSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.WordSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.WordSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.WordSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.WordSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.WordSparseVector_vec_index_get, _modshogun.WordSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.WordSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.WordSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.WordSparseVector_num_feat_entries_get, _modshogun.WordSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.WordSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.WordSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.WordSparseVector_do_free_get, _modshogun.WordSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_WordSparseVector
    __del__ = lambda self : None;
WordSparseVector_swigregister = _modshogun.WordSparseVector_swigregister
WordSparseVector_swigregister(WordSparseVector)

class IntSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> IntSparseVector
        __init__(self, feats, num_entries, index) -> IntSparseVector
        __init__(self, num_entries, index, free_v = False) -> IntSparseVector
        __init__(self, num_entries, index) -> IntSparseVector
        __init__(self, orig) -> IntSparseVector

        copy constructor 
        """
        this = _modshogun.new_IntSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.IntSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.IntSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.IntSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.IntSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.IntSparseVector_vec_index_get, _modshogun.IntSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.IntSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.IntSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.IntSparseVector_num_feat_entries_get, _modshogun.IntSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.IntSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.IntSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.IntSparseVector_do_free_get, _modshogun.IntSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_IntSparseVector
    __del__ = lambda self : None;
IntSparseVector_swigregister = _modshogun.IntSparseVector_swigregister
IntSparseVector_swigregister(IntSparseVector)

class LongIntSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> LongIntSparseVector
        __init__(self, feats, num_entries, index) -> LongIntSparseVector
        __init__(self, num_entries, index, free_v = False) -> LongIntSparseVector
        __init__(self, num_entries, index) -> LongIntSparseVector
        __init__(self, orig) -> LongIntSparseVector

        copy constructor 
        """
        this = _modshogun.new_LongIntSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.LongIntSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.LongIntSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.LongIntSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.LongIntSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.LongIntSparseVector_vec_index_get, _modshogun.LongIntSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.LongIntSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.LongIntSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.LongIntSparseVector_num_feat_entries_get, _modshogun.LongIntSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.LongIntSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.LongIntSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.LongIntSparseVector_do_free_get, _modshogun.LongIntSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_LongIntSparseVector
    __del__ = lambda self : None;
LongIntSparseVector_swigregister = _modshogun.LongIntSparseVector_swigregister
LongIntSparseVector_swigregister(LongIntSparseVector)

class ULongIntSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> ULongIntSparseVector
        __init__(self, feats, num_entries, index) -> ULongIntSparseVector
        __init__(self, num_entries, index, free_v = False) -> ULongIntSparseVector
        __init__(self, num_entries, index) -> ULongIntSparseVector
        __init__(self, orig) -> ULongIntSparseVector

        copy constructor 
        """
        this = _modshogun.new_ULongIntSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ULongIntSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ULongIntSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.ULongIntSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.ULongIntSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.ULongIntSparseVector_vec_index_get, _modshogun.ULongIntSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.ULongIntSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.ULongIntSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.ULongIntSparseVector_num_feat_entries_get, _modshogun.ULongIntSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.ULongIntSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ULongIntSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ULongIntSparseVector_do_free_get, _modshogun.ULongIntSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ULongIntSparseVector
    __del__ = lambda self : None;
ULongIntSparseVector_swigregister = _modshogun.ULongIntSparseVector_swigregister
ULongIntSparseVector_swigregister(ULongIntSparseVector)

class ShortRealSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> ShortRealSparseVector
        __init__(self, feats, num_entries, index) -> ShortRealSparseVector
        __init__(self, num_entries, index, free_v = False) -> ShortRealSparseVector
        __init__(self, num_entries, index) -> ShortRealSparseVector
        __init__(self, orig) -> ShortRealSparseVector

        copy constructor 
        """
        this = _modshogun.new_ShortRealSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ShortRealSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ShortRealSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.ShortRealSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.ShortRealSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.ShortRealSparseVector_vec_index_get, _modshogun.ShortRealSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.ShortRealSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.ShortRealSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.ShortRealSparseVector_num_feat_entries_get, _modshogun.ShortRealSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.ShortRealSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ShortRealSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ShortRealSparseVector_do_free_get, _modshogun.ShortRealSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ShortRealSparseVector
    __del__ = lambda self : None;
ShortRealSparseVector_swigregister = _modshogun.ShortRealSparseVector_swigregister
ShortRealSparseVector_swigregister(ShortRealSparseVector)

class RealSparseVector(_object):
    """
    template class SGSparseVector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealSparseVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealSparseVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealSparseVector
        __init__(self, feats, num_entries, index, free_v = False) -> RealSparseVector
        __init__(self, feats, num_entries, index) -> RealSparseVector
        __init__(self, num_entries, index, free_v = False) -> RealSparseVector
        __init__(self, num_entries, index) -> RealSparseVector
        __init__(self, orig) -> RealSparseVector

        copy constructor 
        """
        this = _modshogun.new_RealSparseVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.RealSparseVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.RealSparseVector_destroy_vector(self)

    __swig_setmethods__["vec_index"] = _modshogun.RealSparseVector_vec_index_set
    __swig_getmethods__["vec_index"] = _modshogun.RealSparseVector_vec_index_get
    if _newclass:vec_index = _swig_property(_modshogun.RealSparseVector_vec_index_get, _modshogun.RealSparseVector_vec_index_set)
    __swig_setmethods__["num_feat_entries"] = _modshogun.RealSparseVector_num_feat_entries_set
    __swig_getmethods__["num_feat_entries"] = _modshogun.RealSparseVector_num_feat_entries_get
    if _newclass:num_feat_entries = _swig_property(_modshogun.RealSparseVector_num_feat_entries_get, _modshogun.RealSparseVector_num_feat_entries_set)
    __swig_setmethods__["do_free"] = _modshogun.RealSparseVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.RealSparseVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.RealSparseVector_do_free_get, _modshogun.RealSparseVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealSparseVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealSparseVector_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_RealSparseVector
    __del__ = lambda self : None;
RealSparseVector_swigregister = _modshogun.RealSparseVector_swigregister
RealSparseVector_swigregister(RealSparseVector)

class BoolSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> BoolSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> BoolSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> BoolSparseMatrix
        __init__(self, num_vec, num_feat) -> BoolSparseMatrix
        __init__(self, orig) -> BoolSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_BoolSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.BoolSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.BoolSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.BoolSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.BoolSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.BoolSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.BoolSparseMatrix_num_vectors_get, _modshogun.BoolSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.BoolSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.BoolSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.BoolSparseMatrix_num_features_get, _modshogun.BoolSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.BoolSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.BoolSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.BoolSparseMatrix_sparse_matrix_get, _modshogun.BoolSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.BoolSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.BoolSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.BoolSparseMatrix_do_free_get, _modshogun.BoolSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_BoolSparseMatrix
    __del__ = lambda self : None;
BoolSparseMatrix_swigregister = _modshogun.BoolSparseMatrix_swigregister
BoolSparseMatrix_swigregister(BoolSparseMatrix)

class CharSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> CharSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> CharSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> CharSparseMatrix
        __init__(self, num_vec, num_feat) -> CharSparseMatrix
        __init__(self, orig) -> CharSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_CharSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.CharSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.CharSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.CharSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.CharSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.CharSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.CharSparseMatrix_num_vectors_get, _modshogun.CharSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.CharSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.CharSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.CharSparseMatrix_num_features_get, _modshogun.CharSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.CharSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.CharSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.CharSparseMatrix_sparse_matrix_get, _modshogun.CharSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.CharSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.CharSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.CharSparseMatrix_do_free_get, _modshogun.CharSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_CharSparseMatrix
    __del__ = lambda self : None;
CharSparseMatrix_swigregister = _modshogun.CharSparseMatrix_swigregister
CharSparseMatrix_swigregister(CharSparseMatrix)

class ByteSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> ByteSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> ByteSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> ByteSparseMatrix
        __init__(self, num_vec, num_feat) -> ByteSparseMatrix
        __init__(self, orig) -> ByteSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_ByteSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ByteSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.ByteSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ByteSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.ByteSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.ByteSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.ByteSparseMatrix_num_vectors_get, _modshogun.ByteSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.ByteSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.ByteSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.ByteSparseMatrix_num_features_get, _modshogun.ByteSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.ByteSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.ByteSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.ByteSparseMatrix_sparse_matrix_get, _modshogun.ByteSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.ByteSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ByteSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ByteSparseMatrix_do_free_get, _modshogun.ByteSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ByteSparseMatrix
    __del__ = lambda self : None;
ByteSparseMatrix_swigregister = _modshogun.ByteSparseMatrix_swigregister
ByteSparseMatrix_swigregister(ByteSparseMatrix)

class WordSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> WordSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> WordSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> WordSparseMatrix
        __init__(self, num_vec, num_feat) -> WordSparseMatrix
        __init__(self, orig) -> WordSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_WordSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.WordSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.WordSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.WordSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.WordSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.WordSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.WordSparseMatrix_num_vectors_get, _modshogun.WordSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.WordSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.WordSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.WordSparseMatrix_num_features_get, _modshogun.WordSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.WordSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.WordSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.WordSparseMatrix_sparse_matrix_get, _modshogun.WordSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.WordSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.WordSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.WordSparseMatrix_do_free_get, _modshogun.WordSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_WordSparseMatrix
    __del__ = lambda self : None;
WordSparseMatrix_swigregister = _modshogun.WordSparseMatrix_swigregister
WordSparseMatrix_swigregister(WordSparseMatrix)

class IntSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> IntSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> IntSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> IntSparseMatrix
        __init__(self, num_vec, num_feat) -> IntSparseMatrix
        __init__(self, orig) -> IntSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_IntSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.IntSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.IntSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.IntSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.IntSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.IntSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.IntSparseMatrix_num_vectors_get, _modshogun.IntSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.IntSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.IntSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.IntSparseMatrix_num_features_get, _modshogun.IntSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.IntSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.IntSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.IntSparseMatrix_sparse_matrix_get, _modshogun.IntSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.IntSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.IntSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.IntSparseMatrix_do_free_get, _modshogun.IntSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_IntSparseMatrix
    __del__ = lambda self : None;
IntSparseMatrix_swigregister = _modshogun.IntSparseMatrix_swigregister
IntSparseMatrix_swigregister(IntSparseMatrix)

class LongIntSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> LongIntSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> LongIntSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> LongIntSparseMatrix
        __init__(self, num_vec, num_feat) -> LongIntSparseMatrix
        __init__(self, orig) -> LongIntSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_LongIntSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.LongIntSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.LongIntSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.LongIntSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.LongIntSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.LongIntSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.LongIntSparseMatrix_num_vectors_get, _modshogun.LongIntSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.LongIntSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.LongIntSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.LongIntSparseMatrix_num_features_get, _modshogun.LongIntSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.LongIntSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.LongIntSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.LongIntSparseMatrix_sparse_matrix_get, _modshogun.LongIntSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.LongIntSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.LongIntSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.LongIntSparseMatrix_do_free_get, _modshogun.LongIntSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_LongIntSparseMatrix
    __del__ = lambda self : None;
LongIntSparseMatrix_swigregister = _modshogun.LongIntSparseMatrix_swigregister
LongIntSparseMatrix_swigregister(LongIntSparseMatrix)

class ULongIntSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> ULongIntSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> ULongIntSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> ULongIntSparseMatrix
        __init__(self, num_vec, num_feat) -> ULongIntSparseMatrix
        __init__(self, orig) -> ULongIntSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_ULongIntSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ULongIntSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.ULongIntSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ULongIntSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.ULongIntSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.ULongIntSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.ULongIntSparseMatrix_num_vectors_get, _modshogun.ULongIntSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.ULongIntSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.ULongIntSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.ULongIntSparseMatrix_num_features_get, _modshogun.ULongIntSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.ULongIntSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.ULongIntSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.ULongIntSparseMatrix_sparse_matrix_get, _modshogun.ULongIntSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.ULongIntSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ULongIntSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ULongIntSparseMatrix_do_free_get, _modshogun.ULongIntSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ULongIntSparseMatrix
    __del__ = lambda self : None;
ULongIntSparseMatrix_swigregister = _modshogun.ULongIntSparseMatrix_swigregister
ULongIntSparseMatrix_swigregister(ULongIntSparseMatrix)

class ShortRealSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> ShortRealSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> ShortRealSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> ShortRealSparseMatrix
        __init__(self, num_vec, num_feat) -> ShortRealSparseMatrix
        __init__(self, orig) -> ShortRealSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_ShortRealSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ShortRealSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.ShortRealSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ShortRealSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.ShortRealSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.ShortRealSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.ShortRealSparseMatrix_num_vectors_get, _modshogun.ShortRealSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.ShortRealSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.ShortRealSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.ShortRealSparseMatrix_num_features_get, _modshogun.ShortRealSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.ShortRealSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.ShortRealSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.ShortRealSparseMatrix_sparse_matrix_get, _modshogun.ShortRealSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.ShortRealSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ShortRealSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ShortRealSparseMatrix_do_free_get, _modshogun.ShortRealSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ShortRealSparseMatrix
    __del__ = lambda self : None;
ShortRealSparseMatrix_swigregister = _modshogun.ShortRealSparseMatrix_swigregister
ShortRealSparseMatrix_swigregister(ShortRealSparseMatrix)

class RealSparseMatrix(_object):
    """
    template class SGSparseMatrix

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealSparseMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealSparseMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealSparseMatrix
        __init__(self, vecs, num_feat, num_vec, free_m = False) -> RealSparseMatrix
        __init__(self, vecs, num_feat, num_vec) -> RealSparseMatrix
        __init__(self, num_vec, num_feat, free_m = False) -> RealSparseMatrix
        __init__(self, num_vec, num_feat) -> RealSparseMatrix
        __init__(self, orig) -> RealSparseMatrix

        copy constructor 
        """
        this = _modshogun.new_RealSparseMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.RealSparseMatrix_free_matrix(self)

    def own_matrix(self):
        """
        own_matrix(self)

        own matrix 
        """
        return _modshogun.RealSparseMatrix_own_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.RealSparseMatrix_destroy_matrix(self)

    __swig_setmethods__["num_vectors"] = _modshogun.RealSparseMatrix_num_vectors_set
    __swig_getmethods__["num_vectors"] = _modshogun.RealSparseMatrix_num_vectors_get
    if _newclass:num_vectors = _swig_property(_modshogun.RealSparseMatrix_num_vectors_get, _modshogun.RealSparseMatrix_num_vectors_set)
    __swig_setmethods__["num_features"] = _modshogun.RealSparseMatrix_num_features_set
    __swig_getmethods__["num_features"] = _modshogun.RealSparseMatrix_num_features_get
    if _newclass:num_features = _swig_property(_modshogun.RealSparseMatrix_num_features_get, _modshogun.RealSparseMatrix_num_features_set)
    __swig_setmethods__["sparse_matrix"] = _modshogun.RealSparseMatrix_sparse_matrix_set
    __swig_getmethods__["sparse_matrix"] = _modshogun.RealSparseMatrix_sparse_matrix_get
    if _newclass:sparse_matrix = _swig_property(_modshogun.RealSparseMatrix_sparse_matrix_get, _modshogun.RealSparseMatrix_sparse_matrix_set)
    __swig_setmethods__["do_free"] = _modshogun.RealSparseMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.RealSparseMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.RealSparseMatrix_do_free_get, _modshogun.RealSparseMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealSparseMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealSparseMatrix_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_RealSparseMatrix
    __del__ = lambda self : None;
RealSparseMatrix_swigregister = _modshogun.RealSparseMatrix_swigregister
RealSparseMatrix_swigregister(RealSparseMatrix)

class BoolStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> BoolStringList
        __init__(self, s, num_s, max_length) -> BoolStringList
        __init__(self, num_s, max_length, free_strings = False) -> BoolStringList
        __init__(self, num_s, max_length) -> BoolStringList
        __init__(self, orig) -> BoolStringList

        copy constructor 
        """
        this = _modshogun.new_BoolStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.BoolStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.BoolStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.BoolStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.BoolStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.BoolStringList_num_strings_get, _modshogun.BoolStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.BoolStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.BoolStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.BoolStringList_max_string_length_get, _modshogun.BoolStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.BoolStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.BoolStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.BoolStringList_strings_get, _modshogun.BoolStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.BoolStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.BoolStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.BoolStringList_do_free_get, _modshogun.BoolStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_BoolStringList
    __del__ = lambda self : None;
BoolStringList_swigregister = _modshogun.BoolStringList_swigregister
BoolStringList_swigregister(BoolStringList)

class CharStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> CharStringList
        __init__(self, s, num_s, max_length) -> CharStringList
        __init__(self, num_s, max_length, free_strings = False) -> CharStringList
        __init__(self, num_s, max_length) -> CharStringList
        __init__(self, orig) -> CharStringList

        copy constructor 
        """
        this = _modshogun.new_CharStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.CharStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.CharStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.CharStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.CharStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.CharStringList_num_strings_get, _modshogun.CharStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.CharStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.CharStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.CharStringList_max_string_length_get, _modshogun.CharStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.CharStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.CharStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.CharStringList_strings_get, _modshogun.CharStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.CharStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.CharStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.CharStringList_do_free_get, _modshogun.CharStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_CharStringList
    __del__ = lambda self : None;
CharStringList_swigregister = _modshogun.CharStringList_swigregister
CharStringList_swigregister(CharStringList)

class ByteStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> ByteStringList
        __init__(self, s, num_s, max_length) -> ByteStringList
        __init__(self, num_s, max_length, free_strings = False) -> ByteStringList
        __init__(self, num_s, max_length) -> ByteStringList
        __init__(self, orig) -> ByteStringList

        copy constructor 
        """
        this = _modshogun.new_ByteStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.ByteStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.ByteStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.ByteStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.ByteStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.ByteStringList_num_strings_get, _modshogun.ByteStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.ByteStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.ByteStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.ByteStringList_max_string_length_get, _modshogun.ByteStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.ByteStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.ByteStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.ByteStringList_strings_get, _modshogun.ByteStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.ByteStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ByteStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ByteStringList_do_free_get, _modshogun.ByteStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ByteStringList
    __del__ = lambda self : None;
ByteStringList_swigregister = _modshogun.ByteStringList_swigregister
ByteStringList_swigregister(ByteStringList)

class WordStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> WordStringList
        __init__(self, s, num_s, max_length) -> WordStringList
        __init__(self, num_s, max_length, free_strings = False) -> WordStringList
        __init__(self, num_s, max_length) -> WordStringList
        __init__(self, orig) -> WordStringList

        copy constructor 
        """
        this = _modshogun.new_WordStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.WordStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.WordStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.WordStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.WordStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.WordStringList_num_strings_get, _modshogun.WordStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.WordStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.WordStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.WordStringList_max_string_length_get, _modshogun.WordStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.WordStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.WordStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.WordStringList_strings_get, _modshogun.WordStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.WordStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.WordStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.WordStringList_do_free_get, _modshogun.WordStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_WordStringList
    __del__ = lambda self : None;
WordStringList_swigregister = _modshogun.WordStringList_swigregister
WordStringList_swigregister(WordStringList)

class IntStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> IntStringList
        __init__(self, s, num_s, max_length) -> IntStringList
        __init__(self, num_s, max_length, free_strings = False) -> IntStringList
        __init__(self, num_s, max_length) -> IntStringList
        __init__(self, orig) -> IntStringList

        copy constructor 
        """
        this = _modshogun.new_IntStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.IntStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.IntStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.IntStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.IntStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.IntStringList_num_strings_get, _modshogun.IntStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.IntStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.IntStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.IntStringList_max_string_length_get, _modshogun.IntStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.IntStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.IntStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.IntStringList_strings_get, _modshogun.IntStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.IntStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.IntStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.IntStringList_do_free_get, _modshogun.IntStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_IntStringList
    __del__ = lambda self : None;
IntStringList_swigregister = _modshogun.IntStringList_swigregister
IntStringList_swigregister(IntStringList)

class LongIntStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> LongIntStringList
        __init__(self, s, num_s, max_length) -> LongIntStringList
        __init__(self, num_s, max_length, free_strings = False) -> LongIntStringList
        __init__(self, num_s, max_length) -> LongIntStringList
        __init__(self, orig) -> LongIntStringList

        copy constructor 
        """
        this = _modshogun.new_LongIntStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.LongIntStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.LongIntStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.LongIntStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.LongIntStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.LongIntStringList_num_strings_get, _modshogun.LongIntStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.LongIntStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.LongIntStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.LongIntStringList_max_string_length_get, _modshogun.LongIntStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.LongIntStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.LongIntStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.LongIntStringList_strings_get, _modshogun.LongIntStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.LongIntStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.LongIntStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.LongIntStringList_do_free_get, _modshogun.LongIntStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_LongIntStringList
    __del__ = lambda self : None;
LongIntStringList_swigregister = _modshogun.LongIntStringList_swigregister
LongIntStringList_swigregister(LongIntStringList)

class ULongIntStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> ULongIntStringList
        __init__(self, s, num_s, max_length) -> ULongIntStringList
        __init__(self, num_s, max_length, free_strings = False) -> ULongIntStringList
        __init__(self, num_s, max_length) -> ULongIntStringList
        __init__(self, orig) -> ULongIntStringList

        copy constructor 
        """
        this = _modshogun.new_ULongIntStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.ULongIntStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.ULongIntStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.ULongIntStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.ULongIntStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.ULongIntStringList_num_strings_get, _modshogun.ULongIntStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.ULongIntStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.ULongIntStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.ULongIntStringList_max_string_length_get, _modshogun.ULongIntStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.ULongIntStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.ULongIntStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.ULongIntStringList_strings_get, _modshogun.ULongIntStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.ULongIntStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ULongIntStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ULongIntStringList_do_free_get, _modshogun.ULongIntStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ULongIntStringList
    __del__ = lambda self : None;
ULongIntStringList_swigregister = _modshogun.ULongIntStringList_swigregister
ULongIntStringList_swigregister(ULongIntStringList)

class ShortRealStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> ShortRealStringList
        __init__(self, s, num_s, max_length) -> ShortRealStringList
        __init__(self, num_s, max_length, free_strings = False) -> ShortRealStringList
        __init__(self, num_s, max_length) -> ShortRealStringList
        __init__(self, orig) -> ShortRealStringList

        copy constructor 
        """
        this = _modshogun.new_ShortRealStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.ShortRealStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.ShortRealStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.ShortRealStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.ShortRealStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.ShortRealStringList_num_strings_get, _modshogun.ShortRealStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.ShortRealStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.ShortRealStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.ShortRealStringList_max_string_length_get, _modshogun.ShortRealStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.ShortRealStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.ShortRealStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.ShortRealStringList_strings_get, _modshogun.ShortRealStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.ShortRealStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ShortRealStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ShortRealStringList_do_free_get, _modshogun.ShortRealStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ShortRealStringList
    __del__ = lambda self : None;
ShortRealStringList_swigregister = _modshogun.ShortRealStringList_swigregister
ShortRealStringList_swigregister(ShortRealStringList)

class RealStringList(_object):
    """
    template class SGStringList

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealStringList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealStringList, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealStringList
        __init__(self, s, num_s, max_length, free_strings = False) -> RealStringList
        __init__(self, s, num_s, max_length) -> RealStringList
        __init__(self, num_s, max_length, free_strings = False) -> RealStringList
        __init__(self, num_s, max_length) -> RealStringList
        __init__(self, orig) -> RealStringList

        copy constructor 
        """
        this = _modshogun.new_RealStringList(*args)
        try: self.this.append(this)
        except: self.this = this
    def free_list(self):
        """
        free_list(self)

        free list 
        """
        return _modshogun.RealStringList_free_list(self)

    def destroy_list(self):
        """
        destroy_list(self)

        destroy list 
        """
        return _modshogun.RealStringList_destroy_list(self)

    __swig_setmethods__["num_strings"] = _modshogun.RealStringList_num_strings_set
    __swig_getmethods__["num_strings"] = _modshogun.RealStringList_num_strings_get
    if _newclass:num_strings = _swig_property(_modshogun.RealStringList_num_strings_get, _modshogun.RealStringList_num_strings_set)
    __swig_setmethods__["max_string_length"] = _modshogun.RealStringList_max_string_length_set
    __swig_getmethods__["max_string_length"] = _modshogun.RealStringList_max_string_length_get
    if _newclass:max_string_length = _swig_property(_modshogun.RealStringList_max_string_length_get, _modshogun.RealStringList_max_string_length_set)
    __swig_setmethods__["strings"] = _modshogun.RealStringList_strings_set
    __swig_getmethods__["strings"] = _modshogun.RealStringList_strings_get
    if _newclass:strings = _swig_property(_modshogun.RealStringList_strings_get, _modshogun.RealStringList_strings_set)
    __swig_setmethods__["do_free"] = _modshogun.RealStringList_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.RealStringList_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.RealStringList_do_free_get, _modshogun.RealStringList_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealStringList_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealStringList_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_RealStringList
    __del__ = lambda self : None;
RealStringList_swigregister = _modshogun.RealStringList_swigregister
RealStringList_swigregister(RealStringList)

class BoolVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolVector
        __init__(self, v, len, free_vec = False) -> BoolVector
        __init__(self, v, len) -> BoolVector
        __init__(self, len, free_vec = False) -> BoolVector
        __init__(self, len) -> BoolVector
        __init__(self, orig) -> BoolVector

        copy constructor 
        """
        this = _modshogun.new_BoolVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BoolVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> BoolVector
        get_vector(src) -> BoolVector
        """
        return _modshogun.BoolVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.BoolVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.BoolVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.BoolVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.BoolVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.BoolVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> bool

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.BoolVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.BoolVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.BoolVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.BoolVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.BoolVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.BoolVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.BoolVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.BoolVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.BoolVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.BoolVector_vector_get, _modshogun.BoolVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.BoolVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.BoolVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.BoolVector_vlen_get, _modshogun.BoolVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.BoolVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.BoolVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.BoolVector_do_free_get, _modshogun.BoolVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolVector_load_serializable(self, *args)

BoolVector_swigregister = _modshogun.BoolVector_swigregister
BoolVector_swigregister(BoolVector)

def BoolVector_get_vector(*args):
  """
    get_vector(src, own = True) -> BoolVector
    BoolVector_get_vector(src) -> BoolVector
    """
  return _modshogun.BoolVector_get_vector(*args)

class CharVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharVector
        __init__(self, v, len, free_vec = False) -> CharVector
        __init__(self, v, len) -> CharVector
        __init__(self, len, free_vec = False) -> CharVector
        __init__(self, len) -> CharVector
        __init__(self, orig) -> CharVector

        copy constructor 
        """
        this = _modshogun.new_CharVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CharVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> CharVector
        get_vector(src) -> CharVector
        """
        return _modshogun.CharVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.CharVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.CharVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.CharVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.CharVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.CharVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> str

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.CharVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.CharVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.CharVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.CharVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.CharVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.CharVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.CharVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.CharVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.CharVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.CharVector_vector_get, _modshogun.CharVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.CharVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.CharVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.CharVector_vlen_get, _modshogun.CharVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.CharVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.CharVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.CharVector_do_free_get, _modshogun.CharVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharVector_load_serializable(self, *args)

CharVector_swigregister = _modshogun.CharVector_swigregister
CharVector_swigregister(CharVector)

def CharVector_get_vector(*args):
  """
    get_vector(src, own = True) -> CharVector
    CharVector_get_vector(src) -> CharVector
    """
  return _modshogun.CharVector_get_vector(*args)

class ByteVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteVector
        __init__(self, v, len, free_vec = False) -> ByteVector
        __init__(self, v, len) -> ByteVector
        __init__(self, len, free_vec = False) -> ByteVector
        __init__(self, len) -> ByteVector
        __init__(self, orig) -> ByteVector

        copy constructor 
        """
        this = _modshogun.new_ByteVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ByteVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> ByteVector
        get_vector(src) -> ByteVector
        """
        return _modshogun.ByteVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.ByteVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.ByteVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.ByteVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.ByteVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.ByteVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned str

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.ByteVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.ByteVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.ByteVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ByteVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ByteVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.ByteVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.ByteVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.ByteVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.ByteVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.ByteVector_vector_get, _modshogun.ByteVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.ByteVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.ByteVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.ByteVector_vlen_get, _modshogun.ByteVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.ByteVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ByteVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ByteVector_do_free_get, _modshogun.ByteVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteVector_load_serializable(self, *args)

ByteVector_swigregister = _modshogun.ByteVector_swigregister
ByteVector_swigregister(ByteVector)

def ByteVector_get_vector(*args):
  """
    get_vector(src, own = True) -> ByteVector
    ByteVector_get_vector(src) -> ByteVector
    """
  return _modshogun.ByteVector_get_vector(*args)

class WordVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordVector
        __init__(self, v, len, free_vec = False) -> WordVector
        __init__(self, v, len) -> WordVector
        __init__(self, len, free_vec = False) -> WordVector
        __init__(self, len) -> WordVector
        __init__(self, orig) -> WordVector

        copy constructor 
        """
        this = _modshogun.new_WordVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WordVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> WordVector
        get_vector(src) -> WordVector
        """
        return _modshogun.WordVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.WordVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.WordVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.WordVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.WordVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.WordVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned short

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.WordVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.WordVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.WordVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.WordVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.WordVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.WordVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.WordVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.WordVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.WordVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.WordVector_vector_get, _modshogun.WordVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.WordVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.WordVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.WordVector_vlen_get, _modshogun.WordVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.WordVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.WordVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.WordVector_do_free_get, _modshogun.WordVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordVector_load_serializable(self, *args)

WordVector_swigregister = _modshogun.WordVector_swigregister
WordVector_swigregister(WordVector)

def WordVector_get_vector(*args):
  """
    get_vector(src, own = True) -> WordVector
    WordVector_get_vector(src) -> WordVector
    """
  return _modshogun.WordVector_get_vector(*args)

class IntVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntVector
        __init__(self, v, len, free_vec = False) -> IntVector
        __init__(self, v, len) -> IntVector
        __init__(self, len, free_vec = False) -> IntVector
        __init__(self, len) -> IntVector
        __init__(self, orig) -> IntVector

        copy constructor 
        """
        this = _modshogun.new_IntVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_IntVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> IntVector
        get_vector(src) -> IntVector
        """
        return _modshogun.IntVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.IntVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.IntVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.IntVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.IntVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.IntVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> int

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.IntVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.IntVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.IntVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.IntVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.IntVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.IntVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.IntVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.IntVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.IntVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.IntVector_vector_get, _modshogun.IntVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.IntVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.IntVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.IntVector_vlen_get, _modshogun.IntVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.IntVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.IntVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.IntVector_do_free_get, _modshogun.IntVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntVector_load_serializable(self, *args)

IntVector_swigregister = _modshogun.IntVector_swigregister
IntVector_swigregister(IntVector)

def IntVector_get_vector(*args):
  """
    get_vector(src, own = True) -> IntVector
    IntVector_get_vector(src) -> IntVector
    """
  return _modshogun.IntVector_get_vector(*args)

class LongIntVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntVector
        __init__(self, v, len, free_vec = False) -> LongIntVector
        __init__(self, v, len) -> LongIntVector
        __init__(self, len, free_vec = False) -> LongIntVector
        __init__(self, len) -> LongIntVector
        __init__(self, orig) -> LongIntVector

        copy constructor 
        """
        this = _modshogun.new_LongIntVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LongIntVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> LongIntVector
        get_vector(src) -> LongIntVector
        """
        return _modshogun.LongIntVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.LongIntVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.LongIntVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.LongIntVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.LongIntVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.LongIntVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> long long

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.LongIntVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.LongIntVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.LongIntVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.LongIntVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.LongIntVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.LongIntVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.LongIntVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.LongIntVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.LongIntVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.LongIntVector_vector_get, _modshogun.LongIntVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.LongIntVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.LongIntVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.LongIntVector_vlen_get, _modshogun.LongIntVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.LongIntVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.LongIntVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.LongIntVector_do_free_get, _modshogun.LongIntVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntVector_load_serializable(self, *args)

LongIntVector_swigregister = _modshogun.LongIntVector_swigregister
LongIntVector_swigregister(LongIntVector)

def LongIntVector_get_vector(*args):
  """
    get_vector(src, own = True) -> LongIntVector
    LongIntVector_get_vector(src) -> LongIntVector
    """
  return _modshogun.LongIntVector_get_vector(*args)

class ULongIntVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntVector
        __init__(self, v, len, free_vec = False) -> ULongIntVector
        __init__(self, v, len) -> ULongIntVector
        __init__(self, len, free_vec = False) -> ULongIntVector
        __init__(self, len) -> ULongIntVector
        __init__(self, orig) -> ULongIntVector

        copy constructor 
        """
        this = _modshogun.new_ULongIntVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ULongIntVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> ULongIntVector
        get_vector(src) -> ULongIntVector
        """
        return _modshogun.ULongIntVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.ULongIntVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.ULongIntVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.ULongIntVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.ULongIntVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.ULongIntVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned long long

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.ULongIntVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.ULongIntVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.ULongIntVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ULongIntVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ULongIntVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.ULongIntVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.ULongIntVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.ULongIntVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.ULongIntVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.ULongIntVector_vector_get, _modshogun.ULongIntVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.ULongIntVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.ULongIntVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.ULongIntVector_vlen_get, _modshogun.ULongIntVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.ULongIntVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ULongIntVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ULongIntVector_do_free_get, _modshogun.ULongIntVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntVector_load_serializable(self, *args)

ULongIntVector_swigregister = _modshogun.ULongIntVector_swigregister
ULongIntVector_swigregister(ULongIntVector)

def ULongIntVector_get_vector(*args):
  """
    get_vector(src, own = True) -> ULongIntVector
    ULongIntVector_get_vector(src) -> ULongIntVector
    """
  return _modshogun.ULongIntVector_get_vector(*args)

class ShortRealVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealVector
        __init__(self, v, len, free_vec = False) -> ShortRealVector
        __init__(self, v, len) -> ShortRealVector
        __init__(self, len, free_vec = False) -> ShortRealVector
        __init__(self, len) -> ShortRealVector
        __init__(self, orig) -> ShortRealVector

        copy constructor 
        """
        this = _modshogun.new_ShortRealVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ShortRealVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> ShortRealVector
        get_vector(src) -> ShortRealVector
        """
        return _modshogun.ShortRealVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.ShortRealVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.ShortRealVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.ShortRealVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.ShortRealVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.ShortRealVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.ShortRealVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.ShortRealVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.ShortRealVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.ShortRealVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.ShortRealVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.ShortRealVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.ShortRealVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.ShortRealVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.ShortRealVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.ShortRealVector_vector_get, _modshogun.ShortRealVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.ShortRealVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.ShortRealVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.ShortRealVector_vlen_get, _modshogun.ShortRealVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.ShortRealVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ShortRealVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ShortRealVector_do_free_get, _modshogun.ShortRealVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealVector_load_serializable(self, *args)

ShortRealVector_swigregister = _modshogun.ShortRealVector_swigregister
ShortRealVector_swigregister(ShortRealVector)

def ShortRealVector_get_vector(*args):
  """
    get_vector(src, own = True) -> ShortRealVector
    ShortRealVector_get_vector(src) -> ShortRealVector
    """
  return _modshogun.ShortRealVector_get_vector(*args)

class RealVector(_object):
    """
    shogun vector

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealVector
        __init__(self, v, len, free_vec = False) -> RealVector
        __init__(self, v, len) -> RealVector
        __init__(self, len, free_vec = False) -> RealVector
        __init__(self, len) -> RealVector
        __init__(self, orig) -> RealVector

        copy constructor 
        """
        this = _modshogun.new_RealVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RealVector
    __del__ = lambda self : None;
    def get_vector(*args):
        """
        get_vector(src, own = True) -> RealVector
        get_vector(src) -> RealVector
        """
        return _modshogun.RealVector_get_vector(*args)

    if _newclass:get_vector = staticmethod(get_vector)
    __swig_getmethods__["get_vector"] = lambda x: get_vector
    def zero(self):
        """
        zero(self)

        fill vector with zeros 
        """
        return _modshogun.RealVector_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set vector to a constant 
        """
        return _modshogun.RealVector_set_const(self, *args)

    def range_fill(self, start = 0):
        """
        range_fill(self, start = 0)
        range_fill(self)

        range fill 
        """
        return _modshogun.RealVector_range_fill(self, start)

    def random(self, *args):
        """
        random(self, min_value, max_value)

        random 
        """
        return _modshogun.RealVector_random(self, *args)

    def randperm(self):
        """
        randperm(self)

        random permutate 
        """
        return _modshogun.RealVector_randperm(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get vector element at index

        Parameters:
        -----------

        index:  index

        vector element at index 
        """
        return _modshogun.RealVector_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index)

        set vector element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  vector element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.RealVector_set_element(self, *args)

    def resize_vector(self, *args):
        """
        resize_vector(self, n)

        resize vector

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.RealVector_resize_vector(self, *args)

    def free_vector(self):
        """
        free_vector(self)

        free vector 
        """
        return _modshogun.RealVector_free_vector(self)

    def destroy_vector(self):
        """
        destroy_vector(self)

        destroy vector 
        """
        return _modshogun.RealVector_destroy_vector(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _modshogun.RealVector_display_size(self)

    def display_vector(self):
        """
        display_vector(self)

        display array 
        """
        return _modshogun.RealVector_display_vector(self)

    __swig_setmethods__["vector"] = _modshogun.RealVector_vector_set
    __swig_getmethods__["vector"] = _modshogun.RealVector_vector_get
    if _newclass:vector = _swig_property(_modshogun.RealVector_vector_get, _modshogun.RealVector_vector_set)
    __swig_setmethods__["vlen"] = _modshogun.RealVector_vlen_set
    __swig_getmethods__["vlen"] = _modshogun.RealVector_vlen_get
    if _newclass:vlen = _swig_property(_modshogun.RealVector_vlen_get, _modshogun.RealVector_vlen_set)
    __swig_setmethods__["do_free"] = _modshogun.RealVector_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.RealVector_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.RealVector_do_free_get, _modshogun.RealVector_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealVector_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealVector_load_serializable(self, *args)

RealVector_swigregister = _modshogun.RealVector_swigregister
RealVector_swigregister(RealVector)

def RealVector_get_vector(*args):
  """
    get_vector(src, own = True) -> RealVector
    RealVector_get_vector(src) -> RealVector
    """
  return _modshogun.RealVector_get_vector(*args)

class BoolMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> BoolMatrix
        __init__(self, m, nrows, ncols) -> BoolMatrix
        __init__(self, nrows, ncols, free_mat = False) -> BoolMatrix
        __init__(self, nrows, ncols) -> BoolMatrix
        __init__(self, orig) -> BoolMatrix

        copy constructor 
        """
        this = _modshogun.new_BoolMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BoolMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.BoolMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.BoolMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.BoolMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.BoolMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.BoolMatrix_matrix_get, _modshogun.BoolMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.BoolMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.BoolMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.BoolMatrix_num_rows_get, _modshogun.BoolMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.BoolMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.BoolMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.BoolMatrix_num_cols_get, _modshogun.BoolMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.BoolMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.BoolMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.BoolMatrix_do_free_get, _modshogun.BoolMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolMatrix_load_serializable(self, *args)

BoolMatrix_swigregister = _modshogun.BoolMatrix_swigregister
BoolMatrix_swigregister(BoolMatrix)

class CharMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> CharMatrix
        __init__(self, m, nrows, ncols) -> CharMatrix
        __init__(self, nrows, ncols, free_mat = False) -> CharMatrix
        __init__(self, nrows, ncols) -> CharMatrix
        __init__(self, orig) -> CharMatrix

        copy constructor 
        """
        this = _modshogun.new_CharMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CharMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.CharMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.CharMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.CharMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.CharMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.CharMatrix_matrix_get, _modshogun.CharMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.CharMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.CharMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.CharMatrix_num_rows_get, _modshogun.CharMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.CharMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.CharMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.CharMatrix_num_cols_get, _modshogun.CharMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.CharMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.CharMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.CharMatrix_do_free_get, _modshogun.CharMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharMatrix_load_serializable(self, *args)

CharMatrix_swigregister = _modshogun.CharMatrix_swigregister
CharMatrix_swigregister(CharMatrix)

class ByteMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> ByteMatrix
        __init__(self, m, nrows, ncols) -> ByteMatrix
        __init__(self, nrows, ncols, free_mat = False) -> ByteMatrix
        __init__(self, nrows, ncols) -> ByteMatrix
        __init__(self, orig) -> ByteMatrix

        copy constructor 
        """
        this = _modshogun.new_ByteMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ByteMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ByteMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ByteMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.ByteMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.ByteMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.ByteMatrix_matrix_get, _modshogun.ByteMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.ByteMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.ByteMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.ByteMatrix_num_rows_get, _modshogun.ByteMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.ByteMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.ByteMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.ByteMatrix_num_cols_get, _modshogun.ByteMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.ByteMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ByteMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ByteMatrix_do_free_get, _modshogun.ByteMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteMatrix_load_serializable(self, *args)

ByteMatrix_swigregister = _modshogun.ByteMatrix_swigregister
ByteMatrix_swigregister(ByteMatrix)

class WordMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> WordMatrix
        __init__(self, m, nrows, ncols) -> WordMatrix
        __init__(self, nrows, ncols, free_mat = False) -> WordMatrix
        __init__(self, nrows, ncols) -> WordMatrix
        __init__(self, orig) -> WordMatrix

        copy constructor 
        """
        this = _modshogun.new_WordMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WordMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.WordMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.WordMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.WordMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.WordMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.WordMatrix_matrix_get, _modshogun.WordMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.WordMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.WordMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.WordMatrix_num_rows_get, _modshogun.WordMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.WordMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.WordMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.WordMatrix_num_cols_get, _modshogun.WordMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.WordMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.WordMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.WordMatrix_do_free_get, _modshogun.WordMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordMatrix_load_serializable(self, *args)

WordMatrix_swigregister = _modshogun.WordMatrix_swigregister
WordMatrix_swigregister(WordMatrix)

class IntMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> IntMatrix
        __init__(self, m, nrows, ncols) -> IntMatrix
        __init__(self, nrows, ncols, free_mat = False) -> IntMatrix
        __init__(self, nrows, ncols) -> IntMatrix
        __init__(self, orig) -> IntMatrix

        copy constructor 
        """
        this = _modshogun.new_IntMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_IntMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.IntMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.IntMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.IntMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.IntMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.IntMatrix_matrix_get, _modshogun.IntMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.IntMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.IntMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.IntMatrix_num_rows_get, _modshogun.IntMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.IntMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.IntMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.IntMatrix_num_cols_get, _modshogun.IntMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.IntMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.IntMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.IntMatrix_do_free_get, _modshogun.IntMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntMatrix_load_serializable(self, *args)

IntMatrix_swigregister = _modshogun.IntMatrix_swigregister
IntMatrix_swigregister(IntMatrix)

class LongIntMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> LongIntMatrix
        __init__(self, m, nrows, ncols) -> LongIntMatrix
        __init__(self, nrows, ncols, free_mat = False) -> LongIntMatrix
        __init__(self, nrows, ncols) -> LongIntMatrix
        __init__(self, orig) -> LongIntMatrix

        copy constructor 
        """
        this = _modshogun.new_LongIntMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LongIntMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.LongIntMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.LongIntMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.LongIntMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.LongIntMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.LongIntMatrix_matrix_get, _modshogun.LongIntMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.LongIntMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.LongIntMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.LongIntMatrix_num_rows_get, _modshogun.LongIntMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.LongIntMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.LongIntMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.LongIntMatrix_num_cols_get, _modshogun.LongIntMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.LongIntMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.LongIntMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.LongIntMatrix_do_free_get, _modshogun.LongIntMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntMatrix_load_serializable(self, *args)

LongIntMatrix_swigregister = _modshogun.LongIntMatrix_swigregister
LongIntMatrix_swigregister(LongIntMatrix)

class ULongIntMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> ULongIntMatrix
        __init__(self, m, nrows, ncols) -> ULongIntMatrix
        __init__(self, nrows, ncols, free_mat = False) -> ULongIntMatrix
        __init__(self, nrows, ncols) -> ULongIntMatrix
        __init__(self, orig) -> ULongIntMatrix

        copy constructor 
        """
        this = _modshogun.new_ULongIntMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ULongIntMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ULongIntMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ULongIntMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.ULongIntMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.ULongIntMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.ULongIntMatrix_matrix_get, _modshogun.ULongIntMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.ULongIntMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.ULongIntMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.ULongIntMatrix_num_rows_get, _modshogun.ULongIntMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.ULongIntMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.ULongIntMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.ULongIntMatrix_num_cols_get, _modshogun.ULongIntMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.ULongIntMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ULongIntMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ULongIntMatrix_do_free_get, _modshogun.ULongIntMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntMatrix_load_serializable(self, *args)

ULongIntMatrix_swigregister = _modshogun.ULongIntMatrix_swigregister
ULongIntMatrix_swigregister(ULongIntMatrix)

class ShortRealMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> ShortRealMatrix
        __init__(self, m, nrows, ncols) -> ShortRealMatrix
        __init__(self, nrows, ncols, free_mat = False) -> ShortRealMatrix
        __init__(self, nrows, ncols) -> ShortRealMatrix
        __init__(self, orig) -> ShortRealMatrix

        copy constructor 
        """
        this = _modshogun.new_ShortRealMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ShortRealMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.ShortRealMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.ShortRealMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.ShortRealMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.ShortRealMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.ShortRealMatrix_matrix_get, _modshogun.ShortRealMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.ShortRealMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.ShortRealMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.ShortRealMatrix_num_rows_get, _modshogun.ShortRealMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.ShortRealMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.ShortRealMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.ShortRealMatrix_num_cols_get, _modshogun.ShortRealMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.ShortRealMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.ShortRealMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.ShortRealMatrix_do_free_get, _modshogun.ShortRealMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealMatrix_load_serializable(self, *args)

ShortRealMatrix_swigregister = _modshogun.ShortRealMatrix_swigregister
ShortRealMatrix_swigregister(ShortRealMatrix)

class RealMatrix(_object):
    """
    shogun matrix

    default constructor constructor for setting params constructor to
    create new vector in memory free vector destroy vector idx cache

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealMatrix
        __init__(self, m, nrows, ncols, free_mat = False) -> RealMatrix
        __init__(self, m, nrows, ncols) -> RealMatrix
        __init__(self, nrows, ncols, free_mat = False) -> RealMatrix
        __init__(self, nrows, ncols) -> RealMatrix
        __init__(self, orig) -> RealMatrix

        copy constructor 
        """
        this = _modshogun.new_RealMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RealMatrix
    __del__ = lambda self : None;
    def free_matrix(self):
        """
        free_matrix(self)

        free matrix 
        """
        return _modshogun.RealMatrix_free_matrix(self)

    def destroy_matrix(self):
        """
        destroy_matrix(self)

        destroy matrix 
        """
        return _modshogun.RealMatrix_destroy_matrix(self)

    __swig_setmethods__["matrix"] = _modshogun.RealMatrix_matrix_set
    __swig_getmethods__["matrix"] = _modshogun.RealMatrix_matrix_get
    if _newclass:matrix = _swig_property(_modshogun.RealMatrix_matrix_get, _modshogun.RealMatrix_matrix_set)
    __swig_setmethods__["num_rows"] = _modshogun.RealMatrix_num_rows_set
    __swig_getmethods__["num_rows"] = _modshogun.RealMatrix_num_rows_get
    if _newclass:num_rows = _swig_property(_modshogun.RealMatrix_num_rows_get, _modshogun.RealMatrix_num_rows_set)
    __swig_setmethods__["num_cols"] = _modshogun.RealMatrix_num_cols_set
    __swig_getmethods__["num_cols"] = _modshogun.RealMatrix_num_cols_get
    if _newclass:num_cols = _swig_property(_modshogun.RealMatrix_num_cols_get, _modshogun.RealMatrix_num_cols_set)
    __swig_setmethods__["do_free"] = _modshogun.RealMatrix_do_free_set
    __swig_getmethods__["do_free"] = _modshogun.RealMatrix_do_free_get
    if _newclass:do_free = _swig_property(_modshogun.RealMatrix_do_free_get, _modshogun.RealMatrix_do_free_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealMatrix_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealMatrix_load_serializable(self, *args)

RealMatrix_swigregister = _modshogun.RealMatrix_swigregister
RealMatrix_swigregister(RealMatrix)

class BoolNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BoolNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BoolNDArray
        __init__(self, a, d, nd) -> BoolNDArray
        __init__(self, orig) -> BoolNDArray

        copy constructor 
        """
        this = _modshogun.new_BoolNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.BoolNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.BoolNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.BoolNDArray_array_get, _modshogun.BoolNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.BoolNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.BoolNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.BoolNDArray_dims_get, _modshogun.BoolNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.BoolNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.BoolNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.BoolNDArray_num_dims_get, _modshogun.BoolNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.BoolNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.BoolNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_BoolNDArray
    __del__ = lambda self : None;
BoolNDArray_swigregister = _modshogun.BoolNDArray_swigregister
BoolNDArray_swigregister(BoolNDArray)

class CharNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CharNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharNDArray
        __init__(self, a, d, nd) -> CharNDArray
        __init__(self, orig) -> CharNDArray

        copy constructor 
        """
        this = _modshogun.new_CharNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.CharNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.CharNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.CharNDArray_array_get, _modshogun.CharNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.CharNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.CharNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.CharNDArray_dims_get, _modshogun.CharNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.CharNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.CharNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.CharNDArray_num_dims_get, _modshogun.CharNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CharNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CharNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_CharNDArray
    __del__ = lambda self : None;
CharNDArray_swigregister = _modshogun.CharNDArray_swigregister
CharNDArray_swigregister(CharNDArray)

class WordNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, WordNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordNDArray
        __init__(self, a, d, nd) -> WordNDArray
        __init__(self, orig) -> WordNDArray

        copy constructor 
        """
        this = _modshogun.new_WordNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.WordNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.WordNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.WordNDArray_array_get, _modshogun.WordNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.WordNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.WordNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.WordNDArray_dims_get, _modshogun.WordNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.WordNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.WordNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.WordNDArray_num_dims_get, _modshogun.WordNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.WordNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.WordNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_WordNDArray
    __del__ = lambda self : None;
WordNDArray_swigregister = _modshogun.WordNDArray_swigregister
WordNDArray_swigregister(WordNDArray)

class ByteNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ByteNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteNDArray
        __init__(self, a, d, nd) -> ByteNDArray
        __init__(self, orig) -> ByteNDArray

        copy constructor 
        """
        this = _modshogun.new_ByteNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.ByteNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.ByteNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.ByteNDArray_array_get, _modshogun.ByteNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.ByteNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.ByteNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.ByteNDArray_dims_get, _modshogun.ByteNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.ByteNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.ByteNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.ByteNDArray_num_dims_get, _modshogun.ByteNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ByteNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ByteNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ByteNDArray
    __del__ = lambda self : None;
ByteNDArray_swigregister = _modshogun.ByteNDArray_swigregister
ByteNDArray_swigregister(ByteNDArray)

class IntNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntNDArray
        __init__(self, a, d, nd) -> IntNDArray
        __init__(self, orig) -> IntNDArray

        copy constructor 
        """
        this = _modshogun.new_IntNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.IntNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.IntNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.IntNDArray_array_get, _modshogun.IntNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.IntNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.IntNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.IntNDArray_dims_get, _modshogun.IntNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.IntNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.IntNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.IntNDArray_num_dims_get, _modshogun.IntNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.IntNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.IntNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_IntNDArray
    __del__ = lambda self : None;
IntNDArray_swigregister = _modshogun.IntNDArray_swigregister
IntNDArray_swigregister(IntNDArray)

class LongIntNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongIntNDArray
        __init__(self, a, d, nd) -> LongIntNDArray
        __init__(self, orig) -> LongIntNDArray

        copy constructor 
        """
        this = _modshogun.new_LongIntNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.LongIntNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.LongIntNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.LongIntNDArray_array_get, _modshogun.LongIntNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.LongIntNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.LongIntNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.LongIntNDArray_dims_get, _modshogun.LongIntNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.LongIntNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.LongIntNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.LongIntNDArray_num_dims_get, _modshogun.LongIntNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.LongIntNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.LongIntNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_LongIntNDArray
    __del__ = lambda self : None;
LongIntNDArray_swigregister = _modshogun.LongIntNDArray_swigregister
LongIntNDArray_swigregister(LongIntNDArray)

class ULongIntNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongIntNDArray
        __init__(self, a, d, nd) -> ULongIntNDArray
        __init__(self, orig) -> ULongIntNDArray

        copy constructor 
        """
        this = _modshogun.new_ULongIntNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.ULongIntNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.ULongIntNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.ULongIntNDArray_array_get, _modshogun.ULongIntNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.ULongIntNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.ULongIntNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.ULongIntNDArray_dims_get, _modshogun.ULongIntNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.ULongIntNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.ULongIntNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.ULongIntNDArray_num_dims_get, _modshogun.ULongIntNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ULongIntNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ULongIntNDArray
    __del__ = lambda self : None;
ULongIntNDArray_swigregister = _modshogun.ULongIntNDArray_swigregister
ULongIntNDArray_swigregister(ULongIntNDArray)

class ShortRealNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealNDArray
        __init__(self, a, d, nd) -> ShortRealNDArray
        __init__(self, orig) -> ShortRealNDArray

        copy constructor 
        """
        this = _modshogun.new_ShortRealNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.ShortRealNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.ShortRealNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.ShortRealNDArray_array_get, _modshogun.ShortRealNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.ShortRealNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.ShortRealNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.ShortRealNDArray_dims_get, _modshogun.ShortRealNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.ShortRealNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.ShortRealNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.ShortRealNDArray_num_dims_get, _modshogun.ShortRealNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.ShortRealNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_ShortRealNDArray
    __del__ = lambda self : None;
ShortRealNDArray_swigregister = _modshogun.ShortRealNDArray_swigregister
ShortRealNDArray_swigregister(ShortRealNDArray)

class RealNDArray(_object):
    """
    shogun n-dimensional array

    C++ includes: DataType.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealNDArray, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RealNDArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealNDArray
        __init__(self, a, d, nd) -> RealNDArray
        __init__(self, orig) -> RealNDArray

        copy constructor 
        """
        this = _modshogun.new_RealNDArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["array"] = _modshogun.RealNDArray_array_set
    __swig_getmethods__["array"] = _modshogun.RealNDArray_array_get
    if _newclass:array = _swig_property(_modshogun.RealNDArray_array_get, _modshogun.RealNDArray_array_set)
    __swig_setmethods__["dims"] = _modshogun.RealNDArray_dims_set
    __swig_getmethods__["dims"] = _modshogun.RealNDArray_dims_get
    if _newclass:dims = _swig_property(_modshogun.RealNDArray_dims_get, _modshogun.RealNDArray_dims_set)
    __swig_setmethods__["num_dims"] = _modshogun.RealNDArray_num_dims_set
    __swig_getmethods__["num_dims"] = _modshogun.RealNDArray_num_dims_get
    if _newclass:num_dims = _swig_property(_modshogun.RealNDArray_num_dims_get, _modshogun.RealNDArray_num_dims_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.RealNDArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.RealNDArray_load_serializable(self, *args)

    __swig_destroy__ = _modshogun.delete_RealNDArray
    __del__ = lambda self : None;
RealNDArray_swigregister = _modshogun.RealNDArray_swigregister
RealNDArray_swigregister(RealNDArray)

class DynamicCharArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicCharArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicCharArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicCharArray
        __init__(self) -> DynamicCharArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicCharArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicCharArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicCharArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicCharArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicCharArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> str

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicCharArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> str

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicCharArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicCharArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicCharArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicCharArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicCharArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicCharArray_pop_back(self)

    def back(self):
        """
        back(self) -> str

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicCharArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicCharArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicCharArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicCharArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicCharArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicCharArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicCharArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicCharArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicCharArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicCharArray_load_serializable(self, *args)

DynamicCharArray_swigregister = _modshogun.DynamicCharArray_swigregister
DynamicCharArray_swigregister(DynamicCharArray)

class DynamicByteArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicByteArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicByteArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicByteArray
        __init__(self) -> DynamicByteArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicByteArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicByteArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicByteArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicByteArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicByteArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned str

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicByteArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned str

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicByteArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicByteArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicByteArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicByteArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicByteArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicByteArray_pop_back(self)

    def back(self):
        """
        back(self) -> unsigned str

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicByteArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicByteArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicByteArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicByteArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicByteArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicByteArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicByteArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicByteArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicByteArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicByteArray_load_serializable(self, *args)

DynamicByteArray_swigregister = _modshogun.DynamicByteArray_swigregister
DynamicByteArray_swigregister(DynamicByteArray)

class DynamicWordArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicWordArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicWordArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicWordArray
        __init__(self) -> DynamicWordArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicWordArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicWordArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicWordArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicWordArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicWordArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned short

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicWordArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned short

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicWordArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicWordArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicWordArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicWordArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicWordArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicWordArray_pop_back(self)

    def back(self):
        """
        back(self) -> unsigned short

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicWordArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicWordArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicWordArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicWordArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicWordArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicWordArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicWordArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicWordArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicWordArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicWordArray_load_serializable(self, *args)

DynamicWordArray_swigregister = _modshogun.DynamicWordArray_swigregister
DynamicWordArray_swigregister(DynamicWordArray)

class DynamicIntArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicIntArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicIntArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicIntArray
        __init__(self) -> DynamicIntArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicIntArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicIntArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicIntArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicIntArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicIntArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> int

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicIntArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> int

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicIntArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicIntArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicIntArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicIntArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicIntArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicIntArray_pop_back(self)

    def back(self):
        """
        back(self) -> int

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicIntArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicIntArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicIntArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicIntArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicIntArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicIntArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicIntArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicIntArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicIntArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicIntArray_load_serializable(self, *args)

DynamicIntArray_swigregister = _modshogun.DynamicIntArray_swigregister
DynamicIntArray_swigregister(DynamicIntArray)

class DynamicLongArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicLongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicLongArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicLongArray
        __init__(self) -> DynamicLongArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicLongArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicLongArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicLongArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicLongArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicLongArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> long long

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicLongArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> long long

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicLongArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicLongArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicLongArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicLongArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicLongArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicLongArray_pop_back(self)

    def back(self):
        """
        back(self) -> long long

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicLongArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicLongArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicLongArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicLongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicLongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicLongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicLongArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicLongArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicLongArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicLongArray_load_serializable(self, *args)

DynamicLongArray_swigregister = _modshogun.DynamicLongArray_swigregister
DynamicLongArray_swigregister(DynamicLongArray)

class DynamicULongArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicULongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicULongArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicULongArray
        __init__(self) -> DynamicULongArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicULongArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicULongArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicULongArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicULongArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicULongArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned long long

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicULongArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned long long

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicULongArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicULongArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicULongArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicULongArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicULongArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicULongArray_pop_back(self)

    def back(self):
        """
        back(self) -> unsigned long long

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicULongArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicULongArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicULongArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicULongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicULongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicULongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicULongArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicULongArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicULongArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicULongArray_load_serializable(self, *args)

DynamicULongArray_swigregister = _modshogun.DynamicULongArray_swigregister
DynamicULongArray_swigregister(DynamicULongArray)

class DynamicShortRealArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicShortRealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicShortRealArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicShortRealArray
        __init__(self) -> DynamicShortRealArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicShortRealArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicShortRealArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicShortRealArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicShortRealArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicShortRealArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicShortRealArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> float

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicShortRealArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicShortRealArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicShortRealArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicShortRealArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicShortRealArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicShortRealArray_pop_back(self)

    def back(self):
        """
        back(self) -> float

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicShortRealArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicShortRealArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicShortRealArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicShortRealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicShortRealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicShortRealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicShortRealArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicShortRealArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicShortRealArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicShortRealArray_load_serializable(self, *args)

DynamicShortRealArray_swigregister = _modshogun.DynamicShortRealArray_swigregister
DynamicShortRealArray_swigregister(DynamicShortRealArray)

class DynamicRealArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicRealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicRealArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicRealArray
        __init__(self) -> DynamicRealArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicRealArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicRealArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicRealArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _modshogun.DynamicRealArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicRealArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicRealArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> float

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicRealArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicRealArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicRealArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicRealArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicRealArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicRealArray_pop_back(self)

    def back(self):
        """
        back(self) -> float

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicRealArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicRealArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicRealArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _modshogun.DynamicRealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _modshogun.DynamicRealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _modshogun.DynamicRealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicRealArray_clear_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicRealArray_shuffle(self)

    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool

        Save this object to file.

        Parameters:
        -----------

        file:  where to save the object; will be closed during returning if
        PREFIX is an empty string.

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicRealArray_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool

        Load this object from file. If it will fail (returning FALSE) then
        this object will contain inconsistent data and should not be used!

        Parameters:
        -----------

        file:  where to load from

        prefix:  prefix for members

        TRUE if done, otherwise FALSE 
        """
        return _modshogun.DynamicRealArray_load_serializable(self, *args)

DynamicRealArray_swigregister = _modshogun.DynamicRealArray_swigregister
DynamicRealArray_swigregister(DynamicRealArray)

class Hash(SGObject):
    """
    Collection of Hashing Functions.

    This class implements a number of hashing functions like crc32, md5
    and murmur.

    C++ includes: Hash.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Hash, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Hash, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Hash

        default constructor 
        """
        this = _modshogun.new_Hash()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Hash
    __del__ = lambda self : None;
    def crc32(*args):
        """crc32(data, len) -> int"""
        return _modshogun.Hash_crc32(*args)

    if _newclass:crc32 = staticmethod(crc32)
    __swig_getmethods__["crc32"] = lambda x: crc32
    def MD5(*args):
        """MD5(x, l, buf)"""
        return _modshogun.Hash_MD5(*args)

    if _newclass:MD5 = staticmethod(MD5)
    __swig_getmethods__["MD5"] = lambda x: MD5
    def MurmurHash2(*args):
        """MurmurHash2(data, len, seed) -> int"""
        return _modshogun.Hash_MurmurHash2(*args)

    if _newclass:MurmurHash2 = staticmethod(MurmurHash2)
    __swig_getmethods__["MurmurHash2"] = lambda x: MurmurHash2
    def IncrementalMurmurHash2(*args):
        """IncrementalMurmurHash2(data, h) -> int"""
        return _modshogun.Hash_IncrementalMurmurHash2(*args)

    if _newclass:IncrementalMurmurHash2 = staticmethod(IncrementalMurmurHash2)
    __swig_getmethods__["IncrementalMurmurHash2"] = lambda x: IncrementalMurmurHash2
    def MurmurHashString(*args):
        """MurmurHashString(s, h) -> int"""
        return _modshogun.Hash_MurmurHashString(*args)

    if _newclass:MurmurHashString = staticmethod(MurmurHashString)
    __swig_getmethods__["MurmurHashString"] = lambda x: MurmurHashString
Hash_swigregister = _modshogun.Hash_swigregister
Hash_swigregister(Hash)

def Hash_crc32(*args):
  """Hash_crc32(data, len) -> int"""
  return _modshogun.Hash_crc32(*args)

def Hash_MD5(*args):
  """Hash_MD5(x, l, buf)"""
  return _modshogun.Hash_MD5(*args)

def Hash_MurmurHash2(*args):
  """Hash_MurmurHash2(data, len, seed) -> int"""
  return _modshogun.Hash_MurmurHash2(*args)

def Hash_IncrementalMurmurHash2(*args):
  """Hash_IncrementalMurmurHash2(data, h) -> int"""
  return _modshogun.Hash_IncrementalMurmurHash2(*args)

def Hash_MurmurHashString(*args):
  """Hash_MurmurHashString(s, h) -> int"""
  return _modshogun.Hash_MurmurHashString(*args)

class ListElement(SGObject):
    """
    Class ListElement, defines how an element of the the list looks like.

    C++ includes: List.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ListElement, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ListElement, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ListElement
        __init__(self, p_data, p_prev = None, p_next = None) -> ListElement
        __init__(self, p_data, p_prev = None) -> ListElement
        __init__(self, p_data) -> ListElement

        constructor

        Parameters:
        -----------

        p_data:  data of this element

        p_prev:  previous element

        p_next:  next element 
        """
        this = _modshogun.new_ListElement(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ListElement
    __del__ = lambda self : None;
    __swig_setmethods__["next"] = _modshogun.ListElement_next_set
    __swig_getmethods__["next"] = _modshogun.ListElement_next_get
    if _newclass:next = _swig_property(_modshogun.ListElement_next_get, _modshogun.ListElement_next_set)
    __swig_setmethods__["prev"] = _modshogun.ListElement_prev_set
    __swig_getmethods__["prev"] = _modshogun.ListElement_prev_get
    if _newclass:prev = _swig_property(_modshogun.ListElement_prev_get, _modshogun.ListElement_prev_set)
    __swig_setmethods__["data"] = _modshogun.ListElement_data_set
    __swig_getmethods__["data"] = _modshogun.ListElement_data_get
    if _newclass:data = _swig_property(_modshogun.ListElement_data_get, _modshogun.ListElement_data_set)
ListElement_swigregister = _modshogun.ListElement_swigregister
ListElement_swigregister(ListElement)

class List(SGObject):
    """
    Class List implements a doubly connected list for low-level-objects.

    For higher level objects pointers should be used. The list supports
    calling delete() of an object that is to be removed from the list.

    C++ includes: List.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, List, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, List, name)
    __repr__ = _swig_repr
    def __init__(self, p_delete_data = False): 
        """
        __init__(self, p_delete_data = False) -> List
        __init__(self) -> List

        constructor

        Parameters:
        -----------

        p_delete_data:  if data shall be deleted 
        """
        this = _modshogun.new_List(p_delete_data)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_List
    __del__ = lambda self : None;
    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements in list

        number of elements in list 
        """
        return _modshogun.List_get_num_elements(self)

    def get_first_element(self, *args):
        """
        get_first_element(self) -> SGObject
        get_first_element(self, p_current) -> SGObject

        go to first element in list and return it

        first element in list or NULL if list is empty 
        """
        return _modshogun.List_get_first_element(self, *args)

    def get_last_element(self, *args):
        """
        get_last_element(self) -> SGObject
        get_last_element(self, p_current) -> SGObject

        go to last element in list and return it

        last element in list or NULL if list is empty 
        """
        return _modshogun.List_get_last_element(self, *args)

    def get_next_element(self, *args):
        """
        get_next_element(self) -> SGObject
        get_next_element(self, p_current) -> SGObject

        go to next element in list and return it

        next element in list or NULL if list is empty 
        """
        return _modshogun.List_get_next_element(self, *args)

    def get_previous_element(self, *args):
        """
        get_previous_element(self) -> SGObject
        get_previous_element(self, p_current) -> SGObject

        go to previous element in list and return it

        previous element in list or NULL if list is empty 
        """
        return _modshogun.List_get_previous_element(self, *args)

    def get_current_element(self, *args):
        """
        get_current_element(self) -> SGObject
        get_current_element(self, p_current) -> SGObject

        get current element in list

        current element in list or NULL if not available 
        """
        return _modshogun.List_get_current_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, data) -> bool

        append element AFTER the current element

        Parameters:
        -----------

        data:  data element to append

        if appending was successful 
        """
        return _modshogun.List_append_element(self, *args)

    def append_element_at_listend(self, *args):
        """
        append_element_at_listend(self, data) -> bool

        append at end of list

        Parameters:
        -----------

        data:  data element to append

        if appending was successful 
        """
        return _modshogun.List_append_element_at_listend(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, data) -> bool

        insert element BEFORE the current element

        Parameters:
        -----------

        data:  data element to insert

        if inserting was successful 
        """
        return _modshogun.List_insert_element(self, *args)

    def delete_element(self):
        """
        delete_element(self) -> SGObject

        erases current element the new current element is the successor of the
        former current element

        the elements data - if available - otherwise NULL 
        """
        return _modshogun.List_delete_element(self)

    def load_serializable_post(self):
        """
        load_serializable_post(self)

        throw
        ( ShogunException) Can (optionally) be overridden to post-initialize
        some member variables which are not PARAMETER::ADD'ed. Make sure that
        at first the overridden method BASE_CLASS::LOAD_SERIALIZABLE_POST is
        called.

        Exceptions:
        -----------

        ShogunException Will be thrown if an error occurres. 
        """
        return _modshogun.List_load_serializable_post(self)

List_swigregister = _modshogun.List_swigregister
List_swigregister(List)

class Signal(SGObject):
    """
    Class Signal implements signal handling to e.g. allow ctrl+c to cancel
    a long running process.

    This is done in two ways:

    A signal handler is attached to trap the SIGINT and SIGURG signal.
    Pressing ctrl+c or sending the SIGINT (kill ...) signal to the shogun
    process will make shogun print a message asking to immediately exit
    the running method and to fall back to the command line.

    When an URG signal is received or ctrl+c P is pressed shogun will
    prematurely stop a method and continue execution. For example when an
    SVM solver takes a long time without progressing much, one might still
    be interested in the result and should thus send SIGURG or
    interactively prematurely stop the method

    C++ includes: Signal.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Signal, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Signal, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Signal

        default constructor 
        """
        this = _modshogun.new_Signal()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Signal
    __del__ = lambda self : None;
    def handler(*args):
        """handler(signal)"""
        return _modshogun.Signal_handler(*args)

    if _newclass:handler = staticmethod(handler)
    __swig_getmethods__["handler"] = lambda x: handler
    def set_handler():
        """set_handler() -> bool"""
        return _modshogun.Signal_set_handler()

    if _newclass:set_handler = staticmethod(set_handler)
    __swig_getmethods__["set_handler"] = lambda x: set_handler
    def unset_handler():
        """unset_handler() -> bool"""
        return _modshogun.Signal_unset_handler()

    if _newclass:unset_handler = staticmethod(unset_handler)
    __swig_getmethods__["unset_handler"] = lambda x: unset_handler
    def clear():
        """clear()"""
        return _modshogun.Signal_clear()

    if _newclass:clear = staticmethod(clear)
    __swig_getmethods__["clear"] = lambda x: clear
    def clear_cancel():
        """clear_cancel()"""
        return _modshogun.Signal_clear_cancel()

    if _newclass:clear_cancel = staticmethod(clear_cancel)
    __swig_getmethods__["clear_cancel"] = lambda x: clear_cancel
    def set_cancel(immediately = False):
        """
        set_cancel(immediately = False)
        set_cancel()
        """
        return _modshogun.Signal_set_cancel(immediately)

    if _newclass:set_cancel = staticmethod(set_cancel)
    __swig_getmethods__["set_cancel"] = lambda x: set_cancel
    def cancel_computations():
        """cancel_computations() -> bool"""
        return _modshogun.Signal_cancel_computations()

    if _newclass:cancel_computations = staticmethod(cancel_computations)
    __swig_getmethods__["cancel_computations"] = lambda x: cancel_computations
Signal_swigregister = _modshogun.Signal_swigregister
Signal_swigregister(Signal)

def Signal_handler(*args):
  """Signal_handler(signal)"""
  return _modshogun.Signal_handler(*args)

def Signal_set_handler():
  """Signal_set_handler() -> bool"""
  return _modshogun.Signal_set_handler()

def Signal_unset_handler():
  """Signal_unset_handler() -> bool"""
  return _modshogun.Signal_unset_handler()

def Signal_clear():
  """Signal_clear()"""
  return _modshogun.Signal_clear()

def Signal_clear_cancel():
  """Signal_clear_cancel()"""
  return _modshogun.Signal_clear_cancel()

def Signal_set_cancel(immediately = False):
  """
    set_cancel(immediately = False)
    Signal_set_cancel()
    """
  return _modshogun.Signal_set_cancel(immediately)

def Signal_cancel_computations():
  """Signal_cancel_computations() -> bool"""
  return _modshogun.Signal_cancel_computations()

class Time(SGObject):
    """
    Class Time that implements a stopwatch based on either cpu time or
    wall clock time.

    C++ includes: Time.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Time, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Time, name)
    __repr__ = _swig_repr
    def __init__(self, start = True): 
        """
        __init__(self, start = True) -> Time
        __init__(self) -> Time

        constructor

        Parameters:
        -----------

        start:  if time measurement shall be started 
        """
        this = _modshogun.new_Time(start)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Time
    __del__ = lambda self : None;
    def cur_runtime(self, verbose = False):
        """
        cur_runtime(self, verbose = False) -> clock_t
        cur_runtime(self) -> clock_t

        get current cpu runtime

        Parameters:
        -----------

        verbose:  if time shall be printed

        current cpu runtime 
        """
        return _modshogun.Time_cur_runtime(self, verbose)

    def cur_runtime_diff(self, verbose = False):
        """
        cur_runtime_diff(self, verbose = False) -> clock_t
        cur_runtime_diff(self) -> clock_t

        get time difference between start and NOW

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW 
        """
        return _modshogun.Time_cur_runtime_diff(self, verbose)

    def cur_runtime_diff_sec(self, verbose = False):
        """
        cur_runtime_diff_sec(self, verbose = False) -> float
        cur_runtime_diff_sec(self) -> float

        get time difference between start and NOW in seconds (wall clock time)

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW in seconds 
        """
        return _modshogun.Time_cur_runtime_diff_sec(self, verbose)

    def start(self, verbose = False):
        """
        start(self, verbose = False) -> float
        start(self) -> float

        start the counter

        Parameters:
        -----------

        verbose:  if start time shall be printed

        start time in seconds 
        """
        return _modshogun.Time_start(self, verbose)

    def cur_time_diff(self, verbose = False):
        """
        cur_time_diff(self, verbose = False) -> float
        cur_time_diff(self) -> float

        get time difference between start and NOW in seconds (wall clock time)

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW in seconds 
        """
        return _modshogun.Time_cur_time_diff(self, verbose)

    def time_diff_sec(self, verbose = False):
        """
        time_diff_sec(self, verbose = False) -> float
        time_diff_sec(self) -> float

        get time difference between start and stop in seconds

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and stop in seconds 
        """
        return _modshogun.Time_time_diff_sec(self, verbose)

    def stop(self, verbose = False):
        """
        stop(self, verbose = False) -> float
        stop(self) -> float

        stop the counter

        Parameters:
        -----------

        verbose:  if stop time shall be printed

        stop time in seconds 
        """
        return _modshogun.Time_stop(self, verbose)

    def get_runtime():
        """get_runtime() -> float"""
        return _modshogun.Time_get_runtime()

    if _newclass:get_runtime = staticmethod(get_runtime)
    __swig_getmethods__["get_runtime"] = lambda x: get_runtime
    def get_curtime():
        """get_curtime() -> float"""
        return _modshogun.Time_get_curtime()

    if _newclass:get_curtime = staticmethod(get_curtime)
    __swig_getmethods__["get_curtime"] = lambda x: get_curtime
Time_swigregister = _modshogun.Time_swigregister
Time_swigregister(Time)

def Time_get_runtime():
  """Time_get_runtime() -> float"""
  return _modshogun.Time_get_runtime()

def Time_get_curtime():
  """Time_get_curtime() -> float"""
  return _modshogun.Time_get_curtime()

UNCOMPRESSED = _modshogun.UNCOMPRESSED
LZO = _modshogun.LZO
GZIP = _modshogun.GZIP
BZIP2 = _modshogun.BZIP2
LZMA = _modshogun.LZMA
SNAPPY = _modshogun.SNAPPY
class CCompressor(SGObject):
    """
    Compression library for compressing and decompressing buffers using
    one of the standard compression algorithms, LZO, GZIP, BZIP2 or LZMA.

    The general recommendation is to use LZO whenever lightweight
    compression is sufficient but high i/o throughputs are needed (at 1/2
    the speed of memcpy).

    If size is all that matters use LZMA (which especially when
    compressing can be very slow though).

    Note that besides lzo compression, this library is thread safe.

    C++ includes: Compressor.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CCompressor, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CCompressor, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CCompressor
        __init__(self, ct) -> CCompressor

        default constructor

        Parameters:
        -----------

        ct:  compression to use: one of UNCOMPRESSED, LZO, GZIP, BZIP2 or LZMA

        """
        this = _modshogun.new_CCompressor(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CCompressor
    __del__ = lambda self : None;
    def compress(self, *args):
        """
        compress(self, uncompressed, uncompressed_size, compressed, compressed_size, 
            level = 1)
        compress(self, uncompressed, uncompressed_size, compressed, compressed_size)

        compress data

        compresses the buffer uncompressed using the selected compression
        algorithm and returns compressed data and its size

        Parameters:
        -----------

        uncompressed:  - uncompressed data to be compressed

        uncompressed_size:  - size of the uncompressed data

        compressed:  - pointer to hold compressed data (returned)

        compressed_size:  - size of compressed data (returned)

        level:  - compression level between 1 and 9 
        """
        return _modshogun.CCompressor_compress(self, *args)

    def decompress(self, *args):
        """
        decompress(self, compressed, compressed_size, uncompressed, uncompressed_size)

        decompress data

        Decompresses the buffer using the selected compression algorithm to
        the memory block specified in uncompressed. Note: Compressed and
        uncompressed size must be known prior to calling this function.

        Parameters:
        -----------

        compressed:  - pointer to compressed data

        compressed_size:  - size of compressed data

        uncompressed:  - pointer to buffer to hold uncompressed data

        uncompressed_size:  - size of the uncompressed data 
        """
        return _modshogun.CCompressor_decompress(self, *args)

CCompressor_swigregister = _modshogun.CCompressor_swigregister
CCompressor_swigregister(CCompressor)

RNG_SEED_SIZE = _modshogun.RNG_SEED_SIZE
class Math(SGObject):
    """
    Class which collects generic mathematical functions.

    C++ includes: Math.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Math, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Math, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Math

        Constructor - initializes log-table. 
        """
        this = _modshogun.new_Math()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Math
    __del__ = lambda self : None;
    def round(*args):
        """round(d) -> float"""
        return _modshogun.Math_round(*args)

    if _newclass:round = staticmethod(round)
    __swig_getmethods__["round"] = lambda x: round
    def floor(*args):
        """floor(d) -> float"""
        return _modshogun.Math_floor(*args)

    if _newclass:floor = staticmethod(floor)
    __swig_getmethods__["floor"] = lambda x: floor
    def ceil(*args):
        """ceil(d) -> float"""
        return _modshogun.Math_ceil(*args)

    if _newclass:ceil = staticmethod(ceil)
    __swig_getmethods__["ceil"] = lambda x: ceil
    def sqrt(*args):
        """
        sqrt(x) -> float
        sqrt(x) -> float
        sqrt(x) -> floatmax_t

        x^0.5 
        """
        return _modshogun.Math_sqrt(*args)

    if _newclass:sqrt = staticmethod(sqrt)
    __swig_getmethods__["sqrt"] = lambda x: sqrt
    def invsqrt(*args):
        """
        invsqrt(x) -> float

        x^-0.5 
        """
        return _modshogun.Math_invsqrt(*args)

    if _newclass:invsqrt = staticmethod(invsqrt)
    __swig_getmethods__["invsqrt"] = lambda x: invsqrt
    def powl(*args):
        """
        powl(x, n) -> floatmax_t

        x^n 
        """
        return _modshogun.Math_powl(*args)

    if _newclass:powl = staticmethod(powl)
    __swig_getmethods__["powl"] = lambda x: powl
    def pow(*args):
        """
        pow(x, n) ->  int
        pow(x, n) -> float
        pow(x, n) -> float
        """
        return _modshogun.Math_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def exp(*args):
        """exp(x) -> float"""
        return _modshogun.Math_exp(*args)

    if _newclass:exp = staticmethod(exp)
    __swig_getmethods__["exp"] = lambda x: exp
    def lgamma(*args):
        """
        lgamma(x) -> float

        natural logarithm of the gamma function of input 
        """
        return _modshogun.Math_lgamma(*args)

    if _newclass:lgamma = staticmethod(lgamma)
    __swig_getmethods__["lgamma"] = lambda x: lgamma
    def tgamma(*args):
        """
        tgamma(x) -> float

        gamma function of input 
        """
        return _modshogun.Math_tgamma(*args)

    if _newclass:tgamma = staticmethod(tgamma)
    __swig_getmethods__["tgamma"] = lambda x: tgamma
    def atan(*args):
        """
        atan(x) -> float

        arcus tangens of input 
        """
        return _modshogun.Math_atan(*args)

    if _newclass:atan = staticmethod(atan)
    __swig_getmethods__["atan"] = lambda x: atan
    def lgammal(*args):
        """lgammal(x) -> floatmax_t"""
        return _modshogun.Math_lgammal(*args)

    if _newclass:lgammal = staticmethod(lgammal)
    __swig_getmethods__["lgammal"] = lambda x: lgammal
    def log10(*args):
        """log10(v) -> float"""
        return _modshogun.Math_log10(*args)

    if _newclass:log10 = staticmethod(log10)
    __swig_getmethods__["log10"] = lambda x: log10
    def log2(*args):
        """log2(v) -> float"""
        return _modshogun.Math_log2(*args)

    if _newclass:log2 = staticmethod(log2)
    __swig_getmethods__["log2"] = lambda x: log2
    def log(*args):
        """log(v) -> float"""
        return _modshogun.Math_log(*args)

    if _newclass:log = staticmethod(log)
    __swig_getmethods__["log"] = lambda x: log
    def area_under_curve(*args):
        """area_under_curve(xy, len, reversed) -> float"""
        return _modshogun.Math_area_under_curve(*args)

    if _newclass:area_under_curve = staticmethod(area_under_curve)
    __swig_getmethods__["area_under_curve"] = lambda x: area_under_curve
    def pinv(*args):
        """
        pinv(matrix, rows, cols, target = None) -> float
        pinv(matrix, rows, cols) -> float
        """
        return _modshogun.Math_pinv(*args)

    if _newclass:pinv = staticmethod(pinv)
    __swig_getmethods__["pinv"] = lambda x: pinv
    def dgemm(*args):
        """
        dgemm(alpha, A, rows, cols, transposeA, B, cols_B, transposeB, 
            beta, C)
        """
        return _modshogun.Math_dgemm(*args)

    if _newclass:dgemm = staticmethod(dgemm)
    __swig_getmethods__["dgemm"] = lambda x: dgemm
    def dgemv(*args):
        """dgemv(alpha, A, rows, cols, transposeA, X, beta, Y)"""
        return _modshogun.Math_dgemv(*args)

    if _newclass:dgemv = staticmethod(dgemv)
    __swig_getmethods__["dgemv"] = lambda x: dgemv
    def factorial(*args):
        """factorial(n) -> int"""
        return _modshogun.Math_factorial(*args)

    if _newclass:factorial = staticmethod(factorial)
    __swig_getmethods__["factorial"] = lambda x: factorial
    def init_random(initseed = 0):
        """
        init_random(initseed = 0)
        init_random()
        """
        return _modshogun.Math_init_random(initseed)

    if _newclass:init_random = staticmethod(init_random)
    __swig_getmethods__["init_random"] = lambda x: init_random
    def random(*args):
        """
        random() -> int
        random(min_value, max_value) ->  int
        random(min_value, max_value) -> float
        random(min_value, max_value) -> float
        """
        return _modshogun.Math_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def normal_random(*args):
        """
        normal_random(mean, std_dev) -> float
        normal_random(mean, std_dev) -> float

        Returns a Gaussian or Normal random number. Using the polar form of
        the Box-Muller
        transform.http://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform#Polar_form

        """
        return _modshogun.Math_normal_random(*args)

    if _newclass:normal_random = staticmethod(normal_random)
    __swig_getmethods__["normal_random"] = lambda x: normal_random
    def randn_float():
        """
        randn_float() -> float

        Convenience method for generating Standard Normal random numbers
        Float: Mean = 0 and Standard Deviation = 1 
        """
        return _modshogun.Math_randn_float()

    if _newclass:randn_float = staticmethod(randn_float)
    __swig_getmethods__["randn_float"] = lambda x: randn_float
    def randn_double():
        """
        randn_double() -> float

        Convenience method for generating Standard Normal random numbers
        Double: Mean = 0 and Standard Deviation = 1 
        """
        return _modshogun.Math_randn_double()

    if _newclass:randn_double = staticmethod(randn_double)
    __swig_getmethods__["randn_double"] = lambda x: randn_double
    def randperm(*args):
        """randperm(n) ->  int"""
        return _modshogun.Math_randperm(*args)

    if _newclass:randperm = staticmethod(randperm)
    __swig_getmethods__["randperm"] = lambda x: randperm
    def nchoosek(*args):
        """nchoosek(n, k) -> int"""
        return _modshogun.Math_nchoosek(*args)

    if _newclass:nchoosek = staticmethod(nchoosek)
    __swig_getmethods__["nchoosek"] = lambda x: nchoosek
    def dot(*args):
        """
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> floatmax_t
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float

        compute dot product between v1 and v2 
        """
        return _modshogun.Math_dot(*args)

    if _newclass:dot = staticmethod(dot)
    __swig_getmethods__["dot"] = lambda x: dot
    def mean(*args):
        """
        mean(vec, len) -> float

        Deprecated use CStatistics::mean() instead 
        """
        return _modshogun.Math_mean(*args)

    if _newclass:mean = staticmethod(mean)
    __swig_getmethods__["mean"] = lambda x: mean
    def trace(*args):
        """trace(mat, cols, rows) -> float"""
        return _modshogun.Math_trace(*args)

    if _newclass:trace = staticmethod(trace)
    __swig_getmethods__["trace"] = lambda x: trace
    def sort(*args):
        """
        sort(a, cols, sort_col = 0)
        sort(a, cols)
        sort(a, idx, N)
        """
        return _modshogun.Math_sort(*args)

    if _newclass:sort = staticmethod(sort)
    __swig_getmethods__["sort"] = lambda x: sort
    def compute_eigenvectors(*args):
        """
        compute_eigenvectors(matrix, n, m) -> float

        compute eigenvalues and eigenvectors of symmetric matrix

        Parameters:
        -----------

        matrix:  overwritten and contains n orthonormal eigenvectors

        n:

        m:

        eigenvalues (array of length n, to be deleted[]) 
        """
        return _modshogun.Math_compute_eigenvectors(*args)

    if _newclass:compute_eigenvectors = staticmethod(compute_eigenvectors)
    __swig_getmethods__["compute_eigenvectors"] = lambda x: compute_eigenvectors
    def Align(*args):
        """
        Align(seq1, seq2, l1, l2, gapCost) -> float

        align two sequences seq1 & seq2 of length l1 and l2 using gapCost
        return alignment cost 
        """
        return _modshogun.Math_Align(*args)

    if _newclass:Align = staticmethod(Align)
    __swig_getmethods__["Align"] = lambda x: Align
    def mutual_info(*args):
        """mutual_info(p1, p2, len) -> float"""
        return _modshogun.Math_mutual_info(*args)

    if _newclass:mutual_info = staticmethod(mutual_info)
    __swig_getmethods__["mutual_info"] = lambda x: mutual_info
    def relative_entropy(*args):
        """relative_entropy(p, q, len) -> float"""
        return _modshogun.Math_relative_entropy(*args)

    if _newclass:relative_entropy = staticmethod(relative_entropy)
    __swig_getmethods__["relative_entropy"] = lambda x: relative_entropy
    def entropy(*args):
        """entropy(p, len) -> float"""
        return _modshogun.Math_entropy(*args)

    if _newclass:entropy = staticmethod(entropy)
    __swig_getmethods__["entropy"] = lambda x: entropy
    def get_seed():
        """get_seed() -> int"""
        return _modshogun.Math_get_seed()

    if _newclass:get_seed = staticmethod(get_seed)
    __swig_getmethods__["get_seed"] = lambda x: get_seed
    def get_log_range():
        """get_log_range() -> int"""
        return _modshogun.Math_get_log_range()

    if _newclass:get_log_range = staticmethod(get_log_range)
    __swig_getmethods__["get_log_range"] = lambda x: get_log_range
    def is_finite(*args):
        """is_finite(f) -> int"""
        return _modshogun.Math_is_finite(*args)

    if _newclass:is_finite = staticmethod(is_finite)
    __swig_getmethods__["is_finite"] = lambda x: is_finite
    def is_infinity(*args):
        """is_infinity(f) -> int"""
        return _modshogun.Math_is_infinity(*args)

    if _newclass:is_infinity = staticmethod(is_infinity)
    __swig_getmethods__["is_infinity"] = lambda x: is_infinity
    def is_nan(*args):
        """is_nan(f) -> int"""
        return _modshogun.Math_is_nan(*args)

    if _newclass:is_nan = staticmethod(is_nan)
    __swig_getmethods__["is_nan"] = lambda x: is_nan
    def fishers_exact_test_for_multiple_2x3_tables(*args):
        """fishers_exact_test_for_multiple_2x3_tables(tables) -> RealVector"""
        return _modshogun.Math_fishers_exact_test_for_multiple_2x3_tables(*args)

    if _newclass:fishers_exact_test_for_multiple_2x3_tables = staticmethod(fishers_exact_test_for_multiple_2x3_tables)
    __swig_getmethods__["fishers_exact_test_for_multiple_2x3_tables"] = lambda x: fishers_exact_test_for_multiple_2x3_tables
    def fishers_exact_test_for_2x3_table(*args):
        """fishers_exact_test_for_2x3_table(table) -> float"""
        return _modshogun.Math_fishers_exact_test_for_2x3_table(*args)

    if _newclass:fishers_exact_test_for_2x3_table = staticmethod(fishers_exact_test_for_2x3_table)
    __swig_getmethods__["fishers_exact_test_for_2x3_table"] = lambda x: fishers_exact_test_for_2x3_table
    def logarithmic_sum(*args):
        """
        logarithmic_sum(p, q) -> float

        sum logarithmic probabilities. Probability measures are summed up but
        are now given in logspace where direct summation of exp(operand) is
        not possible due to numerical problems, i.e. eg. exp(-1000)=0.
        Therefore we do log( exp(a) + exp(b)) = a + log (1 + exp (b-a)) where
        a = max(p,q) and b min(p,q). 
        """
        return _modshogun.Math_logarithmic_sum(*args)

    if _newclass:logarithmic_sum = staticmethod(logarithmic_sum)
    __swig_getmethods__["logarithmic_sum"] = lambda x: logarithmic_sum
Math_swigregister = _modshogun.Math_swigregister
Math_swigregister(Math)

def Math_round(*args):
  """Math_round(d) -> float"""
  return _modshogun.Math_round(*args)

def Math_floor(*args):
  """Math_floor(d) -> float"""
  return _modshogun.Math_floor(*args)

def Math_ceil(*args):
  """Math_ceil(d) -> float"""
  return _modshogun.Math_ceil(*args)

def Math_sqrt(*args):
  """
    sqrt(x) -> float
    sqrt(x) -> float
    Math_sqrt(x) -> floatmax_t

    x^0.5 
    """
  return _modshogun.Math_sqrt(*args)

def Math_invsqrt(*args):
  """
    Math_invsqrt(x) -> float

    x^-0.5 
    """
  return _modshogun.Math_invsqrt(*args)

def Math_powl(*args):
  """
    Math_powl(x, n) -> floatmax_t

    x^n 
    """
  return _modshogun.Math_powl(*args)

def Math_pow(*args):
  """
    pow(x, n) ->  int
    pow(x, n) -> float
    Math_pow(x, n) -> float
    """
  return _modshogun.Math_pow(*args)

def Math_exp(*args):
  """Math_exp(x) -> float"""
  return _modshogun.Math_exp(*args)

def Math_lgamma(*args):
  """
    Math_lgamma(x) -> float

    natural logarithm of the gamma function of input 
    """
  return _modshogun.Math_lgamma(*args)

def Math_tgamma(*args):
  """
    Math_tgamma(x) -> float

    gamma function of input 
    """
  return _modshogun.Math_tgamma(*args)

def Math_atan(*args):
  """
    Math_atan(x) -> float

    arcus tangens of input 
    """
  return _modshogun.Math_atan(*args)

def Math_lgammal(*args):
  """Math_lgammal(x) -> floatmax_t"""
  return _modshogun.Math_lgammal(*args)

def Math_log10(*args):
  """Math_log10(v) -> float"""
  return _modshogun.Math_log10(*args)

def Math_log2(*args):
  """Math_log2(v) -> float"""
  return _modshogun.Math_log2(*args)

def Math_log(*args):
  """Math_log(v) -> float"""
  return _modshogun.Math_log(*args)

def Math_area_under_curve(*args):
  """Math_area_under_curve(xy, len, reversed) -> float"""
  return _modshogun.Math_area_under_curve(*args)

def Math_pinv(*args):
  """
    pinv(matrix, rows, cols, target = None) -> float
    Math_pinv(matrix, rows, cols) -> float
    """
  return _modshogun.Math_pinv(*args)

def Math_dgemm(*args):
  """
    Math_dgemm(alpha, A, rows, cols, transposeA, B, cols_B, transposeB, 
        beta, C)
    """
  return _modshogun.Math_dgemm(*args)

def Math_dgemv(*args):
  """Math_dgemv(alpha, A, rows, cols, transposeA, X, beta, Y)"""
  return _modshogun.Math_dgemv(*args)

def Math_factorial(*args):
  """Math_factorial(n) -> int"""
  return _modshogun.Math_factorial(*args)

def Math_init_random(initseed = 0):
  """
    init_random(initseed = 0)
    Math_init_random()
    """
  return _modshogun.Math_init_random(initseed)

def Math_random(*args):
  """
    random() -> int
    random(min_value, max_value) ->  int
    random(min_value, max_value) -> float
    Math_random(min_value, max_value) -> float
    """
  return _modshogun.Math_random(*args)

def Math_normal_random(*args):
  """
    normal_random(mean, std_dev) -> float
    Math_normal_random(mean, std_dev) -> float

    Returns a Gaussian or Normal random number. Using the polar form of
    the Box-Muller
    transform.http://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform#Polar_form

    """
  return _modshogun.Math_normal_random(*args)

def Math_randn_float():
  """
    Math_randn_float() -> float

    Convenience method for generating Standard Normal random numbers
    Float: Mean = 0 and Standard Deviation = 1 
    """
  return _modshogun.Math_randn_float()

def Math_randn_double():
  """
    Math_randn_double() -> float

    Convenience method for generating Standard Normal random numbers
    Double: Mean = 0 and Standard Deviation = 1 
    """
  return _modshogun.Math_randn_double()

def Math_randperm(*args):
  """Math_randperm(n) ->  int"""
  return _modshogun.Math_randperm(*args)

def Math_nchoosek(*args):
  """Math_nchoosek(n, k) -> int"""
  return _modshogun.Math_nchoosek(*args)

def Math_dot(*args):
  """
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> floatmax_t
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    Math_dot(v1, v2, n) -> float

    compute dot product between v1 and v2 
    """
  return _modshogun.Math_dot(*args)

def Math_mean(*args):
  """
    Math_mean(vec, len) -> float

    Deprecated use CStatistics::mean() instead 
    """
  return _modshogun.Math_mean(*args)

def Math_trace(*args):
  """Math_trace(mat, cols, rows) -> float"""
  return _modshogun.Math_trace(*args)

def Math_sort(*args):
  """
    sort(a, cols, sort_col = 0)
    sort(a, cols)
    Math_sort(a, idx, N)
    """
  return _modshogun.Math_sort(*args)

def Math_compute_eigenvectors(*args):
  """
    Math_compute_eigenvectors(matrix, n, m) -> float

    compute eigenvalues and eigenvectors of symmetric matrix

    Parameters:
    -----------

    matrix:  overwritten and contains n orthonormal eigenvectors

    n:

    m:

    eigenvalues (array of length n, to be deleted[]) 
    """
  return _modshogun.Math_compute_eigenvectors(*args)

def Math_Align(*args):
  """
    Math_Align(seq1, seq2, l1, l2, gapCost) -> float

    align two sequences seq1 & seq2 of length l1 and l2 using gapCost
    return alignment cost 
    """
  return _modshogun.Math_Align(*args)

def Math_mutual_info(*args):
  """Math_mutual_info(p1, p2, len) -> float"""
  return _modshogun.Math_mutual_info(*args)

def Math_relative_entropy(*args):
  """Math_relative_entropy(p, q, len) -> float"""
  return _modshogun.Math_relative_entropy(*args)

def Math_entropy(*args):
  """Math_entropy(p, len) -> float"""
  return _modshogun.Math_entropy(*args)

def Math_get_seed():
  """Math_get_seed() -> int"""
  return _modshogun.Math_get_seed()

def Math_get_log_range():
  """Math_get_log_range() -> int"""
  return _modshogun.Math_get_log_range()

def Math_is_finite(*args):
  """Math_is_finite(f) -> int"""
  return _modshogun.Math_is_finite(*args)

def Math_is_infinity(*args):
  """Math_is_infinity(f) -> int"""
  return _modshogun.Math_is_infinity(*args)

def Math_is_nan(*args):
  """Math_is_nan(f) -> int"""
  return _modshogun.Math_is_nan(*args)

def Math_fishers_exact_test_for_multiple_2x3_tables(*args):
  """Math_fishers_exact_test_for_multiple_2x3_tables(tables) -> RealVector"""
  return _modshogun.Math_fishers_exact_test_for_multiple_2x3_tables(*args)

def Math_fishers_exact_test_for_2x3_table(*args):
  """Math_fishers_exact_test_for_2x3_table(table) -> float"""
  return _modshogun.Math_fishers_exact_test_for_2x3_table(*args)

def Math_logarithmic_sum(*args):
  """
    Math_logarithmic_sum(p, q) -> float

    sum logarithmic probabilities. Probability measures are summed up but
    are now given in logspace where direct summation of exp(operand) is
    not possible due to numerical problems, i.e. eg. exp(-1000)=0.
    Therefore we do log( exp(a) + exp(b)) = a + log (1 + exp (b-a)) where
    a = max(p,q) and b min(p,q). 
    """
  return _modshogun.Math_logarithmic_sum(*args)
Math.INFTY = _modshogun.cvar.Math_INFTY
Math.ALMOST_INFTY = _modshogun.cvar.Math_ALMOST_INFTY
Math.ALMOST_NEG_INFTY = _modshogun.cvar.Math_ALMOST_NEG_INFTY
Math.PI = _modshogun.cvar.Math_PI
Math.MACHINE_EPSILON = _modshogun.cvar.Math_MACHINE_EPSILON
Math.MAX_REAL_NUMBER = _modshogun.cvar.Math_MAX_REAL_NUMBER
Math.MIN_REAL_NUMBER = _modshogun.cvar.Math_MIN_REAL_NUMBER

F_UNKNOWN = _modshogun.F_UNKNOWN
F_BOOL = _modshogun.F_BOOL
F_CHAR = _modshogun.F_CHAR
F_BYTE = _modshogun.F_BYTE
F_SHORT = _modshogun.F_SHORT
F_WORD = _modshogun.F_WORD
F_INT = _modshogun.F_INT
F_UINT = _modshogun.F_UINT
F_LONG = _modshogun.F_LONG
F_ULONG = _modshogun.F_ULONG
F_SHORTREAL = _modshogun.F_SHORTREAL
F_DREAL = _modshogun.F_DREAL
F_LONGREAL = _modshogun.F_LONGREAL
F_ANY = _modshogun.F_ANY
C_UNKNOWN = _modshogun.C_UNKNOWN
C_SIMPLE = _modshogun.C_SIMPLE
C_SPARSE = _modshogun.C_SPARSE
C_STRING = _modshogun.C_STRING
C_COMBINED = _modshogun.C_COMBINED
C_COMBINED_DOT = _modshogun.C_COMBINED_DOT
C_WD = _modshogun.C_WD
C_SPEC = _modshogun.C_SPEC
C_WEIGHTEDSPEC = _modshogun.C_WEIGHTEDSPEC
C_POLY = _modshogun.C_POLY
C_STREAMING_SIMPLE = _modshogun.C_STREAMING_SIMPLE
C_STREAMING_SPARSE = _modshogun.C_STREAMING_SPARSE
C_STREAMING_STRING = _modshogun.C_STREAMING_STRING
C_STREAMING_VW = _modshogun.C_STREAMING_VW
C_ANY = _modshogun.C_ANY
FP_NONE = _modshogun.FP_NONE
FP_DOT = _modshogun.FP_DOT
FP_STREAMING_DOT = _modshogun.FP_STREAMING_DOT
DNA = _modshogun.DNA
RAWDNA = _modshogun.RAWDNA
RNA = _modshogun.RNA
PROTEIN = _modshogun.PROTEIN
BINARY = _modshogun.BINARY
ALPHANUM = _modshogun.ALPHANUM
CUBE = _modshogun.CUBE
RAWBYTE = _modshogun.RAWBYTE
IUPAC_NUCLEIC_ACID = _modshogun.IUPAC_NUCLEIC_ACID
IUPAC_AMINO_ACID = _modshogun.IUPAC_AMINO_ACID
NONE = _modshogun.NONE
DIGIT = _modshogun.DIGIT
DIGIT2 = _modshogun.DIGIT2
RAWDIGIT = _modshogun.RAWDIGIT
RAWDIGIT2 = _modshogun.RAWDIGIT2
UNKNOWN = _modshogun.UNKNOWN
SNP = _modshogun.SNP
RAWSNP = _modshogun.RAWSNP
class Alphabet(SGObject):
    """
    The class Alphabet implements an alphabet and alphabet utility
    functions.

    These utility functions can be used to remap stracters to more
    (bit-)efficient representations, check if a string is valid, compute
    histograms etc.

    Currently supported alphabets are DNA, RAWDNA, RNA, PROTEIN, BINARY,
    ALPHANUM, CUBE, RAW, IUPAC_NUCLEIC_ACID and IUPAC_AMINO_ACID.

    C++ includes: Alphabet.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Alphabet, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Alphabet, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Alphabet
        __init__(self, alpha, len) -> Alphabet
        __init__(self, alpha) -> Alphabet
        __init__(self, alpha) -> Alphabet

        constructor

        Parameters:
        -----------

        alpha:  alphabet to use 
        """
        this = _modshogun.new_Alphabet(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Alphabet
    __del__ = lambda self : None;
    def set_alphabet(self, *args):
        """
        set_alphabet(self, alpha) -> bool

        set alphabet and initialize mapping table (for remap)

        Parameters:
        -----------

        alpha:  new alphabet 
        """
        return _modshogun.Alphabet_set_alphabet(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> EAlphabet

        get alphabet

        alphabet 
        """
        return _modshogun.Alphabet_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) ->  int

        get number of symbols in alphabet

        number of symbols 
        """
        return _modshogun.Alphabet_get_num_symbols(self)

    def get_num_bits(self):
        """
        get_num_bits(self) ->  int

        get number of bits necessary to store all symbols in alphabet

        number of necessary storage bits 
        """
        return _modshogun.Alphabet_get_num_bits(self)

    def remap_to_bin(self, *args):
        """
        remap_to_bin(self, c) -> int

        remap element e.g translate ACGT to 0123

        Parameters:
        -----------

        c:  element to remap

        remapped element 
        """
        return _modshogun.Alphabet_remap_to_bin(self, *args)

    def remap_to_char(self, *args):
        """
        remap_to_char(self, c) -> int

        remap element e.g translate 0123 to ACGT

        Parameters:
        -----------

        c:  element to remap

        remapped element 
        """
        return _modshogun.Alphabet_remap_to_char(self, *args)

    def clear_histogram(self):
        """
        clear_histogram(self)

        clear histogram 
        """
        return _modshogun.Alphabet_clear_histogram(self)

    def add_byte_to_histogram(self, *args):
        """
        add_byte_to_histogram(self, p)

        add element to histogram

        Parameters:
        -----------

        p:  element 
        """
        return _modshogun.Alphabet_add_byte_to_histogram(self, *args)

    def print_histogram(self):
        """
        print_histogram(self)

        print histogram 
        """
        return _modshogun.Alphabet_print_histogram(self)

    def get_histogram(self):
        """
        get_histogram(self) -> LongIntVector

        get histogram

        histogram 
        """
        return _modshogun.Alphabet_get_histogram(self)

    def check_alphabet(self, print_error = True):
        """
        check_alphabet(self, print_error = True) -> bool
        check_alphabet(self) -> bool

        check whether symbols in histogram are valid in alphabet e.g. for DNA
        if only letters ACGT appear

        Parameters:
        -----------

        print_error:  if errors shall be printed

        if symbols in histogram are valid in alphabet 
        """
        return _modshogun.Alphabet_check_alphabet(self, print_error)

    def is_valid(self, *args):
        """
        is_valid(self, c) -> bool

        check whether symbols are valid in alphabet e.g. for DNA if symbol is
        one of the A,C,G or T

        Parameters:
        -----------

        c:  symbol

        if symbol is a valid stracter in alphabet 
        """
        return _modshogun.Alphabet_is_valid(self, *args)

    def check_alphabet_size(self, print_error = True):
        """
        check_alphabet_size(self, print_error = True) -> bool
        check_alphabet_size(self) -> bool

        check whether symbols in histogram ALL fit in alphabet

        Parameters:
        -----------

        print_error:  if errors shall be printed

        if symbols in histogram ALL fit in alphabet 
        """
        return _modshogun.Alphabet_check_alphabet_size(self, print_error)

    def get_num_symbols_in_histogram(self):
        """
        get_num_symbols_in_histogram(self) ->  int

        return number of symbols in histogram

        number of symbols in histogram 
        """
        return _modshogun.Alphabet_get_num_symbols_in_histogram(self)

    def get_max_value_in_histogram(self):
        """
        get_max_value_in_histogram(self) ->  int

        return maximum value in histogram

        maximum value in histogram 
        """
        return _modshogun.Alphabet_get_max_value_in_histogram(self)

    def get_num_bits_in_histogram(self):
        """
        get_num_bits_in_histogram(self) ->  int

        return number of bits required to store all symbols in histogram

        number of bits required to store all symbols in histogram 
        """
        return _modshogun.Alphabet_get_num_bits_in_histogram(self)

    def get_alphabet_name(*args):
        """get_alphabet_name(alphabet) -> str"""
        return _modshogun.Alphabet_get_alphabet_name(*args)

    if _newclass:get_alphabet_name = staticmethod(get_alphabet_name)
    __swig_getmethods__["get_alphabet_name"] = lambda x: get_alphabet_name
    __swig_setmethods__["alphabet_names"] = _modshogun.Alphabet_alphabet_names_set
    __swig_getmethods__["alphabet_names"] = _modshogun.Alphabet_alphabet_names_get
    if _newclass:alphabet_names = _swig_property(_modshogun.Alphabet_alphabet_names_get, _modshogun.Alphabet_alphabet_names_set)
Alphabet_swigregister = _modshogun.Alphabet_swigregister
Alphabet_swigregister(Alphabet)

def Alphabet_get_alphabet_name(*args):
  """Alphabet_get_alphabet_name(alphabet) -> str"""
  return _modshogun.Alphabet_get_alphabet_name(*args)
Alphabet.B_A = _modshogun.cvar.Alphabet_B_A
Alphabet.B_C = _modshogun.cvar.Alphabet_B_C
Alphabet.B_G = _modshogun.cvar.Alphabet_B_G
Alphabet.B_T = _modshogun.cvar.Alphabet_B_T
Alphabet.B_0 = _modshogun.cvar.Alphabet_B_0
Alphabet.MAPTABLE_UNDEF = _modshogun.cvar.Alphabet_MAPTABLE_UNDEF

class Features(SGObject):
    """
    The class Features is the base class of all feature objects.

    It can be understood as a dense real valued feature matrix (with e.g.
    columns as single feature vectors), a set of strings, graphs or any
    other arbitrary collection of objects. As a result this class is kept
    very general and implements only very weak interfaces to

    duplicate the Feature object

    obtain the feature type (like F_DREAL, F_SHORT ...)

    obtain the feature class (like Simple dense matrices, sparse or
    strings)

    obtain the number of feature "vectors"

    In addition it provides helpers to check e.g. for compability of
    feature objects.

    Currently there are 3 general feature classes, which are
    CSimpleFeatures (dense matrices), CSparseFeatures (sparse matrices),
    CStringFeatures (a set of strings) from which all the specific
    features like CSimpleFeatures<float64_t> (dense real valued feature
    matrices) are derived.

    Subsets may be supported by inheriting classes. Sub-classes may want
    to overwrite the subset_changed_post() method which is called
    automatically after each subset change

    C++ includes: Features.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Features, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Features, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def duplicate(self):
        """
        duplicate(self) -> Features

        duplicate feature object

        abstract base method

        feature object 
        """
        return _modshogun.Features_duplicate(self)

    __swig_destroy__ = _modshogun.delete_Features
    __del__ = lambda self : None;
    def get_feature_type(self):
        """
        get_feature_type(self) -> EFeatureType

        get feature type

        abstract base method

        templated feature type 
        """
        return _modshogun.Features_get_feature_type(self)

    def get_feature_class(self):
        """
        get_feature_class(self) -> EFeatureClass

        get feature class

        abstract base method

        feature class like STRING, SIMPLE, SPARSE... 
        """
        return _modshogun.Features_get_feature_class(self)

    def add_preprocessor(self, *args):
        """
        add_preprocessor(self, p) ->  int

        add preprocessor

        Parameters:
        -----------

        p:  preprocessor to set

        something inty 
        """
        return _modshogun.Features_add_preprocessor(self, *args)

    def del_preprocessor(self, *args):
        """
        del_preprocessor(self, num) -> Preprocessor

        delete preprocessor from list caller has to clean up returned preproc

        Parameters:
        -----------

        num:  index of preprocessor in list 
        """
        return _modshogun.Features_del_preprocessor(self, *args)

    def get_preprocessor(self, *args):
        """
        get_preprocessor(self, num) -> Preprocessor

        get specified preprocessor

        Parameters:
        -----------

        num:  index of preprocessor in list 
        """
        return _modshogun.Features_get_preprocessor(self, *args)

    def set_preprocessed(self, *args):
        """
        set_preprocessed(self, num)

        set applied flag for preprocessor

        Parameters:
        -----------

        num:  index of preprocessor in list 
        """
        return _modshogun.Features_set_preprocessed(self, *args)

    def is_preprocessed(self, *args):
        """
        is_preprocessed(self, num) -> bool

        get whether specified preprocessor was already applied

        Parameters:
        -----------

        num:  index of preprocessor in list 
        """
        return _modshogun.Features_is_preprocessed(self, *args)

    def get_num_preprocessed(self):
        """
        get_num_preprocessed(self) ->  int

        get the number of applied preprocs

        number of applied preprocessors 
        """
        return _modshogun.Features_get_num_preprocessed(self)

    def get_num_preprocessors(self):
        """
        get_num_preprocessors(self) ->  int

        get number of preprocessors

        number of preprocessors 
        """
        return _modshogun.Features_get_num_preprocessors(self)

    def clean_preprocessors(self):
        """
        clean_preprocessors(self)

        clears all preprocs 
        """
        return _modshogun.Features_clean_preprocessors(self)

    def get_cache_size(self):
        """
        get_cache_size(self) ->  int

        get cache size

        cache size 
        """
        return _modshogun.Features_get_cache_size(self)

    def get_num_vectors(self):
        """
        get_num_vectors(self) ->  int

        get number of examples/vectors, possibly corresponding to the current
        subset

        abstract base method

        number of examples/vectors (possibly of subset, if implemented) 
        """
        return _modshogun.Features_get_num_vectors(self)

    def reshape(self, *args):
        """
        reshape(self, num_features, num_vectors) -> bool

        in case there is a feature matrix allow for reshaping

        NOT IMPLEMENTED!

        Parameters:
        -----------

        num_features:  new number of features

        num_vectors:  new number of vectors

        if reshaping was successful 
        """
        return _modshogun.Features_reshape(self, *args)

    def get_size(self):
        """
        get_size(self) ->  int

        get memory footprint of one feature

        abstract base method

        memory footprint of one feature 
        """
        return _modshogun.Features_get_size(self)

    def list_feature_obj(self):
        """
        list_feature_obj(self)

        list feature object 
        """
        return _modshogun.Features_list_feature_obj(self)

    def load(self, *args):
        """
        load(self, loader)

        load features from file

        Parameters:
        -----------

        loader:  File object via which data shall be loaded 
        """
        return _modshogun.Features_load(self, *args)

    def save(self, *args):
        """
        save(self, writer)

        save features to file

        Parameters:
        -----------

        writer:  File object via which data shall be saved 
        """
        return _modshogun.Features_save(self, *args)

    def check_feature_compatibility(self, *args):
        """
        check_feature_compatibility(self, f) -> bool

        check feature compatibility

        Parameters:
        -----------

        f:  features to check for compatibility

        if features are compatible 
        """
        return _modshogun.Features_check_feature_compatibility(self, *args)

    def has_property(self, *args):
        """
        has_property(self, p) -> bool

        check if features have given property

        Parameters:
        -----------

        p:  feature property

        if features have given property 
        """
        return _modshogun.Features_has_property(self, *args)

    def set_property(self, *args):
        """
        set_property(self, p)

        set property

        Parameters:
        -----------

        p:  kernel property to set 
        """
        return _modshogun.Features_set_property(self, *args)

    def unset_property(self, *args):
        """
        unset_property(self, p)

        unset property

        Parameters:
        -----------

        p:  kernel property to unset 
        """
        return _modshogun.Features_unset_property(self, *args)

    def set_subset(self, *args):
        """
        set_subset(self, subset)

        setter for subset variable, deletes old one subset_changed_post() is
        called afterwards

        Parameters:
        -----------

        subset:  subset instance to set 
        """
        return _modshogun.Features_set_subset(self, *args)

    def remove_subset(self):
        """
        remove_subset(self)

        deletes any set subset subset_changed_post() is called afterwards 
        """
        return _modshogun.Features_remove_subset(self)

    def subset_changed_post(self):
        """
        subset_changed_post(self)

        method may be overwritten to update things that depend on subset 
        """
        return _modshogun.Features_subset_changed_post(self)

    def subset_idx_conversion(self, *args):
        """
        subset_idx_conversion(self, idx) -> index_t

        does subset index conversion with the underlying subset if possible

        Parameters:
        -----------

        idx:  index to convert

        converted index 
        """
        return _modshogun.Features_subset_idx_conversion(self, *args)

    def has_subset(self):
        """
        has_subset(self) -> bool

        check if has subsets true if has subsets 
        """
        return _modshogun.Features_has_subset(self)

    def copy_subset(self, *args):
        """
        copy_subset(self, indices) -> Features

        Creates a new CFeatures instance containing copies of the elements
        which are specified by the provided indices.

        This method is needed for a KernelMachine to store its model data. NOT
        IMPLEMENTED!

        Parameters:
        -----------

        indices:  indices of feature elements to copy

        new CFeatures instance with copies of feature data 
        """
        return _modshogun.Features_copy_subset(self, *args)

Features_swigregister = _modshogun.Features_swigregister
Features_swigregister(Features)

class DotFeatures(Features):
    """
    Features that support dot products among other operations.

    DotFeatures support the following operations:

    a way to obtain the dimensionality of the feature space, i.e.
    $\\mbox{dim}({\\cal X})$

    dot product between feature vectors:

    \\[r = {\\bf x} \\cdot {\\bf x'}\\]

    dot product between feature vector and a dense vector ${\\bf z}$:

    \\[r = {\\bf x} \\cdot {\\bf z}\\]

    multiplication with a scalar $\\alpha$ and addition to a dense
    vector ${\\bf z}$:

    \\[ {\\bf z'} = \\alpha {\\bf x} + {\\bf z} \\]

    iteration over all (potentially) non-zero features of ${\\bf x}$

    C++ includes: DotFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DotFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DotFeatures, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_DotFeatures
    __del__ = lambda self : None;
    def get_dim_feature_space(self):
        """
        get_dim_feature_space(self) ->  int

        obtain the dimensionality of the feature space

        (not mix this up with the dimensionality of the input space, usually
        obtained via get_num_features())

        dimensionality 
        """
        return _modshogun.DotFeatures_get_dim_feature_space(self)

    def dot(self, *args):
        """
        dot(self, vec_idx1, df, vec_idx2) -> float

        compute dot product between vector1 and vector2, appointed by their
        indices

        Parameters:
        -----------

        vec_idx1:  index of first vector

        df:  DotFeatures (of same kind) to compute dot product with

        vec_idx2:  index of second vector 
        """
        return _modshogun.DotFeatures_dot(self, *args)

    def get_nnz_features_for_vector(self, *args):
        """
        get_nnz_features_for_vector(self, num) ->  int

        get number of non-zero features in vector

        (in case accurate estimates are too expensive overestimating is OK)

        Parameters:
        -----------

        num:  which vector

        number of sparse features in vector 
        """
        return _modshogun.DotFeatures_get_nnz_features_for_vector(self, *args)

    def get_combined_feature_weight(self):
        """
        get_combined_feature_weight(self) -> float

        get combined feature weight

        combined feature weight 
        """
        return _modshogun.DotFeatures_get_combined_feature_weight(self)

    def set_combined_feature_weight(self, *args):
        """
        set_combined_feature_weight(self, nw)

        set combined kernel weight

        Parameters:
        -----------

        nw:  new combined feature weight 
        """
        return _modshogun.DotFeatures_set_combined_feature_weight(self, *args)

    def get_computed_dot_feature_matrix(self):
        """
        get_computed_dot_feature_matrix(self) -> RealMatrix

        compute the feature matrix in feature space

        computed feature matrix 
        """
        return _modshogun.DotFeatures_get_computed_dot_feature_matrix(self)

    def get_computed_dot_feature_vector(self, *args):
        """
        get_computed_dot_feature_vector(self, num) -> RealVector

        compute the feature vector in feature space

        computed feature vector 
        """
        return _modshogun.DotFeatures_get_computed_dot_feature_vector(self, *args)

    def benchmark_add_to_dense_vector(self, repeats = 5):
        """
        benchmark_add_to_dense_vector(self, repeats = 5)
        benchmark_add_to_dense_vector(self)

        run benchmark for add_to_dense_vec 
        """
        return _modshogun.DotFeatures_benchmark_add_to_dense_vector(self, repeats)

    def benchmark_dense_dot_range(self, repeats = 5):
        """
        benchmark_dense_dot_range(self, repeats = 5)
        benchmark_dense_dot_range(self)

        run benchmark for dense_dot_range 
        """
        return _modshogun.DotFeatures_benchmark_dense_dot_range(self, repeats)

    def get_mean(self):
        """
        get_mean(self) -> RealVector

        get mean

        mean returned 
        """
        return _modshogun.DotFeatures_get_mean(self)

    def get_cov(self):
        """
        get_cov(self) -> RealMatrix

        get covariance

        covariance 
        """
        return _modshogun.DotFeatures_get_cov(self)

DotFeatures_swigregister = _modshogun.DotFeatures_swigregister
DotFeatures_swigregister(DotFeatures)

class StreamingFeatures(Features):
    """
    Streaming features are features which are used for online algorithms.

    Reading/parsing of input, and learning through the algorithm are
    carried out in separate threads. Input is from a CStreamingFile
    object.

    A StreamingFeatures object usually stores only one example at a time,
    and any function like dot(), add_to_dense_vec() etc. apply with this
    example as one implicit operand.

    Similarly, when we refer to the "feature vector" of a
    StreamingFeatures object, it refers to the vector of the example
    currently stored in that object.

    It is up to the user to indicate when he is done using the example so
    that the next one can be fetched and stored in its place.

    Example objects are fetched one-by-one through a CInputParser object,
    and therefore a StreamingFeatures object must implement the following
    methods in the derived class:

    start_parser(): a function to begin processing of the input.

    end_parser(): end the parser; wait for the parsing thread to finish.

    get_next_example(): instruct the parser to get the next example.

    release_example(): instruct the parser to release the current example.

    get_label(): returns the label (if applicable) for the current
    example.

    get_num_features(): returns the number of features for the current
    example.

    release_example() must be called before get_next_example().

    The feature vector itself may be returned through a derived class
    since at the moment the parser is templated for each data type.

    Thus, a templated or specialized version of get_vector(SGVector<T>)
    must be implemented in the derived class.

    C++ includes: StreamingFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingFeatures, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StreamingFeatures
    __del__ = lambda self : None;
    def set_read_functions(self):
        """
        set_read_functions(self)

        Set the vector reading functions.

        The functions are implemented specific to the type in the derived
        class. 
        """
        return _modshogun.StreamingFeatures_set_read_functions(self)

    def set_vector_reader(self):
        """
        set_vector_reader(self)

        The derived object must set the function which will be used for
        reading one vector from the file. This function should be a member of
        the CStreamingFile class.

        See the implementation in StreamingSimpleFeatures for details. 
        """
        return _modshogun.StreamingFeatures_set_vector_reader(self)

    def set_vector_and_label_reader(self):
        """
        set_vector_and_label_reader(self)

        The derived object must set the function which will be used by the
        parser for reading one vector and label from the file. This function
        should be a member of the CStreamingFile class.

        See the implementation in StreamingSimpleFeatures for details. 
        """
        return _modshogun.StreamingFeatures_set_vector_and_label_reader(self)

    def start_parser(self):
        """
        start_parser(self)

        Start the parser. It stores parsed examples from the input in a
        separate thread. 
        """
        return _modshogun.StreamingFeatures_start_parser(self)

    def end_parser(self):
        """
        end_parser(self)

        End the parser. Wait for the parsing thread to complete. 
        """
        return _modshogun.StreamingFeatures_end_parser(self)

    def get_label(self):
        """
        get_label(self) -> float

        Return the label of the current example.

        Raise an error if the input has been specified as unlabelled.

        Label (if labelled example) 
        """
        return _modshogun.StreamingFeatures_get_label(self)

    def get_next_example(self):
        """
        get_next_example(self) -> bool

        Indicate to the parser that it must fetch the next example.

        true on success, false on failure (i.e., no more examples). 
        """
        return _modshogun.StreamingFeatures_get_next_example(self)

    def release_example(self):
        """
        release_example(self)

        Indicate that processing of the current example is done. The parser
        then considers it safe to dispose of that example and replace it with
        another one. 
        """
        return _modshogun.StreamingFeatures_release_example(self)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        Get the number of features in the current example.

        number of features in current example 
        """
        return _modshogun.StreamingFeatures_get_num_features(self)

    def get_has_labels(self):
        """
        get_has_labels(self) -> bool

        Return whether the examples are labelled or not.

        true if labelled, else false 
        """
        return _modshogun.StreamingFeatures_get_has_labels(self)

    def is_seekable(self):
        """
        is_seekable(self) -> bool

        Whether the stream is seekable (to check if multiple epochs are
        possible), i.e., whether we can process examples in a batch fashion.

        A stream can usually seekable when it comes from a file or when it
        comes from another conventional CFeatures object.

        true if seekable, else false. 
        """
        return _modshogun.StreamingFeatures_is_seekable(self)

    def reset_stream(self):
        """
        reset_stream(self)

        Function to reset the stream (if possible). 
        """
        return _modshogun.StreamingFeatures_reset_stream(self)

StreamingFeatures_swigregister = _modshogun.StreamingFeatures_swigregister
StreamingFeatures_swigregister(StreamingFeatures)

class StreamingDotFeatures(StreamingFeatures):
    """
    Streaming features that support dot products among other operations.

    DotFeatures support the following operations:

    a way to obtain the dimensionality of the feature space, i.e.
    $\\mbox{dim}({\\cal X})$

    dot product between feature vectors:

    \\[r = {\\bf x} \\cdot {\\bf x'}\\]

    dot product between feature vector and a dense vector ${\\bf z}$:

    \\[r = {\\bf x} \\cdot {\\bf z}\\]

    multiplication with a scalar $\\alpha$ and addition to a dense
    vector ${\\bf z}$:

    \\[ {\\bf z'} = \\alpha {\\bf x} + {\\bf z} \\]

    iteration over all (potentially) non-zero features of ${\\bf x}$

    C++ includes: StreamingDotFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingDotFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingDotFeatures, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StreamingDotFeatures
    __del__ = lambda self : None;
    def dot(self, *args):
        """
        dot(self, df) -> float

        compute dot product between vectors of two StreamingDotFeatures
        objects.

        Parameters:
        -----------

        df:  StreamingDotFeatures (of same kind) to compute dot product with

        """
        return _modshogun.StreamingDotFeatures_dot(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingDotFeatures_expand_if_required(self, *args)

    def get_dim_feature_space(self):
        """
        get_dim_feature_space(self) ->  int

        obtain the dimensionality of the feature space

        (not mix this up with the dimensionality of the input space, usually
        obtained via get_num_features())

        dimensionality 
        """
        return _modshogun.StreamingDotFeatures_get_dim_feature_space(self)

    def get_nnz_features_for_vector(self):
        """
        get_nnz_features_for_vector(self) ->  int

        get number of non-zero features in vector

        (in case accurate estimates are too expensive overestimating is OK)

        number of sparse features in vector 
        """
        return _modshogun.StreamingDotFeatures_get_nnz_features_for_vector(self)

StreamingDotFeatures_swigregister = _modshogun.StreamingDotFeatures_swigregister
StreamingDotFeatures_swigregister(StreamingDotFeatures)

class StreamingVwFeatures(StreamingDotFeatures):
    """
    This class implements streaming features for use with VW.

    Each example is stored in a VwExample object, which also contains
    label and other information. Features are hashed and are supposed to
    be used with a weight vector of preallocated dimensions.

    C++ includes: StreamingVwFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingVwFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingVwFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingVwFeatures
        __init__(self, file, is_labelled, size) -> StreamingVwFeatures
        __init__(self, file, is_labelled, size) -> StreamingVwFeatures

        Constructor used when initialized with a cache file.

        Parameters:
        -----------

        file:  StreamingVwCacheFile object

        is_labelled:  Whether examples are labelled or not

        size:  Number of example objects to be stored in the parser at a time

        """
        this = _modshogun.new_StreamingVwFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingVwFeatures
    __del__ = lambda self : None;
    def get_env(self):
        """
        get_env(self) -> CVwEnvironment

        Get the environment environment 
        """
        return _modshogun.StreamingVwFeatures_get_env(self)

    def set_env(self, *args):
        """
        set_env(self, vw_env)

        Set the environment

        Parameters:
        -----------

        vw_env:  environment 
        """
        return _modshogun.StreamingVwFeatures_set_env(self, *args)

    def get_example(self):
        """
        get_example(self) -> VwExample

        Returns the current example.

        current example as VwExample* 
        """
        return _modshogun.StreamingVwFeatures_get_example(self)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingVwFeatures_expand_if_required(self, *args)

    def real_weight(self, *args):
        """
        real_weight(self, w, gravity) -> float

        Reduce element 'w' to max(w-gravity, 0)

        Parameters:
        -----------

        w:  value to truncate

        gravity:  value to truncate using

        truncated value 
        """
        return _modshogun.StreamingVwFeatures_real_weight(self, *args)

    def dense_dot_truncated(self, *args):
        """
        dense_dot_truncated(self, vec2, ex, gravity) -> float

        Calculate dot product of features with another vector, truncating the
        elements of that vector by magnitude 'gravity' to a minimum final
        magnitude of zero.

        Parameters:
        -----------

        vec2:  vector to take dot product with

        ex:  example whose features have to be taken

        gravity:  value to use for truncating

        dot product 
        """
        return _modshogun.StreamingVwFeatures_dense_dot_truncated(self, *args)

StreamingVwFeatures_swigregister = _modshogun.StreamingVwFeatures_swigregister
StreamingVwFeatures_swigregister(StreamingVwFeatures)

class StringBoolFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringBoolFeatures
        __init__(self, alpha) -> StringBoolFeatures
        __init__(self, string_list, alpha) -> StringBoolFeatures
        __init__(self, string_list, alpha) -> StringBoolFeatures
        __init__(self, alpha) -> StringBoolFeatures
        __init__(self, orig) -> StringBoolFeatures
        __init__(self, loader, alpha = DNA) -> StringBoolFeatures
        __init__(self, loader) -> StringBoolFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringBoolFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringBoolFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringBoolFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringBoolFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> BoolVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringBoolFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringBoolFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringBoolFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringBoolFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringBoolFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringBoolFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> bool

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringBoolFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringBoolFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringBoolFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringBoolFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringBoolFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringBoolFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringBoolFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> bool

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringBoolFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> bool

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringBoolFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> bool

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringBoolFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringBoolFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringBoolFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringBoolFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringBoolFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringBoolFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringBoolFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> BoolStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringBoolFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringBoolFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringBoolFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringBoolFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringBoolFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringBoolFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringBoolFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringBoolFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringBoolFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringBoolFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringBoolFeatures_determine_maximum_string_length(self)

StringBoolFeatures_swigregister = _modshogun.StringBoolFeatures_swigregister
StringBoolFeatures_swigregister(StringBoolFeatures)

class StringCharFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringCharFeatures
        __init__(self, alpha) -> StringCharFeatures
        __init__(self, string_list, alpha) -> StringCharFeatures
        __init__(self, string_list, alpha) -> StringCharFeatures
        __init__(self, alpha) -> StringCharFeatures
        __init__(self, orig) -> StringCharFeatures
        __init__(self, loader, alpha = DNA) -> StringCharFeatures
        __init__(self, loader) -> StringCharFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringCharFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringCharFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringCharFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringCharFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> CharVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringCharFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringCharFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringCharFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringCharFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringCharFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringCharFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> str

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringCharFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringCharFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringCharFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringCharFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringCharFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringCharFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringCharFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> str

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringCharFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> str

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringCharFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> str

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringCharFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringCharFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringCharFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringCharFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringCharFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringCharFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringCharFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> CharStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringCharFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringCharFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringCharFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringCharFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringCharFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringCharFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringCharFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringCharFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringCharFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringCharFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringCharFeatures_determine_maximum_string_length(self)

StringCharFeatures_swigregister = _modshogun.StringCharFeatures_swigregister
StringCharFeatures_swigregister(StringCharFeatures)

class StringByteFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringByteFeatures
        __init__(self, alpha) -> StringByteFeatures
        __init__(self, string_list, alpha) -> StringByteFeatures
        __init__(self, string_list, alpha) -> StringByteFeatures
        __init__(self, alpha) -> StringByteFeatures
        __init__(self, orig) -> StringByteFeatures
        __init__(self, loader, alpha = DNA) -> StringByteFeatures
        __init__(self, loader) -> StringByteFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringByteFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringByteFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringByteFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringByteFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ByteVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringByteFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringByteFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringByteFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringByteFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringByteFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringByteFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> unsigned str

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringByteFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringByteFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringByteFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringByteFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringByteFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringByteFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringByteFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> unsigned str

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringByteFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> unsigned str

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringByteFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> unsigned str

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringByteFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringByteFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringByteFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringByteFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringByteFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringByteFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringByteFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> ByteStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringByteFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringByteFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringByteFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringByteFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringByteFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringByteFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringByteFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringByteFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringByteFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringByteFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringByteFeatures_determine_maximum_string_length(self)

StringByteFeatures_swigregister = _modshogun.StringByteFeatures_swigregister
StringByteFeatures_swigregister(StringByteFeatures)

class StringWordFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringWordFeatures
        __init__(self, alpha) -> StringWordFeatures
        __init__(self, string_list, alpha) -> StringWordFeatures
        __init__(self, string_list, alpha) -> StringWordFeatures
        __init__(self, alpha) -> StringWordFeatures
        __init__(self, orig) -> StringWordFeatures
        __init__(self, loader, alpha = DNA) -> StringWordFeatures
        __init__(self, loader) -> StringWordFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringWordFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringWordFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringWordFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringWordFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> WordVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringWordFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringWordFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringWordFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringWordFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringWordFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringWordFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> unsigned short

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringWordFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringWordFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringWordFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringWordFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringWordFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringWordFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringWordFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> unsigned short

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringWordFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> unsigned short

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringWordFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> unsigned short

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringWordFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringWordFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringWordFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringWordFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringWordFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringWordFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringWordFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> WordStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringWordFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringWordFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringWordFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringWordFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringWordFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringWordFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringWordFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringWordFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringWordFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringWordFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringWordFeatures_determine_maximum_string_length(self)

StringWordFeatures_swigregister = _modshogun.StringWordFeatures_swigregister
StringWordFeatures_swigregister(StringWordFeatures)

class StringIntFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringIntFeatures
        __init__(self, alpha) -> StringIntFeatures
        __init__(self, string_list, alpha) -> StringIntFeatures
        __init__(self, string_list, alpha) -> StringIntFeatures
        __init__(self, alpha) -> StringIntFeatures
        __init__(self, orig) -> StringIntFeatures
        __init__(self, loader, alpha = DNA) -> StringIntFeatures
        __init__(self, loader) -> StringIntFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringIntFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringIntFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringIntFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringIntFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> IntVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringIntFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringIntFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringIntFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringIntFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringIntFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringIntFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> int

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringIntFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringIntFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringIntFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringIntFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringIntFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringIntFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringIntFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> int

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringIntFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> int

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringIntFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> int

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringIntFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringIntFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringIntFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringIntFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringIntFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringIntFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringIntFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> IntStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringIntFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringIntFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringIntFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringIntFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringIntFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringIntFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringIntFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringIntFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringIntFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringIntFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringIntFeatures_determine_maximum_string_length(self)

StringIntFeatures_swigregister = _modshogun.StringIntFeatures_swigregister
StringIntFeatures_swigregister(StringIntFeatures)

class StringLongFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringLongFeatures
        __init__(self, alpha) -> StringLongFeatures
        __init__(self, string_list, alpha) -> StringLongFeatures
        __init__(self, string_list, alpha) -> StringLongFeatures
        __init__(self, alpha) -> StringLongFeatures
        __init__(self, orig) -> StringLongFeatures
        __init__(self, loader, alpha = DNA) -> StringLongFeatures
        __init__(self, loader) -> StringLongFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringLongFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringLongFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringLongFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringLongFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> LongIntVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringLongFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringLongFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringLongFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringLongFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringLongFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringLongFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> long long

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringLongFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringLongFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringLongFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringLongFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringLongFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringLongFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringLongFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> long long

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringLongFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> long long

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringLongFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> long long

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringLongFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringLongFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringLongFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringLongFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringLongFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringLongFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringLongFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> LongIntStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringLongFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringLongFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringLongFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringLongFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringLongFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringLongFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringLongFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringLongFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringLongFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringLongFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringLongFeatures_determine_maximum_string_length(self)

StringLongFeatures_swigregister = _modshogun.StringLongFeatures_swigregister
StringLongFeatures_swigregister(StringLongFeatures)

class StringUlongFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringUlongFeatures
        __init__(self, alpha) -> StringUlongFeatures
        __init__(self, string_list, alpha) -> StringUlongFeatures
        __init__(self, string_list, alpha) -> StringUlongFeatures
        __init__(self, alpha) -> StringUlongFeatures
        __init__(self, orig) -> StringUlongFeatures
        __init__(self, loader, alpha = DNA) -> StringUlongFeatures
        __init__(self, loader) -> StringUlongFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringUlongFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringUlongFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringUlongFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringUlongFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ULongIntVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringUlongFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringUlongFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringUlongFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringUlongFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringUlongFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringUlongFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> unsigned long long

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringUlongFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringUlongFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringUlongFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringUlongFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringUlongFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringUlongFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringUlongFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> unsigned long long

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringUlongFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> unsigned long long

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringUlongFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> unsigned long long

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringUlongFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringUlongFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringUlongFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringUlongFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringUlongFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringUlongFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringUlongFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> ULongIntStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringUlongFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringUlongFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringUlongFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringUlongFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringUlongFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringUlongFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringUlongFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringUlongFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringUlongFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringUlongFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringUlongFeatures_determine_maximum_string_length(self)

StringUlongFeatures_swigregister = _modshogun.StringUlongFeatures_swigregister
StringUlongFeatures_swigregister(StringUlongFeatures)

class StringShortRealFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringShortRealFeatures
        __init__(self, alpha) -> StringShortRealFeatures
        __init__(self, string_list, alpha) -> StringShortRealFeatures
        __init__(self, string_list, alpha) -> StringShortRealFeatures
        __init__(self, alpha) -> StringShortRealFeatures
        __init__(self, orig) -> StringShortRealFeatures
        __init__(self, loader, alpha = DNA) -> StringShortRealFeatures
        __init__(self, loader) -> StringShortRealFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringShortRealFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringShortRealFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringShortRealFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringShortRealFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ShortRealVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringShortRealFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringShortRealFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringShortRealFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringShortRealFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringShortRealFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringShortRealFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> float

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringShortRealFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringShortRealFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringShortRealFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringShortRealFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringShortRealFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringShortRealFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringShortRealFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> float

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringShortRealFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> float

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringShortRealFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> float

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringShortRealFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringShortRealFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringShortRealFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringShortRealFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringShortRealFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringShortRealFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringShortRealFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> ShortRealStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringShortRealFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringShortRealFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringShortRealFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringShortRealFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringShortRealFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringShortRealFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringShortRealFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringShortRealFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringShortRealFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringShortRealFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringShortRealFeatures_determine_maximum_string_length(self)

StringShortRealFeatures_swigregister = _modshogun.StringShortRealFeatures_swigregister
StringShortRealFeatures_swigregister(StringShortRealFeatures)

class StringRealFeatures(Features):
    """
    Template class StringFeatures implements a list of strings.

    As this class is a template the underlying storage type is quite
    arbitrary and not limited to stracter strings, but could also be
    sequences of floating point numbers etc. Strings differ from matrices
    (cf. CSimpleFeatures) in a way that the dimensionality of the feature
    vectors (i.e. the strings) is not fixed; it may vary between strings.

    Most string kernels require StringFeatures but a number of them
    actually requires strings to have same length.

    When preprocessors are attached to string features they may shorten
    the string, but are not allowed to return strings longer than
    max_string_length, as some algorithms depend on this.

    Also note that string features cannot currently be computed on-the-
    fly.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: StringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringRealFeatures
        __init__(self, alpha) -> StringRealFeatures
        __init__(self, string_list, alpha) -> StringRealFeatures
        __init__(self, string_list, alpha) -> StringRealFeatures
        __init__(self, alpha) -> StringRealFeatures
        __init__(self, orig) -> StringRealFeatures
        __init__(self, loader, alpha = DNA) -> StringRealFeatures
        __init__(self, loader) -> StringRealFeatures

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringRealFeatures
    __del__ = lambda self : None;
    def cleanup_feature_vector(self, *args):
        """
        cleanup_feature_vector(self, num)

        cleanup a single feature vector

        possible with subset

        Parameters:
        -----------

        num:  number of the vector 
        """
        return _modshogun.StringRealFeatures_cleanup_feature_vector(self, *args)

    def cleanup_feature_vectors(self, *args):
        """
        cleanup_feature_vectors(self, start, stop)

        cleanup multiple feature vectors

        possible with subset

        Parameters:
        -----------

        start:  index of first vector to be cleaned

        stop:  index of the last vector to be cleaned 
        """
        return _modshogun.StringRealFeatures_cleanup_feature_vectors(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        get alphabet used in string features

        alphabet 
        """
        return _modshogun.StringRealFeatures_get_alphabet(self)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> RealVector

        get feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        len:  length is returned by reference

        dofree:  whether returned vector must be freed by caller via
        free_feature_vector

        feature vector for sample num 
        """
        return _modshogun.StringRealFeatures_get_feature_vector(self, *args)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector for sample num

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        string:  string with the feature vector's content

        len:  length of the string 
        """
        return _modshogun.StringRealFeatures_set_feature_vector(self, *args)

    def enable_on_the_fly_preprocessing(self):
        """
        enable_on_the_fly_preprocessing(self)

        call this to preprocess string features upon get_feature_vector 
        """
        return _modshogun.StringRealFeatures_enable_on_the_fly_preprocessing(self)

    def disable_on_the_fly_preprocessing(self):
        """
        disable_on_the_fly_preprocessing(self)

        call this to disable on the fly feature preprocessing on
        get_feature_vector. Useful when you manually apply preprocessors. 
        """
        return _modshogun.StringRealFeatures_disable_on_the_fly_preprocessing(self)

    def get_transposed(self):
        """
        get_transposed(self) -> StringRealFeatures

        compute and return the transpose of string features matrix which will
        be prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        note that strings all have to have same length

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed string features 
        """
        return _modshogun.StringRealFeatures_get_transposed(self)

    def get_feature(self, *args):
        """
        get_feature(self, vec_num, feat_num) -> float

        get feature

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector

        feat_num:  which feature, possibly from subset

        feature 
        """
        return _modshogun.StringRealFeatures_get_feature(self, *args)

    def get_vector_length(self, *args):
        """
        get_vector_length(self, vec_num) ->  int

        get vector length

        possible with subset

        Parameters:
        -----------

        vec_num:  which vector, possibly from subset

        length of vector 
        """
        return _modshogun.StringRealFeatures_get_vector_length(self, *args)

    def get_max_vector_length(self):
        """
        get_max_vector_length(self) ->  int

        get maximum vector length

        this one is updated when a subset is set

        maximum vector/string length 
        """
        return _modshogun.StringRealFeatures_get_max_vector_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StringRealFeatures_get_num_symbols(self)

    def get_max_num_symbols(self):
        """
        get_max_num_symbols(self) -> floatmax_t

        get maximum number of symbols

        Note: floatmax_t sounds weird, but int is not long enough (and
        there is no int128_t type)

        maximum number of symbols 
        """
        return _modshogun.StringRealFeatures_get_max_num_symbols(self)

    def get_original_num_symbols(self):
        """
        get_original_num_symbols(self) -> floatmax_t

        number of symbols before higher order mapping

        original number of symbols 
        """
        return _modshogun.StringRealFeatures_get_original_num_symbols(self)

    def get_order(self):
        """
        get_order(self) ->  int

        order used for higher order mapping

        order 
        """
        return _modshogun.StringRealFeatures_get_order(self)

    def get_masked_symbols(self, *args):
        """
        get_masked_symbols(self, symbol, mask) -> float

        a higher order mapped symbol will be shaped such that the symbols
        specified by bits in the mask will be returned.

        Parameters:
        -----------

        symbol:  symbol to mask

        mask:  mask to apply

        masked symbol 
        """
        return _modshogun.StringRealFeatures_get_masked_symbols(self, *args)

    def shift_offset(self, *args):
        """
        shift_offset(self, offset, amount) -> float

        shift offset to the left by amount

        Parameters:
        -----------

        offset:  offset to shift

        amount:  amount to shift the offset

        shifted offset 
        """
        return _modshogun.StringRealFeatures_shift_offset(self, *args)

    def shift_symbol(self, *args):
        """
        shift_symbol(self, symbol, amount) -> float

        shift symbol to the right by amount (taking care of custom symbol
        sizes)

        Parameters:
        -----------

        symbol:  symbol to shift

        amount:  amount to shift the symbol

        shifted symbol 
        """
        return _modshogun.StringRealFeatures_shift_symbol(self, *args)

    def load_ascii_file(self, *args):
        """
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        load_ascii_file(self, fname, remap_to_bin = True, ascii_alphabet = DNA)
        load_ascii_file(self, fname, remap_to_bin = True)
        load_ascii_file(self, fname)

        load ascii line-based string features from file.

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        remap_to_bin:  if translation to other binary alphabet should be
        performed

        ascii_alphabet:  src alphabet

        binary_alphabet:  alphabet to translate to 
        """
        return _modshogun.StringRealFeatures_load_ascii_file(self, *args)

    def load_fasta_file(self, *args):
        """
        load_fasta_file(self, fname, ignore_invalid = False) -> bool
        load_fasta_file(self, fname) -> bool

        load fasta file as string features

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        if loading was successful 
        """
        return _modshogun.StringRealFeatures_load_fasta_file(self, *args)

    def load_fastq_file(self, *args):
        """
        load_fastq_file(self, fname, ignore_invalid = False, bitremap_in_single_string = False) -> bool
        load_fastq_file(self, fname, ignore_invalid = False) -> bool
        load_fastq_file(self, fname) -> bool

        load fastq file as string features

        removes subset beforehand

        Parameters:
        -----------

        fname:  filename to load from

        ignore_invalid:  if set to true, stracters other than A,C,G,T are
        converted to A

        bitremap_in_single_string:  if set to true, do binary embedding of
        symbols

        if loading was successful 
        """
        return _modshogun.StringRealFeatures_load_fastq_file(self, *args)

    def load_from_directory(self, *args):
        """
        load_from_directory(self, dirname) -> bool

        load features from directory

        removes subset before

        Parameters:
        -----------

        dirname:  directory name to load from

        if loading was successful 
        """
        return _modshogun.StringRealFeatures_load_from_directory(self, *args)

    def set_features(self, *args):
        """
        set_features(self, feats)

        set features

        not possible with subset

        Parameters:
        -----------

        p_features:  new features

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        if setting was successful 
        """
        return _modshogun.StringRealFeatures_set_features(self, *args)

    def append_features(self, *args):
        """
        append_features(self, sf) -> bool

        append features

        not possible with subset

        Parameters:
        -----------

        p_features:  features to append

        p_num_vectors:  number of vectors

        p_max_string_length:  maximum string length

        note that p_features will be SG_FREE()'d on success

        if setting was successful 
        """
        return _modshogun.StringRealFeatures_append_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> RealStringList

        get_features (swig compatible)

        possible with subset

        Parameters:
        -----------

        dst:  string features (returned)

        num_str:  number of strings (returned) 
        """
        return _modshogun.StringRealFeatures_get_features(self)

    def load_compressed(self, *args):
        """
        load_compressed(self, src, decompress) -> bool

        load compressed features from file

        any subset is removed before

        Parameters:
        -----------

        src:  filename to load from

        decompress:  whether to decompress on loading

        if loading was successful 
        """
        return _modshogun.StringRealFeatures_load_compressed(self, *args)

    def save_compressed(self, *args):
        """
        save_compressed(self, dest, compression, level) -> bool

        save compressed features to file

        not possible with subset

        Parameters:
        -----------

        dest:  filename to save to

        compression:  compressor to use

        level:  compression level to use (1-9)

        if saving was successful 
        """
        return _modshogun.StringRealFeatures_save_compressed(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.StringRealFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_by_sliding_window(self, *args):
        """
        obtain_by_sliding_window(self, window_size, step_size, skip = 0) ->  int
        obtain_by_sliding_window(self, window_size, step_size) ->  int

        slides a window of size window_size over the current single string
        step_size is the amount by which the window is shifted. creates
        (string_len-window_size)/step_size many feature obj if skip is
        nonzero, skip the first 'skip' stracters of each string

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        step_size:  step size

        skip:  skip

        something inty 
        """
        return _modshogun.StringRealFeatures_obtain_by_sliding_window(self, *args)

    def obtain_by_position_list(self, *args):
        """
        obtain_by_position_list(self, window_size, positions, skip = 0) ->  int
        obtain_by_position_list(self, window_size, positions) ->  int

        extracts windows of size window_size from first string using the
        positions in list

        not implemented for subset

        Parameters:
        -----------

        window_size:  window size

        positions:  positions

        skip:  skip

        something inty 
        """
        return _modshogun.StringRealFeatures_obtain_by_position_list(self, *args)

    def obtain_from_char(self, *args):
        """
        obtain_from_char(self, sf, start, p_order, gap, rev) -> bool

        obtain string features from str features

        wrapper for template method

        any subset is removed before, subset of parameter sf is possible

        Parameters:
        -----------

        sf:  string features

        start:  start

        p_order:  order

        gap:  gap

        rev:  reverse

        if obtaining was successful 
        """
        return _modshogun.StringRealFeatures_obtain_from_char(self, *args)

    def have_same_length(self, *args):
        """
        have_same_length(self, len = -1) -> bool
        have_same_length(self) -> bool

        check if length of each vector in this feature object equals the given
        length. if existant, only subset is checked

        possible for subset

        Parameters:
        -----------

        len:  vector length to check against

        if length of each vector in this feature object equals the given
        length. 
        """
        return _modshogun.StringRealFeatures_have_same_length(self, *args)

    def embed_features(self, *args):
        """
        embed_features(self, p_order)

        embed string features in bit representation in-place

        not implemented for subset 
        """
        return _modshogun.StringRealFeatures_embed_features(self, *args)

    def compute_symbol_mask_table(self, *args):
        """
        compute_symbol_mask_table(self, max_val)

        compute symbol mask table

        required to access bit-based symbols

        not implemented for subset 
        """
        return _modshogun.StringRealFeatures_compute_symbol_mask_table(self, *args)

    def determine_maximum_string_length(self):
        """
        determine_maximum_string_length(self)

        determine new maximum string length

        possible with subset 
        """
        return _modshogun.StringRealFeatures_determine_maximum_string_length(self)

StringRealFeatures_swigregister = _modshogun.StringRealFeatures_swigregister
StringRealFeatures_swigregister(StringRealFeatures)

class StreamingStringBoolFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringBoolFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringBoolFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringBoolFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringBoolFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringBoolFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringBoolFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringBoolFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringBoolFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringBoolFeatures_get_vector_length(self)

StreamingStringBoolFeatures_swigregister = _modshogun.StreamingStringBoolFeatures_swigregister
StreamingStringBoolFeatures_swigregister(StreamingStringBoolFeatures)

class StreamingStringCharFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringCharFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringCharFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringCharFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringCharFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringCharFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringCharFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringCharFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringCharFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringCharFeatures_get_vector_length(self)

StreamingStringCharFeatures_swigregister = _modshogun.StreamingStringCharFeatures_swigregister
StreamingStringCharFeatures_swigregister(StreamingStringCharFeatures)

class StreamingStringByteFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringByteFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringByteFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringByteFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringByteFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringByteFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringByteFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringByteFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringByteFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringByteFeatures_get_vector_length(self)

StreamingStringByteFeatures_swigregister = _modshogun.StreamingStringByteFeatures_swigregister
StreamingStringByteFeatures_swigregister(StreamingStringByteFeatures)

class StreamingStringWordFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringWordFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringWordFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringWordFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringWordFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringWordFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringWordFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringWordFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringWordFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringWordFeatures_get_vector_length(self)

StreamingStringWordFeatures_swigregister = _modshogun.StreamingStringWordFeatures_swigregister
StreamingStringWordFeatures_swigregister(StreamingStringWordFeatures)

class StreamingStringIntFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringIntFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringIntFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringIntFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringIntFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringIntFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringIntFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringIntFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringIntFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringIntFeatures_get_vector_length(self)

StreamingStringIntFeatures_swigregister = _modshogun.StreamingStringIntFeatures_swigregister
StreamingStringIntFeatures_swigregister(StreamingStringIntFeatures)

class StreamingStringLongFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringLongFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringLongFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringLongFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringLongFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringLongFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringLongFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringLongFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringLongFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringLongFeatures_get_vector_length(self)

StreamingStringLongFeatures_swigregister = _modshogun.StreamingStringLongFeatures_swigregister
StreamingStringLongFeatures_swigregister(StreamingStringLongFeatures)

class StreamingStringUlongFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringUlongFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringUlongFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringUlongFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringUlongFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringUlongFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringUlongFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringUlongFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringUlongFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringUlongFeatures_get_vector_length(self)

StreamingStringUlongFeatures_swigregister = _modshogun.StreamingStringUlongFeatures_swigregister
StreamingStringUlongFeatures_swigregister(StreamingStringUlongFeatures)

class StreamingStringShortRealFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringShortRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringShortRealFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringShortRealFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringShortRealFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringShortRealFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringShortRealFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringShortRealFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringShortRealFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringShortRealFeatures_get_vector_length(self)

StreamingStringShortRealFeatures_swigregister = _modshogun.StreamingStringShortRealFeatures_swigregister
StreamingStringShortRealFeatures_swigregister(StreamingStringShortRealFeatures)

class StreamingStringRealFeatures(StreamingFeatures):
    """
    This class implements streaming features as strings.

    C++ includes: StreamingStringFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingStringRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingStringRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingStringRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingStringRealFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingStringRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingStringRealFeatures
    __del__ = lambda self : None;
    def use_alphabet(self, *args):
        """
        use_alphabet(self, alpha)
        use_alphabet(self, alpha)

        Set the alphabet to be used. Call before parsing.

        Parameters:
        -----------

        alpha:  alphabet as a pointer to a CAlphabet object. 
        """
        return _modshogun.StreamingStringRealFeatures_use_alphabet(self, *args)

    def set_remap(self, *args):
        """
        set_remap(self, ascii_alphabet, binary_alphabet)
        set_remap(self, ascii_alphabet = DNA, binary_alphabet = RAWDNA)
        set_remap(self, ascii_alphabet = DNA)
        set_remap(self)

        Set whether remapping to another alphabet is required.

        Call before parsing.

        Parameters:
        -----------

        ascii_alphabet:  the alphabet to convert from, EAlphabet

        binary_alphabet:  the alphabet to convert to, EAlphabet 
        """
        return _modshogun.StreamingStringRealFeatures_set_remap(self, *args)

    def get_alphabet(self):
        """
        get_alphabet(self) -> Alphabet

        Return the alphabet being used as a CAlphabet* 
        """
        return _modshogun.StreamingStringRealFeatures_get_alphabet(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) -> floatmax_t

        get number of symbols

        Note: floatmax_t sounds weird, but LONG is not long enough

        number of symbols 
        """
        return _modshogun.StreamingStringRealFeatures_get_num_symbols(self)

    def get_vector(self):
        """
        get_vector(self)

        Return the current feature vector as an SGString<T>.

        The vector as SGString<T> 
        """
        return _modshogun.StreamingStringRealFeatures_get_vector(self)

    def get_vector_length(self):
        """
        get_vector_length(self) ->  int

        Return the length of the current vector.

        current vector length as  int 
        """
        return _modshogun.StreamingStringRealFeatures_get_vector_length(self)

StreamingStringRealFeatures_swigregister = _modshogun.StreamingStringRealFeatures_swigregister
StreamingStringRealFeatures_swigregister(StreamingStringRealFeatures)

class StringFileBoolFeatures(StringBoolFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringBoolFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringBoolFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileBoolFeatures
        __init__(self, fname, alpha) -> StringFileBoolFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileBoolFeatures
    __del__ = lambda self : None;
StringFileBoolFeatures_swigregister = _modshogun.StringFileBoolFeatures_swigregister
StringFileBoolFeatures_swigregister(StringFileBoolFeatures)

class StringFileCharFeatures(StringCharFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileCharFeatures
        __init__(self, fname, alpha) -> StringFileCharFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileCharFeatures
    __del__ = lambda self : None;
StringFileCharFeatures_swigregister = _modshogun.StringFileCharFeatures_swigregister
StringFileCharFeatures_swigregister(StringFileCharFeatures)

class StringFileByteFeatures(StringByteFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringByteFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringByteFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileByteFeatures
        __init__(self, fname, alpha) -> StringFileByteFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileByteFeatures
    __del__ = lambda self : None;
StringFileByteFeatures_swigregister = _modshogun.StringFileByteFeatures_swigregister
StringFileByteFeatures_swigregister(StringFileByteFeatures)

class StringFileWordFeatures(StringWordFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileWordFeatures
        __init__(self, fname, alpha) -> StringFileWordFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileWordFeatures
    __del__ = lambda self : None;
StringFileWordFeatures_swigregister = _modshogun.StringFileWordFeatures_swigregister
StringFileWordFeatures_swigregister(StringFileWordFeatures)

class StringFileIntFeatures(StringIntFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringIntFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringIntFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileIntFeatures
        __init__(self, fname, alpha) -> StringFileIntFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileIntFeatures
    __del__ = lambda self : None;
StringFileIntFeatures_swigregister = _modshogun.StringFileIntFeatures_swigregister
StringFileIntFeatures_swigregister(StringFileIntFeatures)

class StringFileLongFeatures(StringLongFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringLongFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringLongFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileLongFeatures
        __init__(self, fname, alpha) -> StringFileLongFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileLongFeatures
    __del__ = lambda self : None;
StringFileLongFeatures_swigregister = _modshogun.StringFileLongFeatures_swigregister
StringFileLongFeatures_swigregister(StringFileLongFeatures)

class StringFileUlongFeatures(StringUlongFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringUlongFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringUlongFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileUlongFeatures
        __init__(self, fname, alpha) -> StringFileUlongFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileUlongFeatures
    __del__ = lambda self : None;
StringFileUlongFeatures_swigregister = _modshogun.StringFileUlongFeatures_swigregister
StringFileUlongFeatures_swigregister(StringFileUlongFeatures)

class StringFileShortRealFeatures(StringShortRealFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringShortRealFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringShortRealFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileShortRealFeatures
        __init__(self, fname, alpha) -> StringFileShortRealFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileShortRealFeatures
    __del__ = lambda self : None;
StringFileShortRealFeatures_swigregister = _modshogun.StringFileShortRealFeatures_swigregister
StringFileShortRealFeatures_swigregister(StringFileShortRealFeatures)

class StringFileRealFeatures(StringRealFeatures):
    """
    File based string features.

    StringFeatures that are file based. Underneath memory mapped files are
    used. Derived from CStringFeatures thus transparently enabling all of
    the StringFeature functionality.

    Supported file format contains one string per line, lines of variable
    length are supported and must be separated by ' '.

    C++ includes: StringFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringRealFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringFileRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StringRealFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringFileRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StringFileRealFeatures
        __init__(self, fname, alpha) -> StringFileRealFeatures

        constructor

        Parameters:
        -----------

        fname:  filename of the file containing line based features

        alpha:  alphabet (type) to use for string features 
        """
        this = _modshogun.new_StringFileRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StringFileRealFeatures
    __del__ = lambda self : None;
StringFileRealFeatures_swigregister = _modshogun.StringFileRealFeatures_swigregister
StringFileRealFeatures_swigregister(StringFileRealFeatures)

class SparseBoolFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseBoolFeatures
        __init__(self) -> SparseBoolFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseBoolFeatures
        __init__(self, src, num_feat, num_vec) -> SparseBoolFeatures
        __init__(self, sparse) -> SparseBoolFeatures
        __init__(self, dense) -> SparseBoolFeatures
        __init__(self, orig) -> SparseBoolFeatures
        __init__(self, loader) -> SparseBoolFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseBoolFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseBoolFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseBoolFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> bool

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseBoolFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> BoolVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseBoolFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> BoolSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseBoolFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> BoolSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseBoolFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseBoolFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseBoolFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseBoolFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> BoolMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseBoolFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseBoolFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseBoolFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseBoolFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseBoolFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseBoolFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseBoolFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseBoolFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseBoolFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseBoolFeatures_write_svmlight_file(self, *args)

SparseBoolFeatures_swigregister = _modshogun.SparseBoolFeatures_swigregister
SparseBoolFeatures_swigregister(SparseBoolFeatures)

class SparseCharFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseCharFeatures
        __init__(self) -> SparseCharFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseCharFeatures
        __init__(self, src, num_feat, num_vec) -> SparseCharFeatures
        __init__(self, sparse) -> SparseCharFeatures
        __init__(self, dense) -> SparseCharFeatures
        __init__(self, orig) -> SparseCharFeatures
        __init__(self, loader) -> SparseCharFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseCharFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseCharFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseCharFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> str

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseCharFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> CharVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseCharFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> CharSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseCharFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> CharSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseCharFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseCharFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseCharFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseCharFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> CharMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseCharFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseCharFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseCharFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseCharFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseCharFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseCharFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseCharFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseCharFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseCharFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseCharFeatures_write_svmlight_file(self, *args)

SparseCharFeatures_swigregister = _modshogun.SparseCharFeatures_swigregister
SparseCharFeatures_swigregister(SparseCharFeatures)

class SparseByteFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseByteFeatures
        __init__(self) -> SparseByteFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseByteFeatures
        __init__(self, src, num_feat, num_vec) -> SparseByteFeatures
        __init__(self, sparse) -> SparseByteFeatures
        __init__(self, dense) -> SparseByteFeatures
        __init__(self, orig) -> SparseByteFeatures
        __init__(self, loader) -> SparseByteFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseByteFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseByteFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseByteFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> unsigned str

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseByteFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> ByteVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseByteFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> ByteSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseByteFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> ByteSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseByteFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseByteFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseByteFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseByteFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> ByteMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseByteFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseByteFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseByteFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseByteFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseByteFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseByteFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseByteFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseByteFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseByteFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseByteFeatures_write_svmlight_file(self, *args)

SparseByteFeatures_swigregister = _modshogun.SparseByteFeatures_swigregister
SparseByteFeatures_swigregister(SparseByteFeatures)

class SparseWordFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseWordFeatures
        __init__(self) -> SparseWordFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseWordFeatures
        __init__(self, src, num_feat, num_vec) -> SparseWordFeatures
        __init__(self, sparse) -> SparseWordFeatures
        __init__(self, dense) -> SparseWordFeatures
        __init__(self, orig) -> SparseWordFeatures
        __init__(self, loader) -> SparseWordFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseWordFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseWordFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseWordFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> unsigned short

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseWordFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> WordVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseWordFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> WordSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseWordFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> WordSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseWordFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseWordFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseWordFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseWordFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> WordMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseWordFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseWordFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseWordFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseWordFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseWordFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseWordFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseWordFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseWordFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseWordFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseWordFeatures_write_svmlight_file(self, *args)

SparseWordFeatures_swigregister = _modshogun.SparseWordFeatures_swigregister
SparseWordFeatures_swigregister(SparseWordFeatures)

class SparseIntFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseIntFeatures
        __init__(self) -> SparseIntFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseIntFeatures
        __init__(self, src, num_feat, num_vec) -> SparseIntFeatures
        __init__(self, sparse) -> SparseIntFeatures
        __init__(self, dense) -> SparseIntFeatures
        __init__(self, orig) -> SparseIntFeatures
        __init__(self, loader) -> SparseIntFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseIntFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseIntFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseIntFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> int

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseIntFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> IntVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseIntFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> IntSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseIntFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> IntSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseIntFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseIntFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseIntFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseIntFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> IntMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseIntFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseIntFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseIntFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseIntFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseIntFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseIntFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseIntFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseIntFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseIntFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseIntFeatures_write_svmlight_file(self, *args)

SparseIntFeatures_swigregister = _modshogun.SparseIntFeatures_swigregister
SparseIntFeatures_swigregister(SparseIntFeatures)

class SparseLongFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseLongFeatures
        __init__(self) -> SparseLongFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseLongFeatures
        __init__(self, src, num_feat, num_vec) -> SparseLongFeatures
        __init__(self, sparse) -> SparseLongFeatures
        __init__(self, dense) -> SparseLongFeatures
        __init__(self, orig) -> SparseLongFeatures
        __init__(self, loader) -> SparseLongFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseLongFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseLongFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseLongFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> long long

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseLongFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> LongIntVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseLongFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> LongIntSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseLongFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> LongIntSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseLongFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseLongFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseLongFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseLongFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> LongIntMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseLongFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseLongFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseLongFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseLongFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseLongFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseLongFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseLongFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseLongFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseLongFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseLongFeatures_write_svmlight_file(self, *args)

SparseLongFeatures_swigregister = _modshogun.SparseLongFeatures_swigregister
SparseLongFeatures_swigregister(SparseLongFeatures)

class SparseUlongFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseUlongFeatures
        __init__(self) -> SparseUlongFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseUlongFeatures
        __init__(self, src, num_feat, num_vec) -> SparseUlongFeatures
        __init__(self, sparse) -> SparseUlongFeatures
        __init__(self, dense) -> SparseUlongFeatures
        __init__(self, orig) -> SparseUlongFeatures
        __init__(self, loader) -> SparseUlongFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseUlongFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseUlongFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseUlongFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> unsigned long long

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseUlongFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> ULongIntVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseUlongFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> ULongIntSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseUlongFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> ULongIntSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseUlongFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseUlongFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseUlongFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseUlongFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> ULongIntMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseUlongFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseUlongFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseUlongFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseUlongFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseUlongFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseUlongFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseUlongFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseUlongFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseUlongFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseUlongFeatures_write_svmlight_file(self, *args)

SparseUlongFeatures_swigregister = _modshogun.SparseUlongFeatures_swigregister
SparseUlongFeatures_swigregister(SparseUlongFeatures)

class SparseShortRealFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseShortRealFeatures
        __init__(self) -> SparseShortRealFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseShortRealFeatures
        __init__(self, src, num_feat, num_vec) -> SparseShortRealFeatures
        __init__(self, sparse) -> SparseShortRealFeatures
        __init__(self, dense) -> SparseShortRealFeatures
        __init__(self, orig) -> SparseShortRealFeatures
        __init__(self, loader) -> SparseShortRealFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseShortRealFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseShortRealFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseShortRealFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> float

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseShortRealFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> ShortRealVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseShortRealFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> ShortRealSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseShortRealFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> ShortRealSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseShortRealFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseShortRealFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseShortRealFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseShortRealFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> ShortRealMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseShortRealFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseShortRealFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseShortRealFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseShortRealFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseShortRealFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseShortRealFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseShortRealFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseShortRealFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseShortRealFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseShortRealFeatures_write_svmlight_file(self, *args)

SparseShortRealFeatures_swigregister = _modshogun.SparseShortRealFeatures_swigregister
SparseShortRealFeatures_swigregister(SparseShortRealFeatures)

class SparseRealFeatures(DotFeatures):
    """
    Template class SparseFeatures implements sparse matrices.

    Features are an array of SGSparseVector, sorted w.r.t. vec_index
    (increasing) and withing same vec_index w.r.t. feat_index
    (increasing);

    Sparse feature vectors can be accessed via get_sparse_feature_vector()
    and should be freed (this operation is a NOP in most cases) via
    free_sparse_feature_vector().

    As this is a template class it can directly be used for different data
    types like sparse matrices of real valued, integer, byte etc type.

    (Partly) subset access is supported for this feature type. Simple use
    the (inherited) set_subset(), remove_subset() functions. If done, all
    calls that work with features are translated to the subset. See
    comments to find out whether it is supported for that method

    C++ includes: SparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> SparseRealFeatures
        __init__(self) -> SparseRealFeatures
        __init__(self, src, num_feat, num_vec, copy = False) -> SparseRealFeatures
        __init__(self, src, num_feat, num_vec) -> SparseRealFeatures
        __init__(self, sparse) -> SparseRealFeatures
        __init__(self, dense) -> SparseRealFeatures
        __init__(self, orig) -> SparseRealFeatures
        __init__(self, loader) -> SparseRealFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object to load data from 
        """
        this = _modshogun.new_SparseRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseRealFeatures
    __del__ = lambda self : None;
    def free_sparse_feature_matrix(self):
        """
        free_sparse_feature_matrix(self)

        free sparse feature matrix

        any subset is removed 
        """
        return _modshogun.SparseRealFeatures_free_sparse_feature_matrix(self)

    def free_sparse_features(self):
        """
        free_sparse_features(self)

        free sparse feature matrix and cache

        any subset is removed 
        """
        return _modshogun.SparseRealFeatures_free_sparse_features(self)

    def get_feature(self, *args):
        """
        get_feature(self, num, index) -> float

        get a single feature

        possible with subset

        Parameters:
        -----------

        num:  number of feature vector to retrieve

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.SparseRealFeatures_get_feature(self, *args)

    def get_full_feature_vector(self, *args):
        """
        get_full_feature_vector(self, num) -> RealVector

        get the fully expanded dense feature vector num

        dense feature vector

        Parameters:
        -----------

        num:  index of feature vector 
        """
        return _modshogun.SparseRealFeatures_get_full_feature_vector(self, *args)

    def get_sparse_feature_vector(self, *args):
        """
        get_sparse_feature_vector(self, num) -> RealSparseVector

        get sparse feature vector for sample num from the matrix as it is if
        matrix is initialized, else return preprocessed compute_feature_vector

        possible with subset

        Parameters:
        -----------

        num:  index of feature vector

        sparse feature vector 
        """
        return _modshogun.SparseRealFeatures_get_sparse_feature_vector(self, *args)

    def get_sparse_feature_matrix(self):
        """
        get_sparse_feature_matrix(self) -> RealSparseMatrix

        get the sparse feature matrix

        not possible with subset

        sparse matrix 
        """
        return _modshogun.SparseRealFeatures_get_sparse_feature_matrix(self)

    def get_transposed(self):
        """
        get_transposed(self) -> SparseRealFeatures

        compute and return the transpose of the sparse feature matrix which
        will be prepocessed. num_feat, num_vectors are returned by reference
        caller has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.SparseRealFeatures_get_transposed(self)

    def set_sparse_feature_matrix(self, *args):
        """
        set_sparse_feature_matrix(self, sm)

        set sparse feature matrix

        not possible with subset

        Parameters:
        -----------

        sm:  sparse feature matrix 
        """
        return _modshogun.SparseRealFeatures_set_sparse_feature_matrix(self, *args)

    def get_full_feature_matrix(self):
        """
        get_full_feature_matrix(self) -> RealMatrix

        gets a copy of a full feature matrix

        possible with subset

        full dense feature matrix 
        """
        return _modshogun.SparseRealFeatures_get_full_feature_matrix(self)

    def set_full_feature_matrix(self, *args):
        """
        set_full_feature_matrix(self, full) -> bool

        creates a sparse feature matrix from a full dense feature matrix
        necessary to set feature_matrix, num_features and num_vectors where
        num_features is the column offset, and columns are linear in memory
        see above for definition of sparse_feature_matrix

        any subset is removed before

        Parameters:
        -----------

        full:  full feature matrix 
        """
        return _modshogun.SparseRealFeatures_set_full_feature_matrix(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.SparseRealFeatures_apply_preprocessor(self, force_preprocessing)

    def obtain_from_simple(self, *args):
        """
        obtain_from_simple(self, sf) -> bool

        obtain sparse features from simple features

        subset on input is ignored, subset of this instance is removed

        Parameters:
        -----------

        sf:  simple features

        if obtaining was successful 
        """
        return _modshogun.SparseRealFeatures_obtain_from_simple(self, *args)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features

        number of features 
        """
        return _modshogun.SparseRealFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.SparseRealFeatures_set_num_features(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        get number of non-zero entries in sparse feature matrix

        number of non-zero entries in sparse feature matrix 
        """
        return _modshogun.SparseRealFeatures_get_num_nonzero_entries(self)

    def load_svmlight_file(self, *args):
        """
        load_svmlight_file(self, fname, do_sort_features = True) -> Labels
        load_svmlight_file(self, fname) -> Labels

        load features from file

        any subset is removed before

        Parameters:
        -----------

        fname:  filename to load from

        do_sort_features:  if true features will be sorted to ensure they are
        in ascending order

        label object with corresponding labels 
        """
        return _modshogun.SparseRealFeatures_load_svmlight_file(self, *args)

    def sort_features(self):
        """
        sort_features(self)

        ensure that features occur in ascending order, only call when no
        preprocessors are attached

        not possiblwe with subset 
        """
        return _modshogun.SparseRealFeatures_sort_features(self)

    def write_svmlight_file(self, *args):
        """
        write_svmlight_file(self, fname, label) -> bool

        write features to file using svm light format

        not possible with subset

        Parameters:
        -----------

        fname:  filename to write to

        label:  Label object (number of labels must correspond to number of
        features)

        true if successful 
        """
        return _modshogun.SparseRealFeatures_write_svmlight_file(self, *args)

SparseRealFeatures_swigregister = _modshogun.SparseRealFeatures_swigregister
SparseRealFeatures_swigregister(SparseRealFeatures)

class StreamingSparseBoolFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseBoolFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseBoolFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseBoolFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> bool

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseBoolFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> BoolSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseBoolFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseBoolFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseBoolFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseBoolFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseBoolFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseBoolFeatures_sort_features(self)

StreamingSparseBoolFeatures_swigregister = _modshogun.StreamingSparseBoolFeatures_swigregister
StreamingSparseBoolFeatures_swigregister(StreamingSparseBoolFeatures)

class StreamingSparseCharFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseCharFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseCharFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseCharFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> str

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseCharFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> CharSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseCharFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseCharFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseCharFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseCharFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseCharFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseCharFeatures_sort_features(self)

StreamingSparseCharFeatures_swigregister = _modshogun.StreamingSparseCharFeatures_swigregister
StreamingSparseCharFeatures_swigregister(StreamingSparseCharFeatures)

class StreamingSparseByteFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseByteFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseByteFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseByteFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> unsigned str

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseByteFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> ByteSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseByteFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseByteFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseByteFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseByteFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseByteFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseByteFeatures_sort_features(self)

StreamingSparseByteFeatures_swigregister = _modshogun.StreamingSparseByteFeatures_swigregister
StreamingSparseByteFeatures_swigregister(StreamingSparseByteFeatures)

class StreamingSparseWordFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseWordFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseWordFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseWordFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> unsigned short

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseWordFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> WordSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseWordFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseWordFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseWordFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseWordFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseWordFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseWordFeatures_sort_features(self)

StreamingSparseWordFeatures_swigregister = _modshogun.StreamingSparseWordFeatures_swigregister
StreamingSparseWordFeatures_swigregister(StreamingSparseWordFeatures)

class StreamingSparseIntFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseIntFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseIntFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseIntFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> int

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseIntFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> IntSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseIntFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseIntFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseIntFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseIntFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseIntFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseIntFeatures_sort_features(self)

StreamingSparseIntFeatures_swigregister = _modshogun.StreamingSparseIntFeatures_swigregister
StreamingSparseIntFeatures_swigregister(StreamingSparseIntFeatures)

class StreamingSparseLongFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseLongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseLongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseLongFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseLongFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseLongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseLongFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> long long

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseLongFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> LongIntSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseLongFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseLongFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseLongFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseLongFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseLongFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseLongFeatures_sort_features(self)

StreamingSparseLongFeatures_swigregister = _modshogun.StreamingSparseLongFeatures_swigregister
StreamingSparseLongFeatures_swigregister(StreamingSparseLongFeatures)

class StreamingSparseUlongFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseUlongFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseUlongFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseUlongFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseUlongFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseUlongFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseUlongFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> unsigned long long

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseUlongFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> ULongIntSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseUlongFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseUlongFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseUlongFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseUlongFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseUlongFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseUlongFeatures_sort_features(self)

StreamingSparseUlongFeatures_swigregister = _modshogun.StreamingSparseUlongFeatures_swigregister
StreamingSparseUlongFeatures_swigregister(StreamingSparseUlongFeatures)

class StreamingSparseShortRealFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseShortRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseShortRealFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseShortRealFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> float

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseShortRealFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> ShortRealSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseShortRealFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseShortRealFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseShortRealFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseShortRealFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseShortRealFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseShortRealFeatures_sort_features(self)

StreamingSparseShortRealFeatures_swigregister = _modshogun.StreamingSparseShortRealFeatures_swigregister
StreamingSparseShortRealFeatures_swigregister(StreamingSparseShortRealFeatures)

class StreamingSparseRealFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with sparse feature vectors.
    The vector is represented as an SGSparseVector<T>. Each entry is of
    type SGSparseVectorEntry<T> with members `feat_index' and `entry'.

    This class expects the input from the StreamingFile object to be zero-
    based, i.e., a feature entered as 1:6.5 would have feat_index=0 and
    entry=6.5.

    The current example is stored as a combination of current_vector and
    current_label. current_num_features stores the highest dimensionality
    of examples encountered upto the point of the function call. For
    example, if the first example is '1:6.5 7:10.0', then
    current_num_features would be 7 after the first function call.

    Since the dimensionality of the feature space is not immediately known
    initially, current_num_features may increase as more examples are
    processed and larger dimensions are seen. For this purpose,
    `expand_if_required()' is provided which when called with a
    dynamically allocated float or float array and the length,
    reallocates that array to the new dimensionality (if necessary),
    setting the newer dimensions to zero, and updates the length parameter
    to equal the new length of the array.

    C++ includes: StreamingSparseFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingSparseRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingSparseRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingSparseRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingSparseRealFeatures

        Constructor taking args. Initializes the parser with the given args.

        Parameters:
        -----------

        file:  StreamingFile object, input file.

        is_labelled:  Whether examples are labelled or not.

        size:  Number of example objects to be stored in the parser at a time.

        """
        this = _modshogun.new_StreamingSparseRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingSparseRealFeatures
    __del__ = lambda self : None;
    def get_feature(self, *args):
        """
        get_feature(self, index) -> float

        get a single feature

        Parameters:
        -----------

        index:  index of feature in this vector

        sum of features that match dimension index and 0 if none is found 
        """
        return _modshogun.StreamingSparseRealFeatures_get_feature(self, *args)

    def get_vector(self):
        """
        get_vector(self) -> RealSparseVector

        Return the current feature vector as an SGSparseVector<T>.

        The vector as SGSparseVector<T> 
        """
        return _modshogun.StreamingSparseRealFeatures_get_vector(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num) ->  int

        set number of features

        Sometimes when loading sparse features not all possible dimensions are
        used. This may pose a problem to classifiers when being applied to
        higher dimensional test-data. This function allows to artificially
        explode the feature space

        Parameters:
        -----------

        num:  the number of features, must be larger than the current number
        of features

        previous number of features 
        """
        return _modshogun.StreamingSparseRealFeatures_set_num_features(self, *args)

    def expand_if_required(self, *args):
        """
        expand_if_required(self, vec, len)
        expand_if_required(self, vec, len)

        Expand the vector passed so that it its length is equal to the
        dimensionality of the features. The previous values are kept intact
        through realloc, and the new ones are set to zero.

        Parameters:
        -----------

        vec:  float* vector

        len:  length of the vector 
        """
        return _modshogun.StreamingSparseRealFeatures_expand_if_required(self, *args)

    def get_num_nonzero_entries(self):
        """
        get_num_nonzero_entries(self) -> int

        Get number of non-zero entries in current sparse vector

        number of features explicity set in the sparse vector 
        """
        return _modshogun.StreamingSparseRealFeatures_get_num_nonzero_entries(self)

    def compute_squared(self):
        """
        compute_squared(self) -> float

        Compute sum of squares of features on current vector.

        sum of squares for current vector 
        """
        return _modshogun.StreamingSparseRealFeatures_compute_squared(self)

    def sort_features(self):
        """
        sort_features(self)

        Ensure features of the current vector are in ascending order. It
        modifies the current_vector in-place, though a temporary vector is
        created and later freed. 
        """
        return _modshogun.StreamingSparseRealFeatures_sort_features(self)

StreamingSparseRealFeatures_swigregister = _modshogun.StreamingSparseRealFeatures_swigregister
StreamingSparseRealFeatures_swigregister(StreamingSparseRealFeatures)

class BoolFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> BoolFeatures
        __init__(self) -> BoolFeatures
        __init__(self, orig) -> BoolFeatures
        __init__(self, matrix) -> BoolFeatures
        __init__(self, loader) -> BoolFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_BoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BoolFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.BoolFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.BoolFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.BoolFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> BoolVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.BoolFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> BoolMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.BoolFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> BoolMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.BoolFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.BoolFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> BoolFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.BoolFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.BoolFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.BoolFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.BoolFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.BoolFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.BoolFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.BoolFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.BoolFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.BoolFeatures_Align_char_features(self, *args)

BoolFeatures_swigregister = _modshogun.BoolFeatures_swigregister
BoolFeatures_swigregister(BoolFeatures)

class CharFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> CharFeatures
        __init__(self) -> CharFeatures
        __init__(self, orig) -> CharFeatures
        __init__(self, matrix) -> CharFeatures
        __init__(self, loader) -> CharFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_CharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CharFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.CharFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.CharFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.CharFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> CharVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.CharFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> CharMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.CharFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> CharMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.CharFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.CharFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> CharFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.CharFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.CharFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.CharFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.CharFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.CharFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.CharFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.CharFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.CharFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.CharFeatures_Align_char_features(self, *args)

CharFeatures_swigregister = _modshogun.CharFeatures_swigregister
CharFeatures_swigregister(CharFeatures)

class ByteFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> ByteFeatures
        __init__(self) -> ByteFeatures
        __init__(self, orig) -> ByteFeatures
        __init__(self, matrix) -> ByteFeatures
        __init__(self, loader) -> ByteFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_ByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ByteFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.ByteFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.ByteFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.ByteFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ByteVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.ByteFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> ByteMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.ByteFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> ByteMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.ByteFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.ByteFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> ByteFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.ByteFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.ByteFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.ByteFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.ByteFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.ByteFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ByteFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ByteFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.ByteFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.ByteFeatures_Align_char_features(self, *args)

ByteFeatures_swigregister = _modshogun.ByteFeatures_swigregister
ByteFeatures_swigregister(ByteFeatures)

class WordFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> WordFeatures
        __init__(self) -> WordFeatures
        __init__(self, orig) -> WordFeatures
        __init__(self, matrix) -> WordFeatures
        __init__(self, loader) -> WordFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_WordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WordFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.WordFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.WordFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.WordFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> WordVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.WordFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> WordMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.WordFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> WordMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.WordFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.WordFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> WordFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.WordFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.WordFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.WordFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.WordFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.WordFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.WordFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.WordFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.WordFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.WordFeatures_Align_char_features(self, *args)

WordFeatures_swigregister = _modshogun.WordFeatures_swigregister
WordFeatures_swigregister(WordFeatures)

class IntFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> IntFeatures
        __init__(self) -> IntFeatures
        __init__(self, orig) -> IntFeatures
        __init__(self, matrix) -> IntFeatures
        __init__(self, loader) -> IntFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_IntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_IntFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.IntFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.IntFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.IntFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> IntVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.IntFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> IntMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.IntFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> IntMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.IntFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.IntFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> IntFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.IntFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.IntFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.IntFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.IntFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.IntFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.IntFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.IntFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.IntFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.IntFeatures_Align_char_features(self, *args)

IntFeatures_swigregister = _modshogun.IntFeatures_swigregister
IntFeatures_swigregister(IntFeatures)

class LongIntFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LongIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> LongIntFeatures
        __init__(self) -> LongIntFeatures
        __init__(self, orig) -> LongIntFeatures
        __init__(self, matrix) -> LongIntFeatures
        __init__(self, loader) -> LongIntFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_LongIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LongIntFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.LongIntFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.LongIntFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.LongIntFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> LongIntVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.LongIntFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> LongIntMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.LongIntFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> LongIntMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.LongIntFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.LongIntFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> LongIntFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.LongIntFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.LongIntFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.LongIntFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.LongIntFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.LongIntFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.LongIntFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.LongIntFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.LongIntFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.LongIntFeatures_Align_char_features(self, *args)

LongIntFeatures_swigregister = _modshogun.LongIntFeatures_swigregister
LongIntFeatures_swigregister(LongIntFeatures)

class ULongIntFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ULongIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> ULongIntFeatures
        __init__(self) -> ULongIntFeatures
        __init__(self, orig) -> ULongIntFeatures
        __init__(self, matrix) -> ULongIntFeatures
        __init__(self, loader) -> ULongIntFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_ULongIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ULongIntFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.ULongIntFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.ULongIntFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.ULongIntFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ULongIntVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.ULongIntFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> ULongIntMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.ULongIntFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> ULongIntMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.ULongIntFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.ULongIntFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> ULongIntFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.ULongIntFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.ULongIntFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.ULongIntFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.ULongIntFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.ULongIntFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ULongIntFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ULongIntFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.ULongIntFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.ULongIntFeatures_Align_char_features(self, *args)

ULongIntFeatures_swigregister = _modshogun.ULongIntFeatures_swigregister
ULongIntFeatures_swigregister(ULongIntFeatures)

class ShortRealFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> ShortRealFeatures
        __init__(self) -> ShortRealFeatures
        __init__(self, orig) -> ShortRealFeatures
        __init__(self, matrix) -> ShortRealFeatures
        __init__(self, loader) -> ShortRealFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_ShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ShortRealFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.ShortRealFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.ShortRealFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.ShortRealFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> ShortRealVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.ShortRealFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> ShortRealMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.ShortRealFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> ShortRealMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.ShortRealFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.ShortRealFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> ShortRealFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.ShortRealFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.ShortRealFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.ShortRealFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.ShortRealFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.ShortRealFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ShortRealFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.ShortRealFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.ShortRealFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.ShortRealFeatures_Align_char_features(self, *args)

ShortRealFeatures_swigregister = _modshogun.ShortRealFeatures_swigregister
ShortRealFeatures_swigregister(ShortRealFeatures)

class RealFeatures(DotFeatures):
    """
    The class SimpleFeatures implements dense feature matrices.

    The feature matrices are stored en-block in memory in fortran order,
    i.e. column-by-column, where a column denotes a feature vector.

    There are get_num_vectors() many feature vectors, of dimension
    get_num_features(). To access a feature vector call
    get_feature_vector() and when you are done treating it call
    free_feature_vector(). While free_feature_vector() is a NOP in most
    cases feature vectors might have been generated on the fly (due to a
    number preprocessors being attached to them).

    From this template class a number the following dense feature matrix
    types are used and supported:

    bool matrix - CSimpleFeatures<bool>

    8bit str matrix - CSimpleFeatures<char>

    8bit Byte matrix - CSimpleFeatures<uint8_t>

    16bit Integer matrix - CSimpleFeatures<int16_t>

    16bit Word matrix - CSimpleFeatures<uint16_t>

    32bit Integer matrix - CSimpleFeatures<int32_t>

    32bit Unsigned Integer matrix - CSimpleFeatures<uint32_t>

    32bit Float matrix - CSimpleFeatures<float32_t>

    64bit Float matrix - CSimpleFeatures<float64_t>

    64bit Float matrix in a file - CRealFileFeatures

    64bit Tangent of posterior log-odds (TOP) features from HMM -
    CTOPFeatures

    64bit Fisher Kernel (FK) features from HMM - CTOPFeatures

    96bit Float matrix - CSimpleFeatures<floatmax_t>

    C++ includes: SimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> RealFeatures
        __init__(self) -> RealFeatures
        __init__(self, orig) -> RealFeatures
        __init__(self, matrix) -> RealFeatures
        __init__(self, loader) -> RealFeatures

        constructor loading features from file

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_RealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RealFeatures
    __del__ = lambda self : None;
    def free_feature_matrix(self):
        """
        free_feature_matrix(self)

        free feature matrix

        Any subset is removed 
        """
        return _modshogun.RealFeatures_free_feature_matrix(self)

    def free_features(self):
        """
        free_features(self)

        free feature matrix and cache

        Any subset is removed 
        """
        return _modshogun.RealFeatures_free_features(self)

    def set_feature_vector(self, *args):
        """
        set_feature_vector(self, vector, num)

        set feature vector num

        possible with subset

        Parameters:
        -----------

        vector:  vector

        num:  index if vector to set 
        """
        return _modshogun.RealFeatures_set_feature_vector(self, *args)

    def get_feature_vector(self, *args):
        """
        get_feature_vector(self, num) -> RealVector

        get feature vector num

        possible with subset

        Parameters:
        -----------

        num:  index of vector

        feature vector 
        """
        return _modshogun.RealFeatures_get_feature_vector(self, *args)

    def get_feature_matrix(self):
        """
        get_feature_matrix(self) -> RealMatrix

        get the pointer to the feature matrix num_feat,num_vectors are
        returned by reference

        subset is ignored

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        feature matrix 
        """
        return _modshogun.RealFeatures_get_feature_matrix(self)

    def steal_feature_matrix(self):
        """
        steal_feature_matrix(self) -> RealMatrix

        steals feature matrix, i.e. returns matrix and forget about it subset
        is ignored

        matrix feature matrix 
        """
        return _modshogun.RealFeatures_steal_feature_matrix(self)

    def set_feature_matrix(self, *args):
        """
        set_feature_matrix(self, matrix)

        set feature matrix necessary to set feature_matrix, num_features,
        num_vectors, where num_features is the column offset, and columns are
        linear in memory see below for definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        fm:  feature matrix to se

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix 
        """
        return _modshogun.RealFeatures_set_feature_matrix(self, *args)

    def get_transposed(self):
        """
        get_transposed(self) -> RealFeatures

        compute and return the transpose of the feature matrix which will be
        prepocessed. num_feat, num_vectors are returned by reference caller
        has to clean up

        possible with subset

        Parameters:
        -----------

        num_feat:  number of features in matrix

        num_vec:  number of vectors in matrix

        transposed sparse feature matrix 
        """
        return _modshogun.RealFeatures_get_transposed(self)

    def copy_feature_matrix(self, *args):
        """
        copy_feature_matrix(self, src)

        copy feature matrix store copy of feature_matrix, where num_features
        is the column offset, and columns are linear in memory see below for
        definition of feature_matrix

        not possible with subset

        Parameters:
        -----------

        src:  feature matrix to copy 
        """
        return _modshogun.RealFeatures_copy_feature_matrix(self, *args)

    def obtain_from_dot(self, *args):
        """
        obtain_from_dot(self, df)

        obtain simple features from other dotfeatures

        removes any subset before

        Parameters:
        -----------

        df:  dotfeatures to obtain features from 
        """
        return _modshogun.RealFeatures_obtain_from_dot(self, *args)

    def apply_preprocessor(self, force_preprocessing = False):
        """
        apply_preprocessor(self, force_preprocessing = False) -> bool
        apply_preprocessor(self) -> bool

        apply preprocessor

        applies preprocessors to ALL features (subset removed before and
        restored afterwards)

        not possible with subset

        Parameters:
        -----------

        force_preprocessing:  if preprocssing shall be forced

        if applying was successful 
        """
        return _modshogun.RealFeatures_apply_preprocessor(self, force_preprocessing)

    def get_num_features(self):
        """
        get_num_features(self) ->  int

        get number of features (of possible subset)

        number of features 
        """
        return _modshogun.RealFeatures_get_num_features(self)

    def set_num_features(self, *args):
        """
        set_num_features(self, num)

        set number of features

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.RealFeatures_set_num_features(self, *args)

    def set_num_vectors(self, *args):
        """
        set_num_vectors(self, num)

        set number of vectors

        not possible with subset

        Parameters:
        -----------

        num:  number to set 
        """
        return _modshogun.RealFeatures_set_num_vectors(self, *args)

    def initialize_cache(self):
        """
        initialize_cache(self)

        Initialize cache

        not possible with subset 
        """
        return _modshogun.RealFeatures_initialize_cache(self)

    def Align_char_features(self, *args):
        """
        Align_char_features(self, cf, Ref, gapCost) -> bool

        align str features

        Parameters:
        -----------

        cf:  str features

        Ref:  other str features

        gapCost:  gap cost

        if aligning was successful 
        """
        return _modshogun.RealFeatures_Align_char_features(self, *args)

RealFeatures_swigregister = _modshogun.RealFeatures_swigregister
RealFeatures_swigregister(RealFeatures)

class StreamingBoolFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingBoolFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingBoolFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingBoolFeatures
        __init__(self, file, is_labelled, size) -> StreamingBoolFeatures
        __init__(self, simple_features, lab = None) -> StreamingBoolFeatures
        __init__(self, simple_features) -> StreamingBoolFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingBoolFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingBoolFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> BoolVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingBoolFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingBoolFeatures_dot(self, *args)

StreamingBoolFeatures_swigregister = _modshogun.StreamingBoolFeatures_swigregister
StreamingBoolFeatures_swigregister(StreamingBoolFeatures)

class StreamingCharFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingCharFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingCharFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingCharFeatures
        __init__(self, file, is_labelled, size) -> StreamingCharFeatures
        __init__(self, simple_features, lab = None) -> StreamingCharFeatures
        __init__(self, simple_features) -> StreamingCharFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingCharFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingCharFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> CharVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingCharFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingCharFeatures_dot(self, *args)

StreamingCharFeatures_swigregister = _modshogun.StreamingCharFeatures_swigregister
StreamingCharFeatures_swigregister(StreamingCharFeatures)

class StreamingByteFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingByteFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingByteFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingByteFeatures
        __init__(self, file, is_labelled, size) -> StreamingByteFeatures
        __init__(self, simple_features, lab = None) -> StreamingByteFeatures
        __init__(self, simple_features) -> StreamingByteFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingByteFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingByteFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> ByteVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingByteFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingByteFeatures_dot(self, *args)

StreamingByteFeatures_swigregister = _modshogun.StreamingByteFeatures_swigregister
StreamingByteFeatures_swigregister(StreamingByteFeatures)

class StreamingWordFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingWordFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingWordFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingWordFeatures
        __init__(self, file, is_labelled, size) -> StreamingWordFeatures
        __init__(self, simple_features, lab = None) -> StreamingWordFeatures
        __init__(self, simple_features) -> StreamingWordFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingWordFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingWordFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> WordVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingWordFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingWordFeatures_dot(self, *args)

StreamingWordFeatures_swigregister = _modshogun.StreamingWordFeatures_swigregister
StreamingWordFeatures_swigregister(StreamingWordFeatures)

class StreamingIntFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingIntFeatures
        __init__(self, file, is_labelled, size) -> StreamingIntFeatures
        __init__(self, simple_features, lab = None) -> StreamingIntFeatures
        __init__(self, simple_features) -> StreamingIntFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingIntFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> IntVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingIntFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingIntFeatures_dot(self, *args)

StreamingIntFeatures_swigregister = _modshogun.StreamingIntFeatures_swigregister
StreamingIntFeatures_swigregister(StreamingIntFeatures)

class StreamingLongIntFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingLongIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingLongIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingLongIntFeatures
        __init__(self, file, is_labelled, size) -> StreamingLongIntFeatures
        __init__(self, simple_features, lab = None) -> StreamingLongIntFeatures
        __init__(self, simple_features) -> StreamingLongIntFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingLongIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingLongIntFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> LongIntVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingLongIntFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingLongIntFeatures_dot(self, *args)

StreamingLongIntFeatures_swigregister = _modshogun.StreamingLongIntFeatures_swigregister
StreamingLongIntFeatures_swigregister(StreamingLongIntFeatures)

class StreamingULongIntFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingULongIntFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingULongIntFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingULongIntFeatures
        __init__(self, file, is_labelled, size) -> StreamingULongIntFeatures
        __init__(self, simple_features, lab = None) -> StreamingULongIntFeatures
        __init__(self, simple_features) -> StreamingULongIntFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingULongIntFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingULongIntFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> ULongIntVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingULongIntFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingULongIntFeatures_dot(self, *args)

StreamingULongIntFeatures_swigregister = _modshogun.StreamingULongIntFeatures_swigregister
StreamingULongIntFeatures_swigregister(StreamingULongIntFeatures)

class StreamingShortRealFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingShortRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingShortRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingShortRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingShortRealFeatures
        __init__(self, simple_features, lab = None) -> StreamingShortRealFeatures
        __init__(self, simple_features) -> StreamingShortRealFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingShortRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingShortRealFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> ShortRealVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingShortRealFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingShortRealFeatures_dot(self, *args)

StreamingShortRealFeatures_swigregister = _modshogun.StreamingShortRealFeatures_swigregister
StreamingShortRealFeatures_swigregister(StreamingShortRealFeatures)

class StreamingRealFeatures(StreamingDotFeatures):
    """
    This class implements streaming features with dense feature vectors.

    The current example is stored as a combination of current_vector and
    current_label.

    C++ includes: StreamingSimpleFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StreamingRealFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [StreamingDotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StreamingRealFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StreamingRealFeatures
        __init__(self, file, is_labelled, size) -> StreamingRealFeatures
        __init__(self, simple_features, lab = None) -> StreamingRealFeatures
        __init__(self, simple_features) -> StreamingRealFeatures

        Constructor taking a SimpleFeatures object and a labels array as args.

        Parameters:
        -----------

        simple_features:  SimpleFeatures object of same type

        lab:  labels array, float* 
        """
        this = _modshogun.new_StreamingRealFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StreamingRealFeatures
    __del__ = lambda self : None;
    def get_vector(self):
        """
        get_vector(self) -> RealVector

        Return the current feature vector as an SGVector<T>.

        The vector as SGVector<T> 
        """
        return _modshogun.StreamingRealFeatures_get_vector(self)

    def dot(self, *args):
        """
        dot(self, vec) -> float
        dot(self, df) -> float

        Dot product taken with another StreamingDotFeatures object.

        Currently only works if it is a CStreamingSimpleFeatures object. It
        takes the dot product of the current_vectors of both objects.

        Parameters:
        -----------

        df:   CStreamingDotFeatures object.

        Dot product. 
        """
        return _modshogun.StreamingRealFeatures_dot(self, *args)

StreamingRealFeatures_swigregister = _modshogun.StreamingRealFeatures_swigregister
StreamingRealFeatures_swigregister(StreamingRealFeatures)

class DummyFeatures(Features):
    """
    The class DummyFeatures implements features that only know the number
    of feature objects (but don't actually contain any).

    This is used in the CCustomKernel.

    C++ includes: DummyFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DummyFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DummyFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DummyFeatures
        __init__(self, num) -> DummyFeatures
        __init__(self, orig) -> DummyFeatures

        copy constructor 
        """
        this = _modshogun.new_DummyFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DummyFeatures
    __del__ = lambda self : None;
DummyFeatures_swigregister = _modshogun.DummyFeatures_swigregister
DummyFeatures_swigregister(DummyFeatures)

class AttributeFeatures(Features):
    """
    Implements attributed features, that is in the simplest case a number
    of (attribute, value) pairs.

    For example

    x[0...].attr1 = <value(s)> x[0...].attr2 = <value(s)>.

    A more complex example would be nested structures
    x[0...].attr1[0...].subattr1 = ..

    This might be used to represent (attr, value) pairs, simple
    structures, trees ...

    C++ includes: AttributeFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AttributeFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AttributeFeatures, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_AttributeFeatures
    __del__ = lambda self : None;
    def get_attribute(self, *args):
        """
        get_attribute(self, attr_name) -> Features

        return the feature object matching attribute name

        Parameters:
        -----------

        attr_name:  attribute name

        feature object 
        """
        return _modshogun.AttributeFeatures_get_attribute(self, *args)

    def get_attribute_by_index(self, *args):
        """
        get_attribute_by_index(self, idx, attr_name, attr_obj)

        return the feature object at index

        Parameters:
        -----------

        idx:  index of attribute

        attr_name:  attribute name (returned by reference)

        attr_obj:  attribute object (returned by reference) 
        """
        return _modshogun.AttributeFeatures_get_attribute_by_index(self, *args)

    def set_attribute(self, *args):
        """
        set_attribute(self, attr_name, attr_obj) -> bool

        set the feature object for attribute name

        Parameters:
        -----------

        attr_name:  attribute name

        attr_obj:  feature object to set

        true on success 
        """
        return _modshogun.AttributeFeatures_set_attribute(self, *args)

    def del_attribute(self, *args):
        """
        del_attribute(self, attr_name) -> bool

        delete the attribute matching attribute name

        Parameters:
        -----------

        attr_name:  attribute name

        true on success 
        """
        return _modshogun.AttributeFeatures_del_attribute(self, *args)

    def get_num_attributes(self):
        """
        get_num_attributes(self) ->  int

        get number of attributes

        number of attributes 
        """
        return _modshogun.AttributeFeatures_get_num_attributes(self)

AttributeFeatures_swigregister = _modshogun.AttributeFeatures_swigregister
AttributeFeatures_swigregister(AttributeFeatures)

class CombinedFeatures(Features):
    """
    The class CombinedFeatures is used to combine a number of of feature
    objects into a single CombinedFeatures object.

    It keeps pointers to the added sub-features and is especially useful
    to combine kernels working on different domains (c.f. CCombinedKernel)
    and to combine kernels looking at independent features.

    C++ includes: CombinedFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [Features]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CombinedFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [Features]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CombinedFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CombinedFeatures
        __init__(self, orig) -> CombinedFeatures

        copy constructor 
        """
        this = _modshogun.new_CombinedFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CombinedFeatures
    __del__ = lambda self : None;
    def list_feature_objs(self):
        """
        list_feature_objs(self)

        list feature objects 
        """
        return _modshogun.CombinedFeatures_list_feature_objs(self)

    def check_feature_obj_compatibility(self, *args):
        """
        check_feature_obj_compatibility(self, comb_feat) -> bool

        check feature object compatibility

        Parameters:
        -----------

        comb_feat:  feature to check for compatibility

        if feature is compatible 
        """
        return _modshogun.CombinedFeatures_check_feature_obj_compatibility(self, *args)

    def get_first_feature_obj(self, *args):
        """
        get_first_feature_obj(self) -> Features
        get_first_feature_obj(self, current) -> Features

        get first feature object

        Parameters:
        -----------

        current:  list of features

        first feature object 
        """
        return _modshogun.CombinedFeatures_get_first_feature_obj(self, *args)

    def get_next_feature_obj(self, *args):
        """
        get_next_feature_obj(self) -> Features
        get_next_feature_obj(self, current) -> Features

        get next feature object

        Parameters:
        -----------

        current:  list of features

        next feature object 
        """
        return _modshogun.CombinedFeatures_get_next_feature_obj(self, *args)

    def get_last_feature_obj(self):
        """
        get_last_feature_obj(self) -> Features

        get last feature object

        last feature object 
        """
        return _modshogun.CombinedFeatures_get_last_feature_obj(self)

    def insert_feature_obj(self, *args):
        """
        insert_feature_obj(self, obj) -> bool

        insert feature object

        Parameters:
        -----------

        obj:  feature object to insert

        if inserting was successful 
        """
        return _modshogun.CombinedFeatures_insert_feature_obj(self, *args)

    def append_feature_obj(self, *args):
        """
        append_feature_obj(self, obj) -> bool

        append feature object

        Parameters:
        -----------

        obj:  feature object to append

        if appending was successful 
        """
        return _modshogun.CombinedFeatures_append_feature_obj(self, *args)

    def delete_feature_obj(self):
        """
        delete_feature_obj(self) -> bool

        delete feature object

        if deleting was successful 
        """
        return _modshogun.CombinedFeatures_delete_feature_obj(self)

    def get_num_feature_obj(self):
        """
        get_num_feature_obj(self) ->  int

        get number of feature objects

        number of feature objects 
        """
        return _modshogun.CombinedFeatures_get_num_feature_obj(self)

CombinedFeatures_swigregister = _modshogun.CombinedFeatures_swigregister
CombinedFeatures_swigregister(CombinedFeatures)

class CombinedDotFeatures(DotFeatures):
    """
    Features that allow stacking of a number of DotFeatures.

    They transparently provide all the operations of DotFeatures, i.e.

    a way to obtain the dimensionality of the feature space, i.e.
    $\\mbox{dim}({\\cal X})$

    dot product between feature vectors:

    \\[r = {\\bf x} \\cdot {\\bf x'}\\]

    dot product between feature vector and a dense vector ${\\bf z}$:

    \\[r = {\\bf x} \\cdot {\\bf z}\\]

    multiplication with a scalar $\\alpha$ and addition on to a dense
    vector ${\\bf z}$:

    \\[{\\bf z'} = \\alpha {\\bf x} + {\\bf z}\\]

    C++ includes: CombinedDotFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CombinedDotFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CombinedDotFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CombinedDotFeatures
        __init__(self, orig) -> CombinedDotFeatures

        copy constructor 
        """
        this = _modshogun.new_CombinedDotFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CombinedDotFeatures
    __del__ = lambda self : None;
    def list_feature_objs(self):
        """
        list_feature_objs(self)

        list feature objects 
        """
        return _modshogun.CombinedDotFeatures_list_feature_objs(self)

    def get_first_feature_obj(self, *args):
        """
        get_first_feature_obj(self) -> DotFeatures
        get_first_feature_obj(self, current) -> DotFeatures

        get first feature object

        Parameters:
        -----------

        current:  list of features

        first feature object 
        """
        return _modshogun.CombinedDotFeatures_get_first_feature_obj(self, *args)

    def get_next_feature_obj(self, *args):
        """
        get_next_feature_obj(self) -> DotFeatures
        get_next_feature_obj(self, current) -> DotFeatures

        get next feature object

        Parameters:
        -----------

        current:  list of features

        next feature object 
        """
        return _modshogun.CombinedDotFeatures_get_next_feature_obj(self, *args)

    def get_last_feature_obj(self):
        """
        get_last_feature_obj(self) -> DotFeatures

        get last feature object

        last feature object 
        """
        return _modshogun.CombinedDotFeatures_get_last_feature_obj(self)

    def insert_feature_obj(self, *args):
        """
        insert_feature_obj(self, obj) -> bool

        insert feature object

        Parameters:
        -----------

        obj:  feature object to insert

        if inserting was successful 
        """
        return _modshogun.CombinedDotFeatures_insert_feature_obj(self, *args)

    def append_feature_obj(self, *args):
        """
        append_feature_obj(self, obj) -> bool

        append feature object

        Parameters:
        -----------

        obj:  feature object to append

        if appending was successful 
        """
        return _modshogun.CombinedDotFeatures_append_feature_obj(self, *args)

    def delete_feature_obj(self):
        """
        delete_feature_obj(self) -> bool

        delete feature object

        if deleting was successful 
        """
        return _modshogun.CombinedDotFeatures_delete_feature_obj(self)

    def get_num_feature_obj(self):
        """
        get_num_feature_obj(self) ->  int

        get number of feature objects

        number of feature objects 
        """
        return _modshogun.CombinedDotFeatures_get_num_feature_obj(self)

    def get_subfeature_weights(self, *args):
        """
        get_subfeature_weights(self, weights, num_weights)

        get subfeature weights

        Parameters:
        -----------

        weights:  subfeature weights

        num_weights:  where number of weights is stored 
        """
        return _modshogun.CombinedDotFeatures_get_subfeature_weights(self, *args)

    def set_subfeature_weights(self, *args):
        """
        set_subfeature_weights(self, weights, num_weights)

        set subfeature weights

        Parameters:
        -----------

        weights:  new subfeature weights

        num_weights:  number of subfeature weights 
        """
        return _modshogun.CombinedDotFeatures_set_subfeature_weights(self, *args)

CombinedDotFeatures_swigregister = _modshogun.CombinedDotFeatures_swigregister
CombinedDotFeatures_swigregister(CombinedDotFeatures)

class Labels(SGObject):
    """
    The class Labels models labels, i.e. class assignments of objects.

    Labels here are always real-valued and thus applicable to
    classification (cf. CClassifier) and regression (cf. CRegression)
    problems.

    (Partly) subset access is supported. Simple use the set_subset(),
    remove_subset() functions. If done, all calls that work with features
    are translated to the subset. See comments to find out whether it is
    supported for that method

    C++ includes: Labels.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Labels, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Labels, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Labels
        __init__(self, num_labels) -> Labels
        __init__(self, src) -> Labels
        __init__(self, loader) -> Labels

        constructor

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        this = _modshogun.new_Labels(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Labels
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, loader)

        load labels from file

        any subset is removed before

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        return _modshogun.Labels_load(self, *args)

    def save(self, *args):
        """
        save(self, writer)

        save labels to file

        not possible with subset

        Parameters:
        -----------

        writer:  File object via which to save data 
        """
        return _modshogun.Labels_save(self, *args)

    def set_label(self, *args):
        """
        set_label(self, idx, label) -> bool

        set label

        possible with subset

        Parameters:
        -----------

        idx:  index of label to set

        label:  value of label

        if setting was successful 
        """
        return _modshogun.Labels_set_label(self, *args)

    def set_int_label(self, *args):
        """
        set_int_label(self, idx, label) -> bool

        set INT label

        possible with subset

        Parameters:
        -----------

        idx:  index of label to set

        label:  INT value of label

        if setting was successful 
        """
        return _modshogun.Labels_set_int_label(self, *args)

    def get_label(self, *args):
        """
        get_label(self, idx) -> float

        get label

        possible with subset

        Parameters:
        -----------

        idx:  index of label to get

        value of label 
        """
        return _modshogun.Labels_get_label(self, *args)

    def get_int_label(self, *args):
        """
        get_int_label(self, idx) ->  int

        get INT label

        possible with subset

        Parameters:
        -----------

        idx:  index of label to get

        INT value of label 
        """
        return _modshogun.Labels_get_int_label(self, *args)

    def is_two_class_labeling(self):
        """
        is_two_class_labeling(self) -> bool

        is two-class labeling

        possible with subset

        if this is two-class labeling 
        """
        return _modshogun.Labels_is_two_class_labeling(self)

    def get_num_classes(self):
        """
        get_num_classes(self) ->  int

        return number of classes (for multiclass)

        possible with subset

        number of classes 
        """
        return _modshogun.Labels_get_num_classes(self)

    def get_labels(self):
        """
        get_labels(self) -> numpy 1dim array of float

        get labels

        not possible with subset

        labels 
        """
        return _modshogun.Labels_get_labels(self)

    def set_labels(self, *args):
        """
        set_labels(self, v)

        set labels

        not possible with subset

        Parameters:
        -----------

        v:  labels 
        """
        return _modshogun.Labels_set_labels(self, *args)

    def set_to_one(self):
        """
        set_to_one(self)

        set all labels to +1

        possible with subset 
        """
        return _modshogun.Labels_set_to_one(self)

    def get_int_labels(self):
        """
        get_int_labels(self) -> IntVector

        get INT label vector caller has to clean up

        possible with subset

        INT labels 
        """
        return _modshogun.Labels_get_int_labels(self)

    def get_classes(self):
        """
        get_classes(self) -> RealVector

        get classes of labels Caller has to clean up

        possible with subset

        classes of labels 
        """
        return _modshogun.Labels_get_classes(self)

    def set_int_labels(self, *args):
        """
        set_int_labels(self, labels)

        set INT labels caller has to clean up

        not possible on subset

        Parameters:
        -----------

        labels:  INT labels 
        """
        return _modshogun.Labels_set_int_labels(self, *args)

    def get_num_labels(self):
        """
        get_num_labels(self) ->  int

        get number of labels, depending on whether a subset is set

        number of labels 
        """
        return _modshogun.Labels_get_num_labels(self)

    def set_subset(self, *args):
        """
        set_subset(self, subset)

        setter for subset variable, deletes old one

        Parameters:
        -----------

        subset:  subset instance to set 
        """
        return _modshogun.Labels_set_subset(self, *args)

    def remove_subset(self):
        """
        remove_subset(self)

        deletes any set subset 
        """
        return _modshogun.Labels_remove_subset(self)

    def subset_idx_conversion(self, *args):
        """
        subset_idx_conversion(self, idx) -> index_t

        does subset index conversion with the underlying subset if possible

        Parameters:
        -----------

        idx:  index to convert

        converted index 
        """
        return _modshogun.Labels_subset_idx_conversion(self, *args)

Labels_swigregister = _modshogun.Labels_swigregister
Labels_swigregister(Labels)

class RealFileFeatures(RealFeatures):
    """
    The class RealFileFeatures implements a dense float-precision
    floating point matrix from a file.

    It inherits its functionality from CSimpleFeatures, which should be
    consulted for further reference.

    C++ includes: RealFileFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealFileFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [RealFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealFileFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealFileFeatures
        __init__(self, size, file) -> RealFileFeatures
        __init__(self, size, filename) -> RealFileFeatures
        __init__(self, orig) -> RealFileFeatures

        copy constructor 
        """
        this = _modshogun.new_RealFileFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RealFileFeatures
    __del__ = lambda self : None;
    def load_feature_matrix(self):
        """
        load_feature_matrix(self) -> float

        load feature matrix

        loaded feature matrix 
        """
        return _modshogun.RealFileFeatures_load_feature_matrix(self)

    def get_label(self, *args):
        """
        get_label(self, idx) ->  int

        get label at given index

        Parameters:
        -----------

        idx:  index to look at

        label at given index 
        """
        return _modshogun.RealFileFeatures_get_label(self, *args)

RealFileFeatures_swigregister = _modshogun.RealFileFeatures_swigregister
RealFileFeatures_swigregister(RealFileFeatures)

class FKFeatures(RealFeatures):
    """
    The class FKFeatures implements Fischer kernel features obtained from
    two Hidden Markov models.

    It was used in

    K. Tsuda, M. Kawanabe, G. Raetsch, S. Sonnenburg, and K.R. Mueller. A
    new discriminative kernel from probabilistic models. Neural
    Computation, 14:2397-2414, 2002.

    which also has the details.

    Note that FK-features are computed on the fly, so to be effective
    feature caching should be enabled.

    It inherits its functionality from CSimpleFeatures, which should be
    consulted for further reference.

    C++ includes: FKFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FKFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [RealFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FKFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> FKFeatures
        __init__(self, size, p, n) -> FKFeatures
        __init__(self, orig) -> FKFeatures

        copy constructor 
        """
        this = _modshogun.new_FKFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_FKFeatures
    __del__ = lambda self : None;
    def set_models(self, *args):
        """
        set_models(self, p, n)

        set HMMs

        Parameters:
        -----------

        p:  positive HMM

        n:  negative HMM 
        """
        return _modshogun.FKFeatures_set_models(self, *args)

    def set_a(self, *args):
        """
        set_a(self, a)

        set weight a

        Parameters:
        -----------

        a:  weight a 
        """
        return _modshogun.FKFeatures_set_a(self, *args)

    def get_a(self):
        """
        get_a(self) -> float

        get weight a

        weight a 
        """
        return _modshogun.FKFeatures_get_a(self)

    def set_feature_matrix(self):
        """
        set_feature_matrix(self) -> float

        set feature matrix

        something floaty 
        """
        return _modshogun.FKFeatures_set_feature_matrix(self)

    def set_opt_a(self, *args):
        """
        set_opt_a(self, a = -1) -> float
        set_opt_a(self) -> float

        set opt a

        Parameters:
        -----------

        a:  a

        something floaty 
        """
        return _modshogun.FKFeatures_set_opt_a(self, *args)

    def get_weight_a(self):
        """
        get_weight_a(self) -> float

        get weight_a

        weight_a 
        """
        return _modshogun.FKFeatures_get_weight_a(self)

FKFeatures_swigregister = _modshogun.FKFeatures_swigregister
FKFeatures_swigregister(FKFeatures)

class TOPFeatures(RealFeatures):
    """
    The class TOPFeatures implements TOP kernel features obtained from two
    Hidden Markov models.

    It was used in

    K. Tsuda, M. Kawanabe, G. Raetsch, S. Sonnenburg, and K.R. Mueller. A
    new discriminative kernel from probabilistic models. Neural
    Computation, 14:2397-2414, 2002.

    which also has the details.

    Note that TOP-features are computed on the fly, so to be effective
    feature caching should be enabled.

    It inherits its functionality from CSimpleFeatures, which should be
    consulted for further reference.

    C++ includes: TOPFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TOPFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [RealFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TOPFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> TOPFeatures
        __init__(self, size, p, n, neglin, poslin) -> TOPFeatures
        __init__(self, orig) -> TOPFeatures

        copy constructor 
        """
        this = _modshogun.new_TOPFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_TOPFeatures
    __del__ = lambda self : None;
    def set_models(self, *args):
        """
        set_models(self, p, n)

        set HMMs

        Parameters:
        -----------

        p:  positive HMM

        n:  negative HMM 
        """
        return _modshogun.TOPFeatures_set_models(self, *args)

    def set_feature_matrix(self):
        """
        set_feature_matrix(self) -> float

        set feature matrix

        something floaty 
        """
        return _modshogun.TOPFeatures_set_feature_matrix(self)

    def compute_num_features(self):
        """
        compute_num_features(self) ->  int

        compute number of features

        number of features 
        """
        return _modshogun.TOPFeatures_compute_num_features(self)

    def compute_relevant_indizes(self, *args):
        """
        compute_relevant_indizes(self, hmm, hmm_idx) -> bool

        compute relevant indices

        Parameters:
        -----------

        hmm:  HMM to compute for

        hmm_idx:  HMM index

        if computing was successful 
        """
        return _modshogun.TOPFeatures_compute_relevant_indizes(self, *args)

TOPFeatures_swigregister = _modshogun.TOPFeatures_swigregister
TOPFeatures_swigregister(TOPFeatures)

class SNPFeatures(DotFeatures):
    """
    Features that compute the Weighted Degreee Kernel feature space
    explicitly.

    See:   CWeightedDegreeStringKernel

    C++ includes: SNPFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SNPFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SNPFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SNPFeatures
        __init__(self, str) -> SNPFeatures
        __init__(self, orig) -> SNPFeatures

        copy constructor 
        """
        this = _modshogun.new_SNPFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SNPFeatures
    __del__ = lambda self : None;
    def set_normalization_const(self, n = 0):
        """
        set_normalization_const(self, n = 0)
        set_normalization_const(self)

        set normalization constant

        Parameters:
        -----------

        n:  n=0 means automagic 
        """
        return _modshogun.SNPFeatures_set_normalization_const(self, n)

    def get_normalization_const(self):
        """
        get_normalization_const(self) -> float

        get normalization constant 
        """
        return _modshogun.SNPFeatures_get_normalization_const(self)

    def set_minor_base_string(self, *args):
        """
        set_minor_base_string(self, str)

        set the minor base string

        Parameters:
        -----------

        str:  base string 
        """
        return _modshogun.SNPFeatures_set_minor_base_string(self, *args)

    def set_major_base_string(self, *args):
        """
        set_major_base_string(self, str)

        set the major base string

        Parameters:
        -----------

        str:  base string 
        """
        return _modshogun.SNPFeatures_set_major_base_string(self, *args)

    def get_minor_base_string(self):
        """
        get_minor_base_string(self) -> str

        get the minor base string

        the minor base string 
        """
        return _modshogun.SNPFeatures_get_minor_base_string(self)

    def get_major_base_string(self):
        """
        get_major_base_string(self) -> str

        return the major base string

        major base string 
        """
        return _modshogun.SNPFeatures_get_major_base_string(self)

    def obtain_base_strings(self, snp = None):
        """
        obtain_base_strings(self, snp = None)
        obtain_base_strings(self)

        compute the base strings from current strings optionally taking into
        account snp

        Parameters:
        -----------

        snp:  optionally compute base string for snp too 
        """
        return _modshogun.SNPFeatures_obtain_base_strings(self, snp)

    def get_histogram(self, normalize = True):
        """
        get_histogram(self, normalize = True) -> RealMatrix
        get_histogram(self) -> RealMatrix

        compute histogram over strings 
        """
        return _modshogun.SNPFeatures_get_histogram(self, normalize)

    def get_2x3_table(*args):
        """get_2x3_table(pos, neg) -> RealMatrix"""
        return _modshogun.SNPFeatures_get_2x3_table(*args)

    if _newclass:get_2x3_table = staticmethod(get_2x3_table)
    __swig_getmethods__["get_2x3_table"] = lambda x: get_2x3_table
SNPFeatures_swigregister = _modshogun.SNPFeatures_swigregister
SNPFeatures_swigregister(SNPFeatures)

def SNPFeatures_get_2x3_table(*args):
  """SNPFeatures_get_2x3_table(pos, neg) -> RealMatrix"""
  return _modshogun.SNPFeatures_get_2x3_table(*args)

class WDFeatures(DotFeatures):
    """
    Features that compute the Weighted Degreee Kernel feature space
    explicitly.

    See:   CWeightedDegreeStringKernel

    C++ includes: WDFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WDFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WDFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WDFeatures
        __init__(self, str, order, from_order) -> WDFeatures
        __init__(self, orig) -> WDFeatures

        copy constructor 
        """
        this = _modshogun.new_WDFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WDFeatures
    __del__ = lambda self : None;
    def set_normalization_const(self, n = 0):
        """
        set_normalization_const(self, n = 0)
        set_normalization_const(self)

        set normalization constant

        Parameters:
        -----------

        n:  n=0 means automagic 
        """
        return _modshogun.WDFeatures_set_normalization_const(self, n)

    def get_normalization_const(self):
        """
        get_normalization_const(self) -> float

        get normalization constant 
        """
        return _modshogun.WDFeatures_get_normalization_const(self)

    def set_wd_weights(self, *args):
        """
        set_wd_weights(self, weights)
        set_wd_weights(self)

        create wd kernel weighting heuristic 
        """
        return _modshogun.WDFeatures_set_wd_weights(self, *args)

WDFeatures_swigregister = _modshogun.WDFeatures_swigregister
WDFeatures_swigregister(WDFeatures)

class HashedWDFeatures(DotFeatures):
    """
    Features that compute the Weighted Degreee Kernel feature space
    explicitly.

    See:   CWeightedDegreeStringKernel

    C++ includes: HashedWDFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HashedWDFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HashedWDFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HashedWDFeatures
        __init__(self, str, start_order, order, from_order, hash_bits = 12) -> HashedWDFeatures
        __init__(self, str, start_order, order, from_order) -> HashedWDFeatures
        __init__(self, orig) -> HashedWDFeatures

        copy constructor 
        """
        this = _modshogun.new_HashedWDFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HashedWDFeatures
    __del__ = lambda self : None;
    def set_normalization_const(self, n = 0):
        """
        set_normalization_const(self, n = 0)
        set_normalization_const(self)

        set normalization constant

        Parameters:
        -----------

        n:  n=0 means automagic 
        """
        return _modshogun.HashedWDFeatures_set_normalization_const(self, n)

    def get_normalization_const(self):
        """
        get_normalization_const(self) -> float

        get normalization constant 
        """
        return _modshogun.HashedWDFeatures_get_normalization_const(self)

HashedWDFeatures_swigregister = _modshogun.HashedWDFeatures_swigregister
HashedWDFeatures_swigregister(HashedWDFeatures)

class HashedWDFeaturesTransposed(DotFeatures):
    """
    Features that compute the Weighted Degreee Kernel feature space
    explicitly.

    See:   CWeightedDegreeStringKernel

    C++ includes: HashedWDFeaturesTransposed.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HashedWDFeaturesTransposed, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HashedWDFeaturesTransposed, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HashedWDFeaturesTransposed
        __init__(self, str, start_order, order, from_order, hash_bits = 12) -> HashedWDFeaturesTransposed
        __init__(self, str, start_order, order, from_order) -> HashedWDFeaturesTransposed
        __init__(self, orig) -> HashedWDFeaturesTransposed

        copy constructor 
        """
        this = _modshogun.new_HashedWDFeaturesTransposed(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HashedWDFeaturesTransposed
    __del__ = lambda self : None;
    def set_normalization_const(self, n = 0):
        """
        set_normalization_const(self, n = 0)
        set_normalization_const(self)

        set normalization constant

        Parameters:
        -----------

        n:  n=0 means automagic 
        """
        return _modshogun.HashedWDFeaturesTransposed_set_normalization_const(self, n)

    def get_normalization_const(self):
        """
        get_normalization_const(self) -> float

        get normalization constant 
        """
        return _modshogun.HashedWDFeaturesTransposed_get_normalization_const(self)

HashedWDFeaturesTransposed_swigregister = _modshogun.HashedWDFeaturesTransposed_swigregister
HashedWDFeaturesTransposed_swigregister(HashedWDFeaturesTransposed)

class PolyFeatures(DotFeatures):
    """
    implement DotFeatures for the polynomial kernel

    see DotFeatures for further discription

    C++ includes: PolyFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyFeatures, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_PolyFeatures
    __del__ = lambda self : None;
PolyFeatures_swigregister = _modshogun.PolyFeatures_swigregister
PolyFeatures_swigregister(PolyFeatures)

class SparsePolyFeatures(DotFeatures):
    """
    implement DotFeatures for the polynomial kernel

    see DotFeatures for further discription

    C++ includes: SparsePolyFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparsePolyFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparsePolyFeatures, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparsePolyFeatures
    __del__ = lambda self : None;
    def __init__(self, *args): 
        """
        __init__(self) -> SparsePolyFeatures
        __init__(self, feat, degree, normalize, hash_bits) -> SparsePolyFeatures
        __init__(self, orig) -> SparsePolyFeatures

        copy constructor

        not implemented!

        Parameters:
        -----------

        orig:  original PolyFeature 
        """
        this = _modshogun.new_SparsePolyFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
SparsePolyFeatures_swigregister = _modshogun.SparsePolyFeatures_swigregister
SparsePolyFeatures_swigregister(SparsePolyFeatures)

class LBPPyrDotFeatures(DotFeatures):
    """
    implement DotFeatures for the polynomial kernel

    see DotFeatures for further discription

    C++ includes: LBPPyrDotFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LBPPyrDotFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LBPPyrDotFeatures, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_LBPPyrDotFeatures
    __del__ = lambda self : None;
    def __init__(self, *args): 
        """
        __init__(self) -> LBPPyrDotFeatures
        __init__(self, images, num_pyramids) -> LBPPyrDotFeatures
        __init__(self, orig) -> LBPPyrDotFeatures

        copy constructor

        not implemented!

        Parameters:
        -----------

        orig:  original PolyFeature 
        """
        this = _modshogun.new_LBPPyrDotFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
LBPPyrDotFeatures_swigregister = _modshogun.LBPPyrDotFeatures_swigregister
LBPPyrDotFeatures_swigregister(LBPPyrDotFeatures)

class ExplicitSpecFeatures(DotFeatures):
    """
    Features that compute the Spectrum Kernel feature space explicitly.

    See:   CCommWordStringKernel

    C++ includes: ExplicitSpecFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ExplicitSpecFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ExplicitSpecFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ExplicitSpecFeatures
        __init__(self, str, normalize = True) -> ExplicitSpecFeatures
        __init__(self, str) -> ExplicitSpecFeatures
        __init__(self, orig) -> ExplicitSpecFeatures

        copy constructor 
        """
        this = _modshogun.new_ExplicitSpecFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ExplicitSpecFeatures
    __del__ = lambda self : None;
ExplicitSpecFeatures_swigregister = _modshogun.ExplicitSpecFeatures_swigregister
ExplicitSpecFeatures_swigregister(ExplicitSpecFeatures)

class ImplicitWeightedSpecFeatures(DotFeatures):
    """
    Features that compute the Weighted Spectrum Kernel feature space
    explicitly.

    See:   CWeightedCommWordStringKernel

    C++ includes: ImplicitWeightedSpecFeatures.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotFeatures]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ImplicitWeightedSpecFeatures, name, value)
    __swig_getmethods__ = {}
    for _s in [DotFeatures]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ImplicitWeightedSpecFeatures, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ImplicitWeightedSpecFeatures
        __init__(self, str, normalize = True) -> ImplicitWeightedSpecFeatures
        __init__(self, str) -> ImplicitWeightedSpecFeatures
        __init__(self, orig) -> ImplicitWeightedSpecFeatures

        copy constructor 
        """
        this = _modshogun.new_ImplicitWeightedSpecFeatures(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ImplicitWeightedSpecFeatures
    __del__ = lambda self : None;
    def set_wd_weights(self):
        """
        set_wd_weights(self) -> bool

        set weighted degree weights

        if setting was successful 
        """
        return _modshogun.ImplicitWeightedSpecFeatures_set_wd_weights(self)

    def set_weights(self, *args):
        """
        set_weights(self, w, d) -> bool

        set custom weights (swig compatible)

        Parameters:
        -----------

        w:  weights

        d:  degree (must match number of weights)

        if setting was successful 
        """
        return _modshogun.ImplicitWeightedSpecFeatures_set_weights(self, *args)

ImplicitWeightedSpecFeatures_swigregister = _modshogun.ImplicitWeightedSpecFeatures_swigregister
ImplicitWeightedSpecFeatures_swigregister(ImplicitWeightedSpecFeatures)

class CConverter(SGObject):
    """
    class Converter used to convert data

    C++ includes: Converter.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CConverter, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CConverter, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_CConverter
    __del__ = lambda self : None;
    def apply(self, *args):
        """
        apply(self, features) -> Features

        applies to the given data, returning converted features (e.g. dense
        embedding of string features)

        Parameters:
        -----------

        features:  features to convert

        converted features 
        """
        return _modshogun.CConverter_apply(self, *args)

CConverter_swigregister = _modshogun.CConverter_swigregister
CConverter_swigregister(CConverter)

class EmbeddingConverter(CConverter):
    """
    class EmbeddingConverter used to create embeddings of features, e.g.
    construct dense numeric embedding of string features

    C++ includes: EmbeddingConverter.h 
    """
    __swig_setmethods__ = {}
    for _s in [CConverter]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EmbeddingConverter, name, value)
    __swig_getmethods__ = {}
    for _s in [CConverter]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, EmbeddingConverter, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_EmbeddingConverter
    __del__ = lambda self : None;
    def embed(self, *args):
        """
        embed(self, features) -> RealFeatures

        embed given features, acts the same as apply, but returns
        SimpleFeatures

        Parameters:
        -----------

        features:  features to embed

        embedding simple features 
        """
        return _modshogun.EmbeddingConverter_embed(self, *args)

    def set_target_dim(self, *args):
        """
        set_target_dim(self, dim)

        setter for target dimension

        Parameters:
        -----------

        dim:  target dimension 
        """
        return _modshogun.EmbeddingConverter_set_target_dim(self, *args)

    def get_target_dim(self):
        """
        get_target_dim(self) ->  int

        getter for target dimension target dimension 
        """
        return _modshogun.EmbeddingConverter_get_target_dim(self)

    def set_distance(self, *args):
        """
        set_distance(self, distance)

        setter for distance

        Parameters:
        -----------

        distance:  distance to set 
        """
        return _modshogun.EmbeddingConverter_set_distance(self, *args)

    def get_distance(self):
        """
        get_distance(self) -> Distance

        getter for distance distance 
        """
        return _modshogun.EmbeddingConverter_get_distance(self)

    def set_kernel(self, *args):
        """
        set_kernel(self, kernel)

        setter for kernel

        Parameters:
        -----------

        kernel:  kernel to set 
        """
        return _modshogun.EmbeddingConverter_set_kernel(self, *args)

    def get_kernel(self):
        """
        get_kernel(self) -> Kernel

        getter for kernel kernel 
        """
        return _modshogun.EmbeddingConverter_get_kernel(self)

EmbeddingConverter_swigregister = _modshogun.EmbeddingConverter_swigregister
EmbeddingConverter_swigregister(EmbeddingConverter)

class LocallyLinearEmbedding(EmbeddingConverter):
    """Proxy of C++ shogun::CLocallyLinearEmbedding class"""
    __swig_setmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocallyLinearEmbedding, name, value)
    __swig_getmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocallyLinearEmbedding, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> LocallyLinearEmbedding"""
        this = _modshogun.new_LocallyLinearEmbedding()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LocallyLinearEmbedding
    __del__ = lambda self : None;
    def set_k(self, *args):
        """set_k(self, k)"""
        return _modshogun.LocallyLinearEmbedding_set_k(self, *args)

    def get_k(self):
        """get_k(self) ->  int"""
        return _modshogun.LocallyLinearEmbedding_get_k(self)

    def set_max_k(self, *args):
        """set_max_k(self, max_k)"""
        return _modshogun.LocallyLinearEmbedding_set_max_k(self, *args)

    def get_max_k(self):
        """get_max_k(self) ->  int"""
        return _modshogun.LocallyLinearEmbedding_get_max_k(self)

    def set_auto_k(self, *args):
        """set_auto_k(self, auto_k)"""
        return _modshogun.LocallyLinearEmbedding_set_auto_k(self, *args)

    def get_auto_k(self):
        """get_auto_k(self) -> bool"""
        return _modshogun.LocallyLinearEmbedding_get_auto_k(self)

    def set_reconstruction_shift(self, *args):
        """set_reconstruction_shift(self, reconstruction_shift)"""
        return _modshogun.LocallyLinearEmbedding_set_reconstruction_shift(self, *args)

    def get_reconstruction_shift(self):
        """get_reconstruction_shift(self) -> float"""
        return _modshogun.LocallyLinearEmbedding_get_reconstruction_shift(self)

    def set_nullspace_shift(self, *args):
        """set_nullspace_shift(self, nullspace_shift)"""
        return _modshogun.LocallyLinearEmbedding_set_nullspace_shift(self, *args)

    def get_nullspace_shift(self):
        """get_nullspace_shift(self) -> float"""
        return _modshogun.LocallyLinearEmbedding_get_nullspace_shift(self)

    def set_use_arpack(self, *args):
        """set_use_arpack(self, use_arpack)"""
        return _modshogun.LocallyLinearEmbedding_set_use_arpack(self, *args)

    def get_use_arpack(self):
        """get_use_arpack(self) -> bool"""
        return _modshogun.LocallyLinearEmbedding_get_use_arpack(self)

LocallyLinearEmbedding_swigregister = _modshogun.LocallyLinearEmbedding_swigregister
LocallyLinearEmbedding_swigregister(LocallyLinearEmbedding)

class NeighborhoodPreservingEmbedding(LocallyLinearEmbedding):
    """Proxy of C++ shogun::CNeighborhoodPreservingEmbedding class"""
    __swig_setmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NeighborhoodPreservingEmbedding, name, value)
    __swig_getmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NeighborhoodPreservingEmbedding, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> NeighborhoodPreservingEmbedding"""
        this = _modshogun.new_NeighborhoodPreservingEmbedding()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_NeighborhoodPreservingEmbedding
    __del__ = lambda self : None;
NeighborhoodPreservingEmbedding_swigregister = _modshogun.NeighborhoodPreservingEmbedding_swigregister
NeighborhoodPreservingEmbedding_swigregister(NeighborhoodPreservingEmbedding)

class LocalTangentSpaceAlignment(LocallyLinearEmbedding):
    """Proxy of C++ shogun::CLocalTangentSpaceAlignment class"""
    __swig_setmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalTangentSpaceAlignment, name, value)
    __swig_getmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalTangentSpaceAlignment, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> LocalTangentSpaceAlignment"""
        this = _modshogun.new_LocalTangentSpaceAlignment()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LocalTangentSpaceAlignment
    __del__ = lambda self : None;
LocalTangentSpaceAlignment_swigregister = _modshogun.LocalTangentSpaceAlignment_swigregister
LocalTangentSpaceAlignment_swigregister(LocalTangentSpaceAlignment)

class LinearLocalTangentSpaceAlignment(LocalTangentSpaceAlignment):
    """Proxy of C++ shogun::CLinearLocalTangentSpaceAlignment class"""
    __swig_setmethods__ = {}
    for _s in [LocalTangentSpaceAlignment]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearLocalTangentSpaceAlignment, name, value)
    __swig_getmethods__ = {}
    for _s in [LocalTangentSpaceAlignment]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearLocalTangentSpaceAlignment, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> LinearLocalTangentSpaceAlignment"""
        this = _modshogun.new_LinearLocalTangentSpaceAlignment()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LinearLocalTangentSpaceAlignment
    __del__ = lambda self : None;
LinearLocalTangentSpaceAlignment_swigregister = _modshogun.LinearLocalTangentSpaceAlignment_swigregister
LinearLocalTangentSpaceAlignment_swigregister(LinearLocalTangentSpaceAlignment)

class HessianLocallyLinearEmbedding(LocallyLinearEmbedding):
    """Proxy of C++ shogun::CHessianLocallyLinearEmbedding class"""
    __swig_setmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HessianLocallyLinearEmbedding, name, value)
    __swig_getmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HessianLocallyLinearEmbedding, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> HessianLocallyLinearEmbedding"""
        this = _modshogun.new_HessianLocallyLinearEmbedding()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HessianLocallyLinearEmbedding
    __del__ = lambda self : None;
HessianLocallyLinearEmbedding_swigregister = _modshogun.HessianLocallyLinearEmbedding_swigregister
HessianLocallyLinearEmbedding_swigregister(HessianLocallyLinearEmbedding)

class KernelLocallyLinearEmbedding(LocallyLinearEmbedding):
    """Proxy of C++ shogun::CKernelLocallyLinearEmbedding class"""
    __swig_setmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelLocallyLinearEmbedding, name, value)
    __swig_getmethods__ = {}
    for _s in [LocallyLinearEmbedding]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelLocallyLinearEmbedding, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KernelLocallyLinearEmbedding
        __init__(self, kernel) -> KernelLocallyLinearEmbedding
        """
        this = _modshogun.new_KernelLocallyLinearEmbedding(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KernelLocallyLinearEmbedding
    __del__ = lambda self : None;
    def embed_kernel(self, *args):
        """embed_kernel(self, kernel) -> RealFeatures"""
        return _modshogun.KernelLocallyLinearEmbedding_embed_kernel(self, *args)

KernelLocallyLinearEmbedding_swigregister = _modshogun.KernelLocallyLinearEmbedding_swigregister
KernelLocallyLinearEmbedding_swigregister(KernelLocallyLinearEmbedding)

class KernelLocalTangentSpaceAlignment(KernelLocallyLinearEmbedding):
    """Proxy of C++ shogun::CKernelLocalTangentSpaceAlignment class"""
    __swig_setmethods__ = {}
    for _s in [KernelLocallyLinearEmbedding]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelLocalTangentSpaceAlignment, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelLocallyLinearEmbedding]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelLocalTangentSpaceAlignment, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KernelLocalTangentSpaceAlignment
        __init__(self, kernel) -> KernelLocalTangentSpaceAlignment
        """
        this = _modshogun.new_KernelLocalTangentSpaceAlignment(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KernelLocalTangentSpaceAlignment
    __del__ = lambda self : None;
KernelLocalTangentSpaceAlignment_swigregister = _modshogun.KernelLocalTangentSpaceAlignment_swigregister
KernelLocalTangentSpaceAlignment_swigregister(KernelLocalTangentSpaceAlignment)

class DiffusionMaps(EmbeddingConverter):
    """Proxy of C++ shogun::CDiffusionMaps class"""
    __swig_setmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DiffusionMaps, name, value)
    __swig_getmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DiffusionMaps, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> DiffusionMaps"""
        this = _modshogun.new_DiffusionMaps()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DiffusionMaps
    __del__ = lambda self : None;
    def embed_kernel(self, *args):
        """embed_kernel(self, kernel) -> RealFeatures"""
        return _modshogun.DiffusionMaps_embed_kernel(self, *args)

    def set_t(self, *args):
        """set_t(self, t)"""
        return _modshogun.DiffusionMaps_set_t(self, *args)

    def get_t(self):
        """get_t(self) ->  int"""
        return _modshogun.DiffusionMaps_get_t(self)

DiffusionMaps_swigregister = _modshogun.DiffusionMaps_swigregister
DiffusionMaps_swigregister(DiffusionMaps)

class LaplacianEigenmaps(EmbeddingConverter):
    """Proxy of C++ shogun::CLaplacianEigenmaps class"""
    __swig_setmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LaplacianEigenmaps, name, value)
    __swig_getmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LaplacianEigenmaps, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> LaplacianEigenmaps"""
        this = _modshogun.new_LaplacianEigenmaps()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LaplacianEigenmaps
    __del__ = lambda self : None;
    def embed_distance(self, *args):
        """
        embed_distance(self, distance, features = None) -> RealFeatures
        embed_distance(self, distance) -> RealFeatures
        """
        return _modshogun.LaplacianEigenmaps_embed_distance(self, *args)

    def set_k(self, *args):
        """set_k(self, k)"""
        return _modshogun.LaplacianEigenmaps_set_k(self, *args)

    def get_k(self):
        """get_k(self) ->  int"""
        return _modshogun.LaplacianEigenmaps_get_k(self)

    def set_tau(self, *args):
        """set_tau(self, tau)"""
        return _modshogun.LaplacianEigenmaps_set_tau(self, *args)

    def get_tau(self):
        """get_tau(self) -> float"""
        return _modshogun.LaplacianEigenmaps_get_tau(self)

LaplacianEigenmaps_swigregister = _modshogun.LaplacianEigenmaps_swigregister
LaplacianEigenmaps_swigregister(LaplacianEigenmaps)

class LocalityPreservingProjections(LaplacianEigenmaps):
    """Proxy of C++ shogun::CLocalityPreservingProjections class"""
    __swig_setmethods__ = {}
    for _s in [LaplacianEigenmaps]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalityPreservingProjections, name, value)
    __swig_getmethods__ = {}
    for _s in [LaplacianEigenmaps]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalityPreservingProjections, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> LocalityPreservingProjections"""
        this = _modshogun.new_LocalityPreservingProjections()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LocalityPreservingProjections
    __del__ = lambda self : None;
LocalityPreservingProjections_swigregister = _modshogun.LocalityPreservingProjections_swigregister
LocalityPreservingProjections_swigregister(LocalityPreservingProjections)

class MultidimensionalScaling(EmbeddingConverter):
    """Proxy of C++ shogun::CMultidimensionalScaling class"""
    __swig_setmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultidimensionalScaling, name, value)
    __swig_getmethods__ = {}
    for _s in [EmbeddingConverter]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultidimensionalScaling, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> MultidimensionalScaling"""
        this = _modshogun.new_MultidimensionalScaling()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultidimensionalScaling
    __del__ = lambda self : None;
    def embed_distance(self, *args):
        """embed_distance(self, distance) -> RealFeatures"""
        return _modshogun.MultidimensionalScaling_embed_distance(self, *args)

    def get_eigenvalues(self):
        """get_eigenvalues(self) -> RealVector"""
        return _modshogun.MultidimensionalScaling_get_eigenvalues(self)

    def set_landmark_number(self, *args):
        """set_landmark_number(self, num)"""
        return _modshogun.MultidimensionalScaling_set_landmark_number(self, *args)

    def get_landmark_number(self):
        """get_landmark_number(self) ->  int"""
        return _modshogun.MultidimensionalScaling_get_landmark_number(self)

    def set_landmark(self, *args):
        """set_landmark(self, landmark)"""
        return _modshogun.MultidimensionalScaling_set_landmark(self, *args)

    def get_landmark(self):
        """get_landmark(self) -> bool"""
        return _modshogun.MultidimensionalScaling_get_landmark(self)

MultidimensionalScaling_swigregister = _modshogun.MultidimensionalScaling_swigregister
MultidimensionalScaling_swigregister(MultidimensionalScaling)

class Isomap(MultidimensionalScaling):
    """Proxy of C++ shogun::CIsomap class"""
    __swig_setmethods__ = {}
    for _s in [MultidimensionalScaling]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Isomap, name, value)
    __swig_getmethods__ = {}
    for _s in [MultidimensionalScaling]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Isomap, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> Isomap"""
        this = _modshogun.new_Isomap()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Isomap
    __del__ = lambda self : None;
    def set_k(self, *args):
        """set_k(self, k)"""
        return _modshogun.Isomap_set_k(self, *args)

    def get_k(self):
        """get_k(self) ->  int"""
        return _modshogun.Isomap_get_k(self)

Isomap_swigregister = _modshogun.Isomap_swigregister
Isomap_swigregister(Isomap)

P_UNKNOWN = _modshogun.P_UNKNOWN
P_NORMONE = _modshogun.P_NORMONE
P_LOGPLUSONE = _modshogun.P_LOGPLUSONE
P_SORTWORDSTRING = _modshogun.P_SORTWORDSTRING
P_SORTULONGSTRING = _modshogun.P_SORTULONGSTRING
P_SORTWORD = _modshogun.P_SORTWORD
P_PRUNEVARSUBMEAN = _modshogun.P_PRUNEVARSUBMEAN
P_DECOMPRESSSTRING = _modshogun.P_DECOMPRESSSTRING
P_DECOMPRESSCHARSTRING = _modshogun.P_DECOMPRESSCHARSTRING
P_DECOMPRESSBYTESTRING = _modshogun.P_DECOMPRESSBYTESTRING
P_DECOMPRESSWORDSTRING = _modshogun.P_DECOMPRESSWORDSTRING
P_DECOMPRESSULONGSTRING = _modshogun.P_DECOMPRESSULONGSTRING
P_RANDOMFOURIERGAUSS = _modshogun.P_RANDOMFOURIERGAUSS
P_PCA = _modshogun.P_PCA
P_KERNELPCA = _modshogun.P_KERNELPCA
P_NORMDERIVATIVELEM3 = _modshogun.P_NORMDERIVATIVELEM3
P_DIMENSIONREDUCTIONPREPROCESSOR = _modshogun.P_DIMENSIONREDUCTIONPREPROCESSOR
P_MULTIDIMENSIONALSCALING = _modshogun.P_MULTIDIMENSIONALSCALING
P_LOCALLYLINEAREMBEDDING = _modshogun.P_LOCALLYLINEAREMBEDDING
P_ISOMAP = _modshogun.P_ISOMAP
P_HESSIANLOCALLYLINEAREMBEDDING = _modshogun.P_HESSIANLOCALLYLINEAREMBEDDING
P_LOCALTANGENTSPACEALIGNMENT = _modshogun.P_LOCALTANGENTSPACEALIGNMENT
P_LAPLACIANEIGENMAPS = _modshogun.P_LAPLACIANEIGENMAPS
P_KERNELLOCALLYLINEAREMBEDDING = _modshogun.P_KERNELLOCALLYLINEAREMBEDDING
P_DIFFUSIONMAPS = _modshogun.P_DIFFUSIONMAPS
P_KERNELLOCALTANGENTSPACEALIGNMENT = _modshogun.P_KERNELLOCALTANGENTSPACEALIGNMENT
class Preprocessor(SGObject):
    """
    Class Preprocessor defines a preprocessor interface.

    Preprocessors are transformation functions that doesn't change the
    domain of the input features. These functions can be applied in-place
    if the input features fit in memory or can be applied on-the-fly when
    (depending on features) a feature caching strategy is applied.
    However, if the individual features are in $\\bf{R}$ they have to
    stay in $\\bf{R}$ although the dimensionality of the feature vectors
    is allowed to be changed.

    As preprocessors might need a certain initialization they may expect
    that the init() function is called before anything else. The actual
    preprocessing is feature type dependent and thus coordinated in the
    sub-classes, cf. e.g. CSimplePreprocessor.

    C++ includes: Preprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Preprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Preprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Preprocessor
    __del__ = lambda self : None;
    def init(self, *args):
        """
        init(self, features) -> bool

        initialize preprocessor with features 
        """
        return _modshogun.Preprocessor_init(self, *args)

    def get_feature_type(self):
        """
        get_feature_type(self) -> EFeatureType

        type of objects preprocessor can deal with 
        """
        return _modshogun.Preprocessor_get_feature_type(self)

    def get_feature_class(self):
        """
        get_feature_class(self) -> EFeatureClass

        class of features preprocessor deals with 
        """
        return _modshogun.Preprocessor_get_feature_class(self)

    def get_type(self):
        """
        get_type(self) -> EPreprocessorType

        the actual type of the preprocessor 
        """
        return _modshogun.Preprocessor_get_type(self)

Preprocessor_swigregister = _modshogun.Preprocessor_swigregister
Preprocessor_swigregister(Preprocessor)

class RealPreprocessor(Preprocessor):
    """
    Template class SimplePreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CSimpleFeatures (i.e. rectangular dense
    matrices)

    Two new functions apply_to_feature_vector() and
    apply_to_feature_matrix() are defined in this interface that need to
    be implemented in each particular preprocessor operating on
    CSimpleFeatures. For examples see e.g. CLogPlusOne or CPCACut.

    C++ includes: SimplePreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_feature_matrix(self, *args):
        """
        apply_to_feature_matrix(self, features) -> RealMatrix

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.RealPreprocessor_apply_to_feature_matrix(self, *args)

    def apply_to_feature_vector(self, *args):
        """
        apply_to_feature_vector(self, vector) -> RealVector

        apply preproc on single feature vector result in feature matrix 
        """
        return _modshogun.RealPreprocessor_apply_to_feature_vector(self, *args)

    __swig_destroy__ = _modshogun.delete_RealPreprocessor
    __del__ = lambda self : None;
RealPreprocessor_swigregister = _modshogun.RealPreprocessor_swigregister
RealPreprocessor_swigregister(RealPreprocessor)

class UlongPreprocessor(Preprocessor):
    """
    Template class SimplePreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CSimpleFeatures (i.e. rectangular dense
    matrices)

    Two new functions apply_to_feature_vector() and
    apply_to_feature_matrix() are defined in this interface that need to
    be implemented in each particular preprocessor operating on
    CSimpleFeatures. For examples see e.g. CLogPlusOne or CPCACut.

    C++ includes: SimplePreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UlongPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UlongPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_feature_matrix(self, *args):
        """
        apply_to_feature_matrix(self, features) -> ULongIntMatrix

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.UlongPreprocessor_apply_to_feature_matrix(self, *args)

    def apply_to_feature_vector(self, *args):
        """
        apply_to_feature_vector(self, vector) -> ULongIntVector

        apply preproc on single feature vector result in feature matrix 
        """
        return _modshogun.UlongPreprocessor_apply_to_feature_vector(self, *args)

    __swig_destroy__ = _modshogun.delete_UlongPreprocessor
    __del__ = lambda self : None;
UlongPreprocessor_swigregister = _modshogun.UlongPreprocessor_swigregister
UlongPreprocessor_swigregister(UlongPreprocessor)

class WordPreprocessor(Preprocessor):
    """
    Template class SimplePreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CSimpleFeatures (i.e. rectangular dense
    matrices)

    Two new functions apply_to_feature_vector() and
    apply_to_feature_matrix() are defined in this interface that need to
    be implemented in each particular preprocessor operating on
    CSimpleFeatures. For examples see e.g. CLogPlusOne or CPCACut.

    C++ includes: SimplePreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_feature_matrix(self, *args):
        """
        apply_to_feature_matrix(self, features) -> WordMatrix

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.WordPreprocessor_apply_to_feature_matrix(self, *args)

    def apply_to_feature_vector(self, *args):
        """
        apply_to_feature_vector(self, vector) -> WordVector

        apply preproc on single feature vector result in feature matrix 
        """
        return _modshogun.WordPreprocessor_apply_to_feature_vector(self, *args)

    __swig_destroy__ = _modshogun.delete_WordPreprocessor
    __del__ = lambda self : None;
WordPreprocessor_swigregister = _modshogun.WordPreprocessor_swigregister
WordPreprocessor_swigregister(WordPreprocessor)

class BytePreprocessor(Preprocessor):
    """
    Template class SimplePreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CSimpleFeatures (i.e. rectangular dense
    matrices)

    Two new functions apply_to_feature_vector() and
    apply_to_feature_matrix() are defined in this interface that need to
    be implemented in each particular preprocessor operating on
    CSimpleFeatures. For examples see e.g. CLogPlusOne or CPCACut.

    C++ includes: SimplePreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BytePreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BytePreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_feature_matrix(self, *args):
        """
        apply_to_feature_matrix(self, features) -> ByteMatrix

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.BytePreprocessor_apply_to_feature_matrix(self, *args)

    def apply_to_feature_vector(self, *args):
        """
        apply_to_feature_vector(self, vector) -> ByteVector

        apply preproc on single feature vector result in feature matrix 
        """
        return _modshogun.BytePreprocessor_apply_to_feature_vector(self, *args)

    __swig_destroy__ = _modshogun.delete_BytePreprocessor
    __del__ = lambda self : None;
BytePreprocessor_swigregister = _modshogun.BytePreprocessor_swigregister
BytePreprocessor_swigregister(BytePreprocessor)

class CharPreprocessor(Preprocessor):
    """
    Template class SimplePreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CSimpleFeatures (i.e. rectangular dense
    matrices)

    Two new functions apply_to_feature_vector() and
    apply_to_feature_matrix() are defined in this interface that need to
    be implemented in each particular preprocessor operating on
    CSimpleFeatures. For examples see e.g. CLogPlusOne or CPCACut.

    C++ includes: SimplePreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_feature_matrix(self, *args):
        """
        apply_to_feature_matrix(self, features) -> CharMatrix

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.CharPreprocessor_apply_to_feature_matrix(self, *args)

    def apply_to_feature_vector(self, *args):
        """
        apply_to_feature_vector(self, vector) -> CharVector

        apply preproc on single feature vector result in feature matrix 
        """
        return _modshogun.CharPreprocessor_apply_to_feature_vector(self, *args)

    __swig_destroy__ = _modshogun.delete_CharPreprocessor
    __del__ = lambda self : None;
CharPreprocessor_swigregister = _modshogun.CharPreprocessor_swigregister
CharPreprocessor_swigregister(CharPreprocessor)

class DimensionReductionPreprocessor(RealPreprocessor):
    """
    the class DimensionReductionPreprocessor, a base class for
    preprocessors used to lower the dimensionality of given simple
    features (dense matrices).

    C++ includes: DimensionReductionPreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DimensionReductionPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [RealPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DimensionReductionPreprocessor, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DimensionReductionPreprocessor
        __init__(self, converter) -> DimensionReductionPreprocessor

        convenience constructor converting any embeddingconverter into a
        dimensionreduction preprocessor

        Parameters:
        -----------

        converter:  embedding converter 
        """
        this = _modshogun.new_DimensionReductionPreprocessor(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DimensionReductionPreprocessor
    __del__ = lambda self : None;
    def set_target_dim(self, *args):
        """
        set_target_dim(self, dim)

        setter for target dimension

        Parameters:
        -----------

        dim:  target dimension 
        """
        return _modshogun.DimensionReductionPreprocessor_set_target_dim(self, *args)

    def get_target_dim(self):
        """
        get_target_dim(self) ->  int

        getter for target dimension target dimension 
        """
        return _modshogun.DimensionReductionPreprocessor_get_target_dim(self)

    def set_distance(self, *args):
        """
        set_distance(self, distance)

        setter for distance

        Parameters:
        -----------

        distance:  distance to set 
        """
        return _modshogun.DimensionReductionPreprocessor_set_distance(self, *args)

    def get_distance(self):
        """
        get_distance(self) -> Distance

        getter for distance distance 
        """
        return _modshogun.DimensionReductionPreprocessor_get_distance(self)

    def set_kernel(self, *args):
        """
        set_kernel(self, kernel)

        setter for kernel

        Parameters:
        -----------

        kernel:  kernel to set 
        """
        return _modshogun.DimensionReductionPreprocessor_set_kernel(self, *args)

    def get_kernel(self):
        """
        get_kernel(self) -> Kernel

        getter for kernel kernel 
        """
        return _modshogun.DimensionReductionPreprocessor_get_kernel(self)

DimensionReductionPreprocessor_swigregister = _modshogun.DimensionReductionPreprocessor_swigregister
DimensionReductionPreprocessor_swigregister(DimensionReductionPreprocessor)

class StringUlongPreprocessor(Preprocessor):
    """
    Template class StringPreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CStringFeatures (i.e. strings of variable
    length).

    Two new functions apply_to_string() and apply_to_string_features() are
    defined in this interface that need to be implemented in each
    particular preprocessor operating on CStringFeatures.

    C++ includes: StringPreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringUlongPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringUlongPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_string_features(self, *args):
        """
        apply_to_string_features(self, f) -> bool

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.StringUlongPreprocessor_apply_to_string_features(self, *args)

    def apply_to_string(self, *args):
        """
        apply_to_string(self, f, len) -> unsigned long long

        apply preproc on single feature vector 
        """
        return _modshogun.StringUlongPreprocessor_apply_to_string(self, *args)

    __swig_destroy__ = _modshogun.delete_StringUlongPreprocessor
    __del__ = lambda self : None;
StringUlongPreprocessor_swigregister = _modshogun.StringUlongPreprocessor_swigregister
StringUlongPreprocessor_swigregister(StringUlongPreprocessor)

class StringWordPreprocessor(Preprocessor):
    """
    Template class StringPreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CStringFeatures (i.e. strings of variable
    length).

    Two new functions apply_to_string() and apply_to_string_features() are
    defined in this interface that need to be implemented in each
    particular preprocessor operating on CStringFeatures.

    C++ includes: StringPreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringWordPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringWordPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_string_features(self, *args):
        """
        apply_to_string_features(self, f) -> bool

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.StringWordPreprocessor_apply_to_string_features(self, *args)

    def apply_to_string(self, *args):
        """
        apply_to_string(self, f, len) -> unsigned short

        apply preproc on single feature vector 
        """
        return _modshogun.StringWordPreprocessor_apply_to_string(self, *args)

    __swig_destroy__ = _modshogun.delete_StringWordPreprocessor
    __del__ = lambda self : None;
StringWordPreprocessor_swigregister = _modshogun.StringWordPreprocessor_swigregister
StringWordPreprocessor_swigregister(StringWordPreprocessor)

class StringBytePreprocessor(Preprocessor):
    """
    Template class StringPreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CStringFeatures (i.e. strings of variable
    length).

    Two new functions apply_to_string() and apply_to_string_features() are
    defined in this interface that need to be implemented in each
    particular preprocessor operating on CStringFeatures.

    C++ includes: StringPreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringBytePreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringBytePreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_string_features(self, *args):
        """
        apply_to_string_features(self, f) -> bool

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.StringBytePreprocessor_apply_to_string_features(self, *args)

    def apply_to_string(self, *args):
        """
        apply_to_string(self, f, len) -> unsigned str

        apply preproc on single feature vector 
        """
        return _modshogun.StringBytePreprocessor_apply_to_string(self, *args)

    __swig_destroy__ = _modshogun.delete_StringBytePreprocessor
    __del__ = lambda self : None;
StringBytePreprocessor_swigregister = _modshogun.StringBytePreprocessor_swigregister
StringBytePreprocessor_swigregister(StringBytePreprocessor)

class StringCharPreprocessor(Preprocessor):
    """
    Template class StringPreprocessor, base class for preprocessors (cf.
    CPreprocessor) that apply to CStringFeatures (i.e. strings of variable
    length).

    Two new functions apply_to_string() and apply_to_string_features() are
    defined in this interface that need to be implemented in each
    particular preprocessor operating on CStringFeatures.

    C++ includes: StringPreprocessor.h 
    """
    __swig_setmethods__ = {}
    for _s in [Preprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringCharPreprocessor, name, value)
    __swig_getmethods__ = {}
    for _s in [Preprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringCharPreprocessor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def apply_to_string_features(self, *args):
        """
        apply_to_string_features(self, f) -> bool

        apply preproc on feature matrix result in feature matrix return
        pointer to feature_matrix, i.e. f->get_feature_matrix(); 
        """
        return _modshogun.StringCharPreprocessor_apply_to_string_features(self, *args)

    def apply_to_string(self, *args):
        """
        apply_to_string(self, f, len) -> str

        apply preproc on single feature vector 
        """
        return _modshogun.StringCharPreprocessor_apply_to_string(self, *args)

    __swig_destroy__ = _modshogun.delete_StringCharPreprocessor
    __del__ = lambda self : None;
StringCharPreprocessor_swigregister = _modshogun.StringCharPreprocessor_swigregister
StringCharPreprocessor_swigregister(StringCharPreprocessor)

class DecompressUlongString(StringUlongPreprocessor):
    """
    Preprocessor that decompresses compressed strings.

    Each string in CStringFeatures might be stored compressed in memory.
    This preprocessor decompresses these strings on the fly. This may be
    especially usefull for long strings and when datasets become too large
    to fit in memoryin uncompressed form but still when they are
    compressed.

    Then avoiding expensive disk i/o strings are on-the-fly decompressed.

    C++ includes: DecompressString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringUlongPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DecompressUlongString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringUlongPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DecompressUlongString, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DecompressUlongString
        __init__(self, ct) -> DecompressUlongString

        constructor 
        """
        this = _modshogun.new_DecompressUlongString(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DecompressUlongString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.DecompressUlongString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.DecompressUlongString_save(self, *args)

DecompressUlongString_swigregister = _modshogun.DecompressUlongString_swigregister
DecompressUlongString_swigregister(DecompressUlongString)

class DecompressWordString(StringWordPreprocessor):
    """
    Preprocessor that decompresses compressed strings.

    Each string in CStringFeatures might be stored compressed in memory.
    This preprocessor decompresses these strings on the fly. This may be
    especially usefull for long strings and when datasets become too large
    to fit in memoryin uncompressed form but still when they are
    compressed.

    Then avoiding expensive disk i/o strings are on-the-fly decompressed.

    C++ includes: DecompressString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DecompressWordString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DecompressWordString, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DecompressWordString
        __init__(self, ct) -> DecompressWordString

        constructor 
        """
        this = _modshogun.new_DecompressWordString(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DecompressWordString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.DecompressWordString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.DecompressWordString_save(self, *args)

DecompressWordString_swigregister = _modshogun.DecompressWordString_swigregister
DecompressWordString_swigregister(DecompressWordString)

class DecompressByteString(StringBytePreprocessor):
    """
    Preprocessor that decompresses compressed strings.

    Each string in CStringFeatures might be stored compressed in memory.
    This preprocessor decompresses these strings on the fly. This may be
    especially usefull for long strings and when datasets become too large
    to fit in memoryin uncompressed form but still when they are
    compressed.

    Then avoiding expensive disk i/o strings are on-the-fly decompressed.

    C++ includes: DecompressString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringBytePreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DecompressByteString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringBytePreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DecompressByteString, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DecompressByteString
        __init__(self, ct) -> DecompressByteString

        constructor 
        """
        this = _modshogun.new_DecompressByteString(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DecompressByteString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.DecompressByteString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.DecompressByteString_save(self, *args)

DecompressByteString_swigregister = _modshogun.DecompressByteString_swigregister
DecompressByteString_swigregister(DecompressByteString)

class DecompressCharString(StringCharPreprocessor):
    """
    Preprocessor that decompresses compressed strings.

    Each string in CStringFeatures might be stored compressed in memory.
    This preprocessor decompresses these strings on the fly. This may be
    especially usefull for long strings and when datasets become too large
    to fit in memoryin uncompressed form but still when they are
    compressed.

    Then avoiding expensive disk i/o strings are on-the-fly decompressed.

    C++ includes: DecompressString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DecompressCharString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DecompressCharString, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DecompressCharString
        __init__(self, ct) -> DecompressCharString

        constructor 
        """
        this = _modshogun.new_DecompressCharString(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DecompressCharString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.DecompressCharString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.DecompressCharString_save(self, *args)

DecompressCharString_swigregister = _modshogun.DecompressCharString_swigregister
DecompressCharString_swigregister(DecompressCharString)

class NormOne(RealPreprocessor):
    """
    Preprocessor NormOne, normalizes vectors to have norm 1.

    Formally, it computes

    \\[ {\\bf x} \\leftarrow \\frac{{\\bf x}}{||{\\bf x}||}
    \\]

    It therefore does not need any initialization. It is most useful to
    get data onto a ball of radius one.

    C++ includes: NormOne.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NormOne, name, value)
    __swig_getmethods__ = {}
    for _s in [RealPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NormOne, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> NormOne

        default constructor 
        """
        this = _modshogun.new_NormOne()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_NormOne
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.NormOne_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.NormOne_save(self, *args)

NormOne_swigregister = _modshogun.NormOne_swigregister
NormOne_swigregister(NormOne)

class LogPlusOne(RealPreprocessor):
    """
    Preprocessor LogPlusOne does what the name says, it adds one to a
    dense real valued vector and takes the logarithm of each component of
    it.

    \\[ {\\bf x}\\leftarrow \\log({\\bf x}+{\\bf 1}) \\] It
    therefore does not need any initialization. It is most useful in
    situations where the inputs are counts: When one compares differences
    of small counts any difference may matter a lot, while small
    differences in large counts don't. This is what this log
    transformation controls for.

    C++ includes: LogPlusOne.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LogPlusOne, name, value)
    __swig_getmethods__ = {}
    for _s in [RealPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LogPlusOne, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> LogPlusOne

        default constructor 
        """
        this = _modshogun.new_LogPlusOne()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LogPlusOne
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.LogPlusOne_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.LogPlusOne_save(self, *args)

LogPlusOne_swigregister = _modshogun.LogPlusOne_swigregister
LogPlusOne_swigregister(LogPlusOne)

class PruneVarSubMean(RealPreprocessor):
    """
    Preprocessor PruneVarSubMean will substract the mean and remove
    features that have zero variance.

    It will optionally normalize standard deviation of features to 1 (by
    dividing by standard deviation of the feature)

    C++ includes: PruneVarSubMean.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PruneVarSubMean, name, value)
    __swig_getmethods__ = {}
    for _s in [RealPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PruneVarSubMean, name)
    __repr__ = _swig_repr
    def __init__(self, divide = True): 
        """
        __init__(self, divide = True) -> PruneVarSubMean
        __init__(self) -> PruneVarSubMean

        constructor

        Parameters:
        -----------

        divide:  if division shall be made 
        """
        this = _modshogun.new_PruneVarSubMean(divide)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PruneVarSubMean
    __del__ = lambda self : None;
PruneVarSubMean_swigregister = _modshogun.PruneVarSubMean_swigregister
PruneVarSubMean_swigregister(PruneVarSubMean)

class RandomFourierGaussPreproc(RealPreprocessor):
    """
    Preprocessor CRandomFourierGaussPreproc implements Random Fourier
    Features for the Gauss kernel a la Ali Rahimi and Ben Recht Nips2007
    after preprocessing the features using them in a linear kernel
    approximates a gaussian kernel.

    approximation quality depends on dimension of feature space, NOT on
    number of data.

    effectively it requires two parameters for initialization: (A) the
    dimension of the input features stored in dim_input_space (B) the
    dimension of the output feature space

    in order to make it work there are two ways: (1) if you have already
    previously computed random fourier features which you want to use
    together with newly computed ones, then you have to take the random
    coefficients from the previous computation and provide them via void
    set_randomcoefficients(...) for the new computation this case is
    important for example if you compute separately features on training
    and testing data in two feature objects

    in this case you have to set 1a) void set_randomcoefficients(...)

    (2) if you compute random fourier features from scratch in this case
    you have to set 2a) set_kernelwidth(...) 2b) void
    set_dim_feature_space(const  int dim); 2c)
    set_dim_input_space(const  int dim); 2d) init_randomcoefficients()
    or apply_to_feature_matrix(...)

    C++ includes: RandomFourierGaussPreproc.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RandomFourierGaussPreproc, name, value)
    __swig_getmethods__ = {}
    for _s in [RealPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RandomFourierGaussPreproc, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RandomFourierGaussPreproc
        __init__(self, pr) -> RandomFourierGaussPreproc

        alternative constructor 
        """
        this = _modshogun.new_RandomFourierGaussPreproc(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RandomFourierGaussPreproc
    __del__ = lambda self : None;
    def set_kernelwidth(self, *args):
        """
        set_kernelwidth(self, width)

        setter for kernel width

        Parameters:
        -----------

        width:  kernel width to be set 
        """
        return _modshogun.RandomFourierGaussPreproc_set_kernelwidth(self, *args)

    def get_kernelwidth(self):
        """
        get_kernelwidth(self) -> float

        getter for kernel width kernel width throws exception if kernelwidth
        <=0 
        """
        return _modshogun.RandomFourierGaussPreproc_get_kernelwidth(self)

    def get_randomcoefficients(self, *args):
        """
        get_randomcoefficients(self, randomcoeff_additive2, randomcoeff_multiplicative2, 
            dim_feature_space2, dim_input_space2, kernelwidth2)

        getter for the random coefficients necessary for creating random
        fourier features compatible to the current ones returns values of
        internal members randomcoeff_additive and randomcoeff_multiplicative

        """
        return _modshogun.RandomFourierGaussPreproc_get_randomcoefficients(self, *args)

    def set_randomcoefficients(self, *args):
        """
        set_randomcoefficients(self, randomcoeff_additive2, randomcoeff_multiplicative2, 
            dim_feature_space2, dim_input_space2, kernelwidth2)

        setter for the random coefficients necessary for creating random
        fourier features compatible to the previous ones sets values of
        internal members randomcoeff_additive and randomcoeff_multiplicative
        simply use as input what you got from get_random_coefficients(...) 
        """
        return _modshogun.RandomFourierGaussPreproc_set_randomcoefficients(self, *args)

    def set_dim_input_space(self, *args):
        """
        set_dim_input_space(self, dim)

        a setter

        Parameters:
        -----------

        dim:  the value of protected member dim_input_space throws a shogun
        exception if dim<=0 
        """
        return _modshogun.RandomFourierGaussPreproc_set_dim_input_space(self, *args)

    def set_dim_feature_space(self, *args):
        """
        set_dim_feature_space(self, dim)

        a setter

        Parameters:
        -----------

        dim:  the value of protected member dim_feature_space throws a shogun
        exception if dim<=0 
        """
        return _modshogun.RandomFourierGaussPreproc_set_dim_feature_space(self, *args)

    def init_randomcoefficients(self):
        """
        init_randomcoefficients(self) -> bool

        computes new random coefficients IF test_rfinited() evaluates to false
        test_rfinited() evaluates to TRUE if void set_randomcoefficients(...)
        hase been called and the values set by set_dim_input_space(...) ,
        set_dim_feature_space(...) and set_kernelwidth(...) are consistent to
        the call of void set_randomcoefficients(...)

        throws shogun exception if dim_feature_space <= 0 or dim_input_space
        <= 0

        returns true if test_rfinited() evaluates to false and new
        coefficients are computed returns false if test_rfinited() evaluates
        to true and old random coefficients are kept which were set by a
        previous call to void set_randomcoefficients(...)  this function is
        useful if you want to use apply_to_feature_vector but cannot call
        before it init(CFeatures *f) 
        """
        return _modshogun.RandomFourierGaussPreproc_init_randomcoefficients(self)

    def get_dim_input_space(self):
        """
        get_dim_input_space(self) ->  int

        a getter the set value of protected member dim_input_space 
        """
        return _modshogun.RandomFourierGaussPreproc_get_dim_input_space(self)

    def get_dim_feature_space(self):
        """
        get_dim_feature_space(self) ->  int

        a getter the set value of protected member dim_feature_space 
        """
        return _modshogun.RandomFourierGaussPreproc_get_dim_feature_space(self)

RandomFourierGaussPreproc_swigregister = _modshogun.RandomFourierGaussPreproc_swigregister
RandomFourierGaussPreproc_swigregister(RandomFourierGaussPreproc)

THRESHOLD = _modshogun.THRESHOLD
VARIANCE_EXPLAINED = _modshogun.VARIANCE_EXPLAINED
FIXED_NUMBER = _modshogun.FIXED_NUMBER
class PCA(DimensionReductionPreprocessor):
    """Proxy of C++ shogun::CPCA class"""
    __swig_setmethods__ = {}
    for _s in [DimensionReductionPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PCA, name, value)
    __swig_getmethods__ = {}
    for _s in [DimensionReductionPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PCA, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, do_whitening = False, mode = FIXED_NUMBER, thresh = 1e-6) -> PCA
        __init__(self, do_whitening = False, mode = FIXED_NUMBER) -> PCA
        __init__(self, do_whitening = False) -> PCA
        __init__(self) -> PCA
        """
        this = _modshogun.new_PCA(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PCA
    __del__ = lambda self : None;
    def get_transformation_matrix(self):
        """get_transformation_matrix(self) -> RealMatrix"""
        return _modshogun.PCA_get_transformation_matrix(self)

    def get_eigenvalues(self):
        """get_eigenvalues(self) -> RealVector"""
        return _modshogun.PCA_get_eigenvalues(self)

    def get_mean(self):
        """get_mean(self) -> RealVector"""
        return _modshogun.PCA_get_mean(self)

PCA_swigregister = _modshogun.PCA_swigregister
PCA_swigregister(PCA)

class KernelPCA(DimensionReductionPreprocessor):
    """Proxy of C++ shogun::CKernelPCA class"""
    __swig_setmethods__ = {}
    for _s in [DimensionReductionPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelPCA, name, value)
    __swig_getmethods__ = {}
    for _s in [DimensionReductionPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelPCA, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KernelPCA
        __init__(self, k) -> KernelPCA
        """
        this = _modshogun.new_KernelPCA(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KernelPCA
    __del__ = lambda self : None;
    def apply_to_string_features(self, *args):
        """apply_to_string_features(self, features) -> RealFeatures"""
        return _modshogun.KernelPCA_apply_to_string_features(self, *args)

    def get_transformation_matrix(self):
        """get_transformation_matrix(self) -> RealMatrix"""
        return _modshogun.KernelPCA_get_transformation_matrix(self)

    def get_bias_vector(self):
        """get_bias_vector(self) -> RealVector"""
        return _modshogun.KernelPCA_get_bias_vector(self)

KernelPCA_swigregister = _modshogun.KernelPCA_swigregister
KernelPCA_swigregister(KernelPCA)

class SortUlongString(StringUlongPreprocessor):
    """
    Preprocessor SortUlongString, sorts the indivual strings in ascending
    order.

    This is useful in conjunction with the CCommUlongStringKernel and will
    result in the spectrum kernel. For this to work the strings have to be
    mapped into a binary higher order representation first (cf.
    obtain_from_*() functions in CStringFeatures)

    C++ includes: SortUlongString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringUlongPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SortUlongString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringUlongPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SortUlongString, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> SortUlongString

        default constructor 
        """
        this = _modshogun.new_SortUlongString()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SortUlongString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.SortUlongString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.SortUlongString_save(self, *args)

SortUlongString_swigregister = _modshogun.SortUlongString_swigregister
SortUlongString_swigregister(SortUlongString)

class SortWordString(StringWordPreprocessor):
    """
    Preprocessor SortWordString, sorts the indivual strings in ascending
    order.

    This is useful in conjunction with the CCommWordStringKernel and will
    result in the spectrum kernel. For this to work the strings have to be
    mapped into a binary higher order representation first (cf.
    obtain_from_*() functions in CStringFeatures)

    C++ includes: SortWordString.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordPreprocessor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SortWordString, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordPreprocessor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SortWordString, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> SortWordString

        default constructor 
        """
        this = _modshogun.new_SortWordString()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SortWordString
    __del__ = lambda self : None;
    def load(self, *args):
        """
        load(self, f) -> bool

        initialize preprocessor from file 
        """
        return _modshogun.SortWordString_load(self, *args)

    def save(self, *args):
        """
        save(self, f) -> bool

        save preprocessor init-data to file 
        """
        return _modshogun.SortWordString_save(self, *args)

SortWordString_swigregister = _modshogun.SortWordString_swigregister
SortWordString_swigregister(SortWordString)

ED_MINIMIZE = _modshogun.ED_MINIMIZE
ED_MAXIMIZE = _modshogun.ED_MAXIMIZE
class Evaluation(SGObject):
    """
    Class Evaluation, a base class for other classes used to evaluate
    labels, e.g. accuracy of classification or mean squared error of
    regression.

    This class provides only interface for evaluation measures.

    C++ includes: Evaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Evaluation, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Evaluation, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Evaluation
    __del__ = lambda self : None;
    def evaluate(self, *args):
        """
        evaluate(self, predicted, ground_truth) -> float

        evaluate labels

        Parameters:
        -----------

        predicted:  labels for evaluating

        ground_truth:  labels assumed to be correct

        evaluation result 
        """
        return _modshogun.Evaluation_evaluate(self, *args)

    def get_evaluation_direction(self):
        """
        get_evaluation_direction(self) -> EEvaluationDirection

        whether criterium has to be maximized or minimized 
        """
        return _modshogun.Evaluation_get_evaluation_direction(self)

Evaluation_swigregister = _modshogun.Evaluation_swigregister
Evaluation_swigregister(Evaluation)

class BinaryClassEvaluation(Evaluation):
    """
    The class TwoClassEvaluation, a base class used to evaluate binary
    classification labels.

    C++ includes: BinaryClassEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [Evaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BinaryClassEvaluation, name, value)
    __swig_getmethods__ = {}
    for _s in [Evaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BinaryClassEvaluation, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_BinaryClassEvaluation
    __del__ = lambda self : None;
BinaryClassEvaluation_swigregister = _modshogun.BinaryClassEvaluation_swigregister
BinaryClassEvaluation_swigregister(BinaryClassEvaluation)

ACCURACY = _modshogun.ACCURACY
ERROR_RATE = _modshogun.ERROR_RATE
BAL = _modshogun.BAL
WRACC = _modshogun.WRACC
F1 = _modshogun.F1
CROSS_CORRELATION = _modshogun.CROSS_CORRELATION
RECALL = _modshogun.RECALL
PRECISION = _modshogun.PRECISION
SPECIFICITY = _modshogun.SPECIFICITY
class ContingencyTableEvaluation(BinaryClassEvaluation):
    """
    The class ContingencyTableEvaluation a base class used to evaluate
    2-class classification with TP, FP, TN, FN rates.

    This class has implementations of the measures listed below:

    Accuracy (ACCURACY): $ \\frac{TP+TN}{N} $

    Error rate (ERROR_RATE): $ \\frac{FP+FN}{N} $

    Balanced error (BAL): $ \\frac{1}{2} \\left( \\frac{FN}{FN+TP} +
    \\frac{FP}{FP+TN} \\right) $

    Weighted relative accuracy (WRACC): $ \\frac{TP}{TP+FN} -
    \\frac{FP}{FP+TN} $

    F1 score (F1): $ \\frac{2\\cdot FP}{2\\cdot TP + FP + FN} $

    Cross correlation coefficient (CROSS_CORRELATION): $
    \\frac{TP\\cdot TN - FP \\cdot
    FN}{\\sqrt{(TP+FP)(TP+FN)(TN+FP)(TN+FN)}} $

    Recall (RECALL): $ \\frac{TP}{TP+FN} $

    Precision (PRECISION): $ \\frac{TP}{TP+FP} $

    Specificity (SPECIFICITY): $ \\frac{TN}{TN+FP} $

    Note that objects of this class should be used only if computing of
    many different measures is required. In other case, using helper
    classes ( CAccuracyMeasure, ...) could be more convenient.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ContingencyTableEvaluation, name, value)
    __swig_getmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ContingencyTableEvaluation, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ContingencyTableEvaluation
        __init__(self, type) -> ContingencyTableEvaluation

        constructor

        Parameters:
        -----------

        type:  type of measure (e.g ACCURACY) 
        """
        this = _modshogun.new_ContingencyTableEvaluation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ContingencyTableEvaluation
    __del__ = lambda self : None;
    def get_accuracy(self):
        """
        get_accuracy(self) -> float

        accuracy computed accuracy 
        """
        return _modshogun.ContingencyTableEvaluation_get_accuracy(self)

    def get_error_rate(self):
        """
        get_error_rate(self) -> float

        error rate computed error rate 
        """
        return _modshogun.ContingencyTableEvaluation_get_error_rate(self)

    def get_BAL(self):
        """
        get_BAL(self) -> float

        Balanced error (BAL) computed BAL 
        """
        return _modshogun.ContingencyTableEvaluation_get_BAL(self)

    def get_WRACC(self):
        """
        get_WRACC(self) -> float

        WRACC computed WRACC 
        """
        return _modshogun.ContingencyTableEvaluation_get_WRACC(self)

    def get_F1(self):
        """
        get_F1(self) -> float

        F1 computed F1 score 
        """
        return _modshogun.ContingencyTableEvaluation_get_F1(self)

    def get_cross_correlation(self):
        """
        get_cross_correlation(self) -> float

        cross correlation computed cross correlation coefficient 
        """
        return _modshogun.ContingencyTableEvaluation_get_cross_correlation(self)

    def get_recall(self):
        """
        get_recall(self) -> float

        recall computed recall 
        """
        return _modshogun.ContingencyTableEvaluation_get_recall(self)

    def get_precision(self):
        """
        get_precision(self) -> float

        precision computed precision 
        """
        return _modshogun.ContingencyTableEvaluation_get_precision(self)

    def get_specificity(self):
        """
        get_specificity(self) -> float

        specificity computed specificity 
        """
        return _modshogun.ContingencyTableEvaluation_get_specificity(self)

ContingencyTableEvaluation_swigregister = _modshogun.ContingencyTableEvaluation_swigregister
ContingencyTableEvaluation_swigregister(ContingencyTableEvaluation)

class AccuracyMeasure(ContingencyTableEvaluation):
    """
    class AccuracyMeasure used to measure accuracy of 2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AccuracyMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AccuracyMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> AccuracyMeasure"""
        this = _modshogun.new_AccuracyMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_AccuracyMeasure
    __del__ = lambda self : None;
AccuracyMeasure_swigregister = _modshogun.AccuracyMeasure_swigregister
AccuracyMeasure_swigregister(AccuracyMeasure)

class ErrorRateMeasure(ContingencyTableEvaluation):
    """
    class ErrorRateMeasure used to measure error rate of 2-class
    classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ErrorRateMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ErrorRateMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> ErrorRateMeasure"""
        this = _modshogun.new_ErrorRateMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ErrorRateMeasure
    __del__ = lambda self : None;
ErrorRateMeasure_swigregister = _modshogun.ErrorRateMeasure_swigregister
ErrorRateMeasure_swigregister(ErrorRateMeasure)

class BALMeasure(ContingencyTableEvaluation):
    """
    class BALMeasure used to measure balanced error of 2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BALMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BALMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> BALMeasure"""
        this = _modshogun.new_BALMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BALMeasure
    __del__ = lambda self : None;
BALMeasure_swigregister = _modshogun.BALMeasure_swigregister
BALMeasure_swigregister(BALMeasure)

class WRACCMeasure(ContingencyTableEvaluation):
    """
    class WRACCMeasure used to measure weighted relative accuracy of
    2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WRACCMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WRACCMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> WRACCMeasure"""
        this = _modshogun.new_WRACCMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WRACCMeasure
    __del__ = lambda self : None;
WRACCMeasure_swigregister = _modshogun.WRACCMeasure_swigregister
WRACCMeasure_swigregister(WRACCMeasure)

class F1Measure(ContingencyTableEvaluation):
    """
    class F1Measure used to measure F1 score of 2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, F1Measure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, F1Measure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> F1Measure"""
        this = _modshogun.new_F1Measure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_F1Measure
    __del__ = lambda self : None;
F1Measure_swigregister = _modshogun.F1Measure_swigregister
F1Measure_swigregister(F1Measure)

class CrossCorrelationMeasure(ContingencyTableEvaluation):
    """
    class CrossCorrelationMeasure used to measure cross correlation
    coefficient of 2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrossCorrelationMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CrossCorrelationMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> CrossCorrelationMeasure"""
        this = _modshogun.new_CrossCorrelationMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CrossCorrelationMeasure
    __del__ = lambda self : None;
CrossCorrelationMeasure_swigregister = _modshogun.CrossCorrelationMeasure_swigregister
CrossCorrelationMeasure_swigregister(CrossCorrelationMeasure)

class RecallMeasure(ContingencyTableEvaluation):
    """
    class RecallMeasure used to measure recall of 2-class classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RecallMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RecallMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> RecallMeasure"""
        this = _modshogun.new_RecallMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RecallMeasure
    __del__ = lambda self : None;
RecallMeasure_swigregister = _modshogun.RecallMeasure_swigregister
RecallMeasure_swigregister(RecallMeasure)

class PrecisionMeasure(ContingencyTableEvaluation):
    """
    class PrecisionMeasure used to measure precision of 2-class
    classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PrecisionMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PrecisionMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> PrecisionMeasure"""
        this = _modshogun.new_PrecisionMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PrecisionMeasure
    __del__ = lambda self : None;
PrecisionMeasure_swigregister = _modshogun.PrecisionMeasure_swigregister
PrecisionMeasure_swigregister(PrecisionMeasure)

class SpecificityMeasure(ContingencyTableEvaluation):
    """
    class SpecificityMeasure used to measure specificity of 2-class
    classifier.

    This class is also capable of measuring any other rate using
    get_[measure name] methods of CContingencyTableEvaluation class.

    Note that evaluate() should be called first.

    C++ includes: ContingencyTableEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpecificityMeasure, name, value)
    __swig_getmethods__ = {}
    for _s in [ContingencyTableEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpecificityMeasure, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> SpecificityMeasure"""
        this = _modshogun.new_SpecificityMeasure()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SpecificityMeasure
    __del__ = lambda self : None;
SpecificityMeasure_swigregister = _modshogun.SpecificityMeasure_swigregister
SpecificityMeasure_swigregister(SpecificityMeasure)

class MulticlassAccuracy(Evaluation):
    """
    The class MulticlassAccuracy used to compute accuracy of multiclass
    classification.

    Formally, for multiclass labels $L,R, |L|=|R|$ multiclass accuracy is
    estimated as

    \\[ \\frac{\\sum_{i=1}^{|L|} [L_i=R_i]}{|L|} \\]

    C++ includes: MulticlassAccuracy.h 
    """
    __swig_setmethods__ = {}
    for _s in [Evaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MulticlassAccuracy, name, value)
    __swig_getmethods__ = {}
    for _s in [Evaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MulticlassAccuracy, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> MulticlassAccuracy

        constructor 
        """
        this = _modshogun.new_MulticlassAccuracy()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MulticlassAccuracy
    __del__ = lambda self : None;
MulticlassAccuracy_swigregister = _modshogun.MulticlassAccuracy_swigregister
MulticlassAccuracy_swigregister(MulticlassAccuracy)

class MeanAbsoluteError(Evaluation):
    """
    Class MeanAbsoluteError used to compute an error of regression model.

    Formally, for real labels $ L,R, |L|=|R|$ mean absolute error (MAE) is
    estimated as

    \\[ \\frac{1}{|L|} \\sum_{i=1}^{|L|} |L_i - R_i| \\]

    C++ includes: MeanAbsoluteError.h 
    """
    __swig_setmethods__ = {}
    for _s in [Evaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MeanAbsoluteError, name, value)
    __swig_getmethods__ = {}
    for _s in [Evaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MeanAbsoluteError, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> MeanAbsoluteError

        constructor 
        """
        this = _modshogun.new_MeanAbsoluteError()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MeanAbsoluteError
    __del__ = lambda self : None;
MeanAbsoluteError_swigregister = _modshogun.MeanAbsoluteError_swigregister
MeanAbsoluteError_swigregister(MeanAbsoluteError)

class MeanSquaredError(Evaluation):
    """
    Class MeanSquaredError used to compute an error of regression model.

    Formally, for real labels $ L,R, |L|=|R|$ mean squared error (MSE) is
    estimated as

    \\[ \\frac{1}{|L|} \\sum_{i=1}^{|L|} (L_i - R_i)^2 \\]

    C++ includes: MeanSquaredError.h 
    """
    __swig_setmethods__ = {}
    for _s in [Evaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MeanSquaredError, name, value)
    __swig_getmethods__ = {}
    for _s in [Evaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MeanSquaredError, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> MeanSquaredError

        constructor 
        """
        this = _modshogun.new_MeanSquaredError()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MeanSquaredError
    __del__ = lambda self : None;
MeanSquaredError_swigregister = _modshogun.MeanSquaredError_swigregister
MeanSquaredError_swigregister(MeanSquaredError)

class ROCEvaluation(BinaryClassEvaluation):
    """
    Class ROCEvalution used to evaluate ROC (Receiver Operator
    Characteristic) and an area under ROC curve (auROC).

    Implementation is based on the efficient ROC algorithm as described in

    Fawcett, Tom (2004) ROC Graphs: Notes and Practical Considerations for
    Researchers; Machine Learning, 2004

    C++ includes: ROCEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ROCEvaluation, name, value)
    __swig_getmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ROCEvaluation, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> ROCEvaluation

        constructor 
        """
        this = _modshogun.new_ROCEvaluation()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ROCEvaluation
    __del__ = lambda self : None;
    def get_auROC(self):
        """
        get_auROC(self) -> float

        get auROC area under ROC (auROC) 
        """
        return _modshogun.ROCEvaluation_get_auROC(self)

    def get_ROC(self):
        """
        get_ROC(self) -> RealMatrix

        get ROC ROC graph matrix 
        """
        return _modshogun.ROCEvaluation_get_ROC(self)

    def get_thresholds(self):
        """
        get_thresholds(self) -> RealVector

        get thresholds corresponding to points on the ROC graph thresholds 
        """
        return _modshogun.ROCEvaluation_get_thresholds(self)

ROCEvaluation_swigregister = _modshogun.ROCEvaluation_swigregister
ROCEvaluation_swigregister(ROCEvaluation)

class PRCEvaluation(BinaryClassEvaluation):
    """
    Class PRCEvaluation used to evaluate PRC (Precision Recall Curve) and
    an area under PRC curve (auPRC).

    C++ includes: PRCEvaluation.h 
    """
    __swig_setmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PRCEvaluation, name, value)
    __swig_getmethods__ = {}
    for _s in [BinaryClassEvaluation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PRCEvaluation, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> PRCEvaluation

        constructor 
        """
        this = _modshogun.new_PRCEvaluation()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PRCEvaluation
    __del__ = lambda self : None;
    def get_auPRC(self):
        """
        get_auPRC(self) -> float

        get auPRC area under PRC (auPRC) 
        """
        return _modshogun.PRCEvaluation_get_auPRC(self)

    def get_PRC(self):
        """
        get_PRC(self) -> RealMatrix

        get PRC PRC graph matrix 
        """
        return _modshogun.PRCEvaluation_get_PRC(self)

    def get_thresholds(self):
        """
        get_thresholds(self) -> RealVector

        get thresholds corresponding to points on the PRC graph thresholds 
        """
        return _modshogun.PRCEvaluation_get_thresholds(self)

PRCEvaluation_swigregister = _modshogun.PRCEvaluation_swigregister
PRCEvaluation_swigregister(PRCEvaluation)

class CrossValidationResult(_object):
    """
    type to encapsulate the results of an evaluation run. May contain
    confidence interval (if conf_int_alpha!=0). m_conf_int_alpha is the
    probability for an error, i.e. the value does not lie in the
    confidence interval.

    C++ includes: CrossValidation.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrossValidationResult, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrossValidationResult, name)
    __repr__ = _swig_repr
    def print_result(self):
        """
        print_result(self)

        print result 
        """
        return _modshogun.CrossValidationResult_print_result(self)

    __swig_setmethods__["mean"] = _modshogun.CrossValidationResult_mean_set
    __swig_getmethods__["mean"] = _modshogun.CrossValidationResult_mean_get
    if _newclass:mean = _swig_property(_modshogun.CrossValidationResult_mean_get, _modshogun.CrossValidationResult_mean_set)
    __swig_setmethods__["has_conf_int"] = _modshogun.CrossValidationResult_has_conf_int_set
    __swig_getmethods__["has_conf_int"] = _modshogun.CrossValidationResult_has_conf_int_get
    if _newclass:has_conf_int = _swig_property(_modshogun.CrossValidationResult_has_conf_int_get, _modshogun.CrossValidationResult_has_conf_int_set)
    __swig_setmethods__["conf_int_low"] = _modshogun.CrossValidationResult_conf_int_low_set
    __swig_getmethods__["conf_int_low"] = _modshogun.CrossValidationResult_conf_int_low_get
    if _newclass:conf_int_low = _swig_property(_modshogun.CrossValidationResult_conf_int_low_get, _modshogun.CrossValidationResult_conf_int_low_set)
    __swig_setmethods__["conf_int_up"] = _modshogun.CrossValidationResult_conf_int_up_set
    __swig_getmethods__["conf_int_up"] = _modshogun.CrossValidationResult_conf_int_up_get
    if _newclass:conf_int_up = _swig_property(_modshogun.CrossValidationResult_conf_int_up_get, _modshogun.CrossValidationResult_conf_int_up_set)
    __swig_setmethods__["conf_int_alpha"] = _modshogun.CrossValidationResult_conf_int_alpha_set
    __swig_getmethods__["conf_int_alpha"] = _modshogun.CrossValidationResult_conf_int_alpha_get
    if _newclass:conf_int_alpha = _swig_property(_modshogun.CrossValidationResult_conf_int_alpha_get, _modshogun.CrossValidationResult_conf_int_alpha_set)
    def save_serializable(self, *args):
        """
        save_serializable(self, file, prefix = "") -> bool
        save_serializable(self, file) -> bool
        """
        return _modshogun.CrossValidationResult_save_serializable(self, *args)

    def load_serializable(self, *args):
        """
        load_serializable(self, file, prefix = "") -> bool
        load_serializable(self, file) -> bool
        """
        return _modshogun.CrossValidationResult_load_serializable(self, *args)

    def __init__(self): 
        """__init__(self) -> CrossValidationResult"""
        this = _modshogun.new_CrossValidationResult()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CrossValidationResult
    __del__ = lambda self : None;
CrossValidationResult_swigregister = _modshogun.CrossValidationResult_swigregister
CrossValidationResult_swigregister(CrossValidationResult)

class CrossValidation(SGObject):
    """
    base class for cross-validation evaluation. Given a learning machine,
    a splitting strategy, an evaluation criterium, features and
    correspnding labels, this provides an interface for cross-validation.
    Results may be retrieved using the evaluate method. A number of
    repetitions may be specified for obtaining more accurate results. The
    arithmetic mean of different runs is returned along with confidence
    intervals, if a p-value is specified. Default number of runs is one,
    confidence interval combutation is disabled.

    This class calculates an evaluation criterium of every fold and then
    calculates the arithmetic mean of all folds. This is for example
    suitable for the AUC or for Accuracy. However, for example F1-measure
    may not be merged this way (result will be biased). To solve this,
    different sub-classes may average results of each cross validation
    fold differently by overwriting the evaluate_one_run method.

    See [Forman, G. and Scholz, M. (2009). Apples-to-apples in cross-
    validation studies: Pitfalls in classifier performance measurement.
    Technical report, HP Laboratories.] for details on this subject.

    C++ includes: CrossValidation.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrossValidation, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CrossValidation, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CrossValidation
        __init__(self, machine, features, labels, splitting_strategy, evaluation_criterium) -> CrossValidation

        constructor

        Parameters:
        -----------

        machine:  learning machine to use

        features:  features to use for cross-validation

        labels:  labels that correspond to the features

        splitting_strategy:  splitting strategy to use

        evaluation_criterium:  evaluation criterium to use 
        """
        this = _modshogun.new_CrossValidation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CrossValidation
    __del__ = lambda self : None;
    def get_evaluation_direction(self):
        """
        get_evaluation_direction(self) -> EEvaluationDirection

        in which direction is the best evaluation value? 
        """
        return _modshogun.CrossValidation_get_evaluation_direction(self)

    def evaluate(self):
        """
        evaluate(self) -> CrossValidationResult

        method for evaluation. Performs cross-validation. Is repeated
        m_num_runs. If this number is larger than one, a confidence interval
        is calculated if m_conf_int_alpha is (0<p<1). By default m_num_runs=1
        and m_conf_int_alpha=0

        result of evaluation 
        """
        return _modshogun.CrossValidation_evaluate(self)

    def get_machine(self):
        """
        get_machine(self) -> Machine

        underlying learning machine 
        """
        return _modshogun.CrossValidation_get_machine(self)

    def set_num_runs(self, *args):
        """
        set_num_runs(self, num_runs)

        setter for the number of runs to use for evaluation 
        """
        return _modshogun.CrossValidation_set_num_runs(self, *args)

    def set_conf_int_alpha(self, *args):
        """
        set_conf_int_alpha(self, m_conf_int_alpha)

        setter for the number of runs to use for evaluation 
        """
        return _modshogun.CrossValidation_set_conf_int_alpha(self, *args)

CrossValidation_swigregister = _modshogun.CrossValidation_swigregister
CrossValidation_swigregister(CrossValidation)

class SplittingStrategy(SGObject):
    """
    Abstract base class for all splitting types. Takes a CLabels instance
    and generates a desired number of subsets which are being accessed by
    their indices via the method generate_subset_indices(...).

    When being extended, the abstract method build_subsets() has to be
    implemented AND to be called in the constructor of sub- classes.
    Implementations have to fill the DynArray<index_t> elements in the
    (inherited) m_subset_indices variable. Note that these elements are
    already created by the constructor of this class - they just have to
    be filled. Every element represents one index subset.

    C++ includes: SplittingStrategy.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SplittingStrategy, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SplittingStrategy, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SplittingStrategy
    __del__ = lambda self : None;
    def generate_subset_indices(self, *args):
        """
        generate_subset_indices(self, subset_idx) -> shogun::SGVector<(shogun::index_t)>

        generates a newly created SGVector<index_t> with indices of the subset
        with the desired index

        Parameters:
        -----------

        subset_idx:  subset index of the to be generated vector indices

        newly created vector of subset indices of the specified subset is
        written here. do not forget to free_vector 
        """
        return _modshogun.SplittingStrategy_generate_subset_indices(self, *args)

    def generate_subset_inverse(self, *args):
        """
        generate_subset_inverse(self, subset_idx) -> shogun::SGVector<(shogun::index_t)>

        generates a newly created SGVector<index_t> with inverse indices of
        the subset with the desired index. inverse here means all other
        indices.

        Parameters:
        -----------

        subset_idx:  subset index of the to be generated inverse indices

        newly created vector of the subset's inverse indices is written here.
        do not forget to free_vector 
        """
        return _modshogun.SplittingStrategy_generate_subset_inverse(self, *args)

    def get_num_subsets(self):
        """
        get_num_subsets(self) -> index_t

        number of subsets 
        """
        return _modshogun.SplittingStrategy_get_num_subsets(self)

SplittingStrategy_swigregister = _modshogun.SplittingStrategy_swigregister
SplittingStrategy_swigregister(SplittingStrategy)

class StratifiedCrossValidationSplitting(SplittingStrategy):
    """
    Implementation of stratified cross-validation on the base of
    CSplittingStrategy. Produces subset index sets of equal size (at most
    one difference) in which the label ratio is equal (at most one
    difference) to the label ratio of the specified labels.

    C++ includes: StratifiedCrossValidationSplitting.h 
    """
    __swig_setmethods__ = {}
    for _s in [SplittingStrategy]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StratifiedCrossValidationSplitting, name, value)
    __swig_getmethods__ = {}
    for _s in [SplittingStrategy]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StratifiedCrossValidationSplitting, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> StratifiedCrossValidationSplitting
        __init__(self, labels, num_subsets) -> StratifiedCrossValidationSplitting

        constructor

        Parameters:
        -----------

        labels:  labels to be (possibly) used for splitting

        num_subsets:  desired number of subsets, the labels are split into 
        """
        this = _modshogun.new_StratifiedCrossValidationSplitting(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_StratifiedCrossValidationSplitting
    __del__ = lambda self : None;
StratifiedCrossValidationSplitting_swigregister = _modshogun.StratifiedCrossValidationSplitting_swigregister
StratifiedCrossValidationSplitting_swigregister(StratifiedCrossValidationSplitting)

D_UNKNOWN = _modshogun.D_UNKNOWN
D_MINKOWSKI = _modshogun.D_MINKOWSKI
D_MANHATTAN = _modshogun.D_MANHATTAN
D_CANBERRA = _modshogun.D_CANBERRA
D_CHEBYSHEW = _modshogun.D_CHEBYSHEW
D_GEODESIC = _modshogun.D_GEODESIC
D_JENSEN = _modshogun.D_JENSEN
D_MANHATTANWORD = _modshogun.D_MANHATTANWORD
D_HAMMINGWORD = _modshogun.D_HAMMINGWORD
D_CANBERRAWORD = _modshogun.D_CANBERRAWORD
D_SPARSEEUCLIDIAN = _modshogun.D_SPARSEEUCLIDIAN
D_EUCLIDIAN = _modshogun.D_EUCLIDIAN
D_CHISQUARE = _modshogun.D_CHISQUARE
D_TANIMOTO = _modshogun.D_TANIMOTO
D_COSINE = _modshogun.D_COSINE
D_BRAYCURTIS = _modshogun.D_BRAYCURTIS
D_CUSTOM = _modshogun.D_CUSTOM
D_ATTENUATEDEUCLIDIAN = _modshogun.D_ATTENUATEDEUCLIDIAN
class Distance(SGObject):
    """
    Class Distance, a base class for all the distances used in the Shogun
    toolbox.

    The distance (or metric) is a function $ d: X \\times X \\to R $
    satisfying (for all $ x,y,z \\in X$) conditions below:  $ d(x,y)
    \\geq 0 $

    $ d(x,y) = 0$ if and only if $ x=y$

    $ d(x,y) = d(y,x) $

    $ d(x,y) \\leq d(x,z) + d(z,y) $

    Currently distance inherited from the CDistance class should be
    symmetric.

    The simpliest example of a distance function is the euclidian
    distance: See:   CEuclidianDistance  In the means of Shogun toolbox
    the distance function is defined on the 'space' of CFeatures.

    C++ includes: Distance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distance, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Distance
    __del__ = lambda self : None;
    def distance(self, *args):
        """
        distance(self, idx_a, idx_b) -> float

        get distance function for lhs feature vector a and rhs feature vector
        b

        Parameters:
        -----------

        idx_a:  feature vector a at idx_a

        idx_b:  feature vector b at idx_b

        distance value 
        """
        return _modshogun.Distance_distance(self, *args)

    def get_distance_matrix(self):
        """
        get_distance_matrix(self) -> numpy 2dim array of float

        get distance matrix

        computed distance matrix (needs to be cleaned up) 
        """
        return _modshogun.Distance_get_distance_matrix(self)

    def get_distance_matrix_real(self, *args):
        """
        get_distance_matrix_real(self, m, n, target) -> float

        get distance matrix real

        Parameters:
        -----------

        m:  dimension m

        n:  dimension n

        target:  target matrix

        target matrix 
        """
        return _modshogun.Distance_get_distance_matrix_real(self, *args)

    def get_distance_matrix_shortreal(self, *args):
        """
        get_distance_matrix_shortreal(self, m, n, target) -> float

        get distance matrix short real

        Parameters:
        -----------

        m:  dimension m

        n:  dimension n

        target:  target matrix

        target matrix 
        """
        return _modshogun.Distance_get_distance_matrix_shortreal(self, *args)

    def init(self, *args):
        """
        init(self, lhs, rhs) -> bool

        init distance

        make sure to check that your distance can deal with the supplied
        features (!)

        Parameters:
        -----------

        lhs:  features of left-hand side

        rhs:  features of right-hand side

        if init was successful 
        """
        return _modshogun.Distance_init(self, *args)

    def load(self, *args):
        """
        load(self, loader)

        load the kernel matrix

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        return _modshogun.Distance_load(self, *args)

    def save(self, *args):
        """
        save(self, writer)

        save kernel matrix

        Parameters:
        -----------

        writer:  File object via which to save data 
        """
        return _modshogun.Distance_save(self, *args)

    def get_lhs(self):
        """
        get_lhs(self) -> Features

        get left-hand side features used in distance matrix

        left-hand side features 
        """
        return _modshogun.Distance_get_lhs(self)

    def get_rhs(self):
        """
        get_rhs(self) -> Features

        get right-hand side features used in distance matrix

        right-hand side features 
        """
        return _modshogun.Distance_get_rhs(self)

    def replace_rhs(self, *args):
        """
        replace_rhs(self, rhs) -> Features

        replace right-hand side features used in distance matrix

        make sure to check that your distance can deal with the supplied
        features (!)

        Parameters:
        -----------

        rhs:  features of right-hand side

        replaced right-hand side features 
        """
        return _modshogun.Distance_replace_rhs(self, *args)

    def remove_lhs_and_rhs(self):
        """
        remove_lhs_and_rhs(self)

        remove lhs and rhs from distance 
        """
        return _modshogun.Distance_remove_lhs_and_rhs(self)

    def remove_lhs(self):
        """
        remove_lhs(self)

        takes all necessary steps if the lhs is removed from distance matrix

        """
        return _modshogun.Distance_remove_lhs(self)

    def remove_rhs(self):
        """
        remove_rhs(self)

        takes all necessary steps if the rhs is removed from distance matrix

        """
        return _modshogun.Distance_remove_rhs(self)

    def get_distance_type(self):
        """
        get_distance_type(self) -> EDistanceType

        get distance type we are

        abstrace base method

        distance type 
        """
        return _modshogun.Distance_get_distance_type(self)

    def get_feature_type(self):
        """
        get_feature_type(self) -> EFeatureType

        get feature type the distance can deal with

        abstrace base method

        feature type 
        """
        return _modshogun.Distance_get_feature_type(self)

    def get_feature_class(self):
        """
        get_feature_class(self) -> EFeatureClass

        get feature class the distance can deal with

        abstract base method

        feature class 
        """
        return _modshogun.Distance_get_feature_class(self)

    def get_precompute_matrix(self):
        """
        get_precompute_matrix(self) -> bool

        FIXME: precompute matrix should be dropped, handling should be via
        customdistance

        if precompute_matrix 
        """
        return _modshogun.Distance_get_precompute_matrix(self)

    def set_precompute_matrix(self, *args):
        """
        set_precompute_matrix(self, flag)

        FIXME: precompute matrix should be dropped, handling should be via
        customdistance

        Parameters:
        -----------

        flag:  if precompute_matrix 
        """
        return _modshogun.Distance_set_precompute_matrix(self, *args)

    def get_num_vec_lhs(self):
        """
        get_num_vec_lhs(self) ->  int

        get number of vectors of lhs features

        number of vectors of left-hand side 
        """
        return _modshogun.Distance_get_num_vec_lhs(self)

    def get_num_vec_rhs(self):
        """
        get_num_vec_rhs(self) ->  int

        get number of vectors of rhs features

        number of vectors of right-hand side 
        """
        return _modshogun.Distance_get_num_vec_rhs(self)

    def has_features(self):
        """
        has_features(self) -> bool

        test whether features have been assigned to lhs and rhs

        true if features are assigned 
        """
        return _modshogun.Distance_has_features(self)

    def lhs_equals_rhs(self):
        """
        lhs_equals_rhs(self) -> bool

        test whether features on lhs and rhs are the same

        true if features are the same 
        """
        return _modshogun.Distance_lhs_equals_rhs(self)

Distance_swigregister = _modshogun.Distance_swigregister
Distance_swigregister(Distance)

class CustomDistance(Distance):
    """
    The Custom Distance allows for custom user provided distance matrices.

    For squared training matrices it allows to store only the upper
    triangle of the distance to save memory: Full symmetric distance
    matrices can be stored as is or can be internally converted into (or
    directly given in) upper triangle representation. Also note that
    values are stored as 32bit floats.

    C++ includes: CustomDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CustomDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CustomDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CustomDistance
        __init__(self, d) -> CustomDistance
        __init__(self, distance_matrix) -> CustomDistance
        __init__(self, dm, rows, cols) -> CustomDistance
        __init__(self, dm, rows, cols) -> CustomDistance

        constructor

        sets full distance matrix from full distance matrix (from single
        precision floats)

        Parameters:
        -----------

        dm:  distance matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        this = _modshogun.new_CustomDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CustomDistance
    __del__ = lambda self : None;
    def dummy_init(self, *args):
        """
        dummy_init(self, rows, cols) -> bool

        initialize distance with dummy features

        Distances always need feature objects assigned. As the custom distance
        does not really require this it creates some magic dummy features that
        only know about the number of vectors

        Parameters:
        -----------

        rows:  features of left-hand side

        cols:  features of right-hand side

        if initializing was successful 
        """
        return _modshogun.CustomDistance_dummy_init(self, *args)

    def set_triangle_distance_matrix_from_triangle(self, *args):
        """
        set_triangle_distance_matrix_from_triangle(self, dm, len) -> bool
        set_triangle_distance_matrix_from_triangle(self, dm, len) -> bool

        set distance matrix (only elements from upper triangle) from elements
        of upper triangle (concat'd), including the main diagonal

        small variant for floats32's, triangle needs to have less than 2**32
        elements

        Parameters:
        -----------

        dm:  distance matrix

        len:  denotes the size of the array and should match
        len=cols*(cols+1)/2

        if setting was successful 
        """
        return _modshogun.CustomDistance_set_triangle_distance_matrix_from_triangle(self, *args)

    def set_triangle_distance_matrix_from_full(self, *args):
        """
        set_triangle_distance_matrix_from_full(self, dm, rows, cols) -> bool
        set_triangle_distance_matrix_from_full(self, dm, rows, cols) -> bool

        set distance matrix (only elements from upper triangle) from squared
        matrix

        for float32's

        Parameters:
        -----------

        dm:  distance matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        return _modshogun.CustomDistance_set_triangle_distance_matrix_from_full(self, *args)

    def set_full_distance_matrix_from_full(self, *args):
        """
        set_full_distance_matrix_from_full(self, dm, rows, cols) -> bool
        set_full_distance_matrix_from_full(self, dm, rows, cols) -> bool

        set full distance matrix from full distance matrix

        for float32's

        Parameters:
        -----------

        dm:  distance matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        return _modshogun.CustomDistance_set_full_distance_matrix_from_full(self, *args)

    def get_num_vec_lhs(self):
        """
        get_num_vec_lhs(self) ->  int

        get number of vectors of lhs features

        number of vectors of left-hand side 
        """
        return _modshogun.CustomDistance_get_num_vec_lhs(self)

    def get_num_vec_rhs(self):
        """
        get_num_vec_rhs(self) ->  int

        get number of vectors of rhs features

        number of vectors of right-hand side 
        """
        return _modshogun.CustomDistance_get_num_vec_rhs(self)

    def has_features(self):
        """
        has_features(self) -> bool

        test whether features have been assigned to lhs and rhs

        true if features are assigned 
        """
        return _modshogun.CustomDistance_has_features(self)

CustomDistance_swigregister = _modshogun.CustomDistance_swigregister
CustomDistance_swigregister(CustomDistance)

class KernelDistance(Distance):
    """
    The Kernel distance takes a distance as input.

    It turns a kernel into something distance like by computing

    \\[ d({\\bf x}, {\\bf x'}) = e^{-\\frac{k({\\bf x}, {\\bf
    x'})}{width}} \\]

    C++ includes: KernelDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KernelDistance
        __init__(self, width, k) -> KernelDistance
        __init__(self, l, r, width, k) -> KernelDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        k:  kernel 
        """
        this = _modshogun.new_KernelDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KernelDistance
    __del__ = lambda self : None;
KernelDistance_swigregister = _modshogun.KernelDistance_swigregister
KernelDistance_swigregister(KernelDistance)

class SimpleCharDistance(Distance):
    """
    template class SimpleDistance

    C++ includes: SimpleDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleCharDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleCharDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SimpleCharDistance
    __del__ = lambda self : None;
SimpleCharDistance_swigregister = _modshogun.SimpleCharDistance_swigregister
SimpleCharDistance_swigregister(SimpleCharDistance)

class SimpleWordDistance(Distance):
    """
    template class SimpleDistance

    C++ includes: SimpleDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleWordDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SimpleWordDistance
    __del__ = lambda self : None;
SimpleWordDistance_swigregister = _modshogun.SimpleWordDistance_swigregister
SimpleWordDistance_swigregister(SimpleWordDistance)

class SimpleIntDistance(Distance):
    """
    template class SimpleDistance

    C++ includes: SimpleDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleIntDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleIntDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SimpleIntDistance
    __del__ = lambda self : None;
SimpleIntDistance_swigregister = _modshogun.SimpleIntDistance_swigregister
SimpleIntDistance_swigregister(SimpleIntDistance)

class SimpleRealDistance(Distance):
    """
    template class SimpleDistance

    C++ includes: SimpleDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleRealDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleRealDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SimpleRealDistance
    __del__ = lambda self : None;
SimpleRealDistance_swigregister = _modshogun.SimpleRealDistance_swigregister
SimpleRealDistance_swigregister(SimpleRealDistance)

class SparseCharDistance(Distance):
    """
    template class SparseDistance

    C++ includes: SparseDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseCharDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseCharDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseCharDistance
    __del__ = lambda self : None;
SparseCharDistance_swigregister = _modshogun.SparseCharDistance_swigregister
SparseCharDistance_swigregister(SparseCharDistance)

class SparseWordDistance(Distance):
    """
    template class SparseDistance

    C++ includes: SparseDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseWordDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseWordDistance
    __del__ = lambda self : None;
SparseWordDistance_swigregister = _modshogun.SparseWordDistance_swigregister
SparseWordDistance_swigregister(SparseWordDistance)

class SparseIntDistance(Distance):
    """
    template class SparseDistance

    C++ includes: SparseDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseIntDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseIntDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseIntDistance
    __del__ = lambda self : None;
SparseIntDistance_swigregister = _modshogun.SparseIntDistance_swigregister
SparseIntDistance_swigregister(SparseIntDistance)

class SparseRealDistance(Distance):
    """
    template class SparseDistance

    C++ includes: SparseDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseRealDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseRealDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseRealDistance
    __del__ = lambda self : None;
SparseRealDistance_swigregister = _modshogun.SparseRealDistance_swigregister
SparseRealDistance_swigregister(SparseRealDistance)

class StringCharDistance(Distance):
    """
    template class StringDistance

    C++ includes: StringDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringCharDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringCharDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringCharDistance
    __del__ = lambda self : None;
StringCharDistance_swigregister = _modshogun.StringCharDistance_swigregister
StringCharDistance_swigregister(StringCharDistance)

class StringWordDistance(Distance):
    """
    template class StringDistance

    C++ includes: StringDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringWordDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringWordDistance
    __del__ = lambda self : None;
StringWordDistance_swigregister = _modshogun.StringWordDistance_swigregister
StringWordDistance_swigregister(StringWordDistance)

class StringIntDistance(Distance):
    """
    template class StringDistance

    C++ includes: StringDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringIntDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringIntDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringIntDistance
    __del__ = lambda self : None;
StringIntDistance_swigregister = _modshogun.StringIntDistance_swigregister
StringIntDistance_swigregister(StringIntDistance)

class StringUlongDistance(Distance):
    """
    template class StringDistance

    C++ includes: StringDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringUlongDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringUlongDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringUlongDistance
    __del__ = lambda self : None;
StringUlongDistance_swigregister = _modshogun.StringUlongDistance_swigregister
StringUlongDistance_swigregister(StringUlongDistance)

class StringRealDistance(Distance):
    """
    template class StringDistance

    C++ includes: StringDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringRealDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [Distance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringRealDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringRealDistance
    __del__ = lambda self : None;
StringRealDistance_swigregister = _modshogun.StringRealDistance_swigregister
StringRealDistance_swigregister(StringRealDistance)

class RealDistance(SimpleRealDistance):
    """
    class RealDistance

    C++ includes: RealDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealDistance, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_RealDistance
    __del__ = lambda self : None;
RealDistance_swigregister = _modshogun.RealDistance_swigregister
RealDistance_swigregister(RealDistance)

class CanberraMetric(SimpleRealDistance):
    """
    class CanberraMetric

    The Canberra distance sums up the dissimilarity (ratios) between
    feature dimensions of two data points.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) =
    \\sum_{i=1}^{n}\\frac{|\\bf{x_{i}-\\bf{x'_{i}}}|}
    {|\\bf{x_{i}}|+|\\bf{x'_{i}}|} \\quad \\bf{x},\\bf{x'}
    \\in R^{n} \\]

    A summation element has range [0,1]. Note that $d(x,0)=d(0,x')=n$ and
    $d(0,0)=0$.

    C++ includes: CanberraMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CanberraMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CanberraMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CanberraMetric
        __init__(self, l, r) -> CanberraMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_CanberraMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CanberraMetric
    __del__ = lambda self : None;
CanberraMetric_swigregister = _modshogun.CanberraMetric_swigregister
CanberraMetric_swigregister(CanberraMetric)

class ChebyshewMetric(SimpleRealDistance):
    """
    class ChebyshewMetric

    The Chebyshev distance ( $L_{\\infty}$ norm) returns the maximum of
    absolute feature dimension differences between two data points.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) =
    max|\\bf{x_{i}}-\\bf{x'_{i}}| \\quad x,x' \\in R^{n} \\]

    See:  Wikipedia: Chebyshev distance

    C++ includes: ChebyshewMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ChebyshewMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ChebyshewMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ChebyshewMetric
        __init__(self, l, r) -> ChebyshewMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_ChebyshewMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ChebyshewMetric
    __del__ = lambda self : None;
ChebyshewMetric_swigregister = _modshogun.ChebyshewMetric_swigregister
ChebyshewMetric_swigregister(ChebyshewMetric)

class GeodesicMetric(SimpleRealDistance):
    """
    class GeodesicMetric

    The Geodesic distance (Great circle distance) computes the shortest
    path between two data points on a sphere (the radius is set to one for
    the evaluation).

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) =
    arccos\\sum_{i=1}^{n} \\frac{\\bf{x_{i}}\\cdot\\bf{x'_{i}}}
    {\\sqrt{x_{i}x_{i} x'_{i}x'_{i}}} \\]

    See:  Wikipedia: Geodesic distance

    C++ includes: GeodesicMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GeodesicMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GeodesicMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GeodesicMetric
        __init__(self, l, r) -> GeodesicMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_GeodesicMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GeodesicMetric
    __del__ = lambda self : None;
GeodesicMetric_swigregister = _modshogun.GeodesicMetric_swigregister
GeodesicMetric_swigregister(GeodesicMetric)

class JensenMetric(SimpleRealDistance):
    """
    class JensenMetric

    The Jensen-Shannon distance/divergence measures the similarity between
    two data points which is based on the Kullback-Leibler divergence.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) = \\sum_{i=0}^{n}
    x_{i} log\\frac{x_{i}}{0.5(x_{i} +x'_{i})} + x'_{i}
    log\\frac{x'_{i}}{0.5(x_{i}+x'_{i})} \\]

    See:  Wikipedia: Jensen-Shannon divergence

    Wikipedia: Kullback-Leibler divergence

    C++ includes: JensenMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, JensenMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, JensenMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> JensenMetric
        __init__(self, l, r) -> JensenMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_JensenMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_JensenMetric
    __del__ = lambda self : None;
JensenMetric_swigregister = _modshogun.JensenMetric_swigregister
JensenMetric_swigregister(JensenMetric)

class ManhattanMetric(SimpleRealDistance):
    """
    class ManhattanMetric

    The Manhattan distance (city block distance, $L_{1}$ norm, rectilinear
    distance or taxi cab metric ) is a special case of general Minkowski
    metric and computes the absolute differences between the feature
    dimensions of two data points.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) = \\sum_{i=1}^{n}
    |\\bf{x_{i}}-\\bf{x'_{i}}| \\quad \\bf{x},\\bf{x'} \\in
    R^{n} \\]

    See:   CMinkowskiMetric

    Wikipedia: Manhattan distance

    C++ includes: ManhattanMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ManhattanMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ManhattanMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ManhattanMetric
        __init__(self, l, r) -> ManhattanMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_ManhattanMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ManhattanMetric
    __del__ = lambda self : None;
ManhattanMetric_swigregister = _modshogun.ManhattanMetric_swigregister
ManhattanMetric_swigregister(ManhattanMetric)

class MinkowskiMetric(SimpleRealDistance):
    """
    class MinkowskiMetric

    The Minkowski metric is one general class of metrics for a
    $\\displaystyle R^{n}$ feature space also referred as the
    $\\displaystyle L_{k} $ norm.

    \\[ \\displaystyle d(\\bf{x},\\bf{x'}) = (\\sum_{i=1}^{n}
    |\\bf{x_{i}}-\\bf{x'_{i}}|^{k})^{\\frac{1}{k}} \\quad x,x'
    \\in R^{n} \\]

    special cases:  $\\displaystyle L_{1} $ norm: Manhattan distance
    See:   CManhattanMetric

    $\\displaystyle L_{2} $ norm: Euclidean distance See:
    CEuclidianDistance  Note that the Minkowski distance tends to the
    Chebyshew distance for increasing $k$.

    See:  Wikipedia: Distance

    C++ includes: MinkowskiMetric.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MinkowskiMetric, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MinkowskiMetric, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MinkowskiMetric
        __init__(self, k) -> MinkowskiMetric
        __init__(self, l, r, k) -> MinkowskiMetric

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        k:  parameter k 
        """
        this = _modshogun.new_MinkowskiMetric(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MinkowskiMetric
    __del__ = lambda self : None;
MinkowskiMetric_swigregister = _modshogun.MinkowskiMetric_swigregister
MinkowskiMetric_swigregister(MinkowskiMetric)

class HammingWordDistance(StringWordDistance):
    """
    class HammingWordDistance

    C++ includes: HammingWordDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HammingWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HammingWordDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HammingWordDistance
        __init__(self, use_sign) -> HammingWordDistance
        __init__(self, l, r, use_sign) -> HammingWordDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used 
        """
        this = _modshogun.new_HammingWordDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HammingWordDistance
    __del__ = lambda self : None;
HammingWordDistance_swigregister = _modshogun.HammingWordDistance_swigregister
HammingWordDistance_swigregister(HammingWordDistance)

class ManhattanWordDistance(StringWordDistance):
    """
    class ManhattanWordDistance

    C++ includes: ManhattanWordDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ManhattanWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ManhattanWordDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ManhattanWordDistance
        __init__(self, l, r) -> ManhattanWordDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_ManhattanWordDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ManhattanWordDistance
    __del__ = lambda self : None;
ManhattanWordDistance_swigregister = _modshogun.ManhattanWordDistance_swigregister
ManhattanWordDistance_swigregister(ManhattanWordDistance)

class CanberraWordDistance(StringWordDistance):
    """
    class CanberraWordDistance

    C++ includes: CanberraWordDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CanberraWordDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CanberraWordDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CanberraWordDistance
        __init__(self, l, r) -> CanberraWordDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_CanberraWordDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CanberraWordDistance
    __del__ = lambda self : None;
CanberraWordDistance_swigregister = _modshogun.CanberraWordDistance_swigregister
CanberraWordDistance_swigregister(CanberraWordDistance)

class EuclidianDistance(RealDistance):
    """
    class EuclidianDistance

    The familiar Euclidian distance for real valued features computes the
    square root of the sum of squared disparity between the corresponding
    feature dimensions of two data points.

    \\[\\displaystyle d({\\bf x},{\\bf x'})=
    \\sqrt{\\sum_{i=0}^{n}|{\\bf x_i}-{\\bf x'_i}|^2} \\]

    This special case of Minkowski metric is invariant to an arbitrary
    translation or rotation in feature space.

    The Euclidian Squared distance does not take the square root:

    \\[\\displaystyle d({\\bf x},{\\bf x'})=
    \\sum_{i=0}^{n}|{\\bf x_i}-{\\bf x'_i}|^2 \\]

    See:   CMinkowskiMetric

    Wikipedia: Distance in Euclidean space

    C++ includes: EuclidianDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EuclidianDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [RealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, EuclidianDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> EuclidianDistance
        __init__(self, l, r) -> EuclidianDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_EuclidianDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_EuclidianDistance
    __del__ = lambda self : None;
    def get_disable_sqrt(self):
        """
        get_disable_sqrt(self) -> bool

        disable application of sqrt on matrix computation the matrix can then
        also be named norm squared

        if application of sqrt is disabled 
        """
        return _modshogun.EuclidianDistance_get_disable_sqrt(self)

    def set_disable_sqrt(self, *args):
        """
        set_disable_sqrt(self, state)

        disable application of sqrt on matrix computation the matrix can then
        also be named norm squared

        Parameters:
        -----------

        state:  new disable_sqrt 
        """
        return _modshogun.EuclidianDistance_set_disable_sqrt(self, *args)

EuclidianDistance_swigregister = _modshogun.EuclidianDistance_swigregister
EuclidianDistance_swigregister(EuclidianDistance)

class SparseEuclidianDistance(SparseRealDistance):
    """
    class SparseEucldianDistance

    C++ includes: SparseEuclidianDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SparseRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseEuclidianDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SparseRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseEuclidianDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SparseEuclidianDistance
        __init__(self, l, r) -> SparseEuclidianDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_SparseEuclidianDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseEuclidianDistance
    __del__ = lambda self : None;
SparseEuclidianDistance_swigregister = _modshogun.SparseEuclidianDistance_swigregister
SparseEuclidianDistance_swigregister(SparseEuclidianDistance)

class BrayCurtisDistance(SimpleRealDistance):
    """
    class Bray-Curtis distance

    The Bray-Curtis distance (Sorensen distance) is similar to the
    Manhattan distance with normalization.

    \\[\\displaystyle d(\\bf{x},\\bf{x}') =
    \\frac{\\sum_{i=1}^{n}|x_{i}-x'_{i}|}{\\sum_{i=1}^{n}|x_{i}
    +x'_{i}|} \\quad x,x' \\in R^{n} \\]

    C++ includes: BrayCurtisDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BrayCurtisDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BrayCurtisDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BrayCurtisDistance
        __init__(self, l, r) -> BrayCurtisDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_BrayCurtisDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_BrayCurtisDistance
    __del__ = lambda self : None;
BrayCurtisDistance_swigregister = _modshogun.BrayCurtisDistance_swigregister
BrayCurtisDistance_swigregister(BrayCurtisDistance)

class ChiSquareDistance(SimpleRealDistance):
    """
    class ChiSquareDistance

    This implementation of $\\chi^{2}$ distance extends the concept of
    $\\chi^{2}$ metric to negative values.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) =
    \\sum_{i=1}^{n}\\frac{(x_{i}-x'_{i})^2} {|x_{i}|+|x'_{i}|}
    \\quad \\bf{x},\\bf{x'} \\in R^{n} \\]

    See:  K. Rieck, P. Laskov. Linear-Time Computation of Similarity
    Measures for Sequential Data. Journal of Machine Learning Research,
    9:23-- 48,2008.

    C++ includes: ChiSquareDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ChiSquareDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ChiSquareDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ChiSquareDistance
        __init__(self, l, r) -> ChiSquareDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_ChiSquareDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ChiSquareDistance
    __del__ = lambda self : None;
ChiSquareDistance_swigregister = _modshogun.ChiSquareDistance_swigregister
ChiSquareDistance_swigregister(ChiSquareDistance)

class CosineDistance(SimpleRealDistance):
    """
    class CosineDistance

    The Cosine distance is obtained by using the Cosine similarity
    (Orchini similarity, angular similarity, normalized dot product),
    which measures similarity between two vectors by finding their angle.
    An extension to the Cosine similarity yields the Tanimoto coefficient.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) = 1 -
    \\frac{\\sum_{i=1}^{n}\\bf{x_{i}}\\bf{x'_{i}}}
    {\\sqrt{\\sum_{i=1}^{n} x_{i}^2 \\sum_{i=1}^{n} {x'}_{i}^2}}
    \\quad x,x' \\in R^{n} \\]

    See:  Wikipedia: Cosine similarity

    CTanimotoDistance

    C++ includes: CosineDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CosineDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CosineDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CosineDistance
        __init__(self, l, r) -> CosineDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_CosineDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CosineDistance
    __del__ = lambda self : None;
CosineDistance_swigregister = _modshogun.CosineDistance_swigregister
CosineDistance_swigregister(CosineDistance)

class TanimotoDistance(SimpleRealDistance):
    """
    class Tanimoto coefficient

    The Tanimoto distance/coefficient (extended Jaccard coefficient) is
    obtained by extending the cosine similarity.

    \\[\\displaystyle d(\\bf{x},\\bf{x'}) =
    \\frac{\\sum_{i=1}^{n}x_{i}x'_{i}}{
    \\sum_{i=1}^{n}x_{i}x_{i}x'_{i}x'_{i}-x_{i}x'_{i}} /quad x,x' /in
    R^{n} \\]

    See:  Wikipedia: Tanimoto coefficient

    CCosineDistance

    C++ includes: TanimotoDistance.h 
    """
    __swig_setmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TanimotoDistance, name, value)
    __swig_getmethods__ = {}
    for _s in [SimpleRealDistance]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TanimotoDistance, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> TanimotoDistance
        __init__(self, l, r) -> TanimotoDistance

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_TanimotoDistance(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_TanimotoDistance
    __del__ = lambda self : None;
TanimotoDistance_swigregister = _modshogun.TanimotoDistance_swigregister
TanimotoDistance_swigregister(TanimotoDistance)

FASTBUTMEMHUNGRY = _modshogun.FASTBUTMEMHUNGRY
SLOWBUTMEMEFFICIENT = _modshogun.SLOWBUTMEMEFFICIENT
K_UNKNOWN = _modshogun.K_UNKNOWN
K_LINEAR = _modshogun.K_LINEAR
K_POLY = _modshogun.K_POLY
K_GAUSSIAN = _modshogun.K_GAUSSIAN
K_GAUSSIANSHIFT = _modshogun.K_GAUSSIANSHIFT
K_GAUSSIANMATCH = _modshogun.K_GAUSSIANMATCH
K_HISTOGRAM = _modshogun.K_HISTOGRAM
K_SALZBERG = _modshogun.K_SALZBERG
K_LOCALITYIMPROVED = _modshogun.K_LOCALITYIMPROVED
K_SIMPLELOCALITYIMPROVED = _modshogun.K_SIMPLELOCALITYIMPROVED
K_FIXEDDEGREE = _modshogun.K_FIXEDDEGREE
K_WEIGHTEDDEGREE = _modshogun.K_WEIGHTEDDEGREE
K_WEIGHTEDDEGREEPOS = _modshogun.K_WEIGHTEDDEGREEPOS
K_WEIGHTEDDEGREERBF = _modshogun.K_WEIGHTEDDEGREERBF
K_WEIGHTEDCOMMWORDSTRING = _modshogun.K_WEIGHTEDCOMMWORDSTRING
K_POLYMATCH = _modshogun.K_POLYMATCH
K_ALIGNMENT = _modshogun.K_ALIGNMENT
K_COMMWORDSTRING = _modshogun.K_COMMWORDSTRING
K_COMMULONGSTRING = _modshogun.K_COMMULONGSTRING
K_SPECTRUMRBF = _modshogun.K_SPECTRUMRBF
K_SPECTRUMMISMATCHRBF = _modshogun.K_SPECTRUMMISMATCHRBF
K_COMBINED = _modshogun.K_COMBINED
K_AUC = _modshogun.K_AUC
K_CUSTOM = _modshogun.K_CUSTOM
K_SIGMOID = _modshogun.K_SIGMOID
K_CHI2 = _modshogun.K_CHI2
K_DIAG = _modshogun.K_DIAG
K_CONST = _modshogun.K_CONST
K_DISTANCE = _modshogun.K_DISTANCE
K_LOCALALIGNMENT = _modshogun.K_LOCALALIGNMENT
K_PYRAMIDCHI2 = _modshogun.K_PYRAMIDCHI2
K_OLIGO = _modshogun.K_OLIGO
K_MATCHWORD = _modshogun.K_MATCHWORD
K_TPPK = _modshogun.K_TPPK
K_REGULATORYMODULES = _modshogun.K_REGULATORYMODULES
K_SPARSESPATIALSAMPLE = _modshogun.K_SPARSESPATIALSAMPLE
K_HISTOGRAMINTERSECTION = _modshogun.K_HISTOGRAMINTERSECTION
K_WAVELET = _modshogun.K_WAVELET
K_WAVE = _modshogun.K_WAVE
K_CAUCHY = _modshogun.K_CAUCHY
K_TSTUDENT = _modshogun.K_TSTUDENT
K_RATIONAL_QUADRATIC = _modshogun.K_RATIONAL_QUADRATIC
K_MULTIQUADRIC = _modshogun.K_MULTIQUADRIC
K_EXPONENTIAL = _modshogun.K_EXPONENTIAL
K_SPHERICAL = _modshogun.K_SPHERICAL
K_SPLINE = _modshogun.K_SPLINE
K_ANOVA = _modshogun.K_ANOVA
K_POWER = _modshogun.K_POWER
K_LOG = _modshogun.K_LOG
K_CIRCULAR = _modshogun.K_CIRCULAR
K_INVERSEMULTIQUADRIC = _modshogun.K_INVERSEMULTIQUADRIC
K_DISTANTSEGMENTS = _modshogun.K_DISTANTSEGMENTS
K_BESSEL = _modshogun.K_BESSEL
KP_NONE = _modshogun.KP_NONE
KP_LINADD = _modshogun.KP_LINADD
KP_KERNCOMBINATION = _modshogun.KP_KERNCOMBINATION
KP_BATCHEVALUATION = _modshogun.KP_BATCHEVALUATION
class Kernel(SGObject):
    """
    The Kernel base class.

    Non-mathematically spoken, a kernel is a function that given two input
    objects ${\\bf x}$ and ${\\bf x'}$ returns a score describing the
    similarity of the vectors. The score should be larger when the objects
    are more similar.

    It can be defined as

    \\[ k({\\bf x},{\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi$ maps the objects into some potentially high
    dimensional feature space.

    Apart from the input features, the base kernel takes only one argument
    (the size of the kernel cache) that is used to efficiently train
    kernel-machines like e.g. SVMs.

    In case you would like to define your own kernel, you only have to
    define a new compute() function (and the kernel name via get_name()
    and the kernel type get_kernel_type()). A good example to look at is
    the GaussianKernel.

    C++ includes: Kernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Kernel, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Kernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Kernel
    __del__ = lambda self : None;
    def kernel(self, *args):
        """
        kernel(self, idx_a, idx_b) -> float

        get kernel function for lhs feature vector a and rhs feature vector b

        Parameters:
        -----------

        idx_a:  index of feature vector a

        idx_b:  index of feature vector b

        computed kernel function 
        """
        return _modshogun.Kernel_kernel(self, *args)

    def get_kernel_matrix(self):
        """
        get_kernel_matrix(self) -> numpy 2dim array of float

        get kernel matrix real

        the kernel matrix 
        """
        return _modshogun.Kernel_get_kernel_matrix(self)

    def get_kernel_col(self, *args):
        """
        get_kernel_col(self, j) -> RealVector

        get column j

        the jth column of the kernel matrix 
        """
        return _modshogun.Kernel_get_kernel_col(self, *args)

    def get_kernel_row(self, *args):
        """
        get_kernel_row(self, i) -> RealVector

        get row i

        the ith row of the kernel matrix 
        """
        return _modshogun.Kernel_get_kernel_row(self, *args)

    def init(self, *args):
        """
        init(self, lhs, rhs) -> bool

        initialize kernel e.g. setup lhs/rhs of kernel, precompute
        normalization constants etc. make sure to check that your kernel can
        deal with the supplied features (!)

        Parameters:
        -----------

        lhs:  features for left-hand side

        rhs:  features for right-hand side

        if init was successful 
        """
        return _modshogun.Kernel_init(self, *args)

    def set_normalizer(self, *args):
        """
        set_normalizer(self, normalizer) -> bool

        set the current kernel normalizer

        if successful 
        """
        return _modshogun.Kernel_set_normalizer(self, *args)

    def get_normalizer(self):
        """
        get_normalizer(self) -> KernelNormalizer

        obtain the current kernel normalizer

        the kernel normalizer 
        """
        return _modshogun.Kernel_get_normalizer(self)

    def init_normalizer(self):
        """
        init_normalizer(self) -> bool

        initialize the current kernel normalizer if init was successful 
        """
        return _modshogun.Kernel_init_normalizer(self)

    def load(self, *args):
        """
        load(self, loader)

        load the kernel matrix

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        return _modshogun.Kernel_load(self, *args)

    def save(self, *args):
        """
        save(self, writer)

        save kernel matrix

        Parameters:
        -----------

        writer:  File object via which to save data 
        """
        return _modshogun.Kernel_save(self, *args)

    def get_lhs(self):
        """
        get_lhs(self) -> Features

        get left-hand side of features used in kernel

        features of left-hand side 
        """
        return _modshogun.Kernel_get_lhs(self)

    def get_rhs(self):
        """
        get_rhs(self) -> Features

        get right-hand side of features used in kernel

        features of right-hand side 
        """
        return _modshogun.Kernel_get_rhs(self)

    def get_num_vec_lhs(self):
        """
        get_num_vec_lhs(self) ->  int

        get number of vectors of lhs features

        number of vectors of left-hand side 
        """
        return _modshogun.Kernel_get_num_vec_lhs(self)

    def get_num_vec_rhs(self):
        """
        get_num_vec_rhs(self) ->  int

        get number of vectors of rhs features

        number of vectors of right-hand side 
        """
        return _modshogun.Kernel_get_num_vec_rhs(self)

    def has_features(self):
        """
        has_features(self) -> bool

        test whether features have been assigned to lhs and rhs

        true if features are assigned 
        """
        return _modshogun.Kernel_has_features(self)

    def get_lhs_equals_rhs(self):
        """
        get_lhs_equals_rhs(self) -> bool

        test whether features on lhs and rhs are the same

        true if features are the same 
        """
        return _modshogun.Kernel_get_lhs_equals_rhs(self)

    def remove_lhs_and_rhs(self):
        """
        remove_lhs_and_rhs(self)

        remove lhs and rhs from kernel 
        """
        return _modshogun.Kernel_remove_lhs_and_rhs(self)

    def remove_lhs(self):
        """
        remove_lhs(self)

        remove lhs from kernel 
        """
        return _modshogun.Kernel_remove_lhs(self)

    def remove_rhs(self):
        """
        remove_rhs(self)

        remove rhs from kernel 
        """
        return _modshogun.Kernel_remove_rhs(self)

    def get_kernel_type(self):
        """
        get_kernel_type(self) -> EKernelType

        return what type of kernel we are, e.g. Linear,Polynomial,
        Gaussian,...

        abstract base method

        kernel type 
        """
        return _modshogun.Kernel_get_kernel_type(self)

    def get_feature_type(self):
        """
        get_feature_type(self) -> EFeatureType

        return feature type the kernel can deal with

        abstract base method

        feature type 
        """
        return _modshogun.Kernel_get_feature_type(self)

    def get_feature_class(self):
        """
        get_feature_class(self) -> EFeatureClass

        return feature class the kernel can deal with

        abstract base method

        feature class 
        """
        return _modshogun.Kernel_get_feature_class(self)

    def set_cache_size(self, *args):
        """
        set_cache_size(self, size)

        set the size of the kernel cache

        Parameters:
        -----------

        size:  of kernel cache 
        """
        return _modshogun.Kernel_set_cache_size(self, *args)

    def get_cache_size(self):
        """
        get_cache_size(self) ->  int

        return the size of the kernel cache

        size of kernel cache 
        """
        return _modshogun.Kernel_get_cache_size(self)

    def list_kernel(self):
        """
        list_kernel(self)

        list kernel 
        """
        return _modshogun.Kernel_list_kernel(self)

    def has_property(self, *args):
        """
        has_property(self, p) -> bool

        check if kernel has given property

        Parameters:
        -----------

        p:  kernel property

        if kernel has given property 
        """
        return _modshogun.Kernel_has_property(self, *args)

    def clear_normal(self):
        """
        clear_normal(self)

        for optimizable kernels, i.e. kernels where the weight vector can be
        computed explicitly (if it fits into memory) 
        """
        return _modshogun.Kernel_clear_normal(self)

    def add_to_normal(self, *args):
        """
        add_to_normal(self, vector_idx, weight)

        add vector*factor to 'virtual' normal vector

        Parameters:
        -----------

        vector_idx:  index

        weight:  weight 
        """
        return _modshogun.Kernel_add_to_normal(self, *args)

    def get_optimization_type(self):
        """
        get_optimization_type(self) -> EOptimizationType

        get optimization type

        optimization type 
        """
        return _modshogun.Kernel_get_optimization_type(self)

    def set_optimization_type(self, *args):
        """
        set_optimization_type(self, t)

        set optimization type

        Parameters:
        -----------

        t:  optimization type to set 
        """
        return _modshogun.Kernel_set_optimization_type(self, *args)

    def get_is_initialized(self):
        """
        get_is_initialized(self) -> bool

        check if optimization is initialized

        if optimization is initialized 
        """
        return _modshogun.Kernel_get_is_initialized(self)

    def init_optimization(self, *args):
        """
        init_optimization(self, count, IDX, weights) -> bool

        initialize optimization

        Parameters:
        -----------

        count:  count

        IDX:  index

        weights:  weights

        if initializing was successful 
        """
        return _modshogun.Kernel_init_optimization(self, *args)

    def delete_optimization(self):
        """
        delete_optimization(self) -> bool

        delete optimization

        if deleting was successful 
        """
        return _modshogun.Kernel_delete_optimization(self)

    def init_optimization_svm(self, *args):
        """
        init_optimization_svm(self, svm) -> bool

        initialize optimization

        Parameters:
        -----------

        svm:  svm model

        if initializing was successful 
        """
        return _modshogun.Kernel_init_optimization_svm(self, *args)

    def compute_optimized(self, *args):
        """
        compute_optimized(self, vector_idx) -> float

        compute optimized

        Parameters:
        -----------

        vector_idx:  index to compute

        optimized value at given index 
        """
        return _modshogun.Kernel_compute_optimized(self, *args)

    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        computes output for a batch of examples in an optimized fashion
        (favorable if kernel supports it, i.e. has KP_BATCHEVALUATION. to the
        outputvector target (of length num_vec elements) the output for the
        examples enumerated in vec_idx are added. therefore make sure that it
        is initialized with ZERO. the following num_suppvec, IDX, alphas
        arguments are the number of support vectors, their indices and weights

        """
        return _modshogun.Kernel_compute_batch(self, *args)

    def get_combined_kernel_weight(self):
        """
        get_combined_kernel_weight(self) -> float

        get combined kernel weight

        combined kernel weight 
        """
        return _modshogun.Kernel_get_combined_kernel_weight(self)

    def set_combined_kernel_weight(self, *args):
        """
        set_combined_kernel_weight(self, nw)

        set combined kernel weight

        Parameters:
        -----------

        nw:  new combined kernel weight 
        """
        return _modshogun.Kernel_set_combined_kernel_weight(self, *args)

    def get_num_subkernels(self):
        """
        get_num_subkernels(self) ->  int

        get number of subkernels

        number of subkernels 
        """
        return _modshogun.Kernel_get_num_subkernels(self)

    def compute_by_subkernel(self, *args):
        """
        compute_by_subkernel(self, vector_idx, subkernel_contrib)

        compute by subkernel

        Parameters:
        -----------

        vector_idx:  index

        subkernel_contrib:  subkernel contribution 
        """
        return _modshogun.Kernel_compute_by_subkernel(self, *args)

    def get_subkernel_weights(self, *args):
        """
        get_subkernel_weights(self, num_weights) -> float

        get subkernel weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        subkernel weights 
        """
        return _modshogun.Kernel_get_subkernel_weights(self, *args)

    def set_subkernel_weights(self, *args):
        """
        set_subkernel_weights(self, weights)

        set subkernel weights

        Parameters:
        -----------

        weights:  new subkernel weights 
        """
        return _modshogun.Kernel_set_subkernel_weights(self, *args)

Kernel_swigregister = _modshogun.Kernel_swigregister
Kernel_swigregister(Kernel)

class DotKernel(Kernel):
    """
    Template class DotKernel is the base class for kernels working on
    DotFeatures.

    CDotFeatures are features supporting operations like dot product, dot
    product with a dense vector and addition to a dense vector. Therefore
    several dot product based kernels derive from this class (cf., e.g.,
    CLinearKernel)

    See:   CDotFeatures

    C++ includes: DotKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DotKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DotKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_DotKernel
    __del__ = lambda self : None;
DotKernel_swigregister = _modshogun.DotKernel_swigregister
DotKernel_swigregister(DotKernel)

class SparseRealKernel(Kernel):
    """
    Template class SparseKernel, is the base class of kernels working on
    sparse features.

    See e.g. the CSparseGaussianKernel for an example.

    C++ includes: SparseKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseRealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseRealKernel
    __del__ = lambda self : None;
SparseRealKernel_swigregister = _modshogun.SparseRealKernel_swigregister
SparseRealKernel_swigregister(SparseRealKernel)

class SparseWordKernel(Kernel):
    """
    Template class SparseKernel, is the base class of kernels working on
    sparse features.

    See e.g. the CSparseGaussianKernel for an example.

    C++ includes: SparseKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseWordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseWordKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_SparseWordKernel
    __del__ = lambda self : None;
SparseWordKernel_swigregister = _modshogun.SparseWordKernel_swigregister
SparseWordKernel_swigregister(SparseWordKernel)

class StringRealKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringRealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringRealKernel
    __del__ = lambda self : None;
StringRealKernel_swigregister = _modshogun.StringRealKernel_swigregister
StringRealKernel_swigregister(StringRealKernel)

class StringWordKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringWordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringWordKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringWordKernel
    __del__ = lambda self : None;
StringWordKernel_swigregister = _modshogun.StringWordKernel_swigregister
StringWordKernel_swigregister(StringWordKernel)

class StringCharKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringCharKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringCharKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringCharKernel
    __del__ = lambda self : None;
StringCharKernel_swigregister = _modshogun.StringCharKernel_swigregister
StringCharKernel_swigregister(StringCharKernel)

class StringUlongKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringUlongKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringUlongKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringUlongKernel
    __del__ = lambda self : None;
StringUlongKernel_swigregister = _modshogun.StringUlongKernel_swigregister
StringUlongKernel_swigregister(StringUlongKernel)

class StringShortKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringShortKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringShortKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringShortKernel
    __del__ = lambda self : None;
StringShortKernel_swigregister = _modshogun.StringShortKernel_swigregister
StringShortKernel_swigregister(StringShortKernel)

class StringByteKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringByteKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringByteKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_StringByteKernel
    __del__ = lambda self : None;
StringByteKernel_swigregister = _modshogun.StringByteKernel_swigregister
StringByteKernel_swigregister(StringByteKernel)

N_REGULAR = _modshogun.N_REGULAR
N_MULTITASK = _modshogun.N_MULTITASK
class KernelNormalizer(SGObject):
    """
    The class Kernel Normalizer defines a function to post-process kernel
    values.

    Formally it defines f(.,.,.)

    \\[ k'({\\bf x},{\\bf x'}) = f(k({\\bf x},{\\bf x'}),{\\bf
    x},{\\bf x'}) \\]

    examples for f(.,.,.) would be scaling with a constant

    \\[ f(k({\\bf x},{\\bf x'}), ., .)= \\frac{1}{c}\\cdot
    k({\\bf x},{\\bf x'}) \\]

    as can be found in class CAvgDiagKernelNormalizer, the identity (cf.
    CIdentityKernelNormalizer), dividing by the Square Root of the product
    of the diagonal elements which effectively normalizes the vectors in
    feature space to norm 1 (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{\\sqrt{k({\\bf x},{\\bf x})k({\\bf x'},{\\bf x'})}}
    \\]

    C++ includes: KernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_KernelNormalizer
    __del__ = lambda self : None;
    def init(self, *args):
        """
        init(self, k) -> bool

        initialization of the normalizer (if needed)

        Parameters:
        -----------

        k:  kernel 
        """
        return _modshogun.KernelNormalizer_init(self, *args)

    def normalize(self, *args):
        """
        normalize(self, value, idx_lhs, idx_rhs) -> float

        normalize the kernel value

        Parameters:
        -----------

        value:  kernel value

        idx_lhs:  index of left hand side vector

        idx_rhs:  index of right hand side vector 
        """
        return _modshogun.KernelNormalizer_normalize(self, *args)

    def normalize_lhs(self, *args):
        """
        normalize_lhs(self, value, idx_lhs) -> float

        normalize only the left hand side vector

        Parameters:
        -----------

        value:  value of a component of the left hand side feature vector

        idx_lhs:  index of left hand side vector 
        """
        return _modshogun.KernelNormalizer_normalize_lhs(self, *args)

    def normalize_rhs(self, *args):
        """
        normalize_rhs(self, value, idx_rhs) -> float

        normalize only the right hand side vector

        Parameters:
        -----------

        value:  value of a component of the right hand side feature vector

        idx_rhs:  index of right hand side vector 
        """
        return _modshogun.KernelNormalizer_normalize_rhs(self, *args)

    def register_params(self):
        """
        register_params(self)

        register the parameters 
        """
        return _modshogun.KernelNormalizer_register_params(self)

    def get_normalizer_type(self):
        """
        get_normalizer_type(self) -> ENormalizerType

        getter for normalizer type 
        """
        return _modshogun.KernelNormalizer_get_normalizer_type(self)

    def set_normalizer_type(self, *args):
        """
        set_normalizer_type(self, type)

        setter for normalizer type

        Parameters:
        -----------

        type:  type of normalizer 
        """
        return _modshogun.KernelNormalizer_set_normalizer_type(self, *args)

KernelNormalizer_swigregister = _modshogun.KernelNormalizer_swigregister
KernelNormalizer_swigregister(KernelNormalizer)

class PyramidChi2(DotKernel):
    """
    Pyramid Kernel over Chi2 matched histograms.

    C++ includes: PyramidChi2.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PyramidChi2, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PyramidChi2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> PyramidChi2
        __init__(self, size, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2) -> PyramidChi2
        __init__(self, l, r, size, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2) -> PyramidChi2

        constructor

        Parameters:
        -----------

        l:  features lhs convention: concatenated features along all cells,
        i.e. [feature for cell1, feature for cell2, ... feature for last cell]
        , the dimensionality of the base feature is equal to dividing the
        total feature length by the number ofcells

        r:  features rhs the same convention as for param l applies here

        size:  cache size

        num_cells2:  - the number of pyramid cells

        weights_foreach_cell2:  the vector of weights for each cell with which
        the Chi2 distance gets weighted

        width_computation_type2:  - 0 use the following parameter as fixed
        width, 1- use mean of inner distances in case 1 the value of parameter
        width is important!!!

        width2:  - in case of width_computation_type ==0 it is the width, in
        case of width_computation_type > 0 its value determines the how many
        random features are used for determining the width in case of
        width_computation_type > 0 set width2 <=1 to use all LEFT HAND SIDE
        features for width estimation 
        """
        this = _modshogun.new_PyramidChi2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PyramidChi2
    __del__ = lambda self : None;
    def setparams_pychi2(self, *args):
        """
        setparams_pychi2(self, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2)

        sets parameters, see also constructor

        Parameters:
        -----------

        num_cells2:  - the number of pyramid cells

        weights_foreach_cell2:  the vector of weights for each cell with which
        the Chi2 distance gets weighted

        width_computation_type2:  - 0 use the following parameter as fixed
        width, 1- use mean of inner distances in cases 1 and 2 the value of
        parameter width is still important, see parameter width2

        width2:  - in case of width_computation_type ==0 it is the width, in
        case of width_computation_type > 0 its value determines the how many
        random features are used for determining the width in case of
        width_computation_type > 0 set width2 <=1 to use all LEFT HAND SIDE
        features for width estimation 
        """
        return _modshogun.PyramidChi2_setparams_pychi2(self, *args)

PyramidChi2_swigregister = _modshogun.PyramidChi2_swigregister
PyramidChi2_swigregister(PyramidChi2)

class ANOVAKernel(DotKernel):
    """
    ANOVA (ANalysis Of VAriances) kernel.

    Formally described as

    \\[ K_d(x,z) = \\sum_{1\\le i_1<i_2<\\dots<i_d\\le n}
    \\prod_{j=1}^d x_{i_j} z_{i_j} \\] with d(cardinality)=1 by
    default this function is computed recusively

    C++ includes: ANOVAKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ANOVAKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ANOVAKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ANOVAKernel
        __init__(self, cache, d) -> ANOVAKernel
        __init__(self, l, r, d, cache) -> ANOVAKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        d:  kernel parameter cardinality

        cache:  cache size 
        """
        this = _modshogun.new_ANOVAKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ANOVAKernel
    __del__ = lambda self : None;
    def get_cardinality(self):
        """
        get_cardinality(self) ->  int

        getter for degree parameter kernel parameter cardinality 
        """
        return _modshogun.ANOVAKernel_get_cardinality(self)

    def set_cardinality(self, *args):
        """
        set_cardinality(self, value)

        setter for degree parameter

        Parameters:
        -----------

        value:  kernel parameter cardinality 
        """
        return _modshogun.ANOVAKernel_set_cardinality(self, *args)

    def compute_rec1(self, *args):
        """
        compute_rec1(self, idx_a, idx_b) -> float

        compute rec 1

        Parameters:
        -----------

        idx_a:

        idx_b:

        rec1 
        """
        return _modshogun.ANOVAKernel_compute_rec1(self, *args)

    def compute_rec2(self, *args):
        """
        compute_rec2(self, idx_a, idx_b) -> float

        computer rec 2

        Parameters:
        -----------

        idx_a:

        idx_b:

        rec2 
        """
        return _modshogun.ANOVAKernel_compute_rec2(self, *args)

ANOVAKernel_swigregister = _modshogun.ANOVAKernel_swigregister
ANOVAKernel_swigregister(ANOVAKernel)

class AUCKernel(DotKernel):
    """
    The AUC kernel can be used to maximize the area under the receiver
    operator stracteristic curve (AUC) instead of margin in SVM training.

    It takes as argument a sub-kernel and Labels based on which number of
    positive labels times number of negative labels many ``virtual''
    examples are created that ensure that all positive examples get a
    higher score than all negative examples in training.

    C++ includes: AUCKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AUCKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AUCKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> AUCKernel
        __init__(self, size, subkernel) -> AUCKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        subkernel:  the subkernel 
        """
        this = _modshogun.new_AUCKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_AUCKernel
    __del__ = lambda self : None;
    def setup_auc_maximization(self, *args):
        """
        setup_auc_maximization(self, labels) -> Labels

        initialize kernel based on current labeling and subkernel

        Parameters:
        -----------

        labels:  - current labeling

        new label object to be used together with this kernel in SVM training
        for AUC maximization 
        """
        return _modshogun.AUCKernel_setup_auc_maximization(self, *args)

AUCKernel_swigregister = _modshogun.AUCKernel_swigregister
AUCKernel_swigregister(AUCKernel)

class AvgDiagKernelNormalizer(KernelNormalizer):
    """
    Normalize the kernel by either a constant or the average value of the
    diagonal elements (depending on argument c of the constructor).

    In case c <= 0 compute scale as \\[ \\mbox{scale} =
    \\frac{1}{N}\\sum_{i=1}^N k(x_i,x_i) \\]

    otherwise use scale=c and normalize the kernel via

    \\[ k'(x,x')= \\frac{k(x,x')}{scale} \\]

    C++ includes: AvgDiagKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AvgDiagKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AvgDiagKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, c = 0.0): 
        """
        __init__(self, c = 0.0) -> AvgDiagKernelNormalizer
        __init__(self) -> AvgDiagKernelNormalizer

        constructor

        Parameters:
        -----------

        c:  scale parameter, if <= 0 scaling will be computed from the avg of
        the kernel diagonal elements 
        """
        this = _modshogun.new_AvgDiagKernelNormalizer(c)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_AvgDiagKernelNormalizer
    __del__ = lambda self : None;
AvgDiagKernelNormalizer_swigregister = _modshogun.AvgDiagKernelNormalizer_swigregister
AvgDiagKernelNormalizer_swigregister(AvgDiagKernelNormalizer)

class RidgeKernelNormalizer(KernelNormalizer):
    """
    Normalize the kernel by adding a constant term to its diagonal. This
    aids kernels to become positive definite (even though they are not -
    often caused by numerical problems).

    Formally,

    \\[ k'(x,x')= \\frac{k(x,x')}+ R\\cdot {\\bf E} \\]

    where E is a matrix with ones on the diagonal and R is the scalar
    ridge term. The ridge term R is computed as $R=r\\dot c$.

    Typically,

    r=1e-10 and c=0.0 will add mean(diag(K))*1e-10 to the diagonal

    r=0.1 and c=1 will add 0.1 to the diagonal

    In case c <= 0, c is compute as the mean of the kernel diagonal \\[
    \\mbox{c} = \\frac{1}{N}\\sum_{i=1}^N k(x_i,x_i) \\]

    C++ includes: RidgeKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RidgeKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RidgeKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, r = 1e-10, c = 0.0): 
        """
        __init__(self, r = 1e-10, c = 0.0) -> RidgeKernelNormalizer
        __init__(self, r = 1e-10) -> RidgeKernelNormalizer
        __init__(self) -> RidgeKernelNormalizer

        constructor

        Parameters:
        -----------

        r:  ridge parameter

        c:  scale parameter, if <= 0 scaling will be computed from the avg of
        the kernel diagonal elements

        the scalar r*c will be added to the kernel diagonal, typical use
        cases: r=1e-10 and c=0.0 will add mean(diag(K))*1e-10 to the diagonal

        r=0.1 and c=1 will add 0.1 to the diagonal 
        """
        this = _modshogun.new_RidgeKernelNormalizer(r, c)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RidgeKernelNormalizer
    __del__ = lambda self : None;
RidgeKernelNormalizer_swigregister = _modshogun.RidgeKernelNormalizer_swigregister
RidgeKernelNormalizer_swigregister(RidgeKernelNormalizer)

class CauchyKernel(Kernel):
    """
    Cauchy kernel.

    Formally described as

    \\[ K(x,x') = \\frac{1}{1+\\frac{\\| x-x' \\|^2}{\\sigma}}
    \\]

    C++ includes: CauchyKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CauchyKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CauchyKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CauchyKernel
        __init__(self, cache, sigma, dist) -> CauchyKernel
        __init__(self, l, r, sigma, dist) -> CauchyKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        sigma:  kernel parameter sigma

        dist:  distance to be used 
        """
        this = _modshogun.new_CauchyKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CauchyKernel
    __del__ = lambda self : None;
CauchyKernel_swigregister = _modshogun.CauchyKernel_swigregister
CauchyKernel_swigregister(CauchyKernel)

class CircularKernel(Kernel):
    """
    Circular kernel.

    Formally described as

    \\[ k(x, y) = \\frac{2}{\\pi}*\\arccos(\\frac{-||{\\bf
    x}-{\\bf x'}||}{\\sigma}) -
    \\frac{2}{\\pi}*(\\frac{||{\\bf x}-{\\bf
    x'}||}{\\sigma})*\\sqrt{1-(\\frac{||{\\bf x}-{\\bf
    x'}||}{\\sigma})^2} \\mbox{if}~ ||x-y|| \\leq \\sigma
    \\mbox{, zero otherwise} \\]

    C++ includes: CircularKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CircularKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CircularKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CircularKernel
        __init__(self, size, sigma, dist) -> CircularKernel
        __init__(self, l, r, sigma, dist) -> CircularKernel

        constructor

        Parameters:
        -----------

        l:  features of left-side

        r:  features of right-side

        sigma:  kernel parameter sigma

        dist:  distance 
        """
        this = _modshogun.new_CircularKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    def set_sigma(self, *args):
        """
        set_sigma(self, s)

        set the kernel's sigma

        Parameters:
        -----------

        s:  kernel sigma 
        """
        return _modshogun.CircularKernel_set_sigma(self, *args)

    def get_sigma(self):
        """
        get_sigma(self) -> float

        return the kernel's sigma

        kernel sigma 
        """
        return _modshogun.CircularKernel_get_sigma(self)

    __swig_destroy__ = _modshogun.delete_CircularKernel
    __del__ = lambda self : None;
    def load_serializable_post(self):
        """
        load_serializable_post(self)

        throw ( ShogunException) Can (optionally) be overridden to post-
        initialize some member variables which are not PARAMETER::ADD'ed. Make
        sure that at first the overridden method
        BASE_CLASS::LOAD_SERIALIZABLE_POST is called.

        Exceptions:
        -----------

        ShogunException Will be thrown if an error occurres. 
        """
        return _modshogun.CircularKernel_load_serializable_post(self)

    def compute(self, *args):
        """
        compute(self, idx_a, idx_b) -> float

        compute kernel function for features a and b idx_{a,b} denote the
        index of the feature vectors in the corresponding feature object

        Parameters:
        -----------

        idx_a:  index a

        idx_b:  index b

        computed kernel function at indices a,b 
        """
        return _modshogun.CircularKernel_compute(self, *args)

CircularKernel_swigregister = _modshogun.CircularKernel_swigregister
CircularKernel_swigregister(CircularKernel)

class Chi2Kernel(DotKernel):
    """
    The Chi2 kernel operating on realvalued vectors computes the chi-
    squared distance between sets of histograms.

    It is a very useful distance in image recognition (used to detect
    objects).

    It is defined as \\[ k({\\bf x},({\\bf x'})=
    e^{-\\frac{1}{width}
    \\sum_{i=0}^{l}\\frac{(x_i-x'_i)^2}{(x_i+x'_i)}} \\]

    C++ includes: Chi2Kernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Chi2Kernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Chi2Kernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Chi2Kernel
        __init__(self, size, width) -> Chi2Kernel
        __init__(self, l, r, width, size) -> Chi2Kernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _modshogun.new_Chi2Kernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Chi2Kernel
    __del__ = lambda self : None;
Chi2Kernel_swigregister = _modshogun.Chi2Kernel_swigregister
Chi2Kernel_swigregister(Chi2Kernel)

class CombinedKernel(Kernel):
    """
    The Combined kernel is used to combine a number of kernels into a
    single CombinedKernel object by linear combination.

    It keeps pointers to the added sub-kernels $k_m({\\bf x}, {\\bf
    x'})$ and for each sub-kernel - a kernel specific weight $\\beta_m$.

    It is especially useful to combine kernels working on different
    domains and to combine kernels looking at independent features and
    requires CCombinedFeatures to be used.

    It is defined as:

    \\[ k_{combined}({\\bf x}, {\\bf x'}) = \\sum_{m=1}^M
    \\beta_m k_m({\\bf x}, {\\bf x'}) \\]

    C++ includes: CombinedKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CombinedKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CombinedKernel, name)
    __repr__ = _swig_repr
    def __init__(self, size = 10, append_subkernel_weights = False): 
        """
        __init__(self, size = 10, append_subkernel_weights = False) -> CombinedKernel
        __init__(self, size = 10) -> CombinedKernel
        __init__(self) -> CombinedKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        append_subkernel_weights:  if subkernel weights shall be appended 
        """
        this = _modshogun.new_CombinedKernel(size, append_subkernel_weights)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CombinedKernel
    __del__ = lambda self : None;
    def list_kernels(self):
        """
        list_kernels(self)

        list kernels 
        """
        return _modshogun.CombinedKernel_list_kernels(self)

    def get_first_kernel(self, *args):
        """
        get_first_kernel(self) -> Kernel
        get_first_kernel(self, current) -> Kernel

        get first kernel

        Parameters:
        -----------

        current:

        first kernel 
        """
        return _modshogun.CombinedKernel_get_first_kernel(self, *args)

    def get_kernel(self, *args):
        """
        get_kernel(self, idx) -> Kernel

        get kernel

        Parameters:
        -----------

        idx:  index of kernel

        kernel at index idx 
        """
        return _modshogun.CombinedKernel_get_kernel(self, *args)

    def get_last_kernel(self):
        """
        get_last_kernel(self) -> Kernel

        get last kernel

        last kernel 
        """
        return _modshogun.CombinedKernel_get_last_kernel(self)

    def get_next_kernel(self, *args):
        """
        get_next_kernel(self) -> Kernel
        get_next_kernel(self, current) -> Kernel

        get next kernel multi-thread safe

        Parameters:
        -----------

        current:

        next kernel 
        """
        return _modshogun.CombinedKernel_get_next_kernel(self, *args)

    def insert_kernel(self, *args):
        """
        insert_kernel(self, k) -> bool

        insert kernel

        Parameters:
        -----------

        k:  kernel

        if inserting was successful 
        """
        return _modshogun.CombinedKernel_insert_kernel(self, *args)

    def append_kernel(self, *args):
        """
        append_kernel(self, k) -> bool

        append kernel

        Parameters:
        -----------

        k:  kernel

        if appending was successful 
        """
        return _modshogun.CombinedKernel_append_kernel(self, *args)

    def delete_kernel(self):
        """
        delete_kernel(self) -> bool

        delete kernel

        if deleting was successful 
        """
        return _modshogun.CombinedKernel_delete_kernel(self)

    def get_append_subkernel_weights(self):
        """
        get_append_subkernel_weights(self) -> bool

        check if subkernel weights are appended

        if subkernel weigths are appended 
        """
        return _modshogun.CombinedKernel_get_append_subkernel_weights(self)

    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        computes output for a batch of examples in an optimized fashion
        (favorable if kernel supports it, i.e. has KP_BATCHEVALUATION. to the
        outputvector target (of length num_vec elements) the output for the
        examples enumerated in vec_idx are added. therefore make sure that it
        is initialized with ZERO. the following num_suppvec, IDX, alphas
        arguments are the number of support vectors, their indices and weights

        """
        return _modshogun.CombinedKernel_compute_batch(self, *args)

    def compute_optimized_kernel_helper(*args):
        """compute_optimized_kernel_helper(p) -> void"""
        return _modshogun.CombinedKernel_compute_optimized_kernel_helper(*args)

    if _newclass:compute_optimized_kernel_helper = staticmethod(compute_optimized_kernel_helper)
    __swig_getmethods__["compute_optimized_kernel_helper"] = lambda x: compute_optimized_kernel_helper
    def compute_kernel_helper(*args):
        """compute_kernel_helper(p) -> void"""
        return _modshogun.CombinedKernel_compute_kernel_helper(*args)

    if _newclass:compute_kernel_helper = staticmethod(compute_kernel_helper)
    __swig_getmethods__["compute_kernel_helper"] = lambda x: compute_kernel_helper
    def emulate_compute_batch(self, *args):
        """
        emulate_compute_batch(self, k, num_vec, vec_idx, target, num_suppvec, IDX, weights)

        emulates batch computation, via linadd optimization w^t x or even down
        to sum_i alpha_i K(x_i,x)

        Parameters:
        -----------

        k:  kernel

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        weights:  weights 
        """
        return _modshogun.CombinedKernel_emulate_compute_batch(self, *args)

    def get_subkernel_weights(self, *args):
        """
        get_subkernel_weights(self, num_weights) -> float
        get_subkernel_weights(self) -> RealVector

        get subkernel weights (swig compatible)

        subkernel weights 
        """
        return _modshogun.CombinedKernel_get_subkernel_weights(self, *args)

    def precompute_subkernels(self):
        """
        precompute_subkernels(self) -> bool

        precompute all sub-kernels 
        """
        return _modshogun.CombinedKernel_precompute_subkernels(self)

    def KernelToCombinedKernel(self, *args):
        """
        KernelToCombinedKernel(self, n) -> CombinedKernel

        casts kernel to combined kernel

        Parameters:
        -----------

        n:  kernel to cast 
        """
        return _modshogun.CombinedKernel_KernelToCombinedKernel(self, *args)

CombinedKernel_swigregister = _modshogun.CombinedKernel_swigregister
CombinedKernel_swigregister(CombinedKernel)

def CombinedKernel_compute_optimized_kernel_helper(*args):
  """CombinedKernel_compute_optimized_kernel_helper(p) -> void"""
  return _modshogun.CombinedKernel_compute_optimized_kernel_helper(*args)

def CombinedKernel_compute_kernel_helper(*args):
  """CombinedKernel_compute_kernel_helper(p) -> void"""
  return _modshogun.CombinedKernel_compute_kernel_helper(*args)

class CommUlongStringKernel(StringUlongKernel):
    """
    The CommUlongString kernel may be used to compute the spectrum kernel
    from strings that have been mapped into unsigned 64bit integers.

    These 64bit integers correspond to k-mers. To be applicable in this
    kernel they need to be sorted (e.g. via the SortUlongString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation enables spectrum kernels of order 8 for
    8bit alphabets (like binaries) and order 32 for 2-bit alphabets like
    DNA.

    For this kernel the linadd speedups are implemented (though there is
    room for improvement here when a whole set of sequences is ADDed)
    using sorted lists.

    C++ includes: CommUlongStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringUlongKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CommUlongStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringUlongKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CommUlongStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 10, use_sign = False) -> CommUlongStringKernel
        __init__(self, size = 10) -> CommUlongStringKernel
        __init__(self) -> CommUlongStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> CommUlongStringKernel
        __init__(self, l, r, use_sign = False) -> CommUlongStringKernel
        __init__(self, l, r) -> CommUlongStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _modshogun.new_CommUlongStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CommUlongStringKernel
    __del__ = lambda self : None;
    def merge_dictionaries(self, *args):
        """
        merge_dictionaries(self, t, j, k, vec, dic, dic_weights, weight, vec_idx)

        merge dictionaries

        Parameters:
        -----------

        t:  t

        j:  j

        k:  k

        vec:  vector

        dic:  dictionary

        dic_weights:  dictionary weights

        weight:  weight

        vec_idx:  vector index 
        """
        return _modshogun.CommUlongStringKernel_merge_dictionaries(self, *args)

    def get_dictionary(self, *args):
        """
        get_dictionary(self, dsize, dict, dweights)

        get dictionary

        Parameters:
        -----------

        dsize:  dictionary size will be stored in here

        dict:  dictionary will be stored in here

        dweights:  dictionary weights will be stored in here 
        """
        return _modshogun.CommUlongStringKernel_get_dictionary(self, *args)

CommUlongStringKernel_swigregister = _modshogun.CommUlongStringKernel_swigregister
CommUlongStringKernel_swigregister(CommUlongStringKernel)

class CommWordStringKernel(StringWordKernel):
    """
    The CommWordString kernel may be used to compute the spectrum kernel
    from strings that have been mapped into unsigned 16bit integers.

    These 16bit integers correspond to k-mers. To applicable in this
    kernel they need to be sorted (e.g. via the SortWordString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation is especially tuned to small alphabets
    (like the 2-bit alphabet DNA), for which it enables spectrum kernels
    of order up to 8.

    For this kernel the linadd speedups are quite efficiently implemented
    using direct maps.

    C++ includes: CommWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CommWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CommWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CommWordStringKernel
        __init__(self, size, use_sign) -> CommWordStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> CommWordStringKernel
        __init__(self, l, r, use_sign = False) -> CommWordStringKernel
        __init__(self, l, r) -> CommWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _modshogun.new_CommWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CommWordStringKernel
    __del__ = lambda self : None;
    def init_dictionary(self, *args):
        """
        init_dictionary(self, size) -> bool

        initialize dictionary

        Parameters:
        -----------

        size:  size 
        """
        return _modshogun.CommWordStringKernel_init_dictionary(self, *args)

    def get_dictionary(self, *args):
        """
        get_dictionary(self, dsize, dweights)

        get dictionary

        Parameters:
        -----------

        dsize:  dictionary size will be stored in here

        dweights:  dictionary weights will be stored in here 
        """
        return _modshogun.CommWordStringKernel_get_dictionary(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas, do_init = True) -> float
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas) -> float

        compute scoring

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        do_init:  if initialization shall be performed

        computed scores 
        """
        return _modshogun.CommWordStringKernel_compute_scoring(self, *args)

    def compute_consensus(self, *args):
        """
        compute_consensus(self, num_feat, num_suppvec, IDX, alphas) -> str

        compute consensus

        Parameters:
        -----------

        num_feat:  number of features

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        computed consensus 
        """
        return _modshogun.CommWordStringKernel_compute_consensus(self, *args)

    def set_use_dict_diagonal_optimization(self, *args):
        """
        set_use_dict_diagonal_optimization(self, flag)

        set_use_dict_diagonal_optimization

        Parameters:
        -----------

        flag:  enable diagonal optimization 
        """
        return _modshogun.CommWordStringKernel_set_use_dict_diagonal_optimization(self, *args)

    def get_use_dict_diagonal_optimization(self):
        """
        get_use_dict_diagonal_optimization(self) -> bool

        get.use.dict.diagonal.optimization

        true if diagonal optimization is on 
        """
        return _modshogun.CommWordStringKernel_get_use_dict_diagonal_optimization(self)

CommWordStringKernel_swigregister = _modshogun.CommWordStringKernel_swigregister
CommWordStringKernel_swigregister(CommWordStringKernel)

class ConstKernel(Kernel):
    """
    The Constant Kernel returns a constant for all elements.

    A ``kernel'' that simply returns a single constant, i.e. $k({\\bf
    x}, {\\bf x'})= c$

    C++ includes: ConstKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ConstKernel
        __init__(self, c) -> ConstKernel
        __init__(self, l, r, c) -> ConstKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        c:  constant c 
        """
        this = _modshogun.new_ConstKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ConstKernel
    __del__ = lambda self : None;
ConstKernel_swigregister = _modshogun.ConstKernel_swigregister
ConstKernel_swigregister(ConstKernel)

class CustomKernel(Kernel):
    """
    The Custom Kernel allows for custom user provided kernel matrices.

    For squared training matrices it allows to store only the upper
    triangle of the kernel to save memory: Full symmetric kernel matrices
    can be stored as is or can be internally converted into (or directly
    given in) upper triangle representation. Also note that values are
    stored as 32bit floats.

    C++ includes: CustomKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CustomKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CustomKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CustomKernel
        __init__(self, k) -> CustomKernel
        __init__(self, km) -> CustomKernel

        constructor

        sets full kernel matrix from full kernel matrix (from float precision
        floats)

        Parameters:
        -----------

        km:  kernel matrix 
        """
        this = _modshogun.new_CustomKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CustomKernel
    __del__ = lambda self : None;
    def dummy_init(self, *args):
        """
        dummy_init(self, rows, cols) -> bool

        initialize kernel with dummy features

        Kernels always need feature objects assigned. As the custom kernel
        does not really require this it creates some magic dummy features that
        only know about the number of vectors

        Parameters:
        -----------

        rows:  features of left-hand side

        cols:  features of right-hand side

        if initializing was successful 
        """
        return _modshogun.CustomKernel_dummy_init(self, *args)

    def set_triangle_kernel_matrix_from_triangle(self, *args):
        """
        set_triangle_kernel_matrix_from_triangle(self, tri_kernel_matrix) -> bool

        set kernel matrix (only elements from upper triangle) from elements of
        upper triangle (concat'd), including the main diagonal

        small variant for floats64's, triangle needs to have less than 2**32
        elements

        Parameters:
        -----------

        tri_kernel_matrix:  tri kernel matrix

        if setting was successful 
        """
        return _modshogun.CustomKernel_set_triangle_kernel_matrix_from_triangle(self, *args)

    def set_triangle_kernel_matrix_from_full(self, *args):
        """
        set_triangle_kernel_matrix_from_full(self, full_kernel_matrix) -> bool

        set kernel matrix (only elements from upper triangle) from squared
        matrix

        for float64's

        if setting was successful 
        """
        return _modshogun.CustomKernel_set_triangle_kernel_matrix_from_full(self, *args)

    def set_full_kernel_matrix_from_full(self, *args):
        """
        set_full_kernel_matrix_from_full(self, full_kernel_matrix) -> bool
        set_full_kernel_matrix_from_full(self, full_kernel_matrix) -> bool

        set full kernel matrix from full kernel matrix

        for float64

        if setting was successful 
        """
        return _modshogun.CustomKernel_set_full_kernel_matrix_from_full(self, *args)

CustomKernel_swigregister = _modshogun.CustomKernel_swigregister
CustomKernel_swigregister(CustomKernel)

class DiagKernel(Kernel):
    """
    The Diagonal Kernel returns a constant for the diagonal and zero
    otherwise.

    A kernel that returns zero for all non-diagonal elements and a single
    constant otherwise, i.e. $k({\\bf x_i}, {\\bf x_j})=
    \\delta_{ij} c$

    C++ includes: DiagKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DiagKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DiagKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DiagKernel
        __init__(self, size, diag = 1.0) -> DiagKernel
        __init__(self, size) -> DiagKernel
        __init__(self, l, r, diag = 1.0) -> DiagKernel
        __init__(self, l, r) -> DiagKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        diag:  diagonal 
        """
        this = _modshogun.new_DiagKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DiagKernel
    __del__ = lambda self : None;
DiagKernel_swigregister = _modshogun.DiagKernel_swigregister
DiagKernel_swigregister(DiagKernel)

class DiceKernelNormalizer(KernelNormalizer):
    """
    DiceKernelNormalizer performs kernel normalization inspired by the
    Dice coefficient (seehttp://en.wikipedia.org/wiki/Dice's_coefficient)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{2k({\\bf x},{\\bf
    x'})}{k({\\bf x},{\\bf x})+k({\\bf x'},{\\bf x'}} \\]

    C++ includes: DiceKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DiceKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DiceKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, use_opt_diag = False): 
        """
        __init__(self, use_opt_diag = False) -> DiceKernelNormalizer
        __init__(self) -> DiceKernelNormalizer

        default constructor

        Parameters:
        -----------

        use_opt_diag:  - some kernels support faster diagonal compuation via
        compute_diag(idx), this flag enables this 
        """
        this = _modshogun.new_DiceKernelNormalizer(use_opt_diag)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DiceKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _modshogun.DiceKernelNormalizer_alloc_and_compute_diag(self, *args)

DiceKernelNormalizer_swigregister = _modshogun.DiceKernelNormalizer_swigregister
DiceKernelNormalizer_swigregister(DiceKernelNormalizer)

class ScatterKernelNormalizer(KernelNormalizer):
    """
    the scatter kernel normalizer

    C++ includes: ScatterKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScatterKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ScatterKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ScatterKernelNormalizer
        __init__(self, const_diag, const_offdiag, labels, normalizer = None) -> ScatterKernelNormalizer
        __init__(self, const_diag, const_offdiag, labels) -> ScatterKernelNormalizer

        default constructor 
        """
        this = _modshogun.new_ScatterKernelNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ScatterKernelNormalizer
    __del__ = lambda self : None;
    def get_testing_class(self):
        """
        get_testing_class(self) ->  int

        get testing class

        testing class (-1 disabled, 0...class otherwise) 
        """
        return _modshogun.ScatterKernelNormalizer_get_testing_class(self)

    def set_testing_class(self, *args):
        """
        set_testing_class(self, c)

        set testing status

        Parameters:
        -----------

        c:  set class to test for 
        """
        return _modshogun.ScatterKernelNormalizer_set_testing_class(self, *args)

ScatterKernelNormalizer_swigregister = _modshogun.ScatterKernelNormalizer_swigregister
ScatterKernelNormalizer_swigregister(ScatterKernelNormalizer)

class VarianceKernelNormalizer(KernelNormalizer):
    """
    VarianceKernelNormalizer divides by the ``variance''.

    This effectively normalizes the vectors in feature space to variance 1
    (see CVarianceKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{\\frac{1}{N}\\sum_{i=1}^N k({\\bf x}_i, {\\bf x}_i) -
    \\sum_{i,j=1}^N, k({\\bf x}_i,{\\bf x'}_j)/N^2} \\]

    C++ includes: VarianceKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VarianceKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VarianceKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> VarianceKernelNormalizer

        default constructor 
        """
        this = _modshogun.new_VarianceKernelNormalizer()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_VarianceKernelNormalizer
    __del__ = lambda self : None;
VarianceKernelNormalizer_swigregister = _modshogun.VarianceKernelNormalizer_swigregister
VarianceKernelNormalizer_swigregister(VarianceKernelNormalizer)

class DistanceKernel(Kernel):
    """
    The Distance kernel takes a distance as input.

    It turns a distance into something kernel like by computing

    \\[ k({\\bf x}, {\\bf x'}) = e^{-\\frac{dist({\\bf x},
    {\\bf x'})}{width}} \\]

    C++ includes: DistanceKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistanceKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistanceKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DistanceKernel
        __init__(self, cache, width, dist) -> DistanceKernel
        __init__(self, l, r, width, dist) -> DistanceKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        dist:  distance 
        """
        this = _modshogun.new_DistanceKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DistanceKernel
    __del__ = lambda self : None;
    def register_params(self):
        """
        register_params(self)

        register the parameters (serialization support) 
        """
        return _modshogun.DistanceKernel_register_params(self)

    def set_width(self, *args):
        """
        set_width(self, w)

        set the kernel's width

        Parameters:
        -----------

        w:  kernel width 
        """
        return _modshogun.DistanceKernel_set_width(self, *args)

    def get_width(self):
        """
        get_width(self) -> float

        return the kernel's width

        kernel width 
        """
        return _modshogun.DistanceKernel_get_width(self)

DistanceKernel_swigregister = _modshogun.DistanceKernel_swigregister
DistanceKernel_swigregister(DistanceKernel)

class DistantSegmentsKernel(StringCharKernel):
    """
    The distant segments kernel is a string kernel, which counts the
    number of substrings, so-called segments, at a certain distance from
    each other.

    The implementation is taken
    fromhttp://www.retrovirology.com/content/5/1/110/ and only adjusted to
    work with shogun. See that page for any details.

    Reference: Sebastien Boisvert, Mario Marchand, Francois Laviolette,
    and Jacques Corbeil. Hiv-1 coreceptor usage prediction without
    multiple alignments: an application of string kernels. Retrovirology,
    5(1):110, Dec 2008.

    C++ includes: DistantSegmentsKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistantSegmentsKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistantSegmentsKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> DistantSegmentsKernel
        __init__(self, size, delta, theta) -> DistantSegmentsKernel
        __init__(self, l, r, size, delta, theta) -> DistantSegmentsKernel

        constructor

        Parameters:
        -----------

        l:  features of left-side

        r:  features of right-side

        size:  cache size

        delta:   \\[\\delta\\]-parameter of the DS-kernel

        theta:   \\[\\theta\\]-parameter of the DS-kernel 
        """
        this = _modshogun.new_DistantSegmentsKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DistantSegmentsKernel
    __del__ = lambda self : None;
DistantSegmentsKernel_swigregister = _modshogun.DistantSegmentsKernel_swigregister
DistantSegmentsKernel_swigregister(DistantSegmentsKernel)

class ExponentialKernel(DotKernel):
    """
    The Exponential Kernel, closely related to the Gaussian Kernel
    computed on CDotFeatures.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: ExponentialKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ExponentialKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ExponentialKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ExponentialKernel
        __init__(self, l, r, width, distance, size) -> ExponentialKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        distance:  distance to be used

        size:  cache size 
        """
        this = _modshogun.new_ExponentialKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ExponentialKernel
    __del__ = lambda self : None;
    def get_width(self):
        """
        get_width(self) -> float

        return the kernel's width

        kernel width 
        """
        return _modshogun.ExponentialKernel_get_width(self)

ExponentialKernel_swigregister = _modshogun.ExponentialKernel_swigregister
ExponentialKernel_swigregister(ExponentialKernel)

class FixedDegreeStringKernel(StringCharKernel):
    """
    The FixedDegree String kernel takes as input two strings of same size
    and counts the number of matches of length d.

    \\[ k({\\bf x}, {\\bf x'}) = \\sum_{i=0}^{l-d} I({\\bf
    x}_{i,i+1,\\dots,i+d-1} = {\\bf x'}_{i,i+1,\\dots,i+d-1}) \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: FixedDegreeStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FixedDegreeStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FixedDegreeStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> FixedDegreeStringKernel
        __init__(self, size, degree) -> FixedDegreeStringKernel
        __init__(self, l, r, degree) -> FixedDegreeStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  the degree 
        """
        this = _modshogun.new_FixedDegreeStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_FixedDegreeStringKernel
    __del__ = lambda self : None;
FixedDegreeStringKernel_swigregister = _modshogun.FixedDegreeStringKernel_swigregister
FixedDegreeStringKernel_swigregister(FixedDegreeStringKernel)

class GaussianKernel(DotKernel):
    """
    The well known Gaussian kernel (swiss army knife for SVMs) computed on
    CDotFeatures.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    The compact version as given in Bart Hamers' thesis Kernel Models for
    Large Scale Applications (Eq. 4.10) is computed as

    \\[ k({\\bf x},{\\bf x'})= max(0, (1-\\frac{||{\\bf
    x}-{\\bf x'}||}{3\\tau})^v)) * exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: GaussianKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianKernel
        __init__(self, size, width) -> GaussianKernel
        __init__(self, l, r, width, size = 10) -> GaussianKernel
        __init__(self, l, r, width) -> GaussianKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _modshogun.new_GaussianKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GaussianKernel
    __del__ = lambda self : None;
    def set_width(self, *args):
        """
        set_width(self, w)

        set the kernel's width

        Parameters:
        -----------

        w:  kernel width 
        """
        return _modshogun.GaussianKernel_set_width(self, *args)

    def get_width(self):
        """
        get_width(self) -> float

        return the kernel's width

        kernel width 
        """
        return _modshogun.GaussianKernel_get_width(self)

    def set_compact_enabled(self, *args):
        """
        set_compact_enabled(self, compact)

        set the compact option

        Parameters:
        -----------

        compact:  value of the compact option 
        """
        return _modshogun.GaussianKernel_set_compact_enabled(self, *args)

    def get_compact_enabled(self):
        """
        get_compact_enabled(self) -> bool

        return value of the compact option

        whether the compact option is enabled 
        """
        return _modshogun.GaussianKernel_get_compact_enabled(self)

GaussianKernel_swigregister = _modshogun.GaussianKernel_swigregister
GaussianKernel_swigregister(GaussianKernel)

class GaussianShiftKernel(GaussianKernel):
    """
    An experimental kernel inspired by the
    WeightedDegreePositionStringKernel and the Gaussian kernel.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= \\exp(-\\frac{||{\\bf
    x}-{\\bf x'}||^2}{\\tau}) +
    \\sum_{s=1}^{S_{\\mathrm{max}}/S_{\\mathrm{step}}}
    \\frac{1}{2s} \\exp(-\\frac{||{\\bf x}_{[1:|{\\bf
    x}|-sS_{\\mathrm{step}}]}-{\\bf
    x'}_{[sS_{\\mathrm{step}}:|{\\bf x}|]}||^2}{\\tau}) +
    \\sum_{s=1}^{S_{max}/S_{step}} \\frac{1}{2s}
    \\exp(-\\frac{||{\\bf x}_{[sS_{\\mathrm{step}}:|{\\bf
    x}|]}-{\\bf x'}_{[1:|{\\bf
    x}|-sS_{\\mathrm{step}}]}||^2}{\\tau}) + \\]

    where $\\tau$ is the kernel width. The idea is to shift the
    dimensions of the input vectors against eachother.
    $S_{\\mathrm{step}}$ is the step size (parameter shift_step) of the
    shifts and $S_{\\mathrm{max}}$ (parameter max_shift) is the maximal
    shift.

    C++ includes: GaussianShiftKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [GaussianKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianShiftKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [GaussianKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianShiftKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianShiftKernel
        __init__(self, size, width, max_shift, shift_step) -> GaussianShiftKernel
        __init__(self, l, r, width, max_shift, shift_step, size = 10) -> GaussianShiftKernel
        __init__(self, l, r, width, max_shift, shift_step) -> GaussianShiftKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        max_shift:  maximum shift

        shift_step:  shift step

        size:  cache size 
        """
        this = _modshogun.new_GaussianShiftKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GaussianShiftKernel
    __del__ = lambda self : None;
GaussianShiftKernel_swigregister = _modshogun.GaussianShiftKernel_swigregister
GaussianShiftKernel_swigregister(GaussianShiftKernel)

class GaussianShortRealKernel(DotKernel):
    """
    The well known Gaussian kernel (swiss army knife for SVMs) on dense
    short-real valued features.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: GaussianShortRealKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianShortRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianShortRealKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianShortRealKernel
        __init__(self, size, width) -> GaussianShortRealKernel
        __init__(self, l, r, width, size = 10) -> GaussianShortRealKernel
        __init__(self, l, r, width) -> GaussianShortRealKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _modshogun.new_GaussianShortRealKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GaussianShortRealKernel
    __del__ = lambda self : None;
    def register_params(self):
        """
        register_params(self)

        register the parameters 
        """
        return _modshogun.GaussianShortRealKernel_register_params(self)

GaussianShortRealKernel_swigregister = _modshogun.GaussianShortRealKernel_swigregister
GaussianShortRealKernel_swigregister(GaussianShortRealKernel)

class HistogramIntersectionKernel(DotKernel):
    """
    The HistogramIntersection kernel operating on realvalued vectors
    computes the histogram intersection distance between sets of
    histograms. Note: the current implementation assumes positive values
    for the histograms, and input vectors should sum to 1.

    It is defined as \\[ k({\\bf x},({\\bf x'})= \\sum_{i=0}^{l}
    \\mbox{min}(x^{\\beta}_i, x'^{\\beta}_i) \\] with $\\beta=1$
    by default

    C++ includes: HistogramIntersectionKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HistogramIntersectionKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HistogramIntersectionKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HistogramIntersectionKernel
        __init__(self, size) -> HistogramIntersectionKernel
        __init__(self, l, r, beta = 1.0, size = 10) -> HistogramIntersectionKernel
        __init__(self, l, r, beta = 1.0) -> HistogramIntersectionKernel
        __init__(self, l, r) -> HistogramIntersectionKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        beta:  kernel parameter

        size:  cache size 
        """
        this = _modshogun.new_HistogramIntersectionKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HistogramIntersectionKernel
    __del__ = lambda self : None;
    def register_params(self):
        """
        register_params(self)

        Separate the function of parameter registration This can be the first
        stage of a *general* framework for cross-validation or other
        parameter-based operations 
        """
        return _modshogun.HistogramIntersectionKernel_register_params(self)

    def get_beta(self):
        """
        get_beta(self) -> float

        getter for beta parameter beta value 
        """
        return _modshogun.HistogramIntersectionKernel_get_beta(self)

    def set_beta(self, *args):
        """
        set_beta(self, beta)

        setter for beta parameter

        Parameters:
        -----------

        beta:  beta value 
        """
        return _modshogun.HistogramIntersectionKernel_set_beta(self, *args)

HistogramIntersectionKernel_swigregister = _modshogun.HistogramIntersectionKernel_swigregister
HistogramIntersectionKernel_swigregister(HistogramIntersectionKernel)

class HistogramWordStringKernel(StringWordKernel):
    """
    The HistogramWordString computes the TOP kernel on inhomogeneous
    Markov Chains.

    C++ includes: HistogramWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HistogramWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HistogramWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HistogramWordStringKernel
        __init__(self, size, pie) -> HistogramWordStringKernel
        __init__(self, l, r, pie) -> HistogramWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        pie:  plugin estimate 
        """
        this = _modshogun.new_HistogramWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HistogramWordStringKernel
    __del__ = lambda self : None;
HistogramWordStringKernel_swigregister = _modshogun.HistogramWordStringKernel_swigregister
HistogramWordStringKernel_swigregister(HistogramWordStringKernel)

class IdentityKernelNormalizer(KernelNormalizer):
    """
    Identity Kernel Normalization, i.e. no normalization is applied.

    C++ includes: IdentityKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IdentityKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IdentityKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> IdentityKernelNormalizer

        default constructor 
        """
        this = _modshogun.new_IdentityKernelNormalizer()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_IdentityKernelNormalizer
    __del__ = lambda self : None;
IdentityKernelNormalizer_swigregister = _modshogun.IdentityKernelNormalizer_swigregister
IdentityKernelNormalizer_swigregister(IdentityKernelNormalizer)

class InverseMultiQuadricKernel(Kernel):
    """
    InverseMultiQuadricKernel.

    \\[ K(x,x') = 1/(\\sqrt{\\| x - x' \\|^2 +c^2}) \\]

    C++ includes: InverseMultiQuadricKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InverseMultiQuadricKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InverseMultiQuadricKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> InverseMultiQuadricKernel
        __init__(self, cache, coef, dist) -> InverseMultiQuadricKernel
        __init__(self, l, r, coef, dist) -> InverseMultiQuadricKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        coef:  kernel parameter coef

        dist:  distance to be used 
        """
        this = _modshogun.new_InverseMultiQuadricKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    def get_coef(self):
        """
        get_coef(self) -> float

        getter for coef parameter kernel parameter coefficient 
        """
        return _modshogun.InverseMultiQuadricKernel_get_coef(self)

    def set_coef(self, *args):
        """
        set_coef(self, value)

        setter for coef parameter

        Parameters:
        -----------

        value:  kernel parameter coefficient 
        """
        return _modshogun.InverseMultiQuadricKernel_set_coef(self, *args)

    __swig_destroy__ = _modshogun.delete_InverseMultiQuadricKernel
    __del__ = lambda self : None;
InverseMultiQuadricKernel_swigregister = _modshogun.InverseMultiQuadricKernel_swigregister
InverseMultiQuadricKernel_swigregister(InverseMultiQuadricKernel)

class LinearKernel(DotKernel):
    """
    Computes the standard linear kernel on CDotFeatures.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= {\\bf x}\\cdot {\\bf x'} \\]

    C++ includes: LinearKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearKernel
        __init__(self, l, r) -> LinearKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_LinearKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LinearKernel
    __del__ = lambda self : None;
    def init_optimization(self, *args):
        """
        init_optimization(self, num_suppvec, sv_idx, alphas) -> bool
        init_optimization(self, km) -> bool

        init optimization

        Parameters:
        -----------

        km:  
        """
        return _modshogun.LinearKernel_init_optimization(self, *args)

    def get_normal(self, *args):
        """
        get_normal(self, len) -> float

        get normal

        Parameters:
        -----------

        len:  where length of normal vector will be stored

        normal vector 
        """
        return _modshogun.LinearKernel_get_normal(self, *args)

    def get_w(self, *args):
        """
        get_w(self, dst_w, dst_dims)

        get normal vector (swig compatible)

        Parameters:
        -----------

        dst_w:  store w in this argument

        dst_dims:  dimension of w 
        """
        return _modshogun.LinearKernel_get_w(self, *args)

    def set_w(self, *args):
        """
        set_w(self, src_w, src_w_dim)

        set normal vector (swig compatible)

        Parameters:
        -----------

        src_w:  new w

        src_w_dim:  dimension of new w - must fit dim of lhs 
        """
        return _modshogun.LinearKernel_set_w(self, *args)

LinearKernel_swigregister = _modshogun.LinearKernel_swigregister
LinearKernel_swigregister(LinearKernel)

class LinearStringKernel(StringCharKernel):
    """
    Computes the standard linear kernel on dense str valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= \\frac{1}{scale}{\\bf x}\\cdot
    {\\bf x'} \\]

    Note: Basically the same as LinearByteKernel but on signed strs.

    C++ includes: LinearStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearStringKernel
        __init__(self, l, r) -> LinearStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_LinearStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LinearStringKernel
    __del__ = lambda self : None;
LinearStringKernel_swigregister = _modshogun.LinearStringKernel_swigregister
LinearStringKernel_swigregister(LinearStringKernel)

class SparseSpatialSampleStringKernel(StringCharKernel):
    """
    Sparse Spatial Sample String Kernel by Pavel Kuksa
    <pkuksa@cs.rutgers.edu> and Vladimir Pavlovic
    <vladimir@cs.rutgers.edu>

    C++ includes: SparseSpatialSampleStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseSpatialSampleStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseSpatialSampleStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SparseSpatialSampleStringKernel
        __init__(self, l, r) -> SparseSpatialSampleStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_SparseSpatialSampleStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SparseSpatialSampleStringKernel
    __del__ = lambda self : None;
    def set_d(self, *args):
        """
        set_d(self, max_distance)

        set d

        Parameters:
        -----------

        max_distance:  
        """
        return _modshogun.SparseSpatialSampleStringKernel_set_d(self, *args)

    def get_d(self):
        """
        get_d(self) ->  int

        get d 
        """
        return _modshogun.SparseSpatialSampleStringKernel_get_d(self)

    def set_t(self, *args):
        """
        set_t(self, sequence_length)

        set t

        Parameters:
        -----------

        sequence_length:  
        """
        return _modshogun.SparseSpatialSampleStringKernel_set_t(self, *args)

    def get_t(self):
        """
        get_t(self) ->  int

        get t 
        """
        return _modshogun.SparseSpatialSampleStringKernel_get_t(self)

SparseSpatialSampleStringKernel_swigregister = _modshogun.SparseSpatialSampleStringKernel_swigregister
SparseSpatialSampleStringKernel_swigregister(SparseSpatialSampleStringKernel)

LOGSUM_TBL = _modshogun.LOGSUM_TBL
class LocalAlignmentStringKernel(StringCharKernel):
    """
    The LocalAlignmentString kernel compares two sequences through all
    possible local alignments between the two sequences.

    The implementation is taken fromhttp://www.mloss.org/software/view/40/
    and only adjusted to work with shogun.

    C++ includes: LocalAlignmentStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalAlignmentStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalAlignmentStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 0) -> LocalAlignmentStringKernel
        __init__(self) -> LocalAlignmentStringKernel
        __init__(self, l, r, opening = 12, extension = 2) -> LocalAlignmentStringKernel
        __init__(self, l, r, opening = 12) -> LocalAlignmentStringKernel
        __init__(self, l, r) -> LocalAlignmentStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        opening:  gap opening penalty

        extension:  gap extension penalty 
        """
        this = _modshogun.new_LocalAlignmentStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LocalAlignmentStringKernel
    __del__ = lambda self : None;
LocalAlignmentStringKernel_swigregister = _modshogun.LocalAlignmentStringKernel_swigregister
LocalAlignmentStringKernel_swigregister(LocalAlignmentStringKernel)

class LocalityImprovedStringKernel(StringCharKernel):
    """
    The LocalityImprovedString kernel is inspired by the polynomial
    kernel. Comparing neighboring stracters it puts emphasize on local
    features.

    It can be defined as \\[ K({\\bf x},{\\bf
    x'})=\\left(\\sum_{i=0}^{T-1}\\left(\\sum_{j=-l}^{+l}w_jI_{i+j}({\\bf
    x},{\\bf x'})\\right)^{d_1}\\right)^{d_2}, \\] where $
    I_i({\\bf x},{\\bf x'})=1$ if $x_i=x'_i$ and 0 otherwise.

    C++ includes: LocalityImprovedStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalityImprovedStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalityImprovedStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LocalityImprovedStringKernel
        __init__(self, size, length, inner_degree, outer_degree) -> LocalityImprovedStringKernel
        __init__(self, l, r, length, inner_degree, outer_degree) -> LocalityImprovedStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        length:  length

        inner_degree:  inner degree

        outer_degree:  outer degree 
        """
        this = _modshogun.new_LocalityImprovedStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LocalityImprovedStringKernel
    __del__ = lambda self : None;
LocalityImprovedStringKernel_swigregister = _modshogun.LocalityImprovedStringKernel_swigregister
LocalityImprovedStringKernel_swigregister(LocalityImprovedStringKernel)

class MatchWordStringKernel(StringWordKernel):
    """
    The class MatchWordStringKernel computes a variant of the polynomial
    kernel on strings of same length converted to a word alphabet.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= \\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: MatchWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MatchWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MatchWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MatchWordStringKernel
        __init__(self, size, d) -> MatchWordStringKernel
        __init__(self, l, r, degree) -> MatchWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _modshogun.new_MatchWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MatchWordStringKernel
    __del__ = lambda self : None;
MatchWordStringKernel_swigregister = _modshogun.MatchWordStringKernel_swigregister
MatchWordStringKernel_swigregister(MatchWordStringKernel)

class MultitaskKernelNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    This effectively normalizes the vectors in feature space to norm 1
    (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\gamma(task({\\bf
    x}),task({\\bf x'})) k({\\bf x},{\\bf x'}) \\]

    C++ includes: MultitaskKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelNormalizer
        __init__(self, task_vector) -> MultitaskKernelNormalizer

        default constructor

        Parameters:
        -----------

        task_vector:  task vector with containing task_id for each example 
        """
        this = _modshogun.new_MultitaskKernelNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultitaskKernelNormalizer
    __del__ = lambda self : None;
    def get_num_unique_tasks(self, *args):
        """
        get_num_unique_tasks(self, vec) ->  int

        helper routine

        Parameters:
        -----------

        vec:  vector with containing task_id for each example

        number of unique task ids 
        """
        return _modshogun.MultitaskKernelNormalizer_get_num_unique_tasks(self, *args)

    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _modshogun.MultitaskKernelNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _modshogun.MultitaskKernelNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelNormalizer_set_task_vector(self, *args)

    def get_task_similarity(self, *args):
        """
        get_task_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _modshogun.MultitaskKernelNormalizer_get_task_similarity(self, *args)

    def set_task_similarity(self, *args):
        """
        set_task_similarity(self, task_lhs, task_rhs, similarity)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity:  similarity between tasks 
        """
        return _modshogun.MultitaskKernelNormalizer_set_task_similarity(self, *args)

    def KernelNormalizerToMultitaskKernelNormalizer(self, *args):
        """
        KernelNormalizerToMultitaskKernelNormalizer(self, n) -> MultitaskKernelNormalizer

        convert generic kernel normalizer object into
        CMultitaskKernelNormalizer

        converted CMultitaskKernelNormalizer object 
        """
        return _modshogun.MultitaskKernelNormalizer_KernelNormalizerToMultitaskKernelNormalizer(self, *args)

MultitaskKernelNormalizer_swigregister = _modshogun.MultitaskKernelNormalizer_swigregister
MultitaskKernelNormalizer_swigregister(MultitaskKernelNormalizer)

class MultitaskKernelMklNormalizer(KernelNormalizer):
    """
    Base-class for parameterized Kernel Normalizers.

    C++ includes: MultitaskKernelMklNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMklNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMklNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def get_beta(self, *args):
        """
        get_beta(self, idx) -> float

        Parameters:

        idx:  index of MKL weight to get 
        """
        return _modshogun.MultitaskKernelMklNormalizer_get_beta(self, *args)

    def set_beta(self, *args):
        """
        set_beta(self, idx, weight)

        Parameters:

        idx:  index of MKL weight to set

        weight:  MKL weight to set 
        """
        return _modshogun.MultitaskKernelMklNormalizer_set_beta(self, *args)

    def get_num_betas(self):
        """
        get_num_betas(self) ->  int

        number of sub-kernel weights for MKL 
        """
        return _modshogun.MultitaskKernelMklNormalizer_get_num_betas(self)

    __swig_destroy__ = _modshogun.delete_MultitaskKernelMklNormalizer
    __del__ = lambda self : None;
MultitaskKernelMklNormalizer_swigregister = _modshogun.MultitaskKernelMklNormalizer_swigregister
MultitaskKernelMklNormalizer_swigregister(MultitaskKernelMklNormalizer)

class CTaxonomy(SGObject):
    """
    CTaxonomy is used to describe hierarchical structure between tasks.

    C++ includes: MultitaskKernelTreeNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CTaxonomy, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CTaxonomy, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> CTaxonomy

        default constructor 
        """
        this = _modshogun.new_CTaxonomy()
        try: self.this.append(this)
        except: self.this = this
    def set_root_beta(self, *args):
        """
        set_root_beta(self, beta)

        set root weight

        Parameters:
        -----------

        beta:  weight 
        """
        return _modshogun.CTaxonomy_set_root_beta(self, *args)

    def get_id(self, *args):
        """
        get_id(self, name) ->  int

        translates name to id

        Parameters:
        -----------

        name:  name of task

        id 
        """
        return _modshogun.CTaxonomy_get_id(self, *args)

    def compute_node_similarity(self, *args):
        """
        compute_node_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _modshogun.CTaxonomy_compute_node_similarity(self, *args)

    def update_task_histogram(self, *args):
        """
        update_task_histogram(self, task_vector_lhs)

        keep track of how many elements each task has

        Parameters:
        -----------

        task_vector_lhs:  vector of task ids for examples 
        """
        return _modshogun.CTaxonomy_update_task_histogram(self, *args)

    def get_num_nodes(self):
        """
        get_num_nodes(self) ->  int

        number of nodes 
        """
        return _modshogun.CTaxonomy_get_num_nodes(self)

    def get_num_leaves(self):
        """
        get_num_leaves(self) ->  int

        number of leaves 
        """
        return _modshogun.CTaxonomy_get_num_leaves(self)

    def get_node_weight(self, *args):
        """
        get_node_weight(self, idx) -> float

        weight of node with identifier idx 
        """
        return _modshogun.CTaxonomy_get_node_weight(self, *args)

    def set_node_weight(self, *args):
        """
        set_node_weight(self, idx, weight)

        Parameters:

        idx:  node id

        weight:  weight to set 
        """
        return _modshogun.CTaxonomy_set_node_weight(self, *args)

    def get_name2id(self):
        """
        get_name2id(self) -> std::map<(std::string,int32_t)>

        mapping from name to id 
        """
        return _modshogun.CTaxonomy_get_name2id(self)

    def get_id_by_name(self, *args):
        """
        get_id_by_name(self, name) ->  int

        translate name to id

        Parameters:
        -----------

        name:  node name

        id 
        """
        return _modshogun.CTaxonomy_get_id_by_name(self, *args)

    __swig_destroy__ = _modshogun.delete_CTaxonomy
    __del__ = lambda self : None;
CTaxonomy_swigregister = _modshogun.CTaxonomy_swigregister
CTaxonomy_swigregister(CTaxonomy)

class MultitaskKernelTreeNormalizer(MultitaskKernelMklNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function based on taxonomy.

    C++ includes: MultitaskKernelTreeNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelTreeNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelTreeNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelTreeNormalizer
        __init__(self, task_lhs, task_rhs, tax) -> MultitaskKernelTreeNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side

        tax:  taxonomy 
        """
        this = _modshogun.new_MultitaskKernelTreeNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultitaskKernelTreeNormalizer
    __del__ = lambda self : None;
    def update_cache(self):
        """
        update_cache(self)

        update cache 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_update_cache(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_set_task_vector_lhs(self, *args)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_set_task_vector(self, *args)

    def get_node_similarity(self, *args):
        """
        get_node_similarity(self, node_lhs, node_rhs) -> float

        Parameters:

        node_lhs:  node_id on left hand side

        node_rhs:  node_id on right hand side

        similarity between nodes 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_get_node_similarity(self, *args)

    def set_node_similarity(self, *args):
        """
        set_node_similarity(self, node_lhs, node_rhs, similarity)

        Parameters:

        node_lhs:  node_id on left hand side

        node_rhs:  node_id on right hand side

        similarity:  similarity between nodes 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_set_node_similarity(self, *args)

    def KernelNormalizerToMultitaskKernelTreeNormalizer(self, *args):
        """
        KernelNormalizerToMultitaskKernelTreeNormalizer(self, n) -> MultitaskKernelTreeNormalizer

        casts kernel normalizer to multitask kernel tree normalizer

        Parameters:
        -----------

        n:  kernel normalizer to cast 
        """
        return _modshogun.MultitaskKernelTreeNormalizer_KernelNormalizerToMultitaskKernelTreeNormalizer(self, *args)

MultitaskKernelTreeNormalizer_swigregister = _modshogun.MultitaskKernelTreeNormalizer_swigregister
MultitaskKernelTreeNormalizer_swigregister(MultitaskKernelTreeNormalizer)

class MultitaskKernelMaskNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    The user defines a set of active tasks. Subsequently, only
    similarities between active tasks are taken into account. Kernel
    entries between tasks of which at least one is not an active tasks are
    set to zero.

    \\[ K_S(x,y)=\\left\\{\\begin{array}{cl} K_B(x,y), &
    \\mbox{if } t(x) \\in S \\wedge t(y) \\in S\\\\ 0, &
    \\mbox{else} \\end{array}\\right. \\]

    C++ includes: MultitaskKernelMaskNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMaskNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMaskNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelMaskNormalizer
        __init__(self, task_lhs, task_rhs, active_tasks_vec) -> MultitaskKernelMaskNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side

        active_tasks_vec:  
        """
        this = _modshogun.new_MultitaskKernelMaskNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultitaskKernelMaskNormalizer
    __del__ = lambda self : None;
    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_set_task_vector(self, *args)

    def get_similarity(self, *args):
        """
        get_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_get_similarity(self, *args)

    def get_active_tasks(self):
        """
        get_active_tasks(self) -> std::vector<(int32_t)>

        list of active task ids 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_get_active_tasks(self)

    def get_normalization_constant(self):
        """
        get_normalization_constant(self) -> float

        normalization constant 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_get_normalization_constant(self)

    def set_normalization_constant(self, *args):
        """
        set_normalization_constant(self, constant) -> float

        Parameters:

        constant:  normalization constant 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_set_normalization_constant(self, *args)

    def KernelNormalizerToMultitaskKernelMaskNormalizer(self, *args):
        """
        KernelNormalizerToMultitaskKernelMaskNormalizer(self, n) -> MultitaskKernelMaskNormalizer

        casts kernel normalizer to multitask kernel mask normalizer

        Parameters:
        -----------

        n:  kernel normalizer to cast 
        """
        return _modshogun.MultitaskKernelMaskNormalizer_KernelNormalizerToMultitaskKernelMaskNormalizer(self, *args)

MultitaskKernelMaskNormalizer_swigregister = _modshogun.MultitaskKernelMaskNormalizer_swigregister
MultitaskKernelMaskNormalizer_swigregister(MultitaskKernelMaskNormalizer)

class MultitaskKernelMaskPairNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    Normalization is based on a mask that is defined by a number of pair
    of tasks.

    C++ includes: MultitaskKernelMaskPairNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMaskPairNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMaskPairNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelMaskPairNormalizer
        __init__(self, task_vector_, active_pairs_) -> MultitaskKernelMaskPairNormalizer

        default constructor

        Parameters:
        -----------

        task_vector_:

        active_pairs_:  
        """
        this = _modshogun.new_MultitaskKernelMaskPairNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultitaskKernelMaskPairNormalizer
    __del__ = lambda self : None;
    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_set_task_vector(self, *args)

    def get_similarity(self, *args):
        """
        get_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_get_similarity(self, *args)

    def get_active_pairs(self):
        """
        get_active_pairs(self) -> std::vector<(std::pair<(int32_t,int32_t)>)>

        vector of active pairs 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_get_active_pairs(self)

    def get_normalization_constant(self):
        """
        get_normalization_constant(self) -> float

        normalization constant 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_get_normalization_constant(self)

    def set_normalization_constant(self, *args):
        """
        set_normalization_constant(self, constant) -> float

        Parameters:

        constant:  normalization constant 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_set_normalization_constant(self, *args)

    def KernelNormalizerToMultitaskKernelMaskPairNormalizer(self, *args):
        """
        KernelNormalizerToMultitaskKernelMaskPairNormalizer(self, n) -> MultitaskKernelMaskPairNormalizer

        casts kernel normalizer to multitask kernel mask normalizer

        Parameters:
        -----------

        n:  kernel normalizer to cast 
        """
        return _modshogun.MultitaskKernelMaskPairNormalizer_KernelNormalizerToMultitaskKernelMaskPairNormalizer(self, *args)

MultitaskKernelMaskPairNormalizer_swigregister = _modshogun.MultitaskKernelMaskPairNormalizer_swigregister
MultitaskKernelMaskPairNormalizer_swigregister(MultitaskKernelMaskPairNormalizer)

class MultitaskKernelPlifNormalizer(MultitaskKernelMklNormalizer):
    """
    The MultitaskKernel allows learning a piece-wise linear function
    (PLIF) via MKL.

    C++ includes: MultitaskKernelPlifNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelPlifNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelPlifNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelPlifNormalizer
        __init__(self, support_, task_vector) -> MultitaskKernelPlifNormalizer

        constructor 
        """
        this = _modshogun.new_MultitaskKernelPlifNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    def get_num_unique_tasks(self, *args):
        """
        get_num_unique_tasks(self, vec) ->  int

        helper routine

        Parameters:
        -----------

        vec:  vector with containing task_id for each example

        number of unique task ids 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_get_num_unique_tasks(self, *args)

    __swig_destroy__ = _modshogun.delete_MultitaskKernelPlifNormalizer
    __del__ = lambda self : None;
    def update_cache(self):
        """
        update_cache(self)

        update cache 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_update_cache(self)

    def compute_task_similarity(self, *args):
        """
        compute_task_similarity(self, task_a, task_b) -> float

        derive similarity from distance with plif 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_compute_task_similarity(self, *args)

    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> std::vector<(int32_t)>

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_set_task_vector(self, *args)

    def get_task_distance(self, *args):
        """
        get_task_distance(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        distance between tasks 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_get_task_distance(self, *args)

    def set_task_distance(self, *args):
        """
        set_task_distance(self, task_lhs, task_rhs, distance)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        distance:  distance between tasks 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_set_task_distance(self, *args)

    def get_task_similarity(self, *args):
        """
        get_task_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_get_task_similarity(self, *args)

    def set_task_similarity(self, *args):
        """
        set_task_similarity(self, task_lhs, task_rhs, similarity)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity:  similarity between tasks 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_set_task_similarity(self, *args)

    def KernelNormalizerToMultitaskKernelPlifNormalizer(self, *args):
        """
        KernelNormalizerToMultitaskKernelPlifNormalizer(self, n) -> MultitaskKernelPlifNormalizer

        casts kernel normalizer to multitask kernel plif normalizer

        Parameters:
        -----------

        n:  kernel normalizer to cast 
        """
        return _modshogun.MultitaskKernelPlifNormalizer_KernelNormalizerToMultitaskKernelPlifNormalizer(self, *args)

MultitaskKernelPlifNormalizer_swigregister = _modshogun.MultitaskKernelPlifNormalizer_swigregister
MultitaskKernelPlifNormalizer_swigregister(MultitaskKernelPlifNormalizer)

class OligoStringKernel(StringCharKernel):
    """
    This class offers access to the Oligo Kernel introduced by Meinicke et
    al. in 2004.

    The class has functions to preprocess the data such that the kernel
    computation can be pursued faster. The kernel function is then
    kernelOligoFast or kernelOligo.

    Requires significant speedup, should be working but as is might be
    applicable only to academic small scale problems:

    the kernel should only ever see encoded sequences, which however
    requires another OligoFeatures object (using CSimpleFeatures of pairs)

    Uses CSqrtDiagKernelNormalizer, as the vanilla kernel seems to be very
    diagonally dominant.

    C++ includes: OligoStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OligoStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OligoStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> OligoStringKernel
        __init__(self, cache_size, k, width) -> OligoStringKernel

        Constructor

        Parameters:
        -----------

        cache_size:  cache size for kernel

        k:  k-mer length

        width:  - equivalent to 2*sigma^2 
        """
        this = _modshogun.new_OligoStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_OligoStringKernel
    __del__ = lambda self : None;
    def compute(self, *args):
        """
        compute(self, x, y) -> float

        compute kernel function for features a and b idx_{a,b} denote the
        index of the feature vectors in the corresponding feature object

        abstract base method

        Parameters:
        -----------

        x:  index a

        y:  index b

        computed kernel function at indices a,b 
        """
        return _modshogun.OligoStringKernel_compute(self, *args)

OligoStringKernel_swigregister = _modshogun.OligoStringKernel_swigregister
OligoStringKernel_swigregister(OligoStringKernel)

class PolyKernel(DotKernel):
    """
    Computes the standard polynomial kernel on CDotFeatures.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= ({\\bf x}\\cdot {\\bf x'}+c)^d
    \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> PolyKernel
        __init__(self, l, r, d, inhom, size = 10) -> PolyKernel
        __init__(self, l, r, d, inhom) -> PolyKernel
        __init__(self, size, degree, inhomogene = True) -> PolyKernel
        __init__(self, size, degree) -> PolyKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _modshogun.new_PolyKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PolyKernel
    __del__ = lambda self : None;
PolyKernel_swigregister = _modshogun.PolyKernel_swigregister
PolyKernel_swigregister(PolyKernel)

class PolyMatchStringKernel(StringCharKernel):
    """
    The class PolyMatchStringKernel computes a variant of the polynomial
    kernel on strings of same length.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyMatchStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyMatchStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyMatchStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> PolyMatchStringKernel
        __init__(self, size, degree, inhomogene) -> PolyMatchStringKernel
        __init__(self, l, r, degree, inhomogene) -> PolyMatchStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _modshogun.new_PolyMatchStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PolyMatchStringKernel
    __del__ = lambda self : None;
    def set_rescaling_enabled(self, *args):
        """
        set_rescaling_enabled(self, n)

        enable rescaling by length of feature vector

        Parameters:
        -----------

        n:  true to enable 
        """
        return _modshogun.PolyMatchStringKernel_set_rescaling_enabled(self, *args)

    def get_rescaling_enabled(self):
        """
        get_rescaling_enabled(self) -> bool

        return rescaling parameter

        true if rescaling is enabled 
        """
        return _modshogun.PolyMatchStringKernel_get_rescaling_enabled(self)

PolyMatchStringKernel_swigregister = _modshogun.PolyMatchStringKernel_swigregister
PolyMatchStringKernel_swigregister(PolyMatchStringKernel)

class PowerKernel(Kernel):
    """
    Power kernel.

    Formally described as

    \\[ K(x,x') = - \\| x-x' \\|^{degree} \\]

    C++ includes: PowerKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PowerKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PowerKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> PowerKernel
        __init__(self, cache, degree, dist) -> PowerKernel
        __init__(self, l, r, degree, dist) -> PowerKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        degree:  kernel parameter degree

        dist:  distance to be used 
        """
        this = _modshogun.new_PowerKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PowerKernel
    __del__ = lambda self : None;
PowerKernel_swigregister = _modshogun.PowerKernel_swigregister
PowerKernel_swigregister(PowerKernel)

class LogKernel(Kernel):
    """
    Log kernel.

    Formally described as

    \\[ K(x,x') = - log (\\| x-x' \\|^{degree} + 1) \\]

    C++ includes: LogKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LogKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LogKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LogKernel
        __init__(self, cache, degree, dist) -> LogKernel
        __init__(self, l, r, degree, dist) -> LogKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        degree:  kernel parameter degree

        dist:  distance to be used 
        """
        this = _modshogun.new_LogKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LogKernel
    __del__ = lambda self : None;
LogKernel_swigregister = _modshogun.LogKernel_swigregister
LogKernel_swigregister(LogKernel)

class GaussianMatchStringKernel(StringCharKernel):
    """
    The class GaussianMatchStringKernel computes a variant of the Gaussian
    kernel on strings of same length.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})=
    e^{-\\frac{\\left(x-x'\\right)^2}{w}} \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: GaussianMatchStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianMatchStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianMatchStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianMatchStringKernel
        __init__(self, size, width) -> GaussianMatchStringKernel
        __init__(self, l, r, width) -> GaussianMatchStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width 
        """
        this = _modshogun.new_GaussianMatchStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GaussianMatchStringKernel
    __del__ = lambda self : None;
    def register_params(self):
        """
        register_params(self)

        register the parameters 
        """
        return _modshogun.GaussianMatchStringKernel_register_params(self)

GaussianMatchStringKernel_swigregister = _modshogun.GaussianMatchStringKernel_swigregister
GaussianMatchStringKernel_swigregister(GaussianMatchStringKernel)

class SNPStringKernel(StringCharKernel):
    """
    The class SNPStringKernel computes a variant of the polynomial kernel
    on strings of same length.

    It is computed as FIXME

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^{L-1} I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: SNPStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SNPStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SNPStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SNPStringKernel
        __init__(self, size, degree, win_len, inhomogene) -> SNPStringKernel
        __init__(self, l, r, degree, win_len, inhomogene) -> SNPStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        win_len:  length of local window

        inhomogene:  whether inhomogeneous poly 
        """
        this = _modshogun.new_SNPStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SNPStringKernel
    __del__ = lambda self : None;
    def set_minor_base_string(self, *args):
        """
        set_minor_base_string(self, str)

        set the base string for minor aleles

        Parameters:
        -----------

        str:  minor freq. string 
        """
        return _modshogun.SNPStringKernel_set_minor_base_string(self, *args)

    def set_major_base_string(self, *args):
        """
        set_major_base_string(self, str)

        set the base string for major aleles

        Parameters:
        -----------

        str:  major freq. string 
        """
        return _modshogun.SNPStringKernel_set_major_base_string(self, *args)

    def get_minor_base_string(self):
        """
        get_minor_base_string(self) -> str

        get the base string for minor aleles

        minor freq. string 
        """
        return _modshogun.SNPStringKernel_get_minor_base_string(self)

    def get_major_base_string(self):
        """
        get_major_base_string(self) -> str

        get the base string for major aleles

        major freq. string 
        """
        return _modshogun.SNPStringKernel_get_major_base_string(self)

    def obtain_base_strings(self):
        """
        obtain_base_strings(self)

        compute the minor / major alele base strings 
        """
        return _modshogun.SNPStringKernel_obtain_base_strings(self)

    def register_params(self):
        """
        register_params(self)

        Separate the function of parameter registration This can be the first
        stage of a *general* framework for cross-validation or other
        parameter-based operations 
        """
        return _modshogun.SNPStringKernel_register_params(self)

SNPStringKernel_swigregister = _modshogun.SNPStringKernel_swigregister
SNPStringKernel_swigregister(SNPStringKernel)

class RegulatoryModulesStringKernel(StringCharKernel):
    """
    The Regulaty Modules kernel, based on the WD kernel, as published in
    Schultheiss et al., Bioinformatics (2009) on regulatory sequences.

    C++ includes: RegulatoryModulesStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RegulatoryModulesStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RegulatoryModulesStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RegulatoryModulesStringKernel
        __init__(self, size, width, degree, shift, window) -> RegulatoryModulesStringKernel
        __init__(self, lstr, rstr, lpos, rpos, width, degree, shift, window, 
            size = 10) -> RegulatoryModulesStringKernel
        __init__(self, lstr, rstr, lpos, rpos, width, degree, shift, window) -> RegulatoryModulesStringKernel

        constructor

        Parameters:
        -----------

        lstr:  string features of left-hand side

        rstr:  string features of right-hand side

        lpos:  motif positions on lhs

        rpos:  motif positions on rhs

        width:  width of gaussian kernel

        degree:  degree of wds kernel

        shift:  shift of wds kernel

        window:  size of window around motifs to compute wds kernels on

        size:  cache size 
        """
        this = _modshogun.new_RegulatoryModulesStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_RegulatoryModulesStringKernel
    __del__ = lambda self : None;
    def set_motif_positions(self, *args):
        """
        set_motif_positions(self, positions_lhs, positions_rhs)

        set motif positions

        Parameters:
        -----------

        positions_lhs:  motif positions on lhs

        positions_rhs:  motif positions on rhs 
        """
        return _modshogun.RegulatoryModulesStringKernel_set_motif_positions(self, *args)

    def register_params(self):
        """
        register_params(self)

        Separate the function of parameter registration This can be the first
        stage of a *general* framework for cross-validation or other
        parameter-based operations 
        """
        return _modshogun.RegulatoryModulesStringKernel_register_params(self)

RegulatoryModulesStringKernel_swigregister = _modshogun.RegulatoryModulesStringKernel_swigregister
RegulatoryModulesStringKernel_swigregister(RegulatoryModulesStringKernel)

class PolyMatchWordStringKernel(StringWordKernel):
    """
    The class PolyMatchWordStringKernel computes a variant of the
    polynomial kernel on word-features.

    It makes sense for strings of same length mapped to word features and
    is computed as

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyMatchWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyMatchWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyMatchWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> PolyMatchWordStringKernel
        __init__(self, size, degree, inhomogene) -> PolyMatchWordStringKernel
        __init__(self, l, r, degree, inhomogene) -> PolyMatchWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _modshogun.new_PolyMatchWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PolyMatchWordStringKernel
    __del__ = lambda self : None;
PolyMatchWordStringKernel_swigregister = _modshogun.PolyMatchWordStringKernel_swigregister
PolyMatchWordStringKernel_swigregister(PolyMatchWordStringKernel)

class SalzbergWordStringKernel(StringWordKernel):
    """
    The SalzbergWordString kernel implements the Salzberg kernel.

    It is described in

    Engineering Support Vector Machine Kernels That Recognize Translation
    Initiation Sites A. Zien, G.Raetsch, S. Mika, B. Schoelkopf, T.
    Lengauer, K.-R. Mueller

    C++ includes: SalzbergWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SalzbergWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SalzbergWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SalzbergWordStringKernel
        __init__(self, size, pie, labels = None) -> SalzbergWordStringKernel
        __init__(self, size, pie) -> SalzbergWordStringKernel
        __init__(self, l, r, pie, labels = None) -> SalzbergWordStringKernel
        __init__(self, l, r, pie) -> SalzbergWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        pie:  the plugin estimate

        labels:  optional labels to set prior from 
        """
        this = _modshogun.new_SalzbergWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SalzbergWordStringKernel
    __del__ = lambda self : None;
    def set_prior_probs(self, *args):
        """
        set_prior_probs(self, pos_prior_, neg_prior_)

        set prior probs

        Parameters:
        -----------

        pos_prior_:  positive prior

        neg_prior_:  negative prior 
        """
        return _modshogun.SalzbergWordStringKernel_set_prior_probs(self, *args)

    def set_prior_probs_from_labels(self, *args):
        """
        set_prior_probs_from_labels(self, labels)

        set prior probs from labels

        Parameters:
        -----------

        labels:  labels to set prior probabilites from 
        """
        return _modshogun.SalzbergWordStringKernel_set_prior_probs_from_labels(self, *args)

SalzbergWordStringKernel_swigregister = _modshogun.SalzbergWordStringKernel_swigregister
SalzbergWordStringKernel_swigregister(SalzbergWordStringKernel)

class SigmoidKernel(DotKernel):
    """
    The standard Sigmoid kernel computed on dense real valued features.

    Formally, it is computed as

    \\[ k({\\bf x},{\\bf x'})=\\mbox{tanh}(\\gamma {\\bf
    x}\\cdot{\\bf x'}+c) \\]

    C++ includes: SigmoidKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SigmoidKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SigmoidKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SigmoidKernel
        __init__(self, size, gamma, coef0) -> SigmoidKernel
        __init__(self, l, r, size, gamma, coef0) -> SigmoidKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        size:  cache size

        gamma:  gamma

        coef0:  coefficient 0 
        """
        this = _modshogun.new_SigmoidKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SigmoidKernel
    __del__ = lambda self : None;
SigmoidKernel_swigregister = _modshogun.SigmoidKernel_swigregister
SigmoidKernel_swigregister(SigmoidKernel)

class SimpleLocalityImprovedStringKernel(StringCharKernel):
    """
    SimpleLocalityImprovedString kernel, is a ``simplified'' and better
    performing version of the Locality improved kernel.

    It can be defined as

    \\[ K({\\bf x},{\\bf
    x'})=\\left(\\sum_{i=0}^{T-1}\\left(\\sum_{j=-l}^{+l}w_jI_{i+j}({\\bf
    x},{\\bf x'})\\right)^{d_1}\\right)^{d_2}, \\] where $
    I_i({\\bf x},{\\bf x'})=1$ if $x_i=x'_i$ and 0 otherwise.

    C++ includes: SimpleLocalityImprovedStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleLocalityImprovedStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleLocalityImprovedStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SimpleLocalityImprovedStringKernel
        __init__(self, size, length, inner_degree, outer_degree) -> SimpleLocalityImprovedStringKernel
        __init__(self, l, r, length, inner_degree, outer_degree) -> SimpleLocalityImprovedStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        length:  length

        inner_degree:  inner degree

        outer_degree:  outer degree 
        """
        this = _modshogun.new_SimpleLocalityImprovedStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SimpleLocalityImprovedStringKernel
    __del__ = lambda self : None;
SimpleLocalityImprovedStringKernel_swigregister = _modshogun.SimpleLocalityImprovedStringKernel_swigregister
SimpleLocalityImprovedStringKernel_swigregister(SimpleLocalityImprovedStringKernel)

class SphericalKernel(Kernel):
    """
    Spherical kernel.

    Formally described as

    \\[ k(x, y) = 1 - \\frac{3}{2} \\frac{|x-y|}{\\sigma} +
    \\frac{1}{2} \\left( \\frac{|x-y|}{\\sigma} \\right)^3
    \\mbox{if}~ |x-y| \\leq \\sigma \\mbox{, zero otherwise} \\]

    C++ includes: SphericalKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SphericalKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SphericalKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SphericalKernel
        __init__(self, size, sigma, dist) -> SphericalKernel
        __init__(self, l, r, sigma, dist) -> SphericalKernel

        constructor

        Parameters:
        -----------

        l:  features of left-side

        r:  features of right-side

        sigma:  kernel parameter sigma

        dist:  distance 
        """
        this = _modshogun.new_SphericalKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    def init(self, *args):
        """
        init(self, l, r) -> bool
        init(self)

        Do basic initialisations like default settings and registering
        parameters 
        """
        return _modshogun.SphericalKernel_init(self, *args)

    def set_sigma(self, *args):
        """
        set_sigma(self, s)

        set the kernel's sigma

        Parameters:
        -----------

        s:  kernel sigma 
        """
        return _modshogun.SphericalKernel_set_sigma(self, *args)

    def get_sigma(self):
        """
        get_sigma(self) -> float

        return the kernel's sigma

        kernel sigma 
        """
        return _modshogun.SphericalKernel_get_sigma(self)

    __swig_destroy__ = _modshogun.delete_SphericalKernel
    __del__ = lambda self : None;
SphericalKernel_swigregister = _modshogun.SphericalKernel_swigregister
SphericalKernel_swigregister(SphericalKernel)

class SplineKernel(DotKernel):
    """
    Computes the Spline Kernel function which is the cubic polynomial.

    The formula is:

    \\[ k({\\bf x},{\\bf x'})= 1 + {\\bf x} \\cdot {\\bf x'} +
    {\\bf x} \\cdot {\\bf x'} \\cdot \\mbox{min}(\\bf x,
    \\bf x') - \\frac{\\bf x + \\bf x'}{2} \\cdot
    \\mbox{min}(\\bf x, \\bf x')^2 + \\frac{ \\mbox{min}(\\bf
    x, \\bf x')^3}{3} \\]

    C++ includes: SplineKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SplineKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SplineKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SplineKernel
        __init__(self, l, r) -> SplineKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _modshogun.new_SplineKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SplineKernel
    __del__ = lambda self : None;
SplineKernel_swigregister = _modshogun.SplineKernel_swigregister
SplineKernel_swigregister(SplineKernel)

class SqrtDiagKernelNormalizer(KernelNormalizer):
    """
    SqrtDiagKernelNormalizer divides by the Square Root of the product of
    the diagonal elements.

    This effectively normalizes the vectors in feature space to norm 1
    (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{\\sqrt{k({\\bf x},{\\bf x})k({\\bf x'},{\\bf x'})}}
    \\]

    C++ includes: SqrtDiagKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SqrtDiagKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SqrtDiagKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, use_opt_diag = False): 
        """
        __init__(self, use_opt_diag = False) -> SqrtDiagKernelNormalizer
        __init__(self) -> SqrtDiagKernelNormalizer

        default constructor

        Parameters:
        -----------

        use_opt_diag:  - some kernels support faster diagonal compuation via
        compute_diag(idx), this flag enables this 
        """
        this = _modshogun.new_SqrtDiagKernelNormalizer(use_opt_diag)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SqrtDiagKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _modshogun.SqrtDiagKernelNormalizer_alloc_and_compute_diag(self, *args)

SqrtDiagKernelNormalizer_swigregister = _modshogun.SqrtDiagKernelNormalizer_swigregister
SqrtDiagKernelNormalizer_swigregister(SqrtDiagKernelNormalizer)

class TanimotoKernelNormalizer(KernelNormalizer):
    """
    TanimotoKernelNormalizer performs kernel normalization inspired by the
    Tanimoto coefficient (seehttp://en.wikipedia.org/wiki/Jaccard_index )

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{k({\\bf x},{\\bf x})+k({\\bf x'},{\\bf x'})-k({\\bf
    x},{\\bf x'})} \\]

    C++ includes: TanimotoKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TanimotoKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TanimotoKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, use_opt_diag = False): 
        """
        __init__(self, use_opt_diag = False) -> TanimotoKernelNormalizer
        __init__(self) -> TanimotoKernelNormalizer

        default constructor

        Parameters:
        -----------

        use_opt_diag:  - some kernels support faster diagonal compuation via
        compute_diag(idx), this flag enables this 
        """
        this = _modshogun.new_TanimotoKernelNormalizer(use_opt_diag)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_TanimotoKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _modshogun.TanimotoKernelNormalizer_alloc_and_compute_diag(self, *args)

TanimotoKernelNormalizer_swigregister = _modshogun.TanimotoKernelNormalizer_swigregister
TanimotoKernelNormalizer_swigregister(TanimotoKernelNormalizer)

class TensorProductPairKernel(DotKernel):
    """
    Computes the Tensor Product Pair Kernel (TPPK).

    Formally, it computes

    \\[ k_{\\mbox{tppk}}(({\\bf a},{\\bf b}), ({\\bf c},{\\bf
    d}))= k({\\bf a}, {\\bf c})\\cdot k({\\bf b}, {\\bf c}) +
    k({\\bf a},{\\bf d})\\cdot k({\\bf b}, {\\bf c}) \\]

    It is defined on pairs of inputs and a subkernel $k$. The subkernel
    has to be given on initialization. The pairs are specified via indizes
    (ab)using 2-dimensional integer features.

    Its feature space $\\Phi_{\\mbox{tppk}}$ is the tensor product of
    the feature spaces of the subkernel $k(.,.)$ on its input.

    It is often used in bioinformatics, e.g., to predict protein-protein
    interactions.

    C++ includes: TensorProductPairKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TensorProductPairKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TensorProductPairKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> TensorProductPairKernel
        __init__(self, size, subkernel) -> TensorProductPairKernel
        __init__(self, l, r, subkernel) -> TensorProductPairKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        subkernel:  the subkernel 
        """
        this = _modshogun.new_TensorProductPairKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_TensorProductPairKernel
    __del__ = lambda self : None;
    def register_params(self):
        """
        register_params(self)

        Separate the function of parameter registration This can be the first
        stage of a *general* framework for cross-validation or other
        parameter-based operations 
        """
        return _modshogun.TensorProductPairKernel_register_params(self)

TensorProductPairKernel_swigregister = _modshogun.TensorProductPairKernel_swigregister
TensorProductPairKernel_swigregister(TensorProductPairKernel)

class TStudentKernel(Kernel):
    """
    Generalized T-Student kernel.

    Formally described as

    \\[ K(x,x') = \\frac{1}{1+\\| x-x' \\|^degree} \\] with
    degree=1 by default

    C++ includes: TStudentKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TStudentKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TStudentKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> TStudentKernel
        __init__(self, cache, d, dist) -> TStudentKernel
        __init__(self, l, r, d, dist) -> TStudentKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        d:  kernel parameter degree

        dist:  distance to be used 
        """
        this = _modshogun.new_TStudentKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_TStudentKernel
    __del__ = lambda self : None;
    def get_degree(self):
        """
        get_degree(self) -> float

        getter for degree parameter kernel parameter degree 
        """
        return _modshogun.TStudentKernel_get_degree(self)

    def set_degree(self, *args):
        """
        set_degree(self, value)

        setter for degree parameter

        Parameters:
        -----------

        value:  kernel parameter degree 
        """
        return _modshogun.TStudentKernel_set_degree(self, *args)

TStudentKernel_swigregister = _modshogun.TStudentKernel_swigregister
TStudentKernel_swigregister(TStudentKernel)

class WaveKernel(Kernel):
    """
    Wave kernel.

    Formally described as

    \\[ K(x,x') = \\frac{\\theta}{\\| x-x' \\|} \\sin
    \\frac{\\| x-x' \\|}{\\theta} \\]

    C++ includes: WaveKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WaveKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WaveKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WaveKernel
        __init__(self, cache, theta, dist) -> WaveKernel
        __init__(self, l, r, theta, dist) -> WaveKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        theta:  kernel parameter theta

        dist:  distance to be used 
        """
        this = _modshogun.new_WaveKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WaveKernel
    __del__ = lambda self : None;
WaveKernel_swigregister = _modshogun.WaveKernel_swigregister
WaveKernel_swigregister(WaveKernel)

class WaveletKernel(DotKernel):
    """
    the class WaveletKernel

    It is defined as

    \\[ k({\\bf x},({\\bf x'})=
    \\prod_{i=0}^{l}h(\\frac{(x-c)}{a})\\cdot h(\\frac{(x'-c)}{a})
    \\]

    Where $h(x)$ is the mother wavelet function

    \\[ h({\\bf x}=cos(1.75*x)\\cdot exp(\\frac{(-x^2)}{2}) \\]

    C++ includes: WaveletKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WaveletKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WaveletKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WaveletKernel
        __init__(self, size, Wdilation, Wtranslation) -> WaveletKernel
        __init__(self, l, r, size, Wdilation, Wtranslation) -> WaveletKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        size:  cache size

        Wdilation:  is Dilation coefficient

        Wtranslation:  is Translation coefficient 
        """
        this = _modshogun.new_WaveletKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WaveletKernel
    __del__ = lambda self : None;
WaveletKernel_swigregister = _modshogun.WaveletKernel_swigregister
WaveletKernel_swigregister(WaveletKernel)

class WeightedCommWordStringKernel(CommWordStringKernel):
    """
    The WeightedCommWordString kernel may be used to compute the weighted
    spectrum kernel (i.e. a spectrum kernel for 1 to K-mers, where each
    k-mer length is weighted by some coefficient $\\beta_k$) from
    strings that have been mapped into unsigned 16bit integers.

    These 16bit integers correspond to k-mers. To applicable in this
    kernel they need to be sorted (e.g. via the SortWordString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})=
    \\sum_{k=1}^K\\beta_k\\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation is especially tuned to small alphabets
    (like the 2-bit alphabet DNA), for which it enables spectrum kernels
    of order 8.

    For this kernel the linadd speedups are quite efficiently implemented
    using direct maps.

    C++ includes: WeightedCommWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [CommWordStringKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedCommWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [CommWordStringKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedCommWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WeightedCommWordStringKernel
        __init__(self, size, use_sign) -> WeightedCommWordStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> WeightedCommWordStringKernel
        __init__(self, l, r, use_sign = False) -> WeightedCommWordStringKernel
        __init__(self, l, r) -> WeightedCommWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _modshogun.new_WeightedCommWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WeightedCommWordStringKernel
    __del__ = lambda self : None;
    def merge_normal(self):
        """
        merge_normal(self)

        merge normal 
        """
        return _modshogun.WeightedCommWordStringKernel_merge_normal(self)

    def set_wd_weights(self):
        """
        set_wd_weights(self) -> bool

        set weighted degree weights

        if setting was successful 
        """
        return _modshogun.WeightedCommWordStringKernel_set_wd_weights(self)

    def set_weights(self, *args):
        """
        set_weights(self, w, d) -> bool

        set custom weights (swig compatible)

        Parameters:
        -----------

        w:  weights

        d:  degree (must match number of weights)

        if setting was successful 
        """
        return _modshogun.WeightedCommWordStringKernel_set_weights(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas, do_init = True) -> float
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas) -> float

        compute scoring

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        do_init:  if initialization shall be performed

        computed score 
        """
        return _modshogun.WeightedCommWordStringKernel_compute_scoring(self, *args)

WeightedCommWordStringKernel_swigregister = _modshogun.WeightedCommWordStringKernel_swigregister
WeightedCommWordStringKernel_swigregister(WeightedCommWordStringKernel)

class WeightedDegreePositionStringKernel(StringCharKernel):
    """
    The Weighted Degree Position String kernel (Weighted Degree kernel
    with shifts).

    The WD-shift kernel of order d compares two sequences ${\\bf x}$ and
    ${\\bf x'}$ of length L by summing all contributions of k-mer
    matches of lengths $k\\in\\{1,\\dots,d\\}$, weighted by
    coefficients $\\beta_k$ allowing for a positional tolerance of up to
    shift s.

    It is formally defined as \\begin{eqnarray*}
    &&\\!\\!\\!\\!\\!\\!\\!k({\\bf x}_i,{\\bf
    x}_j)=\\sum_{k=1}^d\\beta_k\\sum_{l=1}^{\\!\\!\\!\\!L-k+1\\!\\!\\!\\!}\\gamma_l\\sum_{\\begin{array}{c}s=0\\\\
    \\!\\!\\!\\!s+l\\leq
    L\\!\\!\\!\\!\\end{array}}^{S(l)}
    \\delta_s\\;\\mu_{k,l,s,{{\\bf x}_i},{{\\bf x}_j}},\\\\
    &&\\!\\!\\!\\!\\!\\!\\!\\!\\!\\! {\\footnotesize
    \\mu_{k,l,s,{{\\bf x}_i},{{\\bf x}_j}}\\!\\!\\!
    =\\!\\! I({\\bf u}_{k,l+s}({\\bf x}_i)\\! =\\!{\\bf
    u}_{k,l}({\\bf x}_j))\\! +\\!I({\\bf u}_{k,l}({\\bf
    x}_i)\\! =\\!{\\bf u}_{k,l+s}({\\bf x}_j))},\\nonumber
    \\end{eqnarray*} where $\\beta_j$ are the weighting coefficients
    of the j-mers, $\\gamma_l$ is a weighting over the position in the
    sequence, $\\delta_s=1/(2(s+1))$ is the weight assigned to shifts
    (in either direction) of extent s, and S(l) determines the shift range
    at position l.

    C++ includes: WeightedDegreePositionStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreePositionStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreePositionStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WeightedDegreePositionStringKernel
        __init__(self, size, degree, max_mismatch = 0, mkl_stepsize = 1) -> WeightedDegreePositionStringKernel
        __init__(self, size, degree, max_mismatch = 0) -> WeightedDegreePositionStringKernel
        __init__(self, size, degree) -> WeightedDegreePositionStringKernel
        __init__(self, size, weights, degree, max_mismatch, shift, shift_len, 
            mkl_stepsize = 1) -> WeightedDegreePositionStringKernel
        __init__(self, size, weights, degree, max_mismatch, shift, shift_len) -> WeightedDegreePositionStringKernel
        __init__(self, l, r, degree) -> WeightedDegreePositionStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _modshogun.new_WeightedDegreePositionStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WeightedDegreePositionStringKernel
    __del__ = lambda self : None;
    def init_optimization(self, *args):
        """
        init_optimization(self, p_count, IDX, alphas) -> bool
        init_optimization(self, count, IDX, alphas, tree_num, upto_tree = -1) -> bool
        init_optimization(self, count, IDX, alphas, tree_num) -> bool

        initialize optimization do initialization for tree_num up to
        upto_tree, use tree_num=-1 to construct all trees

        Parameters:
        -----------

        count:  count

        IDX:  IDX

        alphas:  alphas

        tree_num:  which tree

        upto_tree:  up to this tree

        if initializing was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_optimization(self, *args)

    def compute_batch_helper(*args):
        """compute_batch_helper(p) -> void"""
        return _modshogun.WeightedDegreePositionStringKernel_compute_batch_helper(*args)

    if _newclass:compute_batch_helper = staticmethod(compute_batch_helper)
    __swig_getmethods__["compute_batch_helper"] = lambda x: compute_batch_helper
    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        compute batch

        Parameters:
        -----------

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        factor:  factor 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_batch(self, *args)

    def compute_abs_weights(self, *args):
        """
        compute_abs_weights(self, len) -> float

        compute abs weights

        Parameters:
        -----------

        len:  len

        computed abs weights 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_abs_weights(self, *args)

    def is_tree_initialized(self):
        """
        is_tree_initialized(self) -> bool

        check if tree is initialized

        if tree is initialized 
        """
        return _modshogun.WeightedDegreePositionStringKernel_is_tree_initialized(self)

    def get_max_mismatch(self):
        """
        get_max_mismatch(self) ->  int

        get maximum mismatch

        maximum mismatch 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_max_mismatch(self)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        the degree 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_degree(self)

    def get_degree_weights(self, *args):
        """
        get_degree_weights(self, d, len) -> float

        get degree weights

        Parameters:
        -----------

        d:  degree weights will be stored here

        len:  number of degree weights will be stored here 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_degree_weights(self, *args)

    def get_weights(self, *args):
        """
        get_weights(self, num_weights) -> float

        get weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        weights 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_weights(self, *args)

    def get_position_weights(self, *args):
        """
        get_position_weights(self, len) -> float

        get position weights

        Parameters:
        -----------

        len:  number of position weights will be stored here

        position weights 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_position_weights(self, *args)

    def set_shifts(self, *args):
        """
        set_shifts(self, shifts)

        set shifts

        Parameters:
        -----------

        shifts:  new shifts 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_shifts(self, *args)

    def set_weights(self, *args):
        """
        set_weights(self, new_weights) -> bool

        set weights

        Parameters:
        -----------

        new_weights:  new weights 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_weights(self, *args)

    def set_wd_weights(self):
        """
        set_wd_weights(self) -> bool

        set wd weights

        if setting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_wd_weights(self)

    def set_position_weights(self, *args):
        """
        set_position_weights(self, pws)

        set position weights

        Parameters:
        -----------

        pws:  new position weights

        if setting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_position_weights(self, *args)

    def set_position_weights_lhs(self, *args):
        """
        set_position_weights_lhs(self, pws, len, num) -> bool

        set position weights for left-hand side

        Parameters:
        -----------

        pws:  new position weights

        len:  len

        num:  num

        if setting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_position_weights_lhs(self, *args)

    def set_position_weights_rhs(self, *args):
        """
        set_position_weights_rhs(self, pws, len, num) -> bool

        set position weights for right-hand side

        Parameters:
        -----------

        pws:  new position weights

        len:  len

        num:  num

        if setting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_set_position_weights_rhs(self, *args)

    def init_block_weights(self):
        """
        init_block_weights(self) -> bool

        initialize block weights

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights(self)

    def init_block_weights_from_wd(self):
        """
        init_block_weights_from_wd(self) -> bool

        initialize block weights from weighted degree

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_from_wd(self)

    def init_block_weights_from_wd_external(self):
        """
        init_block_weights_from_wd_external(self) -> bool

        initialize block weights from external weighted degree

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_from_wd_external(self)

    def init_block_weights_const(self):
        """
        init_block_weights_const(self) -> bool

        initialize block weights constant

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_const(self)

    def init_block_weights_linear(self):
        """
        init_block_weights_linear(self) -> bool

        initialize block weights linear

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_linear(self)

    def init_block_weights_sqpoly(self):
        """
        init_block_weights_sqpoly(self) -> bool

        initialize block weights squared polynomial

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_sqpoly(self)

    def init_block_weights_cubicpoly(self):
        """
        init_block_weights_cubicpoly(self) -> bool

        initialize block weights cubic polynomial

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_cubicpoly(self)

    def init_block_weights_exp(self):
        """
        init_block_weights_exp(self) -> bool

        initialize block weights exponential

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_exp(self)

    def init_block_weights_log(self):
        """
        init_block_weights_log(self) -> bool

        initialize block weights logarithmic

        if initialization was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_init_block_weights_log(self)

    def delete_position_weights(self):
        """
        delete_position_weights(self) -> bool

        delete position weights

        if deleting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_delete_position_weights(self)

    def delete_position_weights_lhs(self):
        """
        delete_position_weights_lhs(self) -> bool

        delete position weights left-hand side

        if deleting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_delete_position_weights_lhs(self)

    def delete_position_weights_rhs(self):
        """
        delete_position_weights_rhs(self) -> bool

        delete position weights right-hand side

        if deleting was successful 
        """
        return _modshogun.WeightedDegreePositionStringKernel_delete_position_weights_rhs(self)

    def compute_by_tree(self, *args):
        """
        compute_by_tree(self, idx) -> float
        compute_by_tree(self, idx, LevelContrib)

        compute by tree

        Parameters:
        -----------

        idx:  index

        LevelContrib:  level contribution 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_by_tree(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, weights) -> float

        compute positional scoring function, which assigns a weight per
        position, per symbol in the sequence

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        weights:  weights

        computed scores 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_scoring(self, *args)

    def compute_consensus(self, *args):
        """
        compute_consensus(self, num_feat, num_suppvec, IDX, alphas) -> str

        compute consensus string

        Parameters:
        -----------

        num_feat:  number of features

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        consensus string 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_consensus(self, *args)

    def extract_w(self, *args):
        """
        extract_w(self, max_degree, num_feat, num_sym, w_result, num_suppvec, 
            IDX, alphas) -> float

        extract w

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        w_result:  w

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        w 
        """
        return _modshogun.WeightedDegreePositionStringKernel_extract_w(self, *args)

    def compute_POIM(self, *args):
        """
        compute_POIM(self, max_degree, num_feat, num_sym, poim_result, num_suppvec, 
            IDX, alphas, distrib) -> float

        compute POIM

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        poim_result:  poim

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        distrib:  distribution

        computed POIMs 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_POIM(self, *args)

    def prepare_POIM2(self, *args):
        """
        prepare_POIM2(self, distrib, num_sym, num_feat)

        prepare POIM2

        Parameters:
        -----------

        num_feat:  number of features

        num_sym:  number of symbols

        distrib:  distribution 
        """
        return _modshogun.WeightedDegreePositionStringKernel_prepare_POIM2(self, *args)

    def compute_POIM2(self, *args):
        """
        compute_POIM2(self, max_degree, svm)

        compute POIM2

        Parameters:
        -----------

        max_degree:  maximum degree

        svm:  SVM 
        """
        return _modshogun.WeightedDegreePositionStringKernel_compute_POIM2(self, *args)

    def get_POIM2(self, *args):
        """
        get_POIM2(self) -> [] of float

        get POIM2

        Parameters:
        -----------

        poim:  POIMs (returned)

        result_len:  (returned) 
        """
        return _modshogun.WeightedDegreePositionStringKernel_get_POIM2(self, *args)

    def cleanup_POIM2(self):
        """
        cleanup_POIM2(self)

        cleanup POIM2 
        """
        return _modshogun.WeightedDegreePositionStringKernel_cleanup_POIM2(self)

WeightedDegreePositionStringKernel_swigregister = _modshogun.WeightedDegreePositionStringKernel_swigregister
WeightedDegreePositionStringKernel_swigregister(WeightedDegreePositionStringKernel)

def WeightedDegreePositionStringKernel_compute_batch_helper(*args):
  """WeightedDegreePositionStringKernel_compute_batch_helper(p) -> void"""
  return _modshogun.WeightedDegreePositionStringKernel_compute_batch_helper(*args)

E_WD = _modshogun.E_WD
E_EXTERNAL = _modshogun.E_EXTERNAL
E_BLOCK_CONST = _modshogun.E_BLOCK_CONST
E_BLOCK_LINEAR = _modshogun.E_BLOCK_LINEAR
E_BLOCK_SQPOLY = _modshogun.E_BLOCK_SQPOLY
E_BLOCK_CUBICPOLY = _modshogun.E_BLOCK_CUBICPOLY
E_BLOCK_EXP = _modshogun.E_BLOCK_EXP
E_BLOCK_LOG = _modshogun.E_BLOCK_LOG
class WeightedDegreeStringKernel(StringCharKernel):
    """
    The Weighted Degree String kernel.

    The WD kernel of order d compares two sequences ${\\bf x}$ and
    ${\\bf x'}$ of length L by summing all contributions of k-mer
    matches of lengths $k\\in\\{1,\\dots,d\\}$, weighted by
    coefficients $\\beta_k$. It is defined as \\[ k({\\bf x},{\\bf
    x'})=\\sum_{k=1}^d\\beta_k\\sum_{l=1}^{L-k+1}I({\\bf
    u}_{k,l}({\\bf x})={\\bf u}_{k,l}({\\bf x'})). \\] Here,
    ${\\bf u}_{k,l}({\\bf x})$ is the string of length k starting at
    position l of the sequence ${\\bf x}$ and $I(\\cdot)$ is the
    indicator function which evaluates to 1 when its argument is true and
    to 0 otherwise.

    C++ includes: WeightedDegreeStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreeStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreeStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WeightedDegreeStringKernel
        __init__(self, degree, type = E_WD) -> WeightedDegreeStringKernel
        __init__(self, degree) -> WeightedDegreeStringKernel
        __init__(self, weights, degree) -> WeightedDegreeStringKernel
        __init__(self, l, r, degree) -> WeightedDegreeStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _modshogun.new_WeightedDegreeStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WeightedDegreeStringKernel
    __del__ = lambda self : None;
    def get_type(self):
        """
        get_type(self) -> EWDKernType

        get WD kernel weighting type

        weighting type

        See:   EWDKernType 
        """
        return _modshogun.WeightedDegreeStringKernel_get_type(self)

    def init_optimization(self, *args):
        """
        init_optimization(self, count, IDX, alphas) -> bool
        init_optimization(self, count, IDX, alphas, tree_num) -> bool

        initialize optimization do initialization for tree_num up to
        upto_tree, use tree_num=-1 to construct all trees

        Parameters:
        -----------

        count:  count

        IDX:  IDX

        alphas:  alphas

        tree_num:  which tree

        if initializing was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_optimization(self, *args)

    def compute_batch_helper(*args):
        """compute_batch_helper(p) -> void"""
        return _modshogun.WeightedDegreeStringKernel_compute_batch_helper(*args)

    if _newclass:compute_batch_helper = staticmethod(compute_batch_helper)
    __swig_getmethods__["compute_batch_helper"] = lambda x: compute_batch_helper
    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        compute batch

        Parameters:
        -----------

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        factor:  factor 
        """
        return _modshogun.WeightedDegreeStringKernel_compute_batch(self, *args)

    def compute_abs_weights(self, *args):
        """
        compute_abs_weights(self, len) -> float

        compute abs weights

        Parameters:
        -----------

        len:  len

        computed abs weights 
        """
        return _modshogun.WeightedDegreeStringKernel_compute_abs_weights(self, *args)

    def compute_by_tree(self, *args):
        """
        compute_by_tree(self, idx, LevelContrib)

        compute by tree

        Parameters:
        -----------

        idx:  index

        LevelContrib:  level contribution

        computed value 
        """
        return _modshogun.WeightedDegreeStringKernel_compute_by_tree(self, *args)

    def is_tree_initialized(self):
        """
        is_tree_initialized(self) -> bool

        check if tree is initialized

        if tree is initialized 
        """
        return _modshogun.WeightedDegreeStringKernel_is_tree_initialized(self)

    def get_degree_weights(self, *args):
        """
        get_degree_weights(self, d, len) -> float

        get degree weights

        Parameters:
        -----------

        d:  degree weights will be stored here

        len:  number of degree weights will be stored here 
        """
        return _modshogun.WeightedDegreeStringKernel_get_degree_weights(self, *args)

    def get_weights(self, *args):
        """
        get_weights(self, num_weights) -> float

        get weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        weights 
        """
        return _modshogun.WeightedDegreeStringKernel_get_weights(self, *args)

    def get_position_weights(self, *args):
        """
        get_position_weights(self, len) -> float

        get position weights

        Parameters:
        -----------

        len:  number of position weights will be stored here

        position weights 
        """
        return _modshogun.WeightedDegreeStringKernel_get_position_weights(self, *args)

    def set_wd_weights_by_type(self, *args):
        """
        set_wd_weights_by_type(self, type) -> bool

        set wd weights

        Parameters:
        -----------

        type:  weighted degree kernel type

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_wd_weights_by_type(self, *args)

    def set_wd_weights(self, *args):
        """
        set_wd_weights(self, new_weights)

        set wd weights

        Parameters:
        -----------

        new_weights:  new weights 
        """
        return _modshogun.WeightedDegreeStringKernel_set_wd_weights(self, *args)

    def set_weights(self, *args):
        """
        set_weights(self, new_weights) -> bool

        set weights

        Parameters:
        -----------

        new_weights:  new weights 
        """
        return _modshogun.WeightedDegreeStringKernel_set_weights(self, *args)

    def set_position_weights(self, *args):
        """
        set_position_weights(self, pws, len) -> bool

        set position weights

        Parameters:
        -----------

        pws:  new position weights

        len:  number of position weights

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_position_weights(self, *args)

    def init_block_weights(self):
        """
        init_block_weights(self) -> bool

        initialize block weights

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights(self)

    def init_block_weights_from_wd(self):
        """
        init_block_weights_from_wd(self) -> bool

        initialize block weights from weighted degree

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_from_wd(self)

    def init_block_weights_from_wd_external(self):
        """
        init_block_weights_from_wd_external(self) -> bool

        initialize block weights from external weighted degree

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_from_wd_external(self)

    def init_block_weights_const(self):
        """
        init_block_weights_const(self) -> bool

        initialize block weights constant

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_const(self)

    def init_block_weights_linear(self):
        """
        init_block_weights_linear(self) -> bool

        initialize block weights linear

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_linear(self)

    def init_block_weights_sqpoly(self):
        """
        init_block_weights_sqpoly(self) -> bool

        initialize block weights squared polynomial

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_sqpoly(self)

    def init_block_weights_cubicpoly(self):
        """
        init_block_weights_cubicpoly(self) -> bool

        initialize block weights cubic polynomial

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_cubicpoly(self)

    def init_block_weights_exp(self):
        """
        init_block_weights_exp(self) -> bool

        initialize block weights exponential

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_exp(self)

    def init_block_weights_log(self):
        """
        init_block_weights_log(self) -> bool

        initialize block weights logarithmic

        if initialization was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_init_block_weights_log(self)

    def delete_position_weights(self):
        """
        delete_position_weights(self) -> bool

        delete position weights

        if deleting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_delete_position_weights(self)

    def set_max_mismatch(self, *args):
        """
        set_max_mismatch(self, max) -> bool

        set maximum mismatch

        Parameters:
        -----------

        max:  new maximum mismatch

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_max_mismatch(self, *args)

    def get_max_mismatch(self):
        """
        get_max_mismatch(self) ->  int

        get maximum mismatch

        maximum mismatch 
        """
        return _modshogun.WeightedDegreeStringKernel_get_max_mismatch(self)

    def set_degree(self, *args):
        """
        set_degree(self, deg) -> bool

        set degree

        Parameters:
        -----------

        deg:  new degree

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_degree(self, *args)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _modshogun.WeightedDegreeStringKernel_get_degree(self)

    def set_use_block_computation(self, *args):
        """
        set_use_block_computation(self, block) -> bool

        set if block computation shall be performed

        Parameters:
        -----------

        block:  if block computation shall be performed

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_use_block_computation(self, *args)

    def get_use_block_computation(self):
        """
        get_use_block_computation(self) -> bool

        check if block computation is performed

        if block computation is performed 
        """
        return _modshogun.WeightedDegreeStringKernel_get_use_block_computation(self)

    def set_mkl_stepsize(self, *args):
        """
        set_mkl_stepsize(self, step) -> bool

        set MKL steps ize

        Parameters:
        -----------

        step:  new step size

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_mkl_stepsize(self, *args)

    def get_mkl_stepsize(self):
        """
        get_mkl_stepsize(self) ->  int

        get MKL step size

        MKL step size 
        """
        return _modshogun.WeightedDegreeStringKernel_get_mkl_stepsize(self)

    def set_which_degree(self, *args):
        """
        set_which_degree(self, which) -> bool

        set which degree

        Parameters:
        -----------

        which:  which degree

        if setting was successful 
        """
        return _modshogun.WeightedDegreeStringKernel_set_which_degree(self, *args)

    def get_which_degree(self):
        """
        get_which_degree(self) ->  int

        get which degree

        which degree 
        """
        return _modshogun.WeightedDegreeStringKernel_get_which_degree(self)

WeightedDegreeStringKernel_swigregister = _modshogun.WeightedDegreeStringKernel_swigregister
WeightedDegreeStringKernel_swigregister(WeightedDegreeStringKernel)

def WeightedDegreeStringKernel_compute_batch_helper(*args):
  """WeightedDegreeStringKernel_compute_batch_helper(p) -> void"""
  return _modshogun.WeightedDegreeStringKernel_compute_batch_helper(*args)

class WeightedDegreeRBFKernel(DotKernel):
    """
    weighted degree RBF kernel

    C++ includes: WeightedDegreeRBFKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [DotKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreeRBFKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [DotKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreeRBFKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WeightedDegreeRBFKernel
        __init__(self, size, width, degree, nof_properties) -> WeightedDegreeRBFKernel
        __init__(self, l, r, width, degree, nof_properties, size = 10) -> WeightedDegreeRBFKernel
        __init__(self, l, r, width, degree, nof_properties) -> WeightedDegreeRBFKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        degree:  degree

        nof_properties:  number of properties per amino acid

        size:  cache size 
        """
        this = _modshogun.new_WeightedDegreeRBFKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WeightedDegreeRBFKernel
    __del__ = lambda self : None;
    def set_degree(self, *args):
        """
        set_degree(self, deg) -> bool

        set degree

        Parameters:
        -----------

        deg:  new degree

        if setting was successful 
        """
        return _modshogun.WeightedDegreeRBFKernel_set_degree(self, *args)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _modshogun.WeightedDegreeRBFKernel_get_degree(self)

WeightedDegreeRBFKernel_swigregister = _modshogun.WeightedDegreeRBFKernel_swigregister
WeightedDegreeRBFKernel_swigregister(WeightedDegreeRBFKernel)

class SpectrumMismatchRBFKernel(StringCharKernel):
    """
    spectrum mismatch rbf kernel

    C++ includes: SpectrumMismatchRBFKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectrumMismatchRBFKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectrumMismatchRBFKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SpectrumMismatchRBFKernel
        __init__(self, size, AA_matrix_, nr_, nc_, degree, max_mismatch, width) -> SpectrumMismatchRBFKernel
        __init__(self, l, r, size, AA_matrix_, nr_, nc_, degree, max_mismatch, 
            width) -> SpectrumMismatchRBFKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        size:

        AA_matrix_:

        nr_:

        nc_:

        degree:

        max_mismatch:

        width:  
        """
        this = _modshogun.new_SpectrumMismatchRBFKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SpectrumMismatchRBFKernel
    __del__ = lambda self : None;
    def set_max_mismatch(self, *args):
        """
        set_max_mismatch(self, max) -> bool

        set maximum mismatch

        Parameters:
        -----------

        max:  new maximum mismatch

        if setting was successful 
        """
        return _modshogun.SpectrumMismatchRBFKernel_set_max_mismatch(self, *args)

    def get_max_mismatch(self):
        """
        get_max_mismatch(self) ->  int

        get maximum mismatch

        maximum mismatch 
        """
        return _modshogun.SpectrumMismatchRBFKernel_get_max_mismatch(self)

    def set_degree(self, *args):
        """
        set_degree(self, deg) -> bool

        set degree

        Parameters:
        -----------

        deg:  new degree

        if setting was successful 
        """
        return _modshogun.SpectrumMismatchRBFKernel_set_degree(self, *args)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _modshogun.SpectrumMismatchRBFKernel_get_degree(self)

    def set_AA_matrix(self, AA_matrix_ = None, nr = 128, nc = 128):
        """
        set_AA_matrix(self, AA_matrix_ = None, nr = 128, nc = 128) -> bool
        set_AA_matrix(self, AA_matrix_ = None, nr = 128) -> bool
        set_AA_matrix(self, AA_matrix_ = None) -> bool
        set_AA_matrix(self) -> bool

        set AA matrix

        Parameters:
        -----------

        AA_matrix_:

        nr:

        nc:

        true if set 
        """
        return _modshogun.SpectrumMismatchRBFKernel_set_AA_matrix(self, AA_matrix_, nr, nc)

SpectrumMismatchRBFKernel_swigregister = _modshogun.SpectrumMismatchRBFKernel_swigregister
SpectrumMismatchRBFKernel_swigregister(SpectrumMismatchRBFKernel)

class ZeroMeanCenterKernelNormalizer(KernelNormalizer):
    """
    ZeroMeanCenterKernelNormalizer centers the kernel in feature space.

    After centering, each feature must have zero mean. The centered kernel
    matrix can be expressed in terms of the non-centered version.

    Denoting the mapping from input space to feature space by
    $\\phi:\\mathcal{X}\\rightarrow\\mathcal{F}$, the centered
    square kernel matrix $K_c$ (with dimensionality $ M $)

    can be expressed in terms of the original matrix $K$ as follows:

    \\begin{eqnarray*} k({\\bf x}_i,{\\bf x}_j)_c & = &
    \\left(\\phi({\\bf x}_i) - \\frac{1}{m} \\sum_{p=1}^M
    \\phi({\\bf x}_p)\\right) \\cdot \\left(\\phi({\\bf
    x}_j) - \\frac{1}{M} \\sum_{q=1}^M \\phi({\\bf x}_q)\\right)
    \\\\ & = & K_{ij} - \\frac{1}{M} \\sum_{p=1}^M K_{pj} -
    \\frac{1}{M} \\sum_{q=1}^M K_{iq} + \\frac{1}{M^2}
    \\sum_{p=1}^M \\sum_{q=1}^M K_{pq} \\\\ & = & (K - 1_M K - K
    1_M + 1_M K 1_M)_{ij} \\end{eqnarray*}

    Additionally, let $ K^{t} $ be the $ L \\times M $ test matrix
    describing the similarity between a $ L $ test instances with $M$
    training instances

    (defined by a $ M x M $ kernel matrix $ K$), the centered testing set
    kernel matrix is given by \\[ K_{c}^t = (K - 1'_M K - K^{t} 1_M +
    1'_M K 1_M) \\]

    C++ includes: ZeroMeanCenterKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ZeroMeanCenterKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ZeroMeanCenterKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> ZeroMeanCenterKernelNormalizer

        default constructor 
        """
        this = _modshogun.new_ZeroMeanCenterKernelNormalizer()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ZeroMeanCenterKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_row_means(self, *args):
        """
        alloc_and_compute_row_means(self, k, v, num_lhs, num_rhs) -> bool

        alloc and compute the vector containing the row margins of all rows
        for a kernel matrix. 
        """
        return _modshogun.ZeroMeanCenterKernelNormalizer_alloc_and_compute_row_means(self, *args)

ZeroMeanCenterKernelNormalizer_swigregister = _modshogun.ZeroMeanCenterKernelNormalizer_swigregister
ZeroMeanCenterKernelNormalizer_swigregister(ZeroMeanCenterKernelNormalizer)

class MultiquadricKernel(Kernel):
    """
    MultiquadricKernel.

    \\[ K(x,x') = \\sqrt{\\| x - x' \\|^2 +c^2} \\]

    C++ includes: MultiquadricKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultiquadricKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultiquadricKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultiquadricKernel
        __init__(self, cache, coef, dist) -> MultiquadricKernel
        __init__(self, l, r, coef, dist) -> MultiquadricKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        coef:  kernel parameter coef

        dist:  distance to be used 
        """
        this = _modshogun.new_MultiquadricKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    def get_coef(self):
        """
        get_coef(self) -> float

        getter for coef parameter kernel parameter coefficient 
        """
        return _modshogun.MultiquadricKernel_get_coef(self)

    def set_coef(self, *args):
        """
        set_coef(self, value)

        setter for coef parameter

        Parameters:
        -----------

        value:  kernel parameter coefficient 
        """
        return _modshogun.MultiquadricKernel_set_coef(self, *args)

    __swig_destroy__ = _modshogun.delete_MultiquadricKernel
    __del__ = lambda self : None;
MultiquadricKernel_swigregister = _modshogun.MultiquadricKernel_swigregister
MultiquadricKernel_swigregister(MultiquadricKernel)

class RationalQuadraticKernel(Kernel):
    """
    Rational Quadratic kernel.

    Formally described as

    \\[ K(x,x') = 1 -\\frac{\\| x-x'\\|^2}{\\|x-x'\\|^2 +
    coef} \\]

    C++ includes: RationalQuadraticKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RationalQuadraticKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RationalQuadraticKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RationalQuadraticKernel
        __init__(self, cache, coef, dist) -> RationalQuadraticKernel
        __init__(self, l, r, c, dist) -> RationalQuadraticKernel

        constructor

        Parameters:
        -----------

        l:  features left-side

        r:  features right-side

        c:  kernel parameter coefficient

        dist:  distance to be used 
        """
        this = _modshogun.new_RationalQuadraticKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    def get_coef(self):
        """
        get_coef(self) -> float

        coef - coefficient parameter of kernel 
        """
        return _modshogun.RationalQuadraticKernel_get_coef(self)

    def set_coef(self, *args):
        """
        set_coef(self, coef)

        setter for degree parameter

        Parameters:
        -----------

        coef:  coefficient parameter of kernel 
        """
        return _modshogun.RationalQuadraticKernel_set_coef(self, *args)

    __swig_destroy__ = _modshogun.delete_RationalQuadraticKernel
    __del__ = lambda self : None;
RationalQuadraticKernel_swigregister = _modshogun.RationalQuadraticKernel_swigregister
RationalQuadraticKernel_swigregister(RationalQuadraticKernel)

class Distribution(SGObject):
    """
    Base class Distribution from which all methods implementing a
    distribution are derived.

    Distributions are based on some general feature object and have to
    implement interfaces to

    train() - for learning a distribution get_num_model_parameters() - for
    the total number of model parameters get_log_model_parameter() - for
    the n-th model parameter (logarithmic) get_log_derivative() - for the
    partial derivative wrt. to the n-th model parameter
    get_log_likelihood_example() - for the likelihood for the n-th example

    This way methods building on CDistribution, might enumerate over all
    possible model parameters and obtain the parameter vector and the
    gradient. This is used to compute e.g. the TOP and Fisher Kernel (cf.
    CPluginEstimate, CHistogramKernel, CTOPFeatures and CFKFeatures ).

    C++ includes: Distribution.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distribution, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distribution, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Distribution
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.Distribution_train(self, data)

    def get_num_model_parameters(self):
        """
        get_num_model_parameters(self) ->  int

        get number of parameters in model

        abstract base method

        number of parameters in model 
        """
        return _modshogun.Distribution_get_num_model_parameters(self)

    def get_num_relevant_model_parameters(self):
        """
        get_num_relevant_model_parameters(self) ->  int

        get number of parameters in model that are relevant, i.e. >
        ALMOST_NEG_INFTY

        number of relevant model parameters 
        """
        return _modshogun.Distribution_get_num_relevant_model_parameters(self)

    def get_log_model_parameter(self, *args):
        """
        get_log_model_parameter(self, num_param) -> float

        get model parameter (logarithmic)

        abstrac base method

        model parameter (logarithmic) 
        """
        return _modshogun.Distribution_get_log_model_parameter(self, *args)

    def get_log_derivative(self, *args):
        """
        get_log_derivative(self, num_param, num_example) -> float

        get partial derivative of likelihood function (logarithmic)

        abstract base method

        Parameters:
        -----------

        num_param:  derivative against which param

        num_example:  which example

        derivative of likelihood (logarithmic) 
        """
        return _modshogun.Distribution_get_log_derivative(self, *args)

    def get_log_likelihood_example(self, *args):
        """
        get_log_likelihood_example(self, num_example) -> float

        compute log likelihood for example

        abstract base method

        Parameters:
        -----------

        num_example:  which example

        log likelihood for example 
        """
        return _modshogun.Distribution_get_log_likelihood_example(self, *args)

    def get_log_likelihood_sample(self):
        """
        get_log_likelihood_sample(self) -> float

        compute log likelihood for whole sample

        log likelihood for whole sample 
        """
        return _modshogun.Distribution_get_log_likelihood_sample(self)

    def get_log_likelihood(self):
        """
        get_log_likelihood(self) -> numpy 1dim array of float

        compute log likelihood for each example

        log likelihood vector 
        """
        return _modshogun.Distribution_get_log_likelihood(self)

    def get_model_parameter(self, *args):
        """
        get_model_parameter(self, num_param) -> float

        get model parameter

        Parameters:
        -----------

        num_param:  which param

        model parameter 
        """
        return _modshogun.Distribution_get_model_parameter(self, *args)

    def get_derivative(self, *args):
        """
        get_derivative(self, num_param, num_example) -> float

        get partial derivative of likelihood function

        Parameters:
        -----------

        num_param:  partial derivative against which param

        num_example:  which example

        derivative of likelihood function 
        """
        return _modshogun.Distribution_get_derivative(self, *args)

    def get_likelihood_example(self, *args):
        """
        get_likelihood_example(self, num_example) -> float

        compute likelihood for example

        Parameters:
        -----------

        num_example:  which example

        likelihood for example 
        """
        return _modshogun.Distribution_get_likelihood_example(self, *args)

    def set_features(self, *args):
        """
        set_features(self, f)

        set feature vectors

        Parameters:
        -----------

        f:  new feature vectors 
        """
        return _modshogun.Distribution_set_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> Features

        get feature vectors

        feature vectors 
        """
        return _modshogun.Distribution_get_features(self)

    def set_pseudo_count(self, *args):
        """
        set_pseudo_count(self, pseudo)

        set pseudo count

        Parameters:
        -----------

        pseudo:  new pseudo count 
        """
        return _modshogun.Distribution_set_pseudo_count(self, *args)

    def get_pseudo_count(self):
        """
        get_pseudo_count(self) -> float

        get pseudo count

        pseudo count 
        """
        return _modshogun.Distribution_get_pseudo_count(self)

Distribution_swigregister = _modshogun.Distribution_swigregister
Distribution_swigregister(Distribution)

class Histogram(Distribution):
    """
    Class Histogram computes a histogram over all 16bit unsigned integers
    in the features.

    Values in histogram are absolute counts (logarithmic)

    C++ includes: Histogram.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Histogram, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Histogram, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Histogram
        __init__(self, f) -> Histogram

        constructor

        Parameters:
        -----------

        f:  histogram's features 
        """
        this = _modshogun.new_Histogram(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Histogram
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.Histogram_train(self, data)

    def set_histogram(self, *args):
        """
        set_histogram(self, histogram) -> bool

        set histogram

        Parameters:
        -----------

        histogram:  new histogram 
        """
        return _modshogun.Histogram_set_histogram(self, *args)

    def get_histogram(self):
        """
        get_histogram(self) -> numpy 1dim array of float

        get histogram

        current histogram 
        """
        return _modshogun.Histogram_get_histogram(self)

Histogram_swigregister = _modshogun.Histogram_swigregister
Histogram_swigregister(Histogram)

BW_NORMAL = _modshogun.BW_NORMAL
BW_TRANS = _modshogun.BW_TRANS
BW_DEFINED = _modshogun.BW_DEFINED
VIT_NORMAL = _modshogun.VIT_NORMAL
VIT_DEFINED = _modshogun.VIT_DEFINED
class HMM(Distribution):
    """
    Hidden Markov Model.

    Structure and Function collection. This Class implements a Hidden
    Markov Model. For a tutorial on HMMs see Rabiner et.al A Tutorial on
    Hidden Markov Models and Selected Applications in Speech Recognition,
    1989

    Several functions for tasks such as training,reading/writing models,
    reading observations, calculation of derivatives are supplied.

    C++ includes: HMM.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HMM, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HMM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> HMM
        __init__(self, N, M, model, PSEUDO) -> HMM
        __init__(self, obs, N, M, PSEUDO) -> HMM
        __init__(self, N, p, q, a) -> HMM
        __init__(self, N, p, q, num_trans, a_trans) -> HMM
        __init__(self, model_file, PSEUDO) -> HMM
        __init__(self, h) -> HMM

        Train definitions. Encapsulates Modelparameters that are
        constant/shall be learned. Consists of structures and access functions
        for learning only defined transitions and constants. default
        constructor 
        """
        this = _modshogun.new_HMM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_HMM
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.HMM_train(self, data)

    def initialize(self, *args):
        """
        initialize(self, model, PSEUDO, model_file = None) -> bool
        initialize(self, model, PSEUDO) -> bool

        initialization function - gets called by constructors.

        Parameters:
        -----------

        model:  model which holds definitions of states to be learned + consts

        PSEUDO:  Pseudo Value

        model_file:  Filehandle to a hmm model file (*.mod) 
        """
        return _modshogun.HMM_initialize(self, *args)

    def alloc_state_dependend_arrays(self):
        """
        alloc_state_dependend_arrays(self) -> bool

        allocates memory that depends on N 
        """
        return _modshogun.HMM_alloc_state_dependend_arrays(self)

    def free_state_dependend_arrays(self):
        """
        free_state_dependend_arrays(self)

        free memory that depends on N 
        """
        return _modshogun.HMM_free_state_dependend_arrays(self)

    def forward_comp(self, *args):
        """
        forward_comp(self, time, state, dimension) -> float

        forward algorithm. calculates Pr[O_0,O_1, ..., O_t, q_time=S_i|
        lambda] for 0<= time <= T-1 Pr[O|lambda] for time > T

        Parameters:
        -----------

        time:  t

        state:  i

        dimension:  dimension of observation (observations are a matrix, where
        a row stands for one dimension i.e. 0_0,O_1,...,O_{T-1} 
        """
        return _modshogun.HMM_forward_comp(self, *args)

    def forward_comp_old(self, *args):
        """forward_comp_old(self, time, state, dimension) -> float"""
        return _modshogun.HMM_forward_comp_old(self, *args)

    def backward_comp(self, *args):
        """
        backward_comp(self, time, state, dimension) -> float

        backward algorithm. calculates Pr[O_t+1,O_t+2, ..., O_T-1| q_time=S_i,
        lambda] for 0<= time <= T-1 Pr[O|lambda] for time >= T

        Parameters:
        -----------

        time:  t

        state:  i

        dimension:  dimension of observation (observations are a matrix, where
        a row stands for one dimension i.e. 0_0,O_1,...,O_{T-1} 
        """
        return _modshogun.HMM_backward_comp(self, *args)

    def backward_comp_old(self, *args):
        """backward_comp_old(self, time, state, dimension) -> float"""
        return _modshogun.HMM_backward_comp_old(self, *args)

    def best_path(self, *args):
        """
        best_path(self, dimension) -> float

        calculates probability of best state sequence s_0,...,s_T-1 AND path
        itself using viterbi algorithm. The path can be found in the array
        PATH(dimension)[0..T-1] afterwards

        Parameters:
        -----------

        dimension:  dimension of observation for which the most probable path
        is calculated (observations are a matrix, where a row stands for one
        dimension i.e. 0_0,O_1,...,O_{T-1} 
        """
        return _modshogun.HMM_best_path(self, *args)

    def get_best_path_state(self, *args):
        """get_best_path_state(self, dim, t) -> int"""
        return _modshogun.HMM_get_best_path_state(self, *args)

    def model_probability_comp(self):
        """
        model_probability_comp(self) -> float

        calculates probability that observations were generated by the model
        using forward algorithm. 
        """
        return _modshogun.HMM_model_probability_comp(self)

    def model_probability(self, *args):
        """
        model_probability(self, dimension = -1) -> float
        model_probability(self) -> float

        inline proxy for model probability. 
        """
        return _modshogun.HMM_model_probability(self, *args)

    def linear_model_probability(self, *args):
        """
        linear_model_probability(self, dimension) -> float

        calculates likelihood for linear model on observations in MEMORY

        Parameters:
        -----------

        dimension:  dimension for which probability is calculated

        model probability 
        """
        return _modshogun.HMM_linear_model_probability(self, *args)

    def set_iterations(self, *args):
        """set_iterations(self, num) -> bool"""
        return _modshogun.HMM_set_iterations(self, *args)

    def get_iterations(self):
        """get_iterations(self) ->  int"""
        return _modshogun.HMM_get_iterations(self)

    def set_epsilon(self, *args):
        """set_epsilon(self, eps) -> bool"""
        return _modshogun.HMM_set_epsilon(self, *args)

    def get_epsilon(self):
        """get_epsilon(self) -> float"""
        return _modshogun.HMM_get_epsilon(self)

    def baum_welch_viterbi_train(self, *args):
        """
        baum_welch_viterbi_train(self, type) -> bool

        interface for e.g. GUIHMM to run BaumWelch or Viterbi training

        Parameters:
        -----------

        type:  type of BaumWelch/Viterbi training 
        """
        return _modshogun.HMM_baum_welch_viterbi_train(self, *args)

    def estimate_model_baum_welch(self, *args):
        """
        estimate_model_baum_welch(self, train)

        uses baum-welch-algorithm to train a fully connected HMM.

        Parameters:
        -----------

        train:  model from which the new model is estimated 
        """
        return _modshogun.HMM_estimate_model_baum_welch(self, *args)

    def estimate_model_baum_welch_trans(self, *args):
        """estimate_model_baum_welch_trans(self, train)"""
        return _modshogun.HMM_estimate_model_baum_welch_trans(self, *args)

    def estimate_model_baum_welch_old(self, *args):
        """estimate_model_baum_welch_old(self, train)"""
        return _modshogun.HMM_estimate_model_baum_welch_old(self, *args)

    def estimate_model_baum_welch_defined(self, *args):
        """
        estimate_model_baum_welch_defined(self, train)

        uses baum-welch-algorithm to train the defined transitions etc.

        Parameters:
        -----------

        train:  model from which the new model is estimated 
        """
        return _modshogun.HMM_estimate_model_baum_welch_defined(self, *args)

    def estimate_model_viterbi(self, *args):
        """
        estimate_model_viterbi(self, train)

        uses viterbi training to train a fully connected HMM

        Parameters:
        -----------

        train:  model from which the new model is estimated 
        """
        return _modshogun.HMM_estimate_model_viterbi(self, *args)

    def estimate_model_viterbi_defined(self, *args):
        """
        estimate_model_viterbi_defined(self, train)

        uses viterbi training to train the defined transitions etc.

        Parameters:
        -----------

        train:  model from which the new model is estimated 
        """
        return _modshogun.HMM_estimate_model_viterbi_defined(self, *args)

    def linear_train(self, right_align = False):
        """
        linear_train(self, right_align = False) -> bool
        linear_train(self) -> bool

        estimates linear model from observations. 
        """
        return _modshogun.HMM_linear_train(self, right_align)

    def permutation_entropy(self, *args):
        """
        permutation_entropy(self, window_width, sequence_number) -> bool

        compute permutation entropy 
        """
        return _modshogun.HMM_permutation_entropy(self, *args)

    def output_model(self, verbose = False):
        """
        output_model(self, verbose = False)
        output_model(self)

        prints the model parameters on screen.

        Parameters:
        -----------

        verbose:  when false only the model probability will be printed when
        true the whole model will be printed additionally 
        """
        return _modshogun.HMM_output_model(self, verbose)

    def output_model_defined(self, verbose = False):
        """
        output_model_defined(self, verbose = False)
        output_model_defined(self)

        performs output_model only for the defined transitions etc 
        """
        return _modshogun.HMM_output_model_defined(self, verbose)

    def normalize(self, keep_dead_states = False):
        """
        normalize(self, keep_dead_states = False)
        normalize(self)

        normalize the model to satisfy stochasticity 
        """
        return _modshogun.HMM_normalize(self, keep_dead_states)

    def add_states(self, *args):
        """
        add_states(self, num_states, default_val = 0)
        add_states(self, num_states)

        increases the number of states by num_states the new a/b/p/q values
        are given the value default_val where 0<=default_val<=1 
        """
        return _modshogun.HMM_add_states(self, *args)

    def append_model(self, *args):
        """
        append_model(self, append_model, cur_out, app_out) -> bool
        append_model(self, append_model) -> bool

        appends the append_model to the current hmm, here no extra states are
        created. former q_i are multiplied by q_ji to give the a_ij from the
        current hmm to the append_model 
        """
        return _modshogun.HMM_append_model(self, *args)

    def chop(self, *args):
        """
        chop(self, value)

        set any model parameter with probability smaller than value to ZERO 
        """
        return _modshogun.HMM_chop(self, *args)

    def convert_to_log(self):
        """
        convert_to_log(self)

        convert model to log probabilities 
        """
        return _modshogun.HMM_convert_to_log(self)

    def init_model_random(self):
        """
        init_model_random(self)

        init model with random values 
        """
        return _modshogun.HMM_init_model_random(self)

    def init_model_defined(self):
        """
        init_model_defined(self)

        init model according to const_x, learn_x. first model is initialized
        with 0 for all parameters then parameters in learn_x are initialized
        with random values finally const_x parameters are set and model is
        normalized. 
        """
        return _modshogun.HMM_init_model_defined(self)

    def clear_model(self):
        """
        clear_model(self)

        initializes model with log(PSEUDO) 
        """
        return _modshogun.HMM_clear_model(self)

    def clear_model_defined(self):
        """
        clear_model_defined(self)

        initializes only parameters in learn_x with log(PSEUDO) 
        """
        return _modshogun.HMM_clear_model_defined(self)

    def copy_model(self, *args):
        """
        copy_model(self, l)

        copies the the modelparameters from l 
        """
        return _modshogun.HMM_copy_model(self, *args)

    def invalidate_model(self):
        """
        invalidate_model(self)

        invalidates all caches. this function has to be called when direct
        changes to the model have been made. this is necessary for the
        forward/backward/viterbi algorithms to not work with old tables 
        """
        return _modshogun.HMM_invalidate_model(self)

    def get_status(self):
        """
        get_status(self) -> bool

        get status true if everything is ok, else false 
        """
        return _modshogun.HMM_get_status(self)

    def get_pseudo(self):
        """
        get_pseudo(self) -> float

        returns current pseudo value 
        """
        return _modshogun.HMM_get_pseudo(self)

    def set_pseudo(self, *args):
        """
        set_pseudo(self, pseudo)

        sets current pseudo value 
        """
        return _modshogun.HMM_set_pseudo(self, *args)

    def set_observations(self, *args):
        """
        set_observations(self, obs, hmm = None)
        set_observations(self, obs)

        observation functions set/get observation matrix set new observations
        sets the observation pointer and initializes observation-dependent
        caches if hmm is given, then the caches of the model hmm are used 
        """
        return _modshogun.HMM_set_observations(self, *args)

    def set_observation_nocache(self, *args):
        """
        set_observation_nocache(self, obs)

        set new observations only set the observation pointer and drop caches
        if there were any 
        """
        return _modshogun.HMM_set_observation_nocache(self, *args)

    def get_observations(self):
        """
        get_observations(self) -> StringWordFeatures

        return observation pointer 
        """
        return _modshogun.HMM_get_observations(self)

    def load_definitions(self, *args):
        """
        load_definitions(self, file, verbose, initialize = True) -> bool
        load_definitions(self, file, verbose) -> bool

        read definitions file (learn_x,const_x) used for training. -format
        specs: definition_file (train.def) % HMM-TRAIN - specification %
        learn_a - elements in state_transition_matrix to be learned % learn_b
        - elements in oberservation_per_state_matrix to be learned % note:
        each line stands for % state, observation(0),
        observation(1)...observation(NOW) % learn_p - elements in initial
        distribution to be learned % learn_q - elements in the end-state
        distribution to be learned % % const_x - specifies initial values of
        elements % rest is assumed to be 0.0 % % NOTE: IMPLICIT DEFINES: %
        define A 0 % define C 1 % define G 2 % define T 3

        learn_a=[ [int32_t,int32_t]; [int32_t,int32_t]; [int32_t,int32_t];
        ........ [int32_t,int32_t]; [-1,-1]; ];

        learn_b=[ [int32_t,int32_t,int32_t,...,int32_t];
        [int32_t,int32_t,int32_t,...,int32_t];
        [int32_t,int32_t,int32_t,...,int32_t]; ........
        [int32_t,int32_t,int32_t,...,int32_t]; [-1,-1]; ];

        learn_p= [  int, ... ,  int, -1 ];

        learn_q= [  int, ... ,  int, -1 ];

        const_a=[ [int32_t,int32_t,float64_t]; [int32_t,int32_t,float64_t];
        [int32_t,int32_t,float64_t]; ........ [int32_t,int32_t,float64_t];
        [-1,-1,-1]; ];

        const_b=[ [int32_t,int32_t,int32_t,...,int32_t,float64_t];
        [int32_t,int32_t,int32_t,...,int32_t,float64_t];
        [int32_t,int32_t,int32_t,...,int32_t,<DOUBLE]; ........
        [int32_t,int32_t,int32_t,...,int32_t,float64_t]; [-1,-1,-1]; ];

        const_p[]=[ [int32_t, float], ... , [int32_t,float64_t], [-1,-1]
        ]; const_q[]=[ [int32_t, float], ... , [int32_t,float64_t],
        [-1,-1] ];

        Parameters:
        -----------

        file:  filehandle to definitions file

        verbose:  true for verbose messages

        initialize:  true to initialize to underlying HMM 
        """
        return _modshogun.HMM_load_definitions(self, *args)

    def load_model(self, *args):
        """
        load_model(self, file) -> bool

        read model from file. -format specs: model_file (model.hmm) % HMM -
        specification % N - number of states % M - number of
        observation_tokens % a is state_transition_matrix % size(a)= [N,N] % %
        b is observation_per_state_matrix % size(b)= [N,M] % % p is initial
        distribution % size(p)= [1, N]

        N=int32_t; M=int32_t;

        p=[float64_t,float64_t...float64_t];
        q=[float64_t,float64_t...float64_t];

        a=[ [float64_t,float64_t...float64_t];
        [float64_t,float64_t...float64_t]; [float64_t,float64_t...float64_t];
        [float64_t,float64_t...float64_t]; [float64_t,float64_t...float64_t];
        ];

        b=[ [float64_t,float64_t...float64_t];
        [float64_t,float64_t...float64_t]; [float64_t,float64_t...float64_t];
        [float64_t,float64_t...float64_t]; [float64_t,float64_t...float64_t];
        ];

        Parameters:
        -----------

        file:  filehandle to model file 
        """
        return _modshogun.HMM_load_model(self, *args)

    def save_model(self, *args):
        """
        save_model(self, file) -> bool

        save model to file.

        Parameters:
        -----------

        file:  filehandle to model file 
        """
        return _modshogun.HMM_save_model(self, *args)

    def save_model_derivatives(self, *args):
        """
        save_model_derivatives(self, file) -> bool

        save model derivatives to file in ascii format.

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_model_derivatives(self, *args)

    def save_model_derivatives_bin(self, *args):
        """
        save_model_derivatives_bin(self, file) -> bool

        save model derivatives to file in binary format.

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_model_derivatives_bin(self, *args)

    def save_model_bin(self, *args):
        """
        save_model_bin(self, file) -> bool

        save model in binary format.

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_model_bin(self, *args)

    def check_model_derivatives(self):
        """
        check_model_derivatives(self) -> bool

        numerically check whether derivates were calculated right 
        """
        return _modshogun.HMM_check_model_derivatives(self)

    def check_model_derivatives_combined(self):
        """check_model_derivatives_combined(self) -> bool"""
        return _modshogun.HMM_check_model_derivatives_combined(self)

    def get_path(self, *args):
        """
        get_path(self, dim, prob) -> T_STATES

        get viterbi path and path probability

        Parameters:
        -----------

        dim:  dimension for which to obtain best path

        prob:  likelihood of path

        viterbi path 
        """
        return _modshogun.HMM_get_path(self, *args)

    def save_path(self, *args):
        """
        save_path(self, file) -> bool

        save viterbi path in ascii format

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_path(self, *args)

    def save_path_derivatives(self, *args):
        """
        save_path_derivatives(self, file) -> bool

        save viterbi path in ascii format

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_path_derivatives(self, *args)

    def save_path_derivatives_bin(self, *args):
        """
        save_path_derivatives_bin(self, file) -> bool

        save viterbi path in binary format

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_path_derivatives_bin(self, *args)

    def save_likelihood_bin(self, *args):
        """
        save_likelihood_bin(self, file) -> bool

        save model probability in binary format

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_likelihood_bin(self, *args)

    def save_likelihood(self, *args):
        """
        save_likelihood(self, file) -> bool

        save model probability in ascii format

        Parameters:
        -----------

        file:  filehandle 
        """
        return _modshogun.HMM_save_likelihood(self, *args)

    def get_N(self):
        """
        get_N(self) -> T_STATES

        access function for number of states N 
        """
        return _modshogun.HMM_get_N(self)

    def get_M(self):
        """
        get_M(self) ->  int

        access function for number of observations M 
        """
        return _modshogun.HMM_get_M(self)

    def set_q(self, *args):
        """
        set_q(self, offset, value)

        access function for probability of end states

        Parameters:
        -----------

        offset:  index 0...N-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_q(self, *args)

    def set_p(self, *args):
        """
        set_p(self, offset, value)

        access function for probability of first state

        Parameters:
        -----------

        offset:  index 0...N-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_p(self, *args)

    def set_A(self, *args):
        """
        set_A(self, line_, column, value)

        access function for matrix A

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_A(self, *args)

    def set_a(self, *args):
        """
        set_a(self, line_, column, value)

        access function for matrix a

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_a(self, *args)

    def set_B(self, *args):
        """
        set_B(self, line_, column, value)

        access function for matrix B

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...M-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_B(self, *args)

    def set_b(self, *args):
        """
        set_b(self, line_, column, value)

        access function for matrix b

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...M-1

        value:  value to be set 
        """
        return _modshogun.HMM_set_b(self, *args)

    def set_psi(self, *args):
        """
        set_psi(self, time, state, value, dimension)

        access function for backtracking table psi

        Parameters:
        -----------

        time:  time 0...T-1

        state:  state 0...N-1

        value:  value to be set

        dimension:  dimension of observations 0...DIMENSION-1 
        """
        return _modshogun.HMM_set_psi(self, *args)

    def get_q(self, *args):
        """
        get_q(self, offset) -> float

        access function for probability of end states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.HMM_get_q(self, *args)

    def get_p(self, *args):
        """
        get_p(self, offset) -> float

        access function for probability of initial states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.HMM_get_p(self, *args)

    def get_A(self, *args):
        """
        get_A(self, line_, column) -> float

        access function for matrix A

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value at position line colum 
        """
        return _modshogun.HMM_get_A(self, *args)

    def get_a(self, *args):
        """
        get_a(self, line_, column) -> float

        access function for matrix a

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value at position line colum 
        """
        return _modshogun.HMM_get_a(self, *args)

    def get_B(self, *args):
        """
        get_B(self, line_, column) -> float

        access function for matrix B

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...M-1

        value at position line colum 
        """
        return _modshogun.HMM_get_B(self, *args)

    def get_b(self, *args):
        """
        get_b(self, line_, column) -> float

        access function for matrix b

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...M-1

        value at position line colum 
        """
        return _modshogun.HMM_get_b(self, *args)

    def get_psi(self, *args):
        """
        get_psi(self, time, state, dimension) -> T_STATES

        access function for backtracking table psi

        Parameters:
        -----------

        time:  time 0...T-1

        state:  state 0...N-1

        dimension:  dimension of observations 0...DIMENSION-1

        state at specified time and position 
        """
        return _modshogun.HMM_get_psi(self, *args)

    def state_probability(self, *args):
        """
        state_probability(self, time, state, dimension) -> float

        calculates probability of being in state i at time t for dimension 
        """
        return _modshogun.HMM_state_probability(self, *args)

    def transition_probability(self, *args):
        """
        transition_probability(self, time, state_i, state_j, dimension) -> float

        calculates probability of being in state i at time t and state j at
        time t+1 for dimension 
        """
        return _modshogun.HMM_transition_probability(self, *args)

    def linear_model_derivative(self, *args):
        """
        linear_model_derivative(self, i, j, dimension) -> float

        computes log dp(lambda)/d b_ij for linear model 
        """
        return _modshogun.HMM_linear_model_derivative(self, *args)

    def model_derivative_p(self, *args):
        """
        model_derivative_p(self, i, dimension) -> float

        computes log dp(lambda)/d p_i. backward path downto time 0 multiplied
        by observing first symbol in path at state i 
        """
        return _modshogun.HMM_model_derivative_p(self, *args)

    def model_derivative_q(self, *args):
        """
        model_derivative_q(self, i, dimension) -> float

        computes log dp(lambda)/d q_i. forward path upto time T-1 
        """
        return _modshogun.HMM_model_derivative_q(self, *args)

    def model_derivative_a(self, *args):
        """
        model_derivative_a(self, i, j, dimension) -> float

        computes log dp(lambda)/d a_ij. 
        """
        return _modshogun.HMM_model_derivative_a(self, *args)

    def model_derivative_b(self, *args):
        """
        model_derivative_b(self, i, j, dimension) -> float

        computes log dp(lambda)/d b_ij. 
        """
        return _modshogun.HMM_model_derivative_b(self, *args)

    def path_derivative_p(self, *args):
        """
        path_derivative_p(self, i, dimension) -> float

        computes d log p(lambda,best_path)/d p_i 
        """
        return _modshogun.HMM_path_derivative_p(self, *args)

    def path_derivative_q(self, *args):
        """
        path_derivative_q(self, i, dimension) -> float

        computes d log p(lambda,best_path)/d q_i 
        """
        return _modshogun.HMM_path_derivative_q(self, *args)

    def path_derivative_a(self, *args):
        """
        path_derivative_a(self, i, j, dimension) -> float

        computes d log p(lambda,best_path)/d a_ij 
        """
        return _modshogun.HMM_path_derivative_a(self, *args)

    def path_derivative_b(self, *args):
        """
        path_derivative_b(self, i, j, dimension) -> float

        computes d log p(lambda,best_path)/d b_ij 
        """
        return _modshogun.HMM_path_derivative_b(self, *args)

HMM_swigregister = _modshogun.HMM_swigregister
HMM_swigregister(HMM)

class GHMM(Distribution):
    """
    class GHMM - this class is non-functional and was meant to implement a
    Generalize Hidden Markov Model (aka Semi Hidden Markov HMM).

    C++ includes: GHMM.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GHMM, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GHMM, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> GHMM

        default constructor 
        """
        this = _modshogun.new_GHMM()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GHMM
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.GHMM_train(self, data)

GHMM_swigregister = _modshogun.GHMM_swigregister
GHMM_swigregister(GHMM)

class LinearHMM(Distribution):
    """
    The class LinearHMM is for learning Higher Order Markov chains.

    While learning the parameters ${\\bf \\theta}$ in

    \\begin{eqnarray*} P({\\bf x}|{\\bf \\theta}^\\pm)&=&P(x_1,
    \\ldots, x_N|{\\bf \\theta}^\\pm)\\\\
    &=&P(x_1,\\ldots,x_{d}|{\\bf \\theta}^\\pm)\\prod_{i=d+1}^N
    P(x_i|x_{i-1},\\ldots,x_{i-d},{\\bf \\theta}^\\pm)
    \\end{eqnarray*}

    are determined.

    A more detailed description can be found in

    Durbin et.al, Biological Sequence Analysis -Probabilistic Models of
    Proteins and Nucleic Acids, 1998

    C++ includes: LinearHMM.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearHMM, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearHMM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearHMM
        __init__(self, f) -> LinearHMM
        __init__(self, p_num_features, p_num_symbols) -> LinearHMM

        constructor

        Parameters:
        -----------

        p_num_features:  number of features

        p_num_symbols:  number of symbols in features 
        """
        this = _modshogun.new_LinearHMM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LinearHMM
    __del__ = lambda self : None;
    def train(self, *args):
        """
        train(self, data = None) -> bool
        train(self) -> bool
        train(self, indizes, num_indizes, pseudo_count) -> bool

        alternative train distribution

        Parameters:
        -----------

        indizes:  indices

        num_indizes:  number of indices

        pseudo_count:  pseudo count

        if training was successful 
        """
        return _modshogun.LinearHMM_train(self, *args)

    def get_likelihood_example(self, *args):
        """
        get_likelihood_example(self, vector, len) -> float

        get one example's likelihood

        Parameters:
        -----------

        vector:  the example

        len:  length of vector

        likelihood 
        """
        return _modshogun.LinearHMM_get_likelihood_example(self, *args)

    def get_log_likelihood_example(self, *args):
        """
        get_log_likelihood_example(self, vector, len) -> float
        get_log_likelihood_example(self, num_example) -> float

        get logarithm of one example's likelihood

        Parameters:
        -----------

        num_example:  which example

        logarithm of example's likelihood 
        """
        return _modshogun.LinearHMM_get_log_likelihood_example(self, *args)

    def get_log_derivative_obsolete(self, *args):
        """
        get_log_derivative_obsolete(self, obs, pos) -> float

        obsolete get logarithm of one example's derivative's likelihood

        Parameters:
        -----------

        obs:  observation

        pos:  position 
        """
        return _modshogun.LinearHMM_get_log_derivative_obsolete(self, *args)

    def get_derivative_obsolete(self, *args):
        """
        get_derivative_obsolete(self, vector, len, pos) -> float

        obsolete get one example's derivative

        Parameters:
        -----------

        vector:  vector

        len:  length

        pos:  position 
        """
        return _modshogun.LinearHMM_get_derivative_obsolete(self, *args)

    def get_sequence_length(self):
        """
        get_sequence_length(self) ->  int

        get sequence length of each example

        sequence length of each example 
        """
        return _modshogun.LinearHMM_get_sequence_length(self)

    def get_num_symbols(self):
        """
        get_num_symbols(self) ->  int

        get number of symbols in examples

        number of symbols in examples 
        """
        return _modshogun.LinearHMM_get_num_symbols(self)

    def get_positional_log_parameter(self, *args):
        """
        get_positional_log_parameter(self, obs, position) -> float

        get positional log parameter

        Parameters:
        -----------

        obs:  observation

        position:  position

        positional log parameter 
        """
        return _modshogun.LinearHMM_get_positional_log_parameter(self, *args)

    def get_log_transition_probs(self):
        """
        get_log_transition_probs(self) -> numpy 1dim array of %float

        get logarithm of all transition probs

        logarithm of transition probs vector 
        """
        return _modshogun.LinearHMM_get_log_transition_probs(self)

    def set_log_transition_probs(self, *args):
        """
        set_log_transition_probs(self, probs) -> bool

        set logarithm of all transition probs

        Parameters:
        -----------

        probs:  new logarithm transition probs

        if setting was successful 
        """
        return _modshogun.LinearHMM_set_log_transition_probs(self, *args)

    def get_transition_probs(self):
        """
        get_transition_probs(self) -> numpy 1dim array of %float

        get all transition probs

        vector of transition probs 
        """
        return _modshogun.LinearHMM_get_transition_probs(self)

    def set_transition_probs(self, *args):
        """
        set_transition_probs(self, probs) -> bool

        set all transition probs

        Parameters:
        -----------

        probs:  new transition probs

        if setting was successful 
        """
        return _modshogun.LinearHMM_set_transition_probs(self, *args)

LinearHMM_swigregister = _modshogun.LinearHMM_swigregister
LinearHMM_swigregister(LinearHMM)

class PositionalPWM(Distribution):
    """
    Positional PWM.

    C++ includes: PositionalPWM.h 
    """
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PositionalPWM, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PositionalPWM, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> PositionalPWM

        default constructor 
        """
        this = _modshogun.new_PositionalPWM()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PositionalPWM
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data

        whether training was successful 
        """
        return _modshogun.PositionalPWM_train(self, data)

    def get_log_likelihood_window(self, *args):
        """
        get_log_likelihood_window(self, window, len, pos) -> float

        get log likelihood window

        Parameters:
        -----------

        window:

        len:

        pos:  
        """
        return _modshogun.PositionalPWM_get_log_likelihood_window(self, *args)

    def get_sigma(self):
        """
        get_sigma(self) -> float

        get sigma 
        """
        return _modshogun.PositionalPWM_get_sigma(self)

    def set_sigma(self, *args):
        """
        set_sigma(self, sigma)

        set sigma

        Parameters:
        -----------

        sigma:  new sigma 
        """
        return _modshogun.PositionalPWM_set_sigma(self, *args)

    def get_mean(self):
        """
        get_mean(self) -> float

        get mean 
        """
        return _modshogun.PositionalPWM_get_mean(self)

    def set_mean(self, *args):
        """
        set_mean(self, mean)

        set mean

        Parameters:
        -----------

        mean:  new mean 
        """
        return _modshogun.PositionalPWM_set_mean(self, *args)

    def set_pwm(self, *args):
        """
        set_pwm(self, pwm)

        set pwm

        Parameters:
        -----------

        pwm:  new pwm (values must be in logspace) 
        """
        return _modshogun.PositionalPWM_set_pwm(self, *args)

    def get_pwm(self):
        """
        get_pwm(self) -> RealMatrix

        get pwm

        current pwm 
        """
        return _modshogun.PositionalPWM_get_pwm(self)

    def get_w(self):
        """
        get_w(self) -> RealMatrix

        get w

        current w 
        """
        return _modshogun.PositionalPWM_get_w(self)

    def get_scoring(self, *args):
        """
        get_scoring(self, d) -> RealMatrix

        get poim u

        Parameters:
        -----------

        d:  degree for which poim should be obtained

        poim u 
        """
        return _modshogun.PositionalPWM_get_scoring(self, *args)

    def compute_w(self, *args):
        """
        compute_w(self, num_pos)

        compute w

        Parameters:
        -----------

        num_pos:  
        """
        return _modshogun.PositionalPWM_compute_w(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree)

        compute scoring

        Parameters:
        -----------

        max_degree:  
        """
        return _modshogun.PositionalPWM_compute_scoring(self, *args)

PositionalPWM_swigregister = _modshogun.PositionalPWM_swigregister
PositionalPWM_swigregister(PositionalPWM)

FULL = _modshogun.FULL
DIAG = _modshogun.DIAG
SPHERICAL = _modshogun.SPHERICAL
class Gaussian(Distribution):
    """Proxy of C++ shogun::CGaussian class"""
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Gaussian, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Gaussian, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Gaussian
        __init__(self, mean, cov, cov_type = FULL) -> Gaussian
        __init__(self, mean, cov) -> Gaussian
        """
        this = _modshogun.new_Gaussian(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Gaussian
    __del__ = lambda self : None;
    def init(self):
        """init(self)"""
        return _modshogun.Gaussian_init(self)

    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.Gaussian_train(self, data)

    def compute_PDF(self, *args):
        """compute_PDF(self, point) -> float"""
        return _modshogun.Gaussian_compute_PDF(self, *args)

    def compute_log_PDF(self, *args):
        """compute_log_PDF(self, point) -> float"""
        return _modshogun.Gaussian_compute_log_PDF(self, *args)

    def get_mean(self):
        """get_mean(self) -> RealVector"""
        return _modshogun.Gaussian_get_mean(self)

    def set_mean(self, *args):
        """set_mean(self, mean)"""
        return _modshogun.Gaussian_set_mean(self, *args)

    def get_cov(self):
        """get_cov(self) -> RealMatrix"""
        return _modshogun.Gaussian_get_cov(self)

    def set_cov(self, *args):
        """set_cov(self, cov)"""
        return _modshogun.Gaussian_set_cov(self, *args)

    def get_cov_type(self):
        """get_cov_type(self) -> ECovType"""
        return _modshogun.Gaussian_get_cov_type(self)

    def set_cov_type(self, *args):
        """set_cov_type(self, cov_type)"""
        return _modshogun.Gaussian_set_cov_type(self, *args)

    def get_d(self):
        """get_d(self) -> RealVector"""
        return _modshogun.Gaussian_get_d(self)

    def set_d(self, *args):
        """set_d(self, d)"""
        return _modshogun.Gaussian_set_d(self, *args)

    def get_u(self):
        """get_u(self) -> RealMatrix"""
        return _modshogun.Gaussian_get_u(self)

    def set_u(self, *args):
        """set_u(self, u)"""
        return _modshogun.Gaussian_set_u(self, *args)

    def sample(self):
        """sample(self) -> RealVector"""
        return _modshogun.Gaussian_sample(self)

Gaussian_swigregister = _modshogun.Gaussian_swigregister
Gaussian_swigregister(Gaussian)

class GMM(Distribution):
    """Proxy of C++ shogun::CGMM class"""
    __swig_setmethods__ = {}
    for _s in [Distribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GMM, name, value)
    __swig_getmethods__ = {}
    for _s in [Distribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GMM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GMM
        __init__(self, n, cov_type = FULL) -> GMM
        __init__(self, n) -> GMM
        __init__(self, components, coefficients, copy = False) -> GMM
        __init__(self, components, coefficients) -> GMM
        """
        this = _modshogun.new_GMM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GMM
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        learn distribution

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.GMM_train(self, data)

    def train_em(self, min_cov = 1e-9, max_iter = 1000, min_change = 1e-9):
        """
        train_em(self, min_cov = 1e-9, max_iter = 1000, min_change = 1e-9) -> float
        train_em(self, min_cov = 1e-9, max_iter = 1000) -> float
        train_em(self, min_cov = 1e-9) -> float
        train_em(self) -> float
        """
        return _modshogun.GMM_train_em(self, min_cov, max_iter, min_change)

    def train_smem(self, max_iter = 100, max_cand = 5, min_cov = 1e-9, max_em_iter = 1000, 
    min_change = 1e-9):
        """
        train_smem(self, max_iter = 100, max_cand = 5, min_cov = 1e-9, max_em_iter = 1000, 
            min_change = 1e-9) -> float
        train_smem(self, max_iter = 100, max_cand = 5, min_cov = 1e-9, max_em_iter = 1000) -> float
        train_smem(self, max_iter = 100, max_cand = 5, min_cov = 1e-9) -> float
        train_smem(self, max_iter = 100, max_cand = 5) -> float
        train_smem(self, max_iter = 100) -> float
        train_smem(self) -> float
        """
        return _modshogun.GMM_train_smem(self, max_iter, max_cand, min_cov, max_em_iter, min_change)

    def max_likelihood(self, *args):
        """max_likelihood(self, alpha, min_cov)"""
        return _modshogun.GMM_max_likelihood(self, *args)

    def get_nth_mean(self, *args):
        """get_nth_mean(self, num) -> RealVector"""
        return _modshogun.GMM_get_nth_mean(self, *args)

    def set_nth_mean(self, *args):
        """set_nth_mean(self, mean, num)"""
        return _modshogun.GMM_set_nth_mean(self, *args)

    def get_nth_cov(self, *args):
        """get_nth_cov(self, num) -> RealMatrix"""
        return _modshogun.GMM_get_nth_cov(self, *args)

    def set_nth_cov(self, *args):
        """set_nth_cov(self, cov, num)"""
        return _modshogun.GMM_set_nth_cov(self, *args)

    def get_coef(self):
        """get_coef(self) -> RealVector"""
        return _modshogun.GMM_get_coef(self)

    def set_coef(self, *args):
        """set_coef(self, coefficients)"""
        return _modshogun.GMM_set_coef(self, *args)

    def sample(self):
        """sample(self) -> RealVector"""
        return _modshogun.GMM_sample(self)

    def cluster(self, *args):
        """cluster(self, point) -> RealVector"""
        return _modshogun.GMM_cluster(self, *args)

GMM_swigregister = _modshogun.GMM_swigregister
GMM_swigregister(GMM)

CT_NONE = _modshogun.CT_NONE
CT_LIGHT = _modshogun.CT_LIGHT
CT_LIGHTONECLASS = _modshogun.CT_LIGHTONECLASS
CT_LIBSVM = _modshogun.CT_LIBSVM
CT_LIBSVMONECLASS = _modshogun.CT_LIBSVMONECLASS
CT_LIBSVMMULTICLASS = _modshogun.CT_LIBSVMMULTICLASS
CT_MPD = _modshogun.CT_MPD
CT_GPBT = _modshogun.CT_GPBT
CT_CPLEXSVM = _modshogun.CT_CPLEXSVM
CT_PERCEPTRON = _modshogun.CT_PERCEPTRON
CT_KERNELPERCEPTRON = _modshogun.CT_KERNELPERCEPTRON
CT_LDA = _modshogun.CT_LDA
CT_LPM = _modshogun.CT_LPM
CT_LPBOOST = _modshogun.CT_LPBOOST
CT_KNN = _modshogun.CT_KNN
CT_SVMLIN = _modshogun.CT_SVMLIN
CT_KRR = _modshogun.CT_KRR
CT_GNPPSVM = _modshogun.CT_GNPPSVM
CT_GMNPSVM = _modshogun.CT_GMNPSVM
CT_SUBGRADIENTSVM = _modshogun.CT_SUBGRADIENTSVM
CT_SUBGRADIENTLPM = _modshogun.CT_SUBGRADIENTLPM
CT_SVMPERF = _modshogun.CT_SVMPERF
CT_LIBSVR = _modshogun.CT_LIBSVR
CT_SVRLIGHT = _modshogun.CT_SVRLIGHT
CT_LIBLINEAR = _modshogun.CT_LIBLINEAR
CT_KMEANS = _modshogun.CT_KMEANS
CT_HIERARCHICAL = _modshogun.CT_HIERARCHICAL
CT_SVMOCAS = _modshogun.CT_SVMOCAS
CT_WDSVMOCAS = _modshogun.CT_WDSVMOCAS
CT_SVMSGD = _modshogun.CT_SVMSGD
CT_MKLMULTICLASS = _modshogun.CT_MKLMULTICLASS
CT_MKLCLASSIFICATION = _modshogun.CT_MKLCLASSIFICATION
CT_MKLONECLASS = _modshogun.CT_MKLONECLASS
CT_MKLREGRESSION = _modshogun.CT_MKLREGRESSION
CT_SCATTERSVM = _modshogun.CT_SCATTERSVM
CT_DASVM = _modshogun.CT_DASVM
CT_LARANK = _modshogun.CT_LARANK
CT_DASVMLINEAR = _modshogun.CT_DASVMLINEAR
CT_GAUSSIANNAIVEBAYES = _modshogun.CT_GAUSSIANNAIVEBAYES
CT_AVERAGEDPERCEPTRON = _modshogun.CT_AVERAGEDPERCEPTRON
CT_SGDQN = _modshogun.CT_SGDQN
ST_AUTO = _modshogun.ST_AUTO
ST_CPLEX = _modshogun.ST_CPLEX
ST_GLPK = _modshogun.ST_GLPK
ST_NEWTON = _modshogun.ST_NEWTON
ST_DIRECT = _modshogun.ST_DIRECT
ST_ELASTICNET = _modshogun.ST_ELASTICNET
ST_BLOCK_NORM = _modshogun.ST_BLOCK_NORM
class Machine(SGObject):
    """
    A generic learning machine interface.

    A machine takes as input CFeatures and (optionally) CLabels. Later
    subclasses may specialize the machine to e.g. require labels and a
    kernel or labels and (real-valued) features.

    A machine needs to override the train() function for training, the
    functions apply(idx) (optionally apply() to predict on the whole set
    of examples) and the load and save routines.

    C++ includes: Machine.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Machine, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Machine, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_Machine
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        train machine

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data). If flag is set, model features will be stored after
        training.

        whether training was successful 
        """
        return _modshogun.Machine_train(self, data)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, num) -> float

        apply machine to one example

        abstract base method

        Parameters:
        -----------

        num:  which example to apply machine to

        infinite float value 
        """
        return _modshogun.Machine_apply(self, *args)

    def load(self, *args):
        """
        load(self, srcfile) -> bool

        load Machine from file

        abstract base method

        Parameters:
        -----------

        srcfile:  file to load from

        failure 
        """
        return _modshogun.Machine_load(self, *args)

    def save(self, *args):
        """
        save(self, dstfile) -> bool

        save Machine to file

        abstract base method

        Parameters:
        -----------

        dstfile:  file to save to

        failure 
        """
        return _modshogun.Machine_save(self, *args)

    def set_labels(self, *args):
        """
        set_labels(self, lab)

        set labels

        Parameters:
        -----------

        lab:  labels 
        """
        return _modshogun.Machine_set_labels(self, *args)

    def get_labels(self):
        """
        get_labels(self) -> numpy 1dim array of float

        get labels

        labels 
        """
        return _modshogun.Machine_get_labels(self)

    def get_label(self, *args):
        """
        get_label(self, i) -> float

        get one specific label

        Parameters:
        -----------

        i:  index of label to get

        value of label at index i 
        """
        return _modshogun.Machine_get_label(self, *args)

    def set_max_train_time(self, *args):
        """
        set_max_train_time(self, t)

        set maximum training time

        Parameters:
        -----------

        t:  maximimum training time 
        """
        return _modshogun.Machine_set_max_train_time(self, *args)

    def get_max_train_time(self):
        """
        get_max_train_time(self) -> float

        get maximum training time

        maximum training time 
        """
        return _modshogun.Machine_get_max_train_time(self)

    def get_classifier_type(self):
        """
        get_classifier_type(self) -> EClassifierType

        get classifier type

        classifier type NONE 
        """
        return _modshogun.Machine_get_classifier_type(self)

    def set_solver_type(self, *args):
        """
        set_solver_type(self, st)

        set solver type

        Parameters:
        -----------

        st:  solver type 
        """
        return _modshogun.Machine_set_solver_type(self, *args)

    def get_solver_type(self):
        """
        get_solver_type(self) -> ESolverType

        get solver type

        solver 
        """
        return _modshogun.Machine_get_solver_type(self)

    def set_store_model_features(self, *args):
        """
        set_store_model_features(self, store_model)

        Setter for store-model-features-after-training flag

        Parameters:
        -----------

        store_model:  whether model should be stored after training 
        """
        return _modshogun.Machine_set_store_model_features(self, *args)

Machine_swigregister = _modshogun.Machine_swigregister
Machine_swigregister(Machine)

class KernelMachine(Machine):
    """
    A generic KernelMachine interface.

    A kernel machine is defined as \\[ f({\\bf x})=\\sum_{i=0}^{N-1}
    \\alpha_i k({\\bf x}, {\\bf x_i})+b \\]

    where $N$ is the number of training examples $\\alpha_i$ are the
    weights assigned to each training example $k(x,x')$ is the kernel and
    $b$ the bias.

    Using an a-priori choosen kernel, the $\\alpha_i$ and bias are
    determined in a training procedure.

    C++ includes: KernelMachine.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelMachine, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelMachine, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> KernelMachine

        default constructor 
        """
        this = _modshogun.new_KernelMachine()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KernelMachine
    __del__ = lambda self : None;
    def set_kernel(self, *args):
        """
        set_kernel(self, k)

        set kernel

        Parameters:
        -----------

        k:  kernel 
        """
        return _modshogun.KernelMachine_set_kernel(self, *args)

    def get_kernel(self):
        """
        get_kernel(self) -> Kernel

        get kernel

        kernel 
        """
        return _modshogun.KernelMachine_get_kernel(self)

    def set_batch_computation_enabled(self, *args):
        """
        set_batch_computation_enabled(self, enable)

        set batch computation enabled

        Parameters:
        -----------

        enable:  if batch computation shall be enabled 
        """
        return _modshogun.KernelMachine_set_batch_computation_enabled(self, *args)

    def get_batch_computation_enabled(self):
        """
        get_batch_computation_enabled(self) -> bool

        check if batch computation is enabled

        if batch computation is enabled 
        """
        return _modshogun.KernelMachine_get_batch_computation_enabled(self)

    def set_linadd_enabled(self, *args):
        """
        set_linadd_enabled(self, enable)

        set linadd enabled

        Parameters:
        -----------

        enable:  if linadd shall be enabled 
        """
        return _modshogun.KernelMachine_set_linadd_enabled(self, *args)

    def get_linadd_enabled(self):
        """
        get_linadd_enabled(self) -> bool

        check if linadd is enabled

        if linadd is enabled 
        """
        return _modshogun.KernelMachine_get_linadd_enabled(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set state of bias

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.KernelMachine_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        get state of bias

        state of bias 
        """
        return _modshogun.KernelMachine_get_bias_enabled(self)

    def get_bias(self):
        """
        get_bias(self) -> float

        get bias

        bias 
        """
        return _modshogun.KernelMachine_get_bias(self)

    def set_bias(self, *args):
        """
        set_bias(self, bias)

        set bias to given value

        Parameters:
        -----------

        bias:  new bias 
        """
        return _modshogun.KernelMachine_set_bias(self, *args)

    def get_support_vector(self, *args):
        """
        get_support_vector(self, idx) ->  int

        get support vector at given index

        Parameters:
        -----------

        idx:  index of support vector

        support vector 
        """
        return _modshogun.KernelMachine_get_support_vector(self, *args)

    def get_alpha(self, *args):
        """
        get_alpha(self, idx) -> float

        get alpha at given index

        Parameters:
        -----------

        idx:  index of alpha

        alpha 
        """
        return _modshogun.KernelMachine_get_alpha(self, *args)

    def set_support_vector(self, *args):
        """
        set_support_vector(self, idx, val) -> bool

        set support vector at given index to given value

        Parameters:
        -----------

        idx:  index of support vector

        val:  new value of support vector

        if operation was successful 
        """
        return _modshogun.KernelMachine_set_support_vector(self, *args)

    def set_alpha(self, *args):
        """
        set_alpha(self, idx, val) -> bool

        set alpha at given index to given value

        Parameters:
        -----------

        idx:  index of alpha vector

        val:  new value of alpha vector

        if operation was successful 
        """
        return _modshogun.KernelMachine_set_alpha(self, *args)

    def get_num_support_vectors(self):
        """
        get_num_support_vectors(self) ->  int

        get number of support vectors

        number of support vectors 
        """
        return _modshogun.KernelMachine_get_num_support_vectors(self)

    def set_alphas(self, *args):
        """
        set_alphas(self, alphas)

        set alphas to given values

        Parameters:
        -----------

        alphas:  float vector with all alphas to set 
        """
        return _modshogun.KernelMachine_set_alphas(self, *args)

    def set_support_vectors(self, *args):
        """
        set_support_vectors(self, svs)

        set support vectors to given values

        Parameters:
        -----------

        svs:  integer vector with all support vectors indexes to set 
        """
        return _modshogun.KernelMachine_set_support_vectors(self, *args)

    def get_support_vectors(self):
        """
        get_support_vectors(self) -> [] of int

        get all support vectors 
        """
        return _modshogun.KernelMachine_get_support_vectors(self)

    def get_alphas(self):
        """
        get_alphas(self) -> [] of float

        get all alphas 
        """
        return _modshogun.KernelMachine_get_alphas(self)

    def create_new_model(self, *args):
        """
        create_new_model(self, num) -> bool

        create new model

        Parameters:
        -----------

        num:  number of alphas and support vectors in new model 
        """
        return _modshogun.KernelMachine_create_new_model(self, *args)

    def init_kernel_optimization(self):
        """
        init_kernel_optimization(self) -> bool

        initialise kernel optimisation

        if operation was successful 
        """
        return _modshogun.KernelMachine_init_kernel_optimization(self)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, num) -> float

        apply kernel machine to one example

        Parameters:
        -----------

        num:  which example to apply to

        classified value 
        """
        return _modshogun.KernelMachine_apply(self, *args)

    def apply_helper(*args):
        """apply_helper(p) -> void"""
        return _modshogun.KernelMachine_apply_helper(*args)

    if _newclass:apply_helper = staticmethod(apply_helper)
    __swig_getmethods__["apply_helper"] = lambda x: apply_helper
KernelMachine_swigregister = _modshogun.KernelMachine_swigregister
KernelMachine_swigregister(KernelMachine)

def KernelMachine_apply_helper(*args):
  """KernelMachine_apply_helper(p) -> void"""
  return _modshogun.KernelMachine_apply_helper(*args)

class CDistanceMachine(Machine):
    """
    A generic DistanceMachine interface.

    A distance machine is based on a a-priori choosen distance.

    C++ includes: DistanceMachine.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CDistanceMachine, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CDistanceMachine, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> CDistanceMachine

        default constructor 
        """
        this = _modshogun.new_CDistanceMachine()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CDistanceMachine
    __del__ = lambda self : None;
    def set_distance(self, *args):
        """
        set_distance(self, d)

        set distance

        Parameters:
        -----------

        d:  distance to set 
        """
        return _modshogun.CDistanceMachine_set_distance(self, *args)

    def get_distance(self):
        """
        get_distance(self) -> Distance

        get distance

        distance 
        """
        return _modshogun.CDistanceMachine_get_distance(self)

    def distances_lhs(self, *args):
        """
        distances_lhs(self, result, idx_a1, idx_a2, idx_b)

        get distance functions for lhs feature vectors going from a1 to a2 and
        rhs feature vector b

        Parameters:
        -----------

        result:  array of distance values

        idx_a1:  first feature vector a1 at idx_a1

        idx_a2:  last feature vector a2 at idx_a2

        idx_b:  feature vector b at idx_b 
        """
        return _modshogun.CDistanceMachine_distances_lhs(self, *args)

    def distances_rhs(self, *args):
        """
        distances_rhs(self, result, idx_b1, idx_b2, idx_a)

        get distance functions for rhs feature vectors going from b1 to b2 and
        lhs feature vector a

        Parameters:
        -----------

        result:  array of distance values

        idx_b1:  first feature vector a1 at idx_b1

        idx_b2:  last feature vector a2 at idx_b2

        idx_a:  feature vector a at idx_a 
        """
        return _modshogun.CDistanceMachine_distances_rhs(self, *args)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, num) -> float

        Apply machine to one example. Cluster index with smallest distance to
        to be classified element is returned

        Parameters:
        -----------

        num:  which example to apply machine to

        cluster label nearest to example 
        """
        return _modshogun.CDistanceMachine_apply(self, *args)

CDistanceMachine_swigregister = _modshogun.CDistanceMachine_swigregister
CDistanceMachine_swigregister(CDistanceMachine)

class CSVM(KernelMachine):
    """
    A generic Support Vector Machine Interface.

    A support vector machine is defined as \\[ f({\\bf
    x})=\\sum_{i=0}^{N-1} \\alpha_i k({\\bf x}, {\\bf x_i})+b
    \\]

    where $N$ is the number of training examples $\\alpha_i$ are the
    weights assigned to each training example $k(x,x')$ is the kernel and
    $b$ the bias.

    Using an a-priori choosen kernel, the $\\alpha_i$ and bias are
    determined by solving the following quadratic program

    \\begin{eqnarray*} \\max_{\\bf \\alpha} && \\sum_{i=0}^{N-1}
    \\alpha_i - \\sum_{i=0}^{N-1}\\sum_{j=0}^{N-1} \\alpha_i y_i
    \\alpha_j y_j k({\\bf x_i}, {\\bf x_j})\\\\ \\mbox{s.t.}
    && 0\\leq\\alpha_i\\leq C\\\\ && \\sum_{i=0}^{N-1}
    \\alpha_i y_i=0\\\\ \\end{eqnarray*} here C is a pre-specified
    regularization parameter.

    C++ includes: SVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, num_sv = 0) -> CSVM
        __init__(self) -> CSVM
        __init__(self, C, k, lab) -> CSVM

        Create a Support Vector Machine Object from a trained SVM

        Parameters:
        -----------

        C:  the C parameter

        k:  the Kernel object

        lab:  the Label object 
        """
        this = _modshogun.new_CSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CSVM
    __del__ = lambda self : None;
    def set_defaults(self, num_sv = 0):
        """
        set_defaults(self, num_sv = 0)
        set_defaults(self)

        set default values for members a SVM object 
        """
        return _modshogun.CSVM_set_defaults(self, num_sv)

    def get_linear_term(self):
        """
        get_linear_term(self) -> RealVector

        get linear term

        the linear term 
        """
        return _modshogun.CSVM_get_linear_term(self)

    def set_linear_term(self, *args):
        """
        set_linear_term(self, linear_term)

        set linear term of the QP

        Parameters:
        -----------

        linear_term:  the linear term 
        """
        return _modshogun.CSVM_set_linear_term(self, *args)

    def set_nu(self, *args):
        """
        set_nu(self, nue)

        set nu

        Parameters:
        -----------

        nue:  new nu 
        """
        return _modshogun.CSVM_set_nu(self, *args)

    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples

        Note that not all SVMs support this (however at least CLibSVM and
        CSVMLight do) 
        """
        return _modshogun.CSVM_set_C(self, *args)

    def set_epsilon(self, *args):
        """
        set_epsilon(self, eps)

        set epsilon

        Parameters:
        -----------

        eps:  new epsilon 
        """
        return _modshogun.CSVM_set_epsilon(self, *args)

    def set_tube_epsilon(self, *args):
        """
        set_tube_epsilon(self, eps)

        set tube epsilon

        Parameters:
        -----------

        eps:  new tube epsilon 
        """
        return _modshogun.CSVM_set_tube_epsilon(self, *args)

    def get_tube_epsilon(self):
        """
        get_tube_epsilon(self) -> float

        get tube epsilon

        tube epsilon 
        """
        return _modshogun.CSVM_get_tube_epsilon(self)

    def set_qpsize(self, *args):
        """
        set_qpsize(self, qps)

        set qpsize

        Parameters:
        -----------

        qps:  new qpsize 
        """
        return _modshogun.CSVM_set_qpsize(self, *args)

    def get_epsilon(self):
        """
        get_epsilon(self) -> float

        get epsilon

        epsilon 
        """
        return _modshogun.CSVM_get_epsilon(self)

    def get_nu(self):
        """
        get_nu(self) -> float

        get nu

        nu 
        """
        return _modshogun.CSVM_get_nu(self)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.CSVM_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.CSVM_get_C2(self)

    def get_qpsize(self):
        """
        get_qpsize(self) ->  int

        get qpsize

        qpsize 
        """
        return _modshogun.CSVM_get_qpsize(self)

    def set_shrinking_enabled(self, *args):
        """
        set_shrinking_enabled(self, enable)

        set state of shrinking

        Parameters:
        -----------

        enable:  if shrinking will be enabled 
        """
        return _modshogun.CSVM_set_shrinking_enabled(self, *args)

    def get_shrinking_enabled(self):
        """
        get_shrinking_enabled(self) -> bool

        get state of shrinking

        if shrinking is enabled 
        """
        return _modshogun.CSVM_get_shrinking_enabled(self)

    def compute_svm_dual_objective(self):
        """
        compute_svm_dual_objective(self) -> float

        compute svm dual objective

        computed dual objective 
        """
        return _modshogun.CSVM_compute_svm_dual_objective(self)

    def compute_svm_primal_objective(self):
        """
        compute_svm_primal_objective(self) -> float

        compute svm primal objective

        computed svm primal objective 
        """
        return _modshogun.CSVM_compute_svm_primal_objective(self)

    def set_objective(self, *args):
        """
        set_objective(self, v)

        set objective

        Parameters:
        -----------

        v:  objective 
        """
        return _modshogun.CSVM_set_objective(self, *args)

    def get_objective(self):
        """
        get_objective(self) -> float

        get objective

        objective 
        """
        return _modshogun.CSVM_get_objective(self)

    def set_callback_function(self, *args):
        """
        set_callback_function(self, m, cb)

        set callback function svm optimizers may call when they have a new
        (small) set of alphas

        Parameters:
        -----------

        m:  pointer to mkl object

        cb:  callback function 
        """
        return _modshogun.CSVM_set_callback_function(self, *args)

CSVM_swigregister = _modshogun.CSVM_swigregister
CSVM_swigregister(CSVM)

ONE_VS_REST = _modshogun.ONE_VS_REST
ONE_VS_ONE = _modshogun.ONE_VS_ONE
class MultiClassSVM(CSVM):
    """
    class MultiClassSVM

    C++ includes: MultiClassSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultiClassSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultiClassSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultiClassSVM
        __init__(self, type) -> MultiClassSVM
        __init__(self, type, C, k, lab) -> MultiClassSVM

        constructor

        Parameters:
        -----------

        type:  type of MultiClassSVM

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_MultiClassSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MultiClassSVM
    __del__ = lambda self : None;
    def create_multiclass_svm(self, *args):
        """
        create_multiclass_svm(self, num_classes) -> bool

        create multiclass SVM

        Parameters:
        -----------

        num_classes:  number of classes in SVM

        if creation was successful 
        """
        return _modshogun.MultiClassSVM_create_multiclass_svm(self, *args)

    def set_svm(self, *args):
        """
        set_svm(self, num, svm) -> bool

        set SVM

        Parameters:
        -----------

        num:  number to set

        svm:  SVM to set

        if setting was successful 
        """
        return _modshogun.MultiClassSVM_set_svm(self, *args)

    def get_svm(self, *args):
        """
        get_svm(self, num) -> CSVM

        get SVM

        Parameters:
        -----------

        num:  which SVM to get

        SVM at number num 
        """
        return _modshogun.MultiClassSVM_get_svm(self, *args)

    def get_num_svms(self):
        """
        get_num_svms(self) ->  int

        get number of SVMs

        number of SVMs 
        """
        return _modshogun.MultiClassSVM_get_num_svms(self)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, num) -> float

        classify one example

        Parameters:
        -----------

        num:  number of example to classify

        resulting classification 
        """
        return _modshogun.MultiClassSVM_apply(self, *args)

    def classify_one_vs_rest(self):
        """
        classify_one_vs_rest(self) -> Labels

        classify one vs rest

        resulting labels 
        """
        return _modshogun.MultiClassSVM_classify_one_vs_rest(self)

    def classify_example_one_vs_rest(self, *args):
        """
        classify_example_one_vs_rest(self, num) -> float

        classify one example one vs rest

        Parameters:
        -----------

        num:  number of example of classify

        resulting classification 
        """
        return _modshogun.MultiClassSVM_classify_example_one_vs_rest(self, *args)

    def classify_one_vs_one(self):
        """
        classify_one_vs_one(self) -> Labels

        classify one vs one

        resulting labels 
        """
        return _modshogun.MultiClassSVM_classify_one_vs_one(self)

    def classify_example_one_vs_one(self, *args):
        """
        classify_example_one_vs_one(self, num) -> float

        classify one example one vs one

        Parameters:
        -----------

        num:  number of example of classify

        resulting classification 
        """
        return _modshogun.MultiClassSVM_classify_example_one_vs_one(self, *args)

    def get_multiclass_type(self):
        """
        get_multiclass_type(self) -> EMultiClassSVM

        get the type of multiclass'ness

        multiclass type 1 vs one etc 
        """
        return _modshogun.MultiClassSVM_get_multiclass_type(self)

MultiClassSVM_swigregister = _modshogun.MultiClassSVM_swigregister
MultiClassSVM_swigregister(MultiClassSVM)

class LinearMachine(Machine):
    """
    Class LinearMachine is a generic interface for all kinds of linear
    machines like classifiers.

    A linear classifier computes

    \\[ f({\\bf x})= {\\bf w} \\cdot {\\bf x} + b \\]

    where ${\\bf w}$ are the weights assigned to each feature in
    training and $b$ the bias.

    To implement a linear classifier all that is required is to define the
    train() function that delivers ${\\bf w}$ above.

    Note that this framework works with linear classifiers of arbitraty
    feature type, e.g. dense and sparse and even string based features.
    This is implemented by using CDotFeatures that may provide a mapping
    function $\\Phi({\\bf x})\\mapsto {\\cal R^D}$ encapsulating
    all the required operations (like the dot product). The decision
    function is thus

    \\[ f({\\bf x})= {\\bf w} \\cdot \\Phi({\\bf x}) + b.
    \\]

    The following linear classifiers are implemented Linear Descriminant
    Analysis (CLDA)

    Linear Programming Machines (CLPM, CLPBoost)

    Perceptron ( CPerceptron)

    Linear SVMs ( CSVMSGD, CLibLinear, CSVMOcas, CSVMLin, CSubgradientSVM)

    See:   CDotFeatures

    C++ includes: LinearMachine.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearMachine, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearMachine, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> LinearMachine

        default constructor 
        """
        this = _modshogun.new_LinearMachine()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LinearMachine
    __del__ = lambda self : None;
    def get_w(self, *args):
        """
        get_w(self) -> [] of float
        get_w(self) -> [] of float

        get w

        weight vector 
        """
        return _modshogun.LinearMachine_get_w(self, *args)

    def set_w(self, *args):
        """
        set_w(self, src_w)

        set w

        Parameters:
        -----------

        src_w:  new w 
        """
        return _modshogun.LinearMachine_set_w(self, *args)

    def set_bias(self, *args):
        """
        set_bias(self, b)

        set bias

        Parameters:
        -----------

        b:  new bias 
        """
        return _modshogun.LinearMachine_set_bias(self, *args)

    def get_bias(self):
        """
        get_bias(self) -> float

        get bias

        bias 
        """
        return _modshogun.LinearMachine_get_bias(self)

    def set_features(self, *args):
        """
        set_features(self, feat)

        set features

        Parameters:
        -----------

        feat:  features to set 
        """
        return _modshogun.LinearMachine_set_features(self, *args)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, vec_idx) -> float

        get output for example "vec_idx" 
        """
        return _modshogun.LinearMachine_apply(self, *args)

    def get_features(self):
        """
        get_features(self) -> DotFeatures

        get features

        features 
        """
        return _modshogun.LinearMachine_get_features(self)

LinearMachine_swigregister = _modshogun.LinearMachine_swigregister
LinearMachine_swigregister(LinearMachine)

class OnlineLinearMachine(Machine):
    """
    Class OnlineLinearMachine is a generic interface for linear machines
    like classifiers which work through online algorithms.

    A linear classifier computes

    \\[ f({\\bf x})= {\\bf w} \\cdot {\\bf x} + b \\]

    where ${\\bf w}$ are the weights assigned to each feature in
    training and $b$ the bias.

    To implement a linear classifier all that is required is to define the
    train() function that delivers ${\\bf w}$ above.

    Note that this framework works with linear classifiers of arbitrary
    feature type, e.g. dense and sparse and even string based features.
    This is implemented by using CStreamingDotFeatures that may provide a
    mapping function $\\Phi({\\bf x})\\mapsto {\\cal R^D}$
    encapsulating all the required operations (like the dot product). The
    decision function is thus

    \\[ f({\\bf x})= {\\bf w} \\cdot \\Phi({\\bf x}) + b.
    \\]

    C++ includes: OnlineLinearMachine.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OnlineLinearMachine, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OnlineLinearMachine, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> OnlineLinearMachine

        default constructor 
        """
        this = _modshogun.new_OnlineLinearMachine()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_OnlineLinearMachine
    __del__ = lambda self : None;
    def get_w(self, *args):
        """
        get_w(self) -> [] of float
        get_w(self) -> [] of float
        get_w(self) -> [] of float

        get w

        weight vector 
        """
        return _modshogun.OnlineLinearMachine_get_w(self, *args)

    def set_w(self, *args):
        """
        set_w(self, src_w, src_w_dim)
        set_w(self, src_w, src_w_dim)

        Set weight vector from a float vector

        Parameters:
        -----------

        src_w:  new w

        src_w_dim:  dimension of new w 
        """
        return _modshogun.OnlineLinearMachine_set_w(self, *args)

    def set_bias(self, *args):
        """
        set_bias(self, b)

        set bias

        Parameters:
        -----------

        b:  new bias 
        """
        return _modshogun.OnlineLinearMachine_set_bias(self, *args)

    def get_bias(self):
        """
        get_bias(self) -> float

        get bias

        bias 
        """
        return _modshogun.OnlineLinearMachine_get_bias(self)

    def set_features(self, *args):
        """
        set_features(self, feat)

        set features

        Parameters:
        -----------

        feat:  features to set 
        """
        return _modshogun.OnlineLinearMachine_set_features(self, *args)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, vec_idx) -> float
        apply(self, vec, len) -> float

        apply linear machine to one vector

        Parameters:
        -----------

        vec:  feature vector

        len:  length of vector

        classified label 
        """
        return _modshogun.OnlineLinearMachine_apply(self, *args)

    def apply_to_current_example(self):
        """
        apply_to_current_example(self) -> float

        apply linear machine to vector currently being processed

        classified label 
        """
        return _modshogun.OnlineLinearMachine_apply_to_current_example(self)

    def get_features(self):
        """
        get_features(self) -> StreamingDotFeatures

        get features

        features 
        """
        return _modshogun.OnlineLinearMachine_get_features(self)

OnlineLinearMachine_swigregister = _modshogun.OnlineLinearMachine_swigregister
OnlineLinearMachine_swigregister(OnlineLinearMachine)

class GaussianNaiveBayes(Machine):
    """
    Class GaussianNaiveBayes, a Gaussian Naive Bayes classifier.

    This classifier assumes that a posteriori conditional probabilities
    are gaussian pdfs. For each vector gaussian naive bayes chooses the
    class C with maximal

    \\[ P(c) \\prod_{i} P(x_i|c) \\]

    C++ includes: GaussianNaiveBayes.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianNaiveBayes, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianNaiveBayes, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianNaiveBayes
        __init__(self, train_examples, train_labels) -> GaussianNaiveBayes

        constructor

        Parameters:
        -----------

        train_examples:  train examples

        train_labels:  labels corresponding to train_examples 
        """
        this = _modshogun.new_GaussianNaiveBayes(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GaussianNaiveBayes
    __del__ = lambda self : None;
    def set_features(self, *args):
        """
        set_features(self, features)

        set features for classify

        Parameters:
        -----------

        features:  features to be set 
        """
        return _modshogun.GaussianNaiveBayes_set_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> DotFeatures

        get features for classify current features 
        """
        return _modshogun.GaussianNaiveBayes_get_features(self)

    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        train classifier

        Parameters:
        -----------

        data:  train examples

        true if successful 
        """
        return _modshogun.GaussianNaiveBayes_train(self, data)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, idx) -> float

        classifiy specified example

        Parameters:
        -----------

        idx:  example index

        label 
        """
        return _modshogun.GaussianNaiveBayes_apply(self, *args)

GaussianNaiveBayes_swigregister = _modshogun.GaussianNaiveBayes_swigregister
GaussianNaiveBayes_swigregister(GaussianNaiveBayes)

class GMNPSVM(MultiClassSVM):
    """
    Class GMNPSVM implements a one vs. rest MultiClass SVM.

    It uses CGMNPLib for training (in true multiclass-SVM fashion).

    C++ includes: GMNPSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultiClassSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GMNPSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiClassSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GMNPSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GMNPSVM
        __init__(self, C, k, lab) -> GMNPSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_GMNPSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GMNPSVM
    __del__ = lambda self : None;
    def get_basealphas_ptr(self, *args):
        """
        get_basealphas_ptr(self, y, x) -> float

        required for CMKLMulticlass constraint computation

        Parameters:
        -----------

        y:  height of basealphas

        x:  width of basealphas

        basealphas basealphas[k][j] is the alpha for class k and sample j
        which is untransformed compared to the alphas stored in CSVM* members

        """
        return _modshogun.GMNPSVM_get_basealphas_ptr(self, *args)

GMNPSVM_swigregister = _modshogun.GMNPSVM_swigregister
GMNPSVM_swigregister(GMNPSVM)

class GNPPSVM(CSVM):
    """
    class GNPPSVM

    C++ includes: GNPPSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GNPPSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GNPPSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GNPPSVM
        __init__(self, C, k, lab) -> GNPPSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_GNPPSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GNPPSVM
    __del__ = lambda self : None;
GNPPSVM_swigregister = _modshogun.GNPPSVM_swigregister
GNPPSVM_swigregister(GNPPSVM)

class GPBTSVM(CSVM):
    """
    class GPBTSVM

    C++ includes: GPBTSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GPBTSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GPBTSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GPBTSVM
        __init__(self, C, k, lab) -> GPBTSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_GPBTSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GPBTSVM
    __del__ = lambda self : None;
GPBTSVM_swigregister = _modshogun.GPBTSVM_swigregister
GPBTSVM_swigregister(GPBTSVM)

class KNN(CDistanceMachine):
    """
    Class KNN, an implementation of the standard k-nearest neigbor
    classifier.

    An example is classified to belong to the class of which the majority
    of the k closest examples belong to. Formally, kNN is described as

    \\[ label for x = \\arg \\max_{l} \\sum_{i=1}^{k} [label of
    i-th example = l] \\]

    This class provides a capability to do weighted classfication using:

    \\[ label for x = \\arg \\max_{l} \\sum_{i=1}^{k} [label of
    i-th example = l] q^{i}, \\]

    where $|q|<1$.

    To avoid ties, k should be an odd number. To define how close examples
    are k-NN requires a CDistance object to work with (e.g.,
    CEuclideanDistance ).

    Note that k-NN has zero training time but classification times
    increase dramatically with the number of examples. Also note that k-NN
    is capable of multi-class-classification. And finally, in case of k=1
    classification will take less time with an special optimization
    provided.

    C++ includes: KNN.h 
    """
    __swig_setmethods__ = {}
    for _s in [CDistanceMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KNN, name, value)
    __swig_getmethods__ = {}
    for _s in [CDistanceMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KNN, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KNN
        __init__(self, k, d, trainlab) -> KNN

        constructor

        Parameters:
        -----------

        k:  k

        d:  distance

        trainlab:  labels for training 
        """
        this = _modshogun.new_KNN(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KNN
    __del__ = lambda self : None;
    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, vec_idx) -> float

        get output for example "vec_idx" 
        """
        return _modshogun.KNN_apply(self, *args)

    def classify_for_multiple_k(self):
        """
        classify_for_multiple_k(self) -> IntMatrix

        classify all examples for 1...k 
        """
        return _modshogun.KNN_classify_for_multiple_k(self)

    def set_k(self, *args):
        """
        set_k(self, k)

        set k

        Parameters:
        -----------

        k:  k to be set 
        """
        return _modshogun.KNN_set_k(self, *args)

    def get_k(self):
        """
        get_k(self) ->  int

        get k

        value of k 
        """
        return _modshogun.KNN_get_k(self)

    def set_q(self, *args):
        """
        set_q(self, q)

        set q

        Parameters:
        -----------

        q:  value 
        """
        return _modshogun.KNN_set_q(self, *args)

    def get_q(self):
        """
        get_q(self) -> float

        get q q parameter 
        """
        return _modshogun.KNN_get_q(self)

KNN_swigregister = _modshogun.KNN_swigregister
KNN_swigregister(KNN)

class LDA(LinearMachine):
    """Proxy of C++ shogun::CLDA class"""
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LDA, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LDA, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, gamma = 0) -> LDA
        __init__(self) -> LDA
        __init__(self, gamma, traindat, trainlab) -> LDA
        """
        this = _modshogun.new_LDA(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LDA
    __del__ = lambda self : None;
    def set_gamma(self, *args):
        """set_gamma(self, gamma)"""
        return _modshogun.LDA_set_gamma(self, *args)

    def get_gamma(self):
        """get_gamma(self) -> float"""
        return _modshogun.LDA_get_gamma(self)

LDA_swigregister = _modshogun.LDA_swigregister
LDA_swigregister(LDA)

L2R_LR = _modshogun.L2R_LR
L2R_L2LOSS_SVC_DUAL = _modshogun.L2R_L2LOSS_SVC_DUAL
L2R_L2LOSS_SVC = _modshogun.L2R_L2LOSS_SVC
L2R_L1LOSS_SVC_DUAL = _modshogun.L2R_L1LOSS_SVC_DUAL
MCSVM_CS = _modshogun.MCSVM_CS
L1R_L2LOSS_SVC = _modshogun.L1R_L2LOSS_SVC
L1R_LR = _modshogun.L1R_LR
class LibLinear(LinearMachine):
    """Proxy of C++ shogun::CLibLinear class"""
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibLinear, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibLinear, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LibLinear
        __init__(self, liblinear_solver_type) -> LibLinear
        __init__(self, C, traindat, trainlab) -> LibLinear
        """
        this = _modshogun.new_LibLinear(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LibLinear
    __del__ = lambda self : None;
    def get_liblinear_solver_type(self):
        """get_liblinear_solver_type(self) -> LIBLINEAR_SOLVER_TYPE"""
        return _modshogun.LibLinear_get_liblinear_solver_type(self)

    def set_liblinear_solver_type(self, *args):
        """set_liblinear_solver_type(self, st)"""
        return _modshogun.LibLinear_set_liblinear_solver_type(self, *args)

    def set_C(self, *args):
        """set_C(self, c_neg, c_pos)"""
        return _modshogun.LibLinear_set_C(self, *args)

    def get_C1(self):
        """get_C1(self) -> float"""
        return _modshogun.LibLinear_get_C1(self)

    def get_C2(self):
        """get_C2(self) -> float"""
        return _modshogun.LibLinear_get_C2(self)

    def set_epsilon(self, *args):
        """set_epsilon(self, eps)"""
        return _modshogun.LibLinear_set_epsilon(self, *args)

    def get_epsilon(self):
        """get_epsilon(self) -> float"""
        return _modshogun.LibLinear_get_epsilon(self)

    def set_bias_enabled(self, *args):
        """set_bias_enabled(self, enable_bias)"""
        return _modshogun.LibLinear_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """get_bias_enabled(self) -> bool"""
        return _modshogun.LibLinear_get_bias_enabled(self)

    def get_max_iterations(self):
        """get_max_iterations(self) ->  int"""
        return _modshogun.LibLinear_get_max_iterations(self)

    def set_max_iterations(self, max_iter = 1000):
        """
        set_max_iterations(self, max_iter = 1000)
        set_max_iterations(self)
        """
        return _modshogun.LibLinear_set_max_iterations(self, max_iter)

    def set_linear_term(self, *args):
        """set_linear_term(self, linear_term)"""
        return _modshogun.LibLinear_set_linear_term(self, *args)

    def get_linear_term(self):
        """get_linear_term(self) -> RealVector"""
        return _modshogun.LibLinear_get_linear_term(self)

    def init_linear_term(self):
        """init_linear_term(self)"""
        return _modshogun.LibLinear_init_linear_term(self)

LibLinear_swigregister = _modshogun.LibLinear_swigregister
LibLinear_swigregister(LibLinear)

NO_BIAS_LIBSVM = _modshogun.NO_BIAS_LIBSVM
TEST_RULE1 = _modshogun.TEST_RULE1
TEST_RULE2 = _modshogun.TEST_RULE2
class ScatterSVM(MultiClassSVM):
    """
    ScatterSVM - Multiclass SVM.

    The ScatterSVM is an unpublished experimental true multiclass SVM.
    Details are availabe in the following technical report.

    This code is currently experimental.

    Robert Jenssen and Marius Kloft and Alexander Zien and S"oren
    Sonnenburg and Klaus-Robert M"{u}ller, A Multi-Class Support Vector
    Machine Based on Scatter Criteria, TR 014-2009 TU Berlin, 2009

    C++ includes: ScatterSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultiClassSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScatterSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiClassSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ScatterSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ScatterSVM
        __init__(self, type) -> ScatterSVM
        __init__(self, C, k, lab) -> ScatterSVM

        constructor (using NO_BIAS as default scatter_type)

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_ScatterSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ScatterSVM
    __del__ = lambda self : None;
ScatterSVM_swigregister = _modshogun.ScatterSVM_swigregister
ScatterSVM_swigregister(ScatterSVM)

LIBSVM_C_SVC = _modshogun.LIBSVM_C_SVC
LIBSVM_NU_SVC = _modshogun.LIBSVM_NU_SVC
class LibSVM(CSVM):
    """
    LibSVM.

    C++ includes: LibSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, st = LIBSVM_C_SVC) -> LibSVM
        __init__(self) -> LibSVM
        __init__(self, C, k, lab) -> LibSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_LibSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LibSVM
    __del__ = lambda self : None;
LibSVM_swigregister = _modshogun.LibSVM_swigregister
LibSVM_swigregister(LibSVM)

class LaRank(MultiClassSVM):
    """
    the LaRank multiclass SVM machine

    C++ includes: LaRank.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultiClassSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LaRank, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiClassSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LaRank, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LaRank
        __init__(self, C, k, lab) -> LaRank

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_LaRank(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LaRank
    __del__ = lambda self : None;
    def add(self, *args):
        """
        add(self, x_id, yi) ->  int

        add

        Parameters:
        -----------

        x_id:

        yi:  
        """
        return _modshogun.LaRank_add(self, *args)

    def predict(self, *args):
        """
        predict(self, x_id) ->  int

        predict

        Parameters:
        -----------

        x_id:  
        """
        return _modshogun.LaRank_predict(self, *args)

    def destroy(self):
        """
        destroy(self)

        destroy 
        """
        return _modshogun.LaRank_destroy(self)

    def computeGap(self):
        """
        computeGap(self) -> float

        computeGap 
        """
        return _modshogun.LaRank_computeGap(self)

    def getNumOutputs(self):
        """
        getNumOutputs(self) -> int

        get num outputs 
        """
        return _modshogun.LaRank_getNumOutputs(self)

    def getNSV(self):
        """
        getNSV(self) ->  int

        get NSV 
        """
        return _modshogun.LaRank_getNSV(self)

    def computeW2(self):
        """
        computeW2(self) -> float

        compute W2 
        """
        return _modshogun.LaRank_computeW2(self)

    def getDual(self):
        """
        getDual(self) -> float

        get Dual 
        """
        return _modshogun.LaRank_getDual(self)

    def set_batch_mode(self, *args):
        """
        set_batch_mode(self, enable)

        set batch mode

        Parameters:
        -----------

        enable:  
        """
        return _modshogun.LaRank_set_batch_mode(self, *args)

    def get_batch_mode(self):
        """
        get_batch_mode(self) -> bool

        get batch mode 
        """
        return _modshogun.LaRank_get_batch_mode(self)

    def set_tau(self, *args):
        """
        set_tau(self, t)

        set tau

        Parameters:
        -----------

        t:  
        """
        return _modshogun.LaRank_set_tau(self, *args)

    def get_tau(self):
        """
        get_tau(self) -> float

        get tau tau 
        """
        return _modshogun.LaRank_get_tau(self)

LaRank_swigregister = _modshogun.LaRank_swigregister
LaRank_swigregister(LaRank)

class LibSVMMultiClass(MultiClassSVM):
    """
    class LibSVMMultiClass

    C++ includes: LibSVMMultiClass.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultiClassSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibSVMMultiClass, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiClassSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibSVMMultiClass, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, st = LIBSVM_C_SVC) -> LibSVMMultiClass
        __init__(self) -> LibSVMMultiClass
        __init__(self, C, k, lab) -> LibSVMMultiClass

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_LibSVMMultiClass(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LibSVMMultiClass
    __del__ = lambda self : None;
LibSVMMultiClass_swigregister = _modshogun.LibSVMMultiClass_swigregister
LibSVMMultiClass_swigregister(LibSVMMultiClass)

class LibSVMOneClass(CSVM):
    """
    class LibSVMOneClass

    C++ includes: LibSVMOneClass.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibSVMOneClass, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibSVMOneClass, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LibSVMOneClass
        __init__(self, C, k) -> LibSVMOneClass

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel 
        """
        this = _modshogun.new_LibSVMOneClass(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LibSVMOneClass
    __del__ = lambda self : None;
LibSVMOneClass_swigregister = _modshogun.LibSVMOneClass_swigregister
LibSVMOneClass_swigregister(LibSVMOneClass)

class MPDSVM(CSVM):
    """
    class MPDSVM

    C++ includes: MPDSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MPDSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MPDSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MPDSVM
        __init__(self, C, k, lab) -> MPDSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_MPDSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MPDSVM
    __del__ = lambda self : None;
MPDSVM_swigregister = _modshogun.MPDSVM_swigregister
MPDSVM_swigregister(MPDSVM)

class OnlineSVMSGD(OnlineLinearMachine):
    """
    class OnlineSVMSGD

    C++ includes: OnlineSVMSGD.h 
    """
    __swig_setmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OnlineSVMSGD, name, value)
    __swig_getmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OnlineSVMSGD, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> OnlineSVMSGD
        __init__(self, C) -> OnlineSVMSGD
        __init__(self, C, traindat) -> OnlineSVMSGD

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features 
        """
        this = _modshogun.new_OnlineSVMSGD(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_OnlineSVMSGD
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        train classifier

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.OnlineSVMSGD_train(self, data)

    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.OnlineSVMSGD_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.OnlineSVMSGD_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.OnlineSVMSGD_get_C2(self)

    def set_epochs(self, *args):
        """
        set_epochs(self, e)

        set epochs

        Parameters:
        -----------

        e:  new number of training epochs 
        """
        return _modshogun.OnlineSVMSGD_set_epochs(self, *args)

    def get_epochs(self):
        """
        get_epochs(self) ->  int

        get epochs

        the number of training epochs 
        """
        return _modshogun.OnlineSVMSGD_get_epochs(self)

    def set_lambda(self, *args):
        """
        set_lambda(self, l)

        set lambda

        Parameters:
        -----------

        l:  value of regularization parameter lambda 
        """
        return _modshogun.OnlineSVMSGD_set_lambda(self, *args)

    def get_lambda(self):
        """
        get_lambda(self) -> float

        get lambda

        the regularization parameter lambda 
        """
        return _modshogun.OnlineSVMSGD_get_lambda(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.OnlineSVMSGD_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        check if bias is enabled

        if bias is enabled 
        """
        return _modshogun.OnlineSVMSGD_get_bias_enabled(self)

    def set_regularized_bias_enabled(self, *args):
        """
        set_regularized_bias_enabled(self, enable_bias)

        set if regularized bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if regularized bias shall be enabled 
        """
        return _modshogun.OnlineSVMSGD_set_regularized_bias_enabled(self, *args)

    def get_regularized_bias_enabled(self):
        """
        get_regularized_bias_enabled(self) -> bool

        check if regularized bias is enabled

        if regularized bias is enabled 
        """
        return _modshogun.OnlineSVMSGD_get_regularized_bias_enabled(self)

    def set_loss_function(self, *args):
        """
        set_loss_function(self, loss_func)

        Set the loss function to use

        Parameters:
        -----------

        loss_func:  object derived from CLossFunction 
        """
        return _modshogun.OnlineSVMSGD_set_loss_function(self, *args)

    def get_loss_function(self):
        """
        get_loss_function(self) -> CLossFunction

        Return the loss function

        loss function as CLossFunction* 
        """
        return _modshogun.OnlineSVMSGD_get_loss_function(self)

OnlineSVMSGD_swigregister = _modshogun.OnlineSVMSGD_swigregister
OnlineSVMSGD_swigregister(OnlineSVMSGD)

class OnlineLibLinear(OnlineLinearMachine):
    """
    Class implementing a purely online version of LibLinear, using the
    L2R_L1LOSS_SVC_DUAL solver only.

    C++ includes: OnlineLibLinear.h 
    """
    __swig_setmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OnlineLibLinear, name, value)
    __swig_getmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OnlineLibLinear, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> OnlineLibLinear
        __init__(self, C) -> OnlineLibLinear
        __init__(self, C, traindat) -> OnlineLibLinear

        Constructor

        Parameters:
        -----------

        C:  Cost constant C

        traindat:  Training examples 
        """
        this = _modshogun.new_OnlineLibLinear(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_OnlineLibLinear
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        Train classifier

        Parameters:
        -----------

        data:  Training data, can be avoided if already initialized with it

        Whether training was successful 
        """
        return _modshogun.OnlineLibLinear_train(self, data)

    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        Set C1 and C2 constants

        Parameters:
        -----------

        c_neg:  C1 value

        c_pos:  C2 value 
        """
        return _modshogun.OnlineLibLinear_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        Get constant C1

        C1 
        """
        return _modshogun.OnlineLibLinear_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        Get constant C2

        C2 
        """
        return _modshogun.OnlineLibLinear_get_C2(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        Set whether to use bias or not

        Parameters:
        -----------

        enable_bias:  true if bias should be used 
        """
        return _modshogun.OnlineLibLinear_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        Check if bias is enabled

        If bias is enabled 
        """
        return _modshogun.OnlineLibLinear_get_bias_enabled(self)

OnlineLibLinear_swigregister = _modshogun.OnlineLibLinear_swigregister
OnlineLibLinear_swigregister(OnlineLibLinear)

class Perceptron(LinearMachine):
    """
    Class Perceptron implements the standard linear (online) perceptron.

    Given a maximum number of iterations (the standard perceptron
    algorithm is not guaranteed to converge) and a fixed lerning rate, the
    result is a linear classifier.

    See:   CLinearMachine

    http://en.wikipedia.org/wiki/Perceptron

    C++ includes: Perceptron.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Perceptron, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Perceptron, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Perceptron
        __init__(self, traindat, trainlab) -> Perceptron

        constructor

        Parameters:
        -----------

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_Perceptron(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Perceptron
    __del__ = lambda self : None;
    def set_learn_rate(self, *args):
        """
        set_learn_rate(self, r)

        set learn rate of gradient descent training algorithm 
        """
        return _modshogun.Perceptron_set_learn_rate(self, *args)

    def set_max_iter(self, *args):
        """
        set_max_iter(self, i)

        set maximum number of iterations 
        """
        return _modshogun.Perceptron_set_max_iter(self, *args)

Perceptron_swigregister = _modshogun.Perceptron_swigregister
Perceptron_swigregister(Perceptron)

class AveragedPerceptron(LinearMachine):
    """
    Class Averaged Perceptron implements the standard linear (online)
    algorithm. Averaged perceptron is the simple extension of Perceptron.

    Given a maximum number of iterations (the standard averaged perceptron
    algorithm is not guaranteed to converge) and a fixed lerning rate, the
    result is a linear classifier.

    See:   CLinearMachine

    C++ includes: AveragedPerceptron.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AveragedPerceptron, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AveragedPerceptron, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> AveragedPerceptron
        __init__(self, traindat, trainlab) -> AveragedPerceptron

        constructor

        Parameters:
        -----------

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_AveragedPerceptron(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_AveragedPerceptron
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        train classifier

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.AveragedPerceptron_train(self, data)

    def set_learn_rate(self, *args):
        """
        set_learn_rate(self, r)

        set learn rate of gradient descent training algorithm 
        """
        return _modshogun.AveragedPerceptron_set_learn_rate(self, *args)

    def set_max_iter(self, *args):
        """
        set_max_iter(self, i)

        set maximum number of iterations 
        """
        return _modshogun.AveragedPerceptron_set_max_iter(self, *args)

AveragedPerceptron_swigregister = _modshogun.AveragedPerceptron_swigregister
AveragedPerceptron_swigregister(AveragedPerceptron)

class SubGradientSVM(LinearMachine):
    """
    class SubGradientSVM

    C++ includes: SubGradientSVM.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SubGradientSVM, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SubGradientSVM, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SubGradientSVM
        __init__(self, C, traindat, trainlab) -> SubGradientSVM

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_SubGradientSVM(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SubGradientSVM
    __del__ = lambda self : None;
    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  C1

        c_pos:  C2 
        """
        return _modshogun.SubGradientSVM_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.SubGradientSVM_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.SubGradientSVM_get_C2(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.SubGradientSVM_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        check if bias is enabled

        if bias is enabled 
        """
        return _modshogun.SubGradientSVM_get_bias_enabled(self)

    def set_epsilon(self, *args):
        """
        set_epsilon(self, eps)

        set epsilon

        Parameters:
        -----------

        eps:  new epsilon 
        """
        return _modshogun.SubGradientSVM_set_epsilon(self, *args)

    def get_epsilon(self):
        """
        get_epsilon(self) -> float

        get epsilon

        epsilon 
        """
        return _modshogun.SubGradientSVM_get_epsilon(self)

    def set_qpsize(self, *args):
        """
        set_qpsize(self, q)

        set qpsize

        Parameters:
        -----------

        q:  new qpsize 
        """
        return _modshogun.SubGradientSVM_set_qpsize(self, *args)

    def get_qpsize(self):
        """
        get_qpsize(self) ->  int

        get qpsize

        qpsize 
        """
        return _modshogun.SubGradientSVM_get_qpsize(self)

    def set_qpsize_max(self, *args):
        """
        set_qpsize_max(self, q)

        set qpsize_max

        Parameters:
        -----------

        q:  new qpsize_max 
        """
        return _modshogun.SubGradientSVM_set_qpsize_max(self, *args)

    def get_qpsize_max(self):
        """
        get_qpsize_max(self) ->  int

        get qpsize_max

        qpsize_max 
        """
        return _modshogun.SubGradientSVM_get_qpsize_max(self)

SubGradientSVM_swigregister = _modshogun.SubGradientSVM_swigregister
SubGradientSVM_swigregister(SubGradientSVM)

class SVMLin(LinearMachine):
    """
    class SVMLin

    C++ includes: SVMLin.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SVMLin, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SVMLin, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SVMLin
        __init__(self, C, traindat, trainlab) -> SVMLin

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features

        trainlab:  labels for features 
        """
        this = _modshogun.new_SVMLin(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SVMLin
    __del__ = lambda self : None;
    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.SVMLin_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.SVMLin_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.SVMLin_get_C2(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.SVMLin_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        get if bias is enabled

        if bias is enabled 
        """
        return _modshogun.SVMLin_get_bias_enabled(self)

    def set_epsilon(self, *args):
        """
        set_epsilon(self, eps)

        set epsilon

        Parameters:
        -----------

        eps:  new epsilon 
        """
        return _modshogun.SVMLin_set_epsilon(self, *args)

    def get_epsilon(self):
        """
        get_epsilon(self) -> float

        get epsilon

        epsilon 
        """
        return _modshogun.SVMLin_get_epsilon(self)

SVMLin_swigregister = _modshogun.SVMLin_swigregister
SVMLin_swigregister(SVMLin)

SVM_OCAS = _modshogun.SVM_OCAS
SVM_BMRM = _modshogun.SVM_BMRM
class SVMOcas(LinearMachine):
    """
    class SVMOcas

    C++ includes: SVMOcas.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SVMOcas, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SVMOcas, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SVMOcas
        __init__(self, type) -> SVMOcas
        __init__(self, C, traindat, trainlab) -> SVMOcas

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_SVMOcas(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SVMOcas
    __del__ = lambda self : None;
    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.SVMOcas_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.SVMOcas_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.SVMOcas_get_C2(self)

    def set_epsilon(self, *args):
        """
        set_epsilon(self, eps)

        set epsilon

        Parameters:
        -----------

        eps:  new epsilon 
        """
        return _modshogun.SVMOcas_set_epsilon(self, *args)

    def get_epsilon(self):
        """
        get_epsilon(self) -> float

        get epsilon

        epsilon 
        """
        return _modshogun.SVMOcas_get_epsilon(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.SVMOcas_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        check if bias is enabled

        if bias is enabled 
        """
        return _modshogun.SVMOcas_get_bias_enabled(self)

    def set_bufsize(self, *args):
        """
        set_bufsize(self, sz)

        set buffer size

        Parameters:
        -----------

        sz:  buffer size 
        """
        return _modshogun.SVMOcas_set_bufsize(self, *args)

    def get_bufsize(self):
        """
        get_bufsize(self) ->  int

        get buffer size

        buffer size 
        """
        return _modshogun.SVMOcas_get_bufsize(self)

SVMOcas_swigregister = _modshogun.SVMOcas_swigregister
SVMOcas_swigregister(SVMOcas)

class SVMSGD(LinearMachine):
    """
    class SVMSGD

    C++ includes: SVMSGD.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SVMSGD, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SVMSGD, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SVMSGD
        __init__(self, C) -> SVMSGD
        __init__(self, C, traindat, trainlab) -> SVMSGD

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_SVMSGD(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SVMSGD
    __del__ = lambda self : None;
    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.SVMSGD_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.SVMSGD_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.SVMSGD_get_C2(self)

    def set_epochs(self, *args):
        """
        set_epochs(self, e)

        set epochs

        Parameters:
        -----------

        e:  new number of training epochs 
        """
        return _modshogun.SVMSGD_set_epochs(self, *args)

    def get_epochs(self):
        """
        get_epochs(self) ->  int

        get epochs

        the number of training epochs 
        """
        return _modshogun.SVMSGD_get_epochs(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.SVMSGD_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        check if bias is enabled

        if bias is enabled 
        """
        return _modshogun.SVMSGD_get_bias_enabled(self)

    def set_regularized_bias_enabled(self, *args):
        """
        set_regularized_bias_enabled(self, enable_bias)

        set if regularized bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if regularized bias shall be enabled 
        """
        return _modshogun.SVMSGD_set_regularized_bias_enabled(self, *args)

    def get_regularized_bias_enabled(self):
        """
        get_regularized_bias_enabled(self) -> bool

        check if regularized bias is enabled

        if regularized bias is enabled 
        """
        return _modshogun.SVMSGD_get_regularized_bias_enabled(self)

    def set_loss_function(self, *args):
        """
        set_loss_function(self, loss_func)

        Set the loss function to use

        Parameters:
        -----------

        loss_func:  object derived from CLossFunction 
        """
        return _modshogun.SVMSGD_set_loss_function(self, *args)

    def get_loss_function(self):
        """
        get_loss_function(self) -> CLossFunction

        Return the loss function

        loss function as CLossFunction* 
        """
        return _modshogun.SVMSGD_get_loss_function(self)

SVMSGD_swigregister = _modshogun.SVMSGD_swigregister
SVMSGD_swigregister(SVMSGD)

class SGDQN(LinearMachine):
    """
    class SGDQN

    C++ includes: SGDQN.h 
    """
    __swig_setmethods__ = {}
    for _s in [LinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SGDQN, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SGDQN, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SGDQN
        __init__(self, C) -> SGDQN
        __init__(self, C, traindat, trainlab) -> SGDQN

        constructor

        Parameters:
        -----------

        C:  constant C

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_SGDQN(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SGDQN
    __del__ = lambda self : None;
    def train(self, data = None):
        """
        train(self, data = None) -> bool
        train(self) -> bool

        train classifier

        Parameters:
        -----------

        data:  training data (parameter can be avoided if distance or kernel-
        based classifiers are used and distance/kernels are initialized with
        train data)

        whether training was successful 
        """
        return _modshogun.SGDQN_train(self, data)

    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.SGDQN_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.SGDQN_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.SGDQN_get_C2(self)

    def set_epochs(self, *args):
        """
        set_epochs(self, e)

        set epochs

        Parameters:
        -----------

        e:  new number of training epochs 
        """
        return _modshogun.SGDQN_set_epochs(self, *args)

    def get_epochs(self):
        """
        get_epochs(self) ->  int

        get epochs

        the number of training epochs 
        """
        return _modshogun.SGDQN_get_epochs(self)

    def compute_ratio(self, *args):
        """
        compute_ratio(self, W, W_1, B, dst, dim, regularizer_lambda, loss)

        computing diagonal scaling matrix B as ratio 
        """
        return _modshogun.SGDQN_compute_ratio(self, *args)

    def combine_and_clip(self, *args):
        """
        combine_and_clip(self, Bc, B, dim, c1, c2, v1, v2)

        combine and clip scaling matrix B 
        """
        return _modshogun.SGDQN_combine_and_clip(self, *args)

    def set_loss_function(self, *args):
        """
        set_loss_function(self, loss_func)

        Set the loss function to use

        Parameters:
        -----------

        loss_func:  object derived from CLossFunction 
        """
        return _modshogun.SGDQN_set_loss_function(self, *args)

    def get_loss_function(self):
        """
        get_loss_function(self) -> CLossFunction

        Return the loss function

        loss function as CLossFunction* 
        """
        return _modshogun.SGDQN_get_loss_function(self)

SGDQN_swigregister = _modshogun.SGDQN_swigregister
SGDQN_swigregister(SGDQN)

class WDSVMOcas(Machine):
    """
    class WDSVMOcas

    C++ includes: WDSVMOcas.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WDSVMOcas, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WDSVMOcas, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WDSVMOcas
        __init__(self, type) -> WDSVMOcas
        __init__(self, C, d, from_d, traindat, trainlab) -> WDSVMOcas

        constructor

        Parameters:
        -----------

        C:  constant C

        d:  degree

        from_d:  from degree

        traindat:  training features

        trainlab:  labels for training features 
        """
        this = _modshogun.new_WDSVMOcas(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_WDSVMOcas
    __del__ = lambda self : None;
    def set_C(self, *args):
        """
        set_C(self, c_neg, c_pos)

        set C

        Parameters:
        -----------

        c_neg:  new C constant for negatively labeled examples

        c_pos:  new C constant for positively labeled examples 
        """
        return _modshogun.WDSVMOcas_set_C(self, *args)

    def get_C1(self):
        """
        get_C1(self) -> float

        get C1

        C1 
        """
        return _modshogun.WDSVMOcas_get_C1(self)

    def get_C2(self):
        """
        get_C2(self) -> float

        get C2

        C2 
        """
        return _modshogun.WDSVMOcas_get_C2(self)

    def set_epsilon(self, *args):
        """
        set_epsilon(self, eps)

        set epsilon

        Parameters:
        -----------

        eps:  new epsilon 
        """
        return _modshogun.WDSVMOcas_set_epsilon(self, *args)

    def get_epsilon(self):
        """
        get_epsilon(self) -> float

        get epsilon

        epsilon 
        """
        return _modshogun.WDSVMOcas_get_epsilon(self)

    def set_features(self, *args):
        """
        set_features(self, feat)

        set features

        Parameters:
        -----------

        feat:  features to set 
        """
        return _modshogun.WDSVMOcas_set_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> StringByteFeatures

        get features

        features 
        """
        return _modshogun.WDSVMOcas_get_features(self)

    def set_bias_enabled(self, *args):
        """
        set_bias_enabled(self, enable_bias)

        set if bias shall be enabled

        Parameters:
        -----------

        enable_bias:  if bias shall be enabled 
        """
        return _modshogun.WDSVMOcas_set_bias_enabled(self, *args)

    def get_bias_enabled(self):
        """
        get_bias_enabled(self) -> bool

        check if bias is enabled

        if bias is enabled 
        """
        return _modshogun.WDSVMOcas_get_bias_enabled(self)

    def set_bufsize(self, *args):
        """
        set_bufsize(self, sz)

        set buffer size

        Parameters:
        -----------

        sz:  buffer size 
        """
        return _modshogun.WDSVMOcas_set_bufsize(self, *args)

    def get_bufsize(self):
        """
        get_bufsize(self) ->  int

        get buffer size

        buffer size 
        """
        return _modshogun.WDSVMOcas_get_bufsize(self)

    def set_degree(self, *args):
        """
        set_degree(self, d, from_d)

        set degree

        Parameters:
        -----------

        d:  degree

        from_d:  from degree 
        """
        return _modshogun.WDSVMOcas_set_degree(self, *args)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _modshogun.WDSVMOcas_get_degree(self)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, num) -> float

        classify one example

        Parameters:
        -----------

        num:  number of example to classify

        classified result 
        """
        return _modshogun.WDSVMOcas_apply(self, *args)

    def set_normalization_const(self):
        """
        set_normalization_const(self)

        set normalization const 
        """
        return _modshogun.WDSVMOcas_set_normalization_const(self)

    def get_normalization_const(self):
        """
        get_normalization_const(self) -> float

        get normalization const

        normalization const 
        """
        return _modshogun.WDSVMOcas_get_normalization_const(self)

WDSVMOcas_swigregister = _modshogun.WDSVMOcas_swigregister
WDSVMOcas_swigregister(WDSVMOcas)

class PluginEstimate(Machine):
    """
    class PluginEstimate

    The class PluginEstimate takes as input two probabilistic models (of
    type CLinearHMM, even though general models are possible ) and
    classifies examples according to the rule

    \\[ f({\\bf x})= \\log(\\mbox{Pr}({\\bf x}|\\theta_+)) -
    \\log(\\mbox{Pr}({\\bf x}|\\theta_-)) \\]

    See:   CLinearHMM

    CDistribution

    C++ includes: PluginEstimate.h 
    """
    __swig_setmethods__ = {}
    for _s in [Machine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PluginEstimate, name, value)
    __swig_getmethods__ = {}
    for _s in [Machine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PluginEstimate, name)
    __repr__ = _swig_repr
    def __init__(self, pos_pseudo = 1e-10, neg_pseudo = 1e-10): 
        """
        __init__(self, pos_pseudo = 1e-10, neg_pseudo = 1e-10) -> PluginEstimate
        __init__(self, pos_pseudo = 1e-10) -> PluginEstimate
        __init__(self) -> PluginEstimate

        default constructor

        Parameters:
        -----------

        pos_pseudo:  pseudo for positive model

        neg_pseudo:  pseudo for negative model 
        """
        this = _modshogun.new_PluginEstimate(pos_pseudo, neg_pseudo)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PluginEstimate
    __del__ = lambda self : None;
    def set_features(self, *args):
        """
        set_features(self, feat)

        set features

        Parameters:
        -----------

        feat:  features to set 
        """
        return _modshogun.PluginEstimate_set_features(self, *args)

    def get_features(self):
        """
        get_features(self) -> StringWordFeatures

        get features

        features 
        """
        return _modshogun.PluginEstimate_get_features(self)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, data) -> Labels
        apply(self, vec_idx) -> float

        classify the test feature vector indexed by vec_idx 
        """
        return _modshogun.PluginEstimate_apply(self, *args)

    def posterior_log_odds_obsolete(self, *args):
        """
        posterior_log_odds_obsolete(self, vector, len) -> float

        obsolete posterior log odds

        Parameters:
        -----------

        vector:  vector

        len:  len

        something floaty 
        """
        return _modshogun.PluginEstimate_posterior_log_odds_obsolete(self, *args)

    def get_parameterwise_log_odds(self, *args):
        """
        get_parameterwise_log_odds(self, obs, position) -> float

        get log odds parameter-wise

        Parameters:
        -----------

        obs:  observation

        position:  position

        log odd at position 
        """
        return _modshogun.PluginEstimate_get_parameterwise_log_odds(self, *args)

    def log_derivative_pos_obsolete(self, *args):
        """
        log_derivative_pos_obsolete(self, obs, pos) -> float

        get obsolete positive log derivative

        Parameters:
        -----------

        obs:  observation

        pos:  position

        positive log derivative 
        """
        return _modshogun.PluginEstimate_log_derivative_pos_obsolete(self, *args)

    def log_derivative_neg_obsolete(self, *args):
        """
        log_derivative_neg_obsolete(self, obs, pos) -> float

        get obsolete negative log derivative

        Parameters:
        -----------

        obs:  observation

        pos:  position

        negative log derivative 
        """
        return _modshogun.PluginEstimate_log_derivative_neg_obsolete(self, *args)

    def get_model_params(self, *args):
        """
        get_model_params(self, pos_params, neg_params, seq_length, num_symbols) -> bool

        get model parameters

        Parameters:
        -----------

        pos_params:  parameters of positive model

        neg_params:  parameters of negative model

        seq_length:  sequence length

        num_symbols:  numbe of symbols

        if operation was successful 
        """
        return _modshogun.PluginEstimate_get_model_params(self, *args)

    def set_model_params(self, *args):
        """
        set_model_params(self, pos_params, neg_params, seq_length, num_symbols)

        set model parameters

        Parameters:
        -----------

        pos_params:  parameters of positive model

        neg_params:  parameters of negative model

        seq_length:  sequence length

        num_symbols:  numbe of symbols 
        """
        return _modshogun.PluginEstimate_set_model_params(self, *args)

    def get_num_params(self):
        """
        get_num_params(self) ->  int

        get number of parameters

        number of parameters 
        """
        return _modshogun.PluginEstimate_get_num_params(self)

    def check_models(self):
        """
        check_models(self) -> bool

        check models

        if one of the two models is invalid 
        """
        return _modshogun.PluginEstimate_check_models(self)

PluginEstimate_swigregister = _modshogun.PluginEstimate_swigregister
PluginEstimate_swigregister(PluginEstimate)

class MKL(CSVM):
    """
    Multiple Kernel Learning.

    A support vector machine based method for use with multiple kernels.
    In Multiple Kernel Learning (MKL) in addition to the SVM
    $\\bf\\alpha$ and bias term $b$ the kernel weights
    $\\bf\\beta$ are estimated in training. The resulting kernel
    method can be stated as

    \\[ f({\\bf x})=\\sum_{i=0}^{N-1} \\alpha_i \\sum_{j=0}^M
    \\beta_j k_j({\\bf x}, {\\bf x_i})+b . \\]

    where $N$ is the number of training examples $\\alpha_i$ are the
    weights assigned to each training example $\\beta_j$ are the weights
    assigned to each sub-kernel $k_j(x,x')$ are sub-kernels and $b$ the
    bias.

    Kernels have to be chosen a-priori. In MKL $\\alpha_i,\\;\\beta$
    and bias are determined by solving the following optimization program

    \\begin{eqnarray*} \\mbox{min} &&
    \\gamma-\\sum_{i=1}^N\\alpha_i\\\\ \\mbox{w.r.t.} &&
    \\gamma\\in R, \\alpha\\in R^N \\nonumber\\\\
    \\mbox{s.t.} && {\\bf 0}\\leq\\alpha\\leq{\\bf
    1}C,\\;\\;\\sum_{i=1}^N \\alpha_i y_i=0 \\nonumber\\\\
    && \\frac{1}{2}\\sum_{i,j=1}^N \\alpha_i \\alpha_j y_i y_j
    k_k({\\bf x}_i,{\\bf x}_j)\\leq \\gamma,\\;\\; \\forall
    k=1,\\ldots,K\\nonumber\\\\ \\end{eqnarray*} here C is a
    pre-specified regularization parameter.

    Within shogun this optimization problem is solved using semi-infinite
    programming. For 1-norm MKL using one of the two approaches described
    in

    Soeren Sonnenburg, Gunnar Raetsch, Christin Schaefer, and Bernhard
    Schoelkopf. Large Scale Multiple Kernel Learning. Journal of Machine
    Learning Research, 7:1531-1565, July 2006.

    The first approach (also called the wrapper algorithm) wraps around a
    single kernel SVMs, alternatingly solving for $\\alpha$ and
    $\\beta$. It is using a traditional SVM to generate new violated
    constraints and thus requires a single kernel SVM and any of the SVMs
    contained in shogun can be used. In the MKL step either a linear
    program is solved via glpk or cplex or analytically or a newton (for
    norms>1) step is performed.

    The second much faster but also more memory demanding approach
    performing interleaved optimization, is integrated into the chunking-
    based SVMlight.

    In addition sparsity of MKL can be controlled by the choice of the
    $L_p$-norm regularizing $\\beta$ as described in

    Marius Kloft, Ulf Brefeld, Soeren Sonnenburg, and Alexander Zien.
    Efficient and accurate lp-norm multiple kernel learning. In Advances
    in Neural Information Processing Systems 21. MIT Press, Cambridge, MA,
    2009.

    An alternative way to control the sparsity is the elastic-net
    regularization, which can be formulated into the following
    optimization problem: \\begin{eqnarray*} \\mbox{min} &&
    C\\sum_{i=1}^N\\ell\\left(\\sum_{k=1}^Kf_k(x_i)+b,y_i\\right)+(1-\\lambda)\\left(\\sum_{k=1}^K\\|f_k\\|_{\\mathcal{H}_k}\\right)^2+\\lambda\\sum_{k=1}^K\\|f_k\\|_{\\mathcal{H}_k}^2\\\\
    \\mbox{w.r.t.} &&
    f_1\\in\\mathcal{H}_1,f_2\\in\\mathcal{H}_2,\\ldots,f_K\\in\\mathcal{H}_K,\\,b\\in
    R \\nonumber\\\\ \\end{eqnarray*} where $\\ell$ is a loss
    function. Here $\\lambda$ controls the trade-off between the two
    regularization terms. $\\lambda=0$ corresponds to $L_1$-MKL, whereas
    $\\lambda=1$ corresponds to the uniform-weighted combination of
    kernels ( $L_\\infty$-MKL). This approach was studied by Shawe-
    Taylor (2008) "Kernel Learning for Novelty Detection" (NIPS MKL
    Workshop 2008) and Tomioka & Suzuki (2009) "Sparsity-accuracy trade-
    off in MKL" (NIPS MKL Workshop 2009).

    C++ includes: MKL.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MKL, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MKL, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_MKL
    __del__ = lambda self : None;
    def set_constraint_generator(self, *args):
        """
        set_constraint_generator(self, s)

        SVM to use as constraint generator in MKL SIP

        Parameters:
        -----------

        s:  svm 
        """
        return _modshogun.MKL_set_constraint_generator(self, *args)

    def set_svm(self, *args):
        """
        set_svm(self, s)

        SVM to use as constraint generator in MKL SIP

        Parameters:
        -----------

        s:  svm 
        """
        return _modshogun.MKL_set_svm(self, *args)

    def get_svm(self):
        """
        get_svm(self) -> CSVM

        get SVM that is used as constraint generator in MKL SIP

        svm 
        """
        return _modshogun.MKL_get_svm(self)

    def set_C_mkl(self, *args):
        """
        set_C_mkl(self, C)

        set C mkl

        Parameters:
        -----------

        C:  new C_mkl 
        """
        return _modshogun.MKL_set_C_mkl(self, *args)

    def set_mkl_norm(self, *args):
        """
        set_mkl_norm(self, norm)

        set mkl norm

        Parameters:
        -----------

        norm:  new mkl norm (must be greater equal 1) 
        """
        return _modshogun.MKL_set_mkl_norm(self, *args)

    def set_elasticnet_lambda(self, *args):
        """
        set_elasticnet_lambda(self, elasticnet_lambda)

        set elasticnet lambda

        Parameters:
        -----------

        elasticnet_lambda:  new elastic net lambda (must be 0<=lambda<=1)
        lambda=0: L1-MKL lambda=1: Linfinity-MKL 
        """
        return _modshogun.MKL_set_elasticnet_lambda(self, *args)

    def set_mkl_block_norm(self, *args):
        """
        set_mkl_block_norm(self, q)

        set block norm q (used in block norm mkl)

        Parameters:
        -----------

        q:  mixed norm (1<=q<=inf) 
        """
        return _modshogun.MKL_set_mkl_block_norm(self, *args)

    def set_interleaved_optimization_enabled(self, *args):
        """
        set_interleaved_optimization_enabled(self, enable)

        set state of optimization (interleaved or wrapper)

        Parameters:
        -----------

        enable:  if true interleaved optimization is used; wrapper otherwise

        """
        return _modshogun.MKL_set_interleaved_optimization_enabled(self, *args)

    def get_interleaved_optimization_enabled(self):
        """
        get_interleaved_optimization_enabled(self) -> bool

        get state of optimization (interleaved or wrapper)

        true if interleaved optimization is used; wrapper otherwise 
        """
        return _modshogun.MKL_get_interleaved_optimization_enabled(self)

    def compute_mkl_primal_objective(self):
        """
        compute_mkl_primal_objective(self) -> float

        compute mkl primal objective

        computed mkl primal objective 
        """
        return _modshogun.MKL_compute_mkl_primal_objective(self)

    def compute_mkl_dual_objective(self):
        """
        compute_mkl_dual_objective(self) -> float

        compute mkl dual objective

        computed dual objective 
        """
        return _modshogun.MKL_compute_mkl_dual_objective(self)

    def compute_elasticnet_dual_objective(self):
        """
        compute_elasticnet_dual_objective(self) -> float

        compute ElasticnetMKL dual objective

        computed dual objective 
        """
        return _modshogun.MKL_compute_elasticnet_dual_objective(self)

    def set_mkl_epsilon(self, *args):
        """
        set_mkl_epsilon(self, eps)

        set mkl epsilon (optimization accuracy for kernel weights)

        Parameters:
        -----------

        eps:  new weight_epsilon 
        """
        return _modshogun.MKL_set_mkl_epsilon(self, *args)

    def get_mkl_epsilon(self):
        """
        get_mkl_epsilon(self) -> float

        get mkl epsilon for weights (optimization accuracy for kernel weights)

        epsilon for weights 
        """
        return _modshogun.MKL_get_mkl_epsilon(self)

    def get_mkl_iterations(self):
        """
        get_mkl_iterations(self) ->  int

        get number of MKL iterations

        mkl_iterations 
        """
        return _modshogun.MKL_get_mkl_iterations(self)

    def perform_mkl_step(self, *args):
        """
        perform_mkl_step(self, sumw, suma) -> bool

        perform single mkl iteration

        given sum of alphas, objectives for current alphas for each kernel and
        current kernel weighting compute the corresponding optimal kernel
        weighting (all via get/set_subkernel_weights in CCombinedKernel)

        Parameters:
        -----------

        sumw:  vector of 1/2*alpha'*K_j*alpha for each kernel j

        suma:  scalar sum_i alpha_i etc. 
        """
        return _modshogun.MKL_perform_mkl_step(self, *args)

    def perform_mkl_step_helper(*args):
        """perform_mkl_step_helper(mkl, sumw, suma) -> bool"""
        return _modshogun.MKL_perform_mkl_step_helper(*args)

    if _newclass:perform_mkl_step_helper = staticmethod(perform_mkl_step_helper)
    __swig_getmethods__["perform_mkl_step_helper"] = lambda x: perform_mkl_step_helper
    def compute_sum_alpha(self):
        """
        compute_sum_alpha(self) -> float

        compute beta independent term from objective, e.g., in 2-class MKL
        sum_i alpha_i etc 
        """
        return _modshogun.MKL_compute_sum_alpha(self)

    def compute_sum_beta(self, *args):
        """
        compute_sum_beta(self, sumw)

        compute 1/2*alpha'*K_j*alpha for each kernel j (beta dependent term
        from objective)

        Parameters:
        -----------

        sumw:  vector of size num_kernels to hold the result 
        """
        return _modshogun.MKL_compute_sum_beta(self, *args)

MKL_swigregister = _modshogun.MKL_swigregister
MKL_swigregister(MKL)

def MKL_perform_mkl_step_helper(*args):
  """MKL_perform_mkl_step_helper(mkl, sumw, suma) -> bool"""
  return _modshogun.MKL_perform_mkl_step_helper(*args)

class MKLClassification(MKL):
    """
    Multiple Kernel Learning for two-class-classification.

    Learns an SVM classifier and its kernel weights. Makes only sense if
    multiple kernels are used.

    See:   CMKL

    C++ includes: MKLClassification.h 
    """
    __swig_setmethods__ = {}
    for _s in [MKL]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MKLClassification, name, value)
    __swig_getmethods__ = {}
    for _s in [MKL]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MKLClassification, name)
    __repr__ = _swig_repr
    def __init__(self, s = None): 
        """
        __init__(self, s = None) -> MKLClassification
        __init__(self) -> MKLClassification

        Constructor

        Parameters:
        -----------

        s:  SVM to use as constraint generator in MKL SILP 
        """
        this = _modshogun.new_MKLClassification(s)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MKLClassification
    __del__ = lambda self : None;
MKLClassification_swigregister = _modshogun.MKLClassification_swigregister
MKLClassification_swigregister(MKLClassification)

class MKLOneClass(MKL):
    """
    Multiple Kernel Learning for one-class-classification.

    Learns a One-Class SVM classifier and its kernel weights. Makes only
    sense if multiple kernels are used.

    See:   CMKL

    C++ includes: MKLOneClass.h 
    """
    __swig_setmethods__ = {}
    for _s in [MKL]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MKLOneClass, name, value)
    __swig_getmethods__ = {}
    for _s in [MKL]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MKLOneClass, name)
    __repr__ = _swig_repr
    def __init__(self, s = None): 
        """
        __init__(self, s = None) -> MKLOneClass
        __init__(self) -> MKLOneClass

        Constructor

        Parameters:
        -----------

        s:  SVM to use as constraint generator in MKL SILP 
        """
        this = _modshogun.new_MKLOneClass(s)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MKLOneClass
    __del__ = lambda self : None;
MKLOneClass_swigregister = _modshogun.MKLOneClass_swigregister
MKLOneClass_swigregister(MKLOneClass)

class MKLMultiClass(MultiClassSVM):
    """
    MKLMultiClass is a class for L1-norm multiclass MKL.

    It is based on the GMNPSVM Multiclass SVM. Its own parameters are the
    L2 norm weight change based MKL Its termination criterion set by void
    set_mkl_epsilon(float64_t eps ); and the maximal number of MKL
    iterations set by void set_max_num_mkliters(int32_t maxnum); It passes
    the regularization constants C1 and C2 to GMNPSVM.

    C++ includes: MKLMultiClass.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultiClassSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MKLMultiClass, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiClassSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MKLMultiClass, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MKLMultiClass
        __init__(self, C, k, lab) -> MKLMultiClass

        Class Constructor commonly used in Shogun Toolbox

        Parameters:
        -----------

        C:  constant C

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_MKLMultiClass(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MKLMultiClass
    __del__ = lambda self : None;
    def getsubkernelweights(self, *args):
        """
        getsubkernelweights(self, numweights) -> float

        returns MKL weights for the different kernels

        Parameters:
        -----------

        numweights:  is output parameter, is set to zero if no weights have
        been computed or to the number of MKL weights which is equal to the
        number of kernels

        NULL if no weights have been computed or otherwise an array with the
        weights, caller has to SG_FREE() the output 
        """
        return _modshogun.MKLMultiClass_getsubkernelweights(self, *args)

    def set_mkl_epsilon(self, *args):
        """
        set_mkl_epsilon(self, eps)

        sets MKL termination threshold

        Parameters:
        -----------

        eps:  is the desired threshold value the termination criterion is the
        L2 norm between the current MKL weights and their counterpart from the
        previous iteration 
        """
        return _modshogun.MKLMultiClass_set_mkl_epsilon(self, *args)

    def set_max_num_mkliters(self, *args):
        """
        set_max_num_mkliters(self, maxnum)

        sets maximal number of MKL iterations

        Parameters:
        -----------

        maxnum:  is the desired maximal number of MKL iterations; when it is
        reached the MKL terminates irrespective of the MKL progress set it to
        a nonpositive value in order to turn it off 
        """
        return _modshogun.MKLMultiClass_set_max_num_mkliters(self, *args)

    def set_mkl_norm(self, *args):
        """
        set_mkl_norm(self, norm)

        set mkl norm

        Parameters:
        -----------

        norm:  
        """
        return _modshogun.MKLMultiClass_set_mkl_norm(self, *args)

MKLMultiClass_swigregister = _modshogun.MKLMultiClass_swigregister
MKLMultiClass_swigregister(MKLMultiClass)

class VowpalWabbit(OnlineLinearMachine):
    """
    Class CVowpalWabbit is the implementation of the online learning
    algorithm used in Vowpal Wabbit.

    VW is a fast online learning algorithm which operates on sparse
    features. It uses an online gradient descent technique.

    For more details, refer to the tutorial
    athttps://github.com/JohnLangford/vowpal_wabbit/wiki/v5.1_tutorial.pdf

    C++ includes: VowpalWabbit.h 
    """
    __swig_setmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VowpalWabbit, name, value)
    __swig_getmethods__ = {}
    for _s in [OnlineLinearMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VowpalWabbit, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> VowpalWabbit
        __init__(self, feat) -> VowpalWabbit

        Constructor, taking a features object as argument

        Parameters:
        -----------

        feat:  StreamingVwFeatures object 
        """
        this = _modshogun.new_VowpalWabbit(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_VowpalWabbit
    __del__ = lambda self : None;
    def reinitialize_weights(self):
        """
        reinitialize_weights(self)

        Reinitialize the weight vectors. Call after updating env variables eg.
        stride. 
        """
        return _modshogun.VowpalWabbit_reinitialize_weights(self)

    def set_no_training(self, *args):
        """
        set_no_training(self, dont_train)

        Set whether one desires to not train and only make passes over all
        examples instead.

        This is useful if one wants to create a cache file from data.

        Parameters:
        -----------

        dont_train:  true if one doesn't want to train 
        """
        return _modshogun.VowpalWabbit_set_no_training(self, *args)

    def set_adaptive(self, *args):
        """
        set_adaptive(self, adaptive_learning)

        Set whether learning is adaptive or not

        Parameters:
        -----------

        adaptive_learning:  true if adaptive 
        """
        return _modshogun.VowpalWabbit_set_adaptive(self, *args)

    def set_exact_adaptive_norm(self, *args):
        """
        set_exact_adaptive_norm(self, exact_adaptive)

        Set whether to use the more expensive exact norm for adaptive learning

        Parameters:
        -----------

        exact_adaptive:  true if exact norm is required 
        """
        return _modshogun.VowpalWabbit_set_exact_adaptive_norm(self, *args)

    def set_num_passes(self, *args):
        """
        set_num_passes(self, passes)

        Set number of passes (only works for cached input)

        Parameters:
        -----------

        passes:  number of passes 
        """
        return _modshogun.VowpalWabbit_set_num_passes(self, *args)

    def load_regressor(self, *args):
        """
        load_regressor(self, file_name)

        Load regressor from a dump file

        Parameters:
        -----------

        file_name:  name of regressor file 
        """
        return _modshogun.VowpalWabbit_load_regressor(self, *args)

    def set_regressor_out(self, *args):
        """
        set_regressor_out(self, file_name, is_text = True)
        set_regressor_out(self, file_name)

        Set regressor output parameters

        Parameters:
        -----------

        file_name:  name of file to save regressor to

        is_text:  human readable or not, bool 
        """
        return _modshogun.VowpalWabbit_set_regressor_out(self, *args)

    def set_prediction_out(self, *args):
        """
        set_prediction_out(self, file_name)

        Set file name of prediction output

        Parameters:
        -----------

        file_name:  name of file to save predictions to 
        """
        return _modshogun.VowpalWabbit_set_prediction_out(self, *args)

    def add_quadratic_pair(self, *args):
        """
        add_quadratic_pair(self, pair)

        Add a pair of namespaces whose features should be crossed for
        quadratic updates

        Parameters:
        -----------

        pair:  a string with the two namespace names concatenated 
        """
        return _modshogun.VowpalWabbit_add_quadratic_pair(self, *args)

    def train_machine(self, feat = None):
        """
        train_machine(self, feat = None) -> bool
        train_machine(self) -> bool

        Train on a StreamingVwFeatures object

        Parameters:
        -----------

        feat:  StreamingVwFeatures to train using 
        """
        return _modshogun.VowpalWabbit_train_machine(self, feat)

    def predict_and_finalize(self, *args):
        """
        predict_and_finalize(self, ex) -> float

        Predict for an example

        Parameters:
        -----------

        ex:   VwExample to predict for

        prediction 
        """
        return _modshogun.VowpalWabbit_predict_and_finalize(self, *args)

    def compute_exact_norm(self, *args):
        """
        compute_exact_norm(self, ex, sum_abs_x) -> float

        Computes the exact norm during adaptive learning

        Parameters:
        -----------

        ex:  example

        sum_abs_x:  set by reference, sum of abs of features

        norm 
        """
        return _modshogun.VowpalWabbit_compute_exact_norm(self, *args)

    def compute_exact_norm_quad(self, *args):
        """
        compute_exact_norm_quad(self, weights, page_feature, offer_features, mask, g, sum_abs_x) -> float

        Computes the exact norm for quadratic features during adaptive
        learning

        Parameters:
        -----------

        weights:  weights

        page_feature:  current feature

        offer_features:  paired features

        mask:  mask

        g:  square of gradient

        sum_abs_x:  sum of absolute value of features

        norm 
        """
        return _modshogun.VowpalWabbit_compute_exact_norm_quad(self, *args)

    def get_env(self):
        """
        get_env(self) -> CVwEnvironment

        Get the environment

        environment as CVwEnvironment* 
        """
        return _modshogun.VowpalWabbit_get_env(self)

VowpalWabbit_swigregister = _modshogun.VowpalWabbit_swigregister
VowpalWabbit_swigregister(VowpalWabbit)

class CDomainAdaptationSVMLinear(LibLinear):
    """Proxy of C++ shogun::CDomainAdaptationSVMLinear class"""
    __swig_setmethods__ = {}
    for _s in [LibLinear]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CDomainAdaptationSVMLinear, name, value)
    __swig_getmethods__ = {}
    for _s in [LibLinear]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CDomainAdaptationSVMLinear, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CDomainAdaptationSVMLinear
        __init__(self, C, f, lab, presvm, B) -> CDomainAdaptationSVMLinear
        """
        this = _modshogun.new_CDomainAdaptationSVMLinear(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_CDomainAdaptationSVMLinear
    __del__ = lambda self : None;
    def init(self, *args):
        """init(self, presvm, B)"""
        return _modshogun.CDomainAdaptationSVMLinear_init(self, *args)

    def apply(self, *args):
        """
        apply(self, data) -> Labels

        get output for example "vec_idx" 
        """
        return _modshogun.CDomainAdaptationSVMLinear_apply(self, *args)

    def get_presvm(self):
        """get_presvm(self) -> LinearMachine"""
        return _modshogun.CDomainAdaptationSVMLinear_get_presvm(self)

    def get_B(self):
        """get_B(self) -> float"""
        return _modshogun.CDomainAdaptationSVMLinear_get_B(self)

    def get_train_factor(self):
        """get_train_factor(self) -> float"""
        return _modshogun.CDomainAdaptationSVMLinear_get_train_factor(self)

    def set_train_factor(self, *args):
        """set_train_factor(self, factor)"""
        return _modshogun.CDomainAdaptationSVMLinear_set_train_factor(self, *args)

CDomainAdaptationSVMLinear_swigregister = _modshogun.CDomainAdaptationSVMLinear_swigregister
CDomainAdaptationSVMLinear_swigregister(CDomainAdaptationSVMLinear)

class SVM(CSVM):
    def __init__(self, kernel, alphas, support_vectors, b):
        assert(len(alphas)==len(support_vectors))
        num_sv=len(alphas)
        CSVM.__init__(self, num_sv)
        self.set_alphas(alphas)
        self.set_support_vectors(support_vectors)
        self.set_kernel(kernel)
        self.set_bias(b)

RT_NONE = _modshogun.RT_NONE
RT_LIGHT = _modshogun.RT_LIGHT
RT_LIBSVM = _modshogun.RT_LIBSVM
class KRR(KernelMachine):
    """Proxy of C++ shogun::CKRR class"""
    __swig_setmethods__ = {}
    for _s in [KernelMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KRR, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KRR, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KRR
        __init__(self, tau, k, lab) -> KRR
        """
        this = _modshogun.new_KRR(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KRR
    __del__ = lambda self : None;
    def set_tau(self, *args):
        """set_tau(self, t)"""
        return _modshogun.KRR_set_tau(self, *args)

    def apply(self, *args):
        """
        apply(self) -> Labels
        apply(self, num) -> float

        apply kernel machine to one example

        Parameters:
        -----------

        num:  which example to apply to

        classified value 
        """
        return _modshogun.KRR_apply(self, *args)

KRR_swigregister = _modshogun.KRR_swigregister
KRR_swigregister(KRR)

class LibSVR(CSVM):
    """
    Class LibSVR, performs support vector regression using LibSVM.

    The SVR solution can be expressed as \\[ f({\\bf
    x})=\\sum_{i=1}^{N} \\alpha_i k({\\bf x}, {\\bf x_i})+b \\]

    where $\\alpha$ and $b$ are determined in training, i.e. using a
    pre-specified kernel, a given tube-epsilon for the epsilon insensitive
    loss, the follwoing quadratic problem is minimized (using sequential
    minimal decomposition (SMO))

    \\begin{eqnarray*} \\max_{{\\bf \\alpha},{\\bf \\alpha}^*}
    &-\\frac{1}{2}\\sum_{i,j=1}^N(\\alpha_i-\\alpha_i^*)(\\alpha_j-\\alpha_j^*){\\bf
    x}_i^T {\\bf x}_j
    -\\sum_{i=1}^N(\\alpha_i+\\alpha_i^*)\\epsilon -
    \\sum_{i=1}^N(\\alpha_i-\\alpha_i^*)y_i\\\\ \\mbox{wrt}:&
    {\\bf \\alpha},{\\bf \\alpha}^*\\in{\\bf R}^N\\\\
    \\mbox{s.t.}:& 0\\leq \\alpha_i,\\alpha_i^*\\leq C,\\,
    \\forall i=1\\dots N\\\\
    &\\sum_{i=1}^N(\\alpha_i-\\alpha_i^*)y_i=0 \\end{eqnarray*}

    Note that the SV regression problem is reduced to the standard SV
    classification problem by introducing artificial labels $-y_i$ which
    leads to the epsilon insensitive loss constraints *
    \\begin{eqnarray*} {\\bf w}^T{\\bf x}_i+b-c_i-\\xi_i\\leq
    0,&\\, \\forall i=1\\dots N\\\\ -{\\bf w}^T{\\bf
    x}_i-b-c_i^*-\\xi_i^*\\leq 0,&\\, \\forall i=1\\dots N
    \\end{eqnarray*} with $c_i=y_i+ \\epsilon$ and $c_i^*=-y_i+
    \\epsilon$

    C++ includes: LibSVR.h 
    """
    __swig_setmethods__ = {}
    for _s in [CSVM]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibSVR, name, value)
    __swig_getmethods__ = {}
    for _s in [CSVM]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibSVR, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LibSVR
        __init__(self, C, epsilon, k, lab) -> LibSVR

        constructor

        Parameters:
        -----------

        C:  constant C

        epsilon:  tube epsilon

        k:  kernel

        lab:  labels 
        """
        this = _modshogun.new_LibSVR(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_LibSVR
    __del__ = lambda self : None;
LibSVR_swigregister = _modshogun.LibSVR_swigregister
LibSVR_swigregister(LibSVR)

class MKLRegression(MKL):
    """
    Multiple Kernel Learning for regression.

    Performs support vector regression while learning kernel weights at
    the same time. Makes only sense if multiple kernels are used.

    See:   CMKL

    C++ includes: MKLRegression.h 
    """
    __swig_setmethods__ = {}
    for _s in [MKL]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MKLRegression, name, value)
    __swig_getmethods__ = {}
    for _s in [MKL]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MKLRegression, name)
    __repr__ = _swig_repr
    def __init__(self, s = None): 
        """
        __init__(self, s = None) -> MKLRegression
        __init__(self) -> MKLRegression

        Constructor

        Parameters:
        -----------

        s:  SVM to use as constraint generator in MKL SILP 
        """
        this = _modshogun.new_MKLRegression(s)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_MKLRegression
    __del__ = lambda self : None;
MKLRegression_swigregister = _modshogun.MKLRegression_swigregister
MKLRegression_swigregister(MKLRegression)

class KMeans(CDistanceMachine):
    """
    KMeans clustering, partitions the data into k (a-priori specified)
    clusters.

    It minimizes \\[ \\sum_{i=1}^k\\sum_{x_j\\in S_i}
    (x_j-\\mu_i)^2 \\]

    where $\\mu_i$ are the cluster centers and $S_i,\\;i=1,\\dots,k$
    are the index sets of the clusters.

    Beware that this algorithm obtains only a local optimum.

    cf.http://en.wikipedia.org/wiki/K-means_algorithm

    C++ includes: KMeans.h 
    """
    __swig_setmethods__ = {}
    for _s in [CDistanceMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KMeans, name, value)
    __swig_getmethods__ = {}
    for _s in [CDistanceMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KMeans, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> KMeans
        __init__(self, k, d) -> KMeans

        constructor

        Parameters:
        -----------

        k:  parameter k

        d:  distance 
        """
        this = _modshogun.new_KMeans(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_KMeans
    __del__ = lambda self : None;
    def set_k(self, *args):
        """
        set_k(self, p_k)

        set k

        Parameters:
        -----------

        p_k:  new k 
        """
        return _modshogun.KMeans_set_k(self, *args)

    def get_k(self):
        """
        get_k(self) ->  int

        get k

        the parameter k 
        """
        return _modshogun.KMeans_get_k(self)

    def set_max_iter(self, *args):
        """
        set_max_iter(self, iter)

        set maximum number of iterations

        Parameters:
        -----------

        iter:  the new maximum 
        """
        return _modshogun.KMeans_set_max_iter(self, *args)

    def get_max_iter(self):
        """
        get_max_iter(self) -> float

        get maximum number of iterations

        maximum number of iterations 
        """
        return _modshogun.KMeans_get_max_iter(self)

    def get_radiuses(self):
        """
        get_radiuses(self) -> RealVector

        get radiuses

        radiuses 
        """
        return _modshogun.KMeans_get_radiuses(self)

    def get_cluster_centers(self):
        """
        get_cluster_centers(self) -> RealMatrix

        get centers

        cluster centers or empty matrix if no radiuses are there (not trained
        yet) 
        """
        return _modshogun.KMeans_get_cluster_centers(self)

    def get_dimensions(self):
        """
        get_dimensions(self) ->  int

        get dimensions

        number of dimensions 
        """
        return _modshogun.KMeans_get_dimensions(self)

KMeans_swigregister = _modshogun.KMeans_swigregister
KMeans_swigregister(KMeans)

class Hierarchical(CDistanceMachine):
    """
    Agglomerative hierarchical single linkage clustering.

    Starting with each object being assigned to its own cluster clusters
    are iteratively merged. Here the clusters are merged whose elements
    have minimum distance, i.e. the clusters A and B that obtain

    \\[ \\min\\{d({\\bf x},{\\bf x'}): {\\bf x}\\in {\\cal
    A},{\\bf x'}\\in {\\cal B}\\} \\]

    are merged.

    cf e.g.http://en.wikipedia.org/wiki/Data_clustering

    C++ includes: Hierarchical.h 
    """
    __swig_setmethods__ = {}
    for _s in [CDistanceMachine]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Hierarchical, name, value)
    __swig_getmethods__ = {}
    for _s in [CDistanceMachine]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Hierarchical, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Hierarchical
        __init__(self, merges, d) -> Hierarchical

        constructor

        Parameters:
        -----------

        merges:  the merges

        d:  distance 
        """
        this = _modshogun.new_Hierarchical(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Hierarchical
    __del__ = lambda self : None;
    def set_merges(self, *args):
        """
        set_merges(self, m)

        set merges

        Parameters:
        -----------

        m:  new merges 
        """
        return _modshogun.Hierarchical_set_merges(self, *args)

    def get_merges(self):
        """
        get_merges(self) ->  int

        get merges

        merges 
        """
        return _modshogun.Hierarchical_get_merges(self)

    def get_assignment(self):
        """
        get_assignment(self) -> IntVector

        get assignment 
        """
        return _modshogun.Hierarchical_get_assignment(self)

    def get_merge_distances(self):
        """
        get_merge_distances(self) -> RealVector

        get merge distance 
        """
        return _modshogun.Hierarchical_get_merge_distances(self)

    def get_cluster_pairs(self):
        """
        get_cluster_pairs(self) -> IntMatrix

        get cluster pairs 
        """
        return _modshogun.Hierarchical_get_cluster_pairs(self)

Hierarchical_swigregister = _modshogun.Hierarchical_swigregister
Hierarchical_swigregister(Hierarchical)

class ModelSelectionBase(SGObject):
    """
    Abstract base class for model selection. Takes a parameter tree which
    specifies parameters for model selection, and a cross-validation
    instance and searches for the best combination of parameters in the
    abstract method select_model(), which has to be implemented in
    concrete sub-classes.

    C++ includes: ModelSelection.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelSelectionBase, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelSelectionBase, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_ModelSelectionBase
    __del__ = lambda self : None;
    def select_model(self):
        """
        select_model(self) -> ParameterCombination

        abstract method to select model best combination of model parameters

        """
        return _modshogun.ModelSelectionBase_select_model(self)

ModelSelectionBase_swigregister = _modshogun.ModelSelectionBase_swigregister
ModelSelectionBase_swigregister(ModelSelectionBase)

class GridSearchModelSelection(ModelSelectionBase):
    """
    Model selection class which searches for the best model by a grid-
    search. See CModelSelection for details.

    C++ includes: GridSearchModelSelection.h 
    """
    __swig_setmethods__ = {}
    for _s in [ModelSelectionBase]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GridSearchModelSelection, name, value)
    __swig_getmethods__ = {}
    for _s in [ModelSelectionBase]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GridSearchModelSelection, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GridSearchModelSelection
        __init__(self, model_parameters, cross_validation) -> GridSearchModelSelection

        constructor

        Parameters:
        -----------

        model_parameters:

        cross_validation:  
        """
        this = _modshogun.new_GridSearchModelSelection(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_GridSearchModelSelection
    __del__ = lambda self : None;
GridSearchModelSelection_swigregister = _modshogun.GridSearchModelSelection_swigregister
GridSearchModelSelection_swigregister(GridSearchModelSelection)

class ParameterCombination(SGObject):
    """
    class that holds ONE combination of parameters for a learning machine.
    The structure is organized as a tree. Every node may hold a name or an
    instance of a Parameter class. Nodes may have children. The nodes are
    organized in such way, that every parameter of a model for model
    selection has one node and sub-parameters are stored in sub-nodes.
    Using a tree of this class, parameters of models may easily be set.
    There are these types of nodes:

    -root node: no name and no Parameter instance, every tree has such a
    node as root. Has children.

    -Parameter node: a node with no name and an instance of Parameter,
    filled with one or more values. There may be different elements in
    these Parameter instances. Parameter nodes may have children with sub-
    parameters.

    Again: Leafs of the tree may only be Parameter nodes.

    C++ includes: ParameterCombination.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterCombination, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterCombination, name)
    __repr__ = _swig_repr
    def print_tree(self, prefix_num = 0):
        """
        print_tree(self, prefix_num = 0)
        print_tree(self)

        Prints a representation of the current node

        Parameters:
        -----------

        prefix_num:  number of tabs that will be prefixed for every output. At
        each recursion level, one is added. 
        """
        return _modshogun.ParameterCombination_print_tree(self, prefix_num)

    def __init__(self, *args): 
        """
        __init__(self) -> ParameterCombination
        __init__(self, param) -> ParameterCombination

        constructor for a Parameter node 
        """
        this = _modshogun.new_ParameterCombination(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ParameterCombination
    __del__ = lambda self : None;
    def apply_to_modsel_parameter(self, *args):
        """
        apply_to_modsel_parameter(self, parameter)

        applies this parameter tree to a parameter instance Recursively
        iterates over all children of the tree and sets model selection
        parameters of children to sub-parameters

        Parameters:
        -----------

        parameter:   Parameter instance to apply parameter tree to 
        """
        return _modshogun.ParameterCombination_apply_to_modsel_parameter(self, *args)

    def apply_to_machine(self, *args):
        """
        apply_to_machine(self, machine)

        applies this parameter tree to a learning machine (wrapper for
        apply_to_modesel_parameter() method)

        Parameters:
        -----------

        machine:  learning machine to apply parameter tree to 
        """
        return _modshogun.ParameterCombination_apply_to_machine(self, *args)

    def append_child(self, *args):
        """
        append_child(self, child)

        appends a child to this node

        Parameters:
        -----------

        child:  child to append 
        """
        return _modshogun.ParameterCombination_append_child(self, *args)

    def copy_tree(self):
        """
        copy_tree(self) -> ParameterCombination

        Copies the complete tree of this node. Note that nodes are actually
        copied. If this is a parameter node, a NEW Parameter instance to the
        same data is created in the copy

        copy of the tree with this node as root as described above 
        """
        return _modshogun.ParameterCombination_copy_tree(self)

    def leaf_sets_multiplication(*args):
        """leaf_sets_multiplication(sets, new_root) -> CDynamicObjectArray<(shogun::CParameterCombination)>"""
        return _modshogun.ParameterCombination_leaf_sets_multiplication(*args)

    if _newclass:leaf_sets_multiplication = staticmethod(leaf_sets_multiplication)
    __swig_getmethods__["leaf_sets_multiplication"] = lambda x: leaf_sets_multiplication
    def has_children(self):
        """
        has_children(self) -> bool

        checks whether this node has children

        true if node has children 
        """
        return _modshogun.ParameterCombination_has_children(self)

    def parameter_set_multiplication(*args):
        """parameter_set_multiplication(set_1, set_2) -> DynArray<(p.shogun::Parameter)>"""
        return _modshogun.ParameterCombination_parameter_set_multiplication(*args)

    if _newclass:parameter_set_multiplication = staticmethod(parameter_set_multiplication)
    __swig_getmethods__["parameter_set_multiplication"] = lambda x: parameter_set_multiplication
ParameterCombination_swigregister = _modshogun.ParameterCombination_swigregister
ParameterCombination_swigregister(ParameterCombination)

def ParameterCombination_leaf_sets_multiplication(*args):
  """ParameterCombination_leaf_sets_multiplication(sets, new_root) -> CDynamicObjectArray<(shogun::CParameterCombination)>"""
  return _modshogun.ParameterCombination_leaf_sets_multiplication(*args)

def ParameterCombination_parameter_set_multiplication(*args):
  """ParameterCombination_parameter_set_multiplication(set_1, set_2) -> DynArray<(p.shogun::Parameter)>"""
  return _modshogun.ParameterCombination_parameter_set_multiplication(*args)

class DynamicParameterCombinationArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It only stores CSGObject pointers, which ARE automagically
    SG_REF'd/deleted.

    Note that this array is generic, but only takes pointers to objects
    which implement the CSGObject interface, so only put these in here. T
    specifies the type of the pointers

    C++ includes: DynamicObjectArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicParameterCombinationArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicParameterCombinationArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicParameterCombinationArray
        __init__(self) -> DynamicParameterCombinationArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _modshogun.new_DynamicParameterCombinationArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynamicParameterCombinationArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _modshogun.DynamicParameterCombinationArray_set_granularity(self, *args)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _modshogun.DynamicParameterCombinationArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> ParameterCombination

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicParameterCombinationArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> ParameterCombination

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _modshogun.DynamicParameterCombinationArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicParameterCombinationArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _modshogun.DynamicParameterCombinationArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _modshogun.DynamicParameterCombinationArray_append_element(self, *args)

    def push_back(self, *args):
        """
        push_back(self, element)

        STD VECTOR compatible. Append array element to the end of array.

        Parameters:
        -----------

        element:  element to append 
        """
        return _modshogun.DynamicParameterCombinationArray_push_back(self, *args)

    def pop_back(self):
        """
        pop_back(self)

        STD VECTOR compatible. Delete array element at the end of array. 
        """
        return _modshogun.DynamicParameterCombinationArray_pop_back(self)

    def back(self):
        """
        back(self) -> ParameterCombination

        STD VECTOR compatible. Return array element at the end of array.

        element at the end of array 
        """
        return _modshogun.DynamicParameterCombinationArray_back(self)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _modshogun.DynamicParameterCombinationArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call SG_FREE() or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _modshogun.DynamicParameterCombinationArray_delete_element(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _modshogun.DynamicParameterCombinationArray_clear_array(self)

    def get_array(self):
        """
        get_array(self) -> ParameterCombination

        underlying array of pointers 
        """
        return _modshogun.DynamicParameterCombinationArray_get_array(self)

    def shuffle(self):
        """
        shuffle(self)

        shuffles the array 
        """
        return _modshogun.DynamicParameterCombinationArray_shuffle(self)

DynamicParameterCombinationArray_swigregister = _modshogun.DynamicParameterCombinationArray_swigregister
DynamicParameterCombinationArray_swigregister(DynamicParameterCombinationArray)

R_LINEAR = _modshogun.R_LINEAR
R_EXP = _modshogun.R_EXP
R_LOG = _modshogun.R_LOG
MSPT_NONE = _modshogun.MSPT_NONE
MSPT_FLOAT64 = _modshogun.MSPT_FLOAT64
MSPT_INT32 = _modshogun.MSPT_INT32
class ModelSelectionParameters(SGObject):
    """
    Class to select parameters and their ranges for model selection. The
    structure is organized as a tree with different kinds of nodes,
    depending on the values of its member variables of name and CSGObject.

    -root node: no name and no CSGObject, may have children

    -CSGObject node: has name and a CSGObject, may have children which are
    the parameters of the CSGObject. CSGObjects are SG_REF'ed/SG_UNREF'ed

    -value node: a node with a (parameter) name and an array of values for
    that parameter. These ranges may be set using build_values(). This
    node is always a leaf.

    After a (legal!) tree is constructed with the append_child method, all
    possible combinations that are implied by this tree may be extracted
    with the get_combinations method. It generates a set of trees
    (different kind than this one) that contain the instantiated parameter
    combinations.

    C++ includes: ModelSelectionParameters.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelSelectionParameters, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelSelectionParameters, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ModelSelectionParameters
        __init__(self, node_name) -> ModelSelectionParameters
        __init__(self, node_name, sgobject) -> ModelSelectionParameters

        constructor for a value node

        Parameters:
        -----------

        node_name:  name of the parameter the values will belong to 
        """
        this = _modshogun.new_ModelSelectionParameters(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_ModelSelectionParameters
    __del__ = lambda self : None;
    def append_child(self, *args):
        """
        append_child(self, child)

        appends a child to this tree. only possible if this is no value node

        Parameters:
        -----------

        child:  child to append 
        """
        return _modshogun.ModelSelectionParameters_append_child(self, *args)

    def print_tree(self, prefix_num = 0):
        """
        print_tree(self, prefix_num = 0)
        print_tree(self)

        SG_PRINT's the tree of which this node is the base

        Parameters:
        -----------

        prefix_num:  a number of tabs that is put before each output to have a
        more readable print layout 
        """
        return _modshogun.ModelSelectionParameters_print_tree(self, prefix_num)

    def get_combinations(self):
        """
        get_combinations(self) -> DynamicParameterCombinationArray

        most important method. If the tree was regarding node types and
        structure, a set of trees which contain all combinations of parameters
        that are implied by this tree is generated.

        result all trees of parameter combinations are put into here 
        """
        return _modshogun.ModelSelectionParameters_get_combinations(self)

    def build_values(self, *args):
        """
        build_values(self, min, max, type, step = 1.0, type_base = 2.0)
        build_values(self, min, max, type, step = 1.0)
        build_values(self, min, max, type)
        build_values(self, min, max, type, step = 1, type_base = 2)
        build_values(self, min, max, type, step = 1)
        build_values(self, min, max, type)

         int wrapper for build_values() 
        """
        return _modshogun.ModelSelectionParameters_build_values(self, *args)

ModelSelectionParameters_swigregister = _modshogun.ModelSelectionParameters_swigregister
ModelSelectionParameters_swigregister(ModelSelectionParameters)

class PlifBase(SGObject):
    """
    class PlifBase

    C++ includes: PlifBase.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PlifBase, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PlifBase, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _modshogun.delete_PlifBase
    __del__ = lambda self : None;
    def lookup_penalty(self, *args):
        """
        lookup_penalty(self, p_value, svm_values) -> float
        lookup_penalty(self, p_value, svm_values) -> float

        lookup penalty  int

        abstract base method

        Parameters:
        -----------

        p_value:  value

        svm_values:  SVM values

        penalty 
        """
        return _modshogun.PlifBase_lookup_penalty(self, *args)

    def penalty_clear_derivative(self):
        """
        penalty_clear_derivative(self)

        penalty clear derivative

        abstrace base method 
        """
        return _modshogun.PlifBase_penalty_clear_derivative(self)

    def penalty_add_derivative(self, *args):
        """
        penalty_add_derivative(self, p_value, svm_values, factor)

        penalty add derivative

        abstract base method

        Parameters:
        -----------

        p_value:  value

        svm_values:  SVM values

        factor:  factor weighting the added value 
        """
        return _modshogun.PlifBase_penalty_add_derivative(self, *args)

    def get_max_value(self):
        """
        get_max_value(self) -> float

        get maximum value

        abstract base method

        maximum value 
        """
        return _modshogun.PlifBase_get_max_value(self)

    def get_min_value(self):
        """
        get_min_value(self) -> float

        get minimum value

        abstract base method

        minimum value 
        """
        return _modshogun.PlifBase_get_min_value(self)

    def get_used_svms(self, *args):
        """
        get_used_svms(self, num_svms, svm_ids)

        get SVM_ids and number of SVMs used

        abstract base method 
        """
        return _modshogun.PlifBase_get_used_svms(self, *args)

    def uses_svm_values(self):
        """
        uses_svm_values(self) -> bool

        if plif uses SVM values

        abstract base method

        if plif uses SVM values 
        """
        return _modshogun.PlifBase_uses_svm_values(self)

    def get_max_id(self):
        """
        get_max_id(self) ->  int

        get maximum ID

        abstract base method

        maximum ID 
        """
        return _modshogun.PlifBase_get_max_id(self)

    def list_plif(self):
        """
        list_plif(self)

        print PLIF

        abstract base method 
        """
        return _modshogun.PlifBase_list_plif(self)

PlifBase_swigregister = _modshogun.PlifBase_swigregister
PlifBase_swigregister(PlifBase)

T_LINEAR = _modshogun.T_LINEAR
T_LOG = _modshogun.T_LOG
T_LOG_PLUS1 = _modshogun.T_LOG_PLUS1
T_LOG_PLUS3 = _modshogun.T_LOG_PLUS3
T_LINEAR_PLUS3 = _modshogun.T_LINEAR_PLUS3
class Plif(PlifBase):
    """
    class Plif

    C++ includes: Plif.h 
    """
    __swig_setmethods__ = {}
    for _s in [PlifBase]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Plif, name, value)
    __swig_getmethods__ = {}
    for _s in [PlifBase]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Plif, name)
    __repr__ = _swig_repr
    def __init__(self, len = 0): 
        """
        __init__(self, len = 0) -> Plif
        __init__(self) -> Plif

        constructor

        Parameters:
        -----------

        len:  len 
        """
        this = _modshogun.new_Plif(len)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_Plif
    __del__ = lambda self : None;
    def init_penalty_struct_cache(self):
        """
        init_penalty_struct_cache(self)

        init penalty struct cache 
        """
        return _modshogun.Plif_init_penalty_struct_cache(self)

    def lookup_penalty_svm(self, *args):
        """
        lookup_penalty_svm(self, p_value, d_values) -> float

        lookup penalty SVM

        Parameters:
        -----------

        p_value:  value

        d_values:  d values

        the penalty 
        """
        return _modshogun.Plif_lookup_penalty_svm(self, *args)

    def lookup_penalty(self, *args):
        """
        lookup_penalty(self, p_value, svm_values) -> float
        lookup_penalty(self, p_value, svm_values) -> float

        lookup penalty  int

        Parameters:
        -----------

        p_value:  value

        svm_values:  SVM values

        the penalty 
        """
        return _modshogun.Plif_lookup_penalty(self, *args)

    def lookup(self, *args):
        """
        lookup(self, p_value) -> float

        lookup

        Parameters:
        -----------

        p_value:  value

        a penalty 
        """
        return _modshogun.Plif_lookup(self, *args)

    def penalty_add_derivative_svm(self, *args):
        """
        penalty_add_derivative_svm(self, p_value, svm_values, factor)

        penalty add derivative SVM

        Parameters:
        -----------

        p_value:  value

        svm_values:  SVM values

        factor:  factor weighting the added value 
        """
        return _modshogun.Plif_penalty_add_derivative_svm(self, *args)

    def get_cum_derivative(self, *args):
        """
        get_cum_derivative(self, p_len) -> float

        get cum derivative

        Parameters:
        -----------

        p_len:  len

        cum derivative 
        """
        return _modshogun.Plif_get_cum_derivative(self, *args)

    def set_transform_type(self, *args):
        """
        set_transform_type(self, type_str) -> bool

        set transform type

        Parameters:
        -----------

        type_str:  type (string)

        if setting was successful 
        """
        return _modshogun.Plif_set_transform_type(self, *args)

    def get_transform_type(self):
        """
        get_transform_type(self) -> str

        get transform type

        type_str type (string) 
        """
        return _modshogun.Plif_get_transform_type(self)

    def set_id(self, *args):
        """
        set_id(self, p_id)

        set ID

        Parameters:
        -----------

        p_id:  the id to set 
        """
        return _modshogun.Plif_set_id(self, *args)

    def get_id(self):
        """
        get_id(self) ->  int

        get ID

        the ID 
        """
        return _modshogun.Plif_get_id(self)

    def set_use_svm(self, *args):
        """
        set_use_svm(self, p_use_svm)

        set use SVM

        Parameters:
        -----------

        p_use_svm:  if SVM shall be used 
        """
        return _modshogun.Plif_set_use_svm(self, *args)

    def get_use_svm(self):
        """
        get_use_svm(self) ->  int

        get use SVM

        if SVM is used 
        """
        return _modshogun.Plif_get_use_svm(self)

    def set_use_cache(self, *args):
        """
        set_use_cache(self, p_use_cache)

        set use cache

        Parameters:
        -----------

        p_use_cache:  if cache shall be used 
        """
        return _modshogun.Plif_set_use_cache(self, *args)

    def invalidate_cache(self):
        """
        invalidate_cache(self)

        invalidate the cache 
        """
        return _modshogun.Plif_invalidate_cache(self)

    def get_use_cache(self):
        """
        get_use_cache(self) ->  int

        get use cache

        if cache is used 
        """
        return _modshogun.Plif_get_use_cache(self)

    def set_plif(self, *args):
        """
        set_plif(self, p_len, p_limits, p_penalties)

        set plif

        Parameters:
        -----------

        p_len:  len

        p_limits:  limit

        p_penalties:  penalties 
        """
        return _modshogun.Plif_set_plif(self, *args)

    def set_plif_limits(self, *args):
        """
        set_plif_limits(self, p_limits)

        set plif_limits

        Parameters:
        -----------

        p_limits:  limit 
        """
        return _modshogun.Plif_set_plif_limits(self, *args)

    def set_plif_penalty(self, *args):
        """
        set_plif_penalty(self, p_penalties)

        set plif penalty

        Parameters:
        -----------

        p_penalties:  penalties 
        """
        return _modshogun.Plif_set_plif_penalty(self, *args)

    def set_plif_length(self, *args):
        """
        set_plif_length(self, p_len)

        set plif length

        Parameters:
        -----------

        p_len:  len 
        """
        return _modshogun.Plif_set_plif_length(self, *args)

    def get_plif_limits(self):
        """
        get_plif_limits(self) -> float

        get Plif limits

        limits 
        """
        return _modshogun.Plif_get_plif_limits(self)

    def get_plif_penalties(self):
        """
        get_plif_penalties(self) -> float

        get plif penalty

        plif penalty 
        """
        return _modshogun.Plif_get_plif_penalties(self)

    def set_max_value(self, *args):
        """
        set_max_value(self, p_max_value)

        set maximum value

        Parameters:
        -----------

        p_max_value:  maximum value 
        """
        return _modshogun.Plif_set_max_value(self, *args)

    def set_min_value(self, *args):
        """
        set_min_value(self, p_min_value)

        set minimum value

        Parameters:
        -----------

        p_min_value:  minimum value 
        """
        return _modshogun.Plif_set_min_value(self, *args)

    def set_plif_name(self, *args):
        """
        set_plif_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  name 
        """
        return _modshogun.Plif_set_plif_name(self, *args)

    def get_plif_name(self):
        """
        get_plif_name(self) -> str

        get name

        name 
        """
        return _modshogun.Plif_get_plif_name(self)

    def get_do_calc(self):
        """
        get_do_calc(self) -> bool

        get do calc

        if calc shall be done 
        """
        return _modshogun.Plif_get_do_calc(self)

    def set_do_calc(self, *args):
        """
        set_do_calc(self, b)

        set do calc

        Parameters:
        -----------

        b:  if calc shall be done 
        """
        return _modshogun.Plif_set_do_calc(self, *args)

    def get_plif_len(self):
        """
        get_plif_len(self) ->  int

        get plif len

        plif len 
        """
        return _modshogun.Plif_get_plif_len(self)

    def delete_penalty_struct(*args):
        """delete_penalty_struct(PEN, P)"""
        return _modshogun.Plif_delete_penalty_struct(*args)

    if _newclass:delete_penalty_struct = staticmethod(delete_penalty_struct)
    __swig_getmethods__["delete_penalty_struct"] = lambda x: delete_penalty_struct
Plif_swigregister = _modshogun.Plif_swigregister
Plif_swigregister(Plif)

def Plif_delete_penalty_struct(*args):
  """Plif_delete_penalty_struct(PEN, P)"""
  return _modshogun.Plif_delete_penalty_struct(*args)

class PlifArray(PlifBase):
    """
    class PlifArray

    C++ includes: PlifArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [PlifBase]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PlifArray, name, value)
    __swig_getmethods__ = {}
    for _s in [PlifBase]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PlifArray, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> PlifArray

        default constructor 
        """
        this = _modshogun.new_PlifArray()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PlifArray
    __del__ = lambda self : None;
    def add_plif(self, *args):
        """
        add_plif(self, new_plif)

        add plif

        Parameters:
        -----------

        new_plif:  the new plif to be added 
        """
        return _modshogun.PlifArray_add_plif(self, *args)

    def clear(self):
        """
        clear(self)

        clear 
        """
        return _modshogun.PlifArray_clear(self)

    def get_num_plifs(self):
        """
        get_num_plifs(self) ->  int

        get number of plifs

        number of plifs 
        """
        return _modshogun.PlifArray_get_num_plifs(self)

    def lookup_penalty(self, *args):
        """
        lookup_penalty(self, p_value, svm_values) -> float
        lookup_penalty(self, p_value, svm_values) -> float

        lookup penalty  int

        Parameters:
        -----------

        p_value:  value

        svm_values:  SVM values 
        """
        return _modshogun.PlifArray_lookup_penalty(self, *args)

PlifArray_swigregister = _modshogun.PlifArray_swigregister
PlifArray_swigregister(PlifArray)

class DynProg(SGObject):
    """
    Dynamic Programming Class.

    Structure and Function collection. This Class implements a Dynamic
    Programming functions.

    C++ includes: DynProg.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynProg, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynProg, name)
    __repr__ = _swig_repr
    def __init__(self, p_num_svms = 8): 
        """
        __init__(self, p_num_svms = 8) -> DynProg
        __init__(self) -> DynProg

        constructor

        Parameters:
        -----------

        p_num_svms:  number of SVMs 
        """
        this = _modshogun.new_DynProg(p_num_svms)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_DynProg
    __del__ = lambda self : None;
    def set_num_states(self, *args):
        """
        set_num_states(self, N)

        set number of states use this to set N first

        Parameters:
        -----------

        N:  new N 
        """
        return _modshogun.DynProg_set_num_states(self, *args)

    def get_num_states(self):
        """
        get_num_states(self) ->  int

        get num states 
        """
        return _modshogun.DynProg_get_num_states(self)

    def get_num_svms(self):
        """
        get_num_svms(self) ->  int

        get num svms 
        """
        return _modshogun.DynProg_get_num_svms(self)

    def init_content_svm_value_array(self, *args):
        """
        init_content_svm_value_array(self, p_num_svms)

        init CArray for precomputed content svm values with size seq_len x
        num_svms

        Parameters:
        -----------

        p_num_svms:  ::  number of svm weight vectors for content prediction

        """
        return _modshogun.DynProg_init_content_svm_value_array(self, *args)

    def init_tiling_data(self, *args):
        """
        init_tiling_data(self, probe_pos, intensities, num_probes)

        init CArray for precomputed tiling intensitie-plif-values with size
        seq_len x num_svms

        Parameters:
        -----------

        probe_pos:  local positions of probes

        intensities:  intensities of probes

        num_probes:  number of probes 
        """
        return _modshogun.DynProg_init_tiling_data(self, *args)

    def precompute_tiling_plifs(self, *args):
        """
        precompute_tiling_plifs(self, PEN, tiling_plif_ids, num_tiling_plifs)

        precompute tiling Plifs

        Parameters:
        -----------

        PEN:  Plif PEN

        tiling_plif_ids:  tiling plif id's

        num_tiling_plifs:  number of tiling plifs 
        """
        return _modshogun.DynProg_precompute_tiling_plifs(self, *args)

    def resize_lin_feat(self, *args):
        """
        resize_lin_feat(self, num_new_feat)

        append rows to linear features array

        Parameters:
        -----------

        num_new_feat:  number of new rows to add 
        """
        return _modshogun.DynProg_resize_lin_feat(self, *args)

    def set_p_vector(self, *args):
        """
        set_p_vector(self, p)

        set vector p

        Parameters:
        -----------

        p:  new vector p 
        """
        return _modshogun.DynProg_set_p_vector(self, *args)

    def set_q_vector(self, *args):
        """
        set_q_vector(self, q)

        set vector q

        Parameters:
        -----------

        q:  new vector q 
        """
        return _modshogun.DynProg_set_q_vector(self, *args)

    def set_a_id(self, *args):
        """
        set_a_id(self, a)

        set a id

        Parameters:
        -----------

        a:  new a id 
        """
        return _modshogun.DynProg_set_a_id(self, *args)

    def set_a_trans_matrix(self, *args):
        """
        set_a_trans_matrix(self, a_trans)

        set a transition matrix

        Parameters:
        -----------

        a_trans:  transition matrix a 
        """
        return _modshogun.DynProg_set_a_trans_matrix(self, *args)

    def init_mod_words_array(self, *args):
        """
        init_mod_words_array(self, p_mod_words_array)

        init mod words array

        Parameters:
        -----------

        p_mod_words_array:  new mod words array 
        """
        return _modshogun.DynProg_init_mod_words_array(self, *args)

    def check_svm_arrays(self):
        """
        check_svm_arrays(self) -> bool

        check SVM arrays call this function to check consistency

        whether arrays are ok 
        """
        return _modshogun.DynProg_check_svm_arrays(self)

    def set_observation_matrix(self, *args):
        """
        set_observation_matrix(self, seq)

        set best path seq

        Parameters:
        -----------

        seq:  signal features 
        """
        return _modshogun.DynProg_set_observation_matrix(self, *args)

    def get_num_positions(self):
        """
        get_num_positions(self) ->  int

        get number of positions; the dynamic program is sparse encoded and
        this function gives the number of positions that can actually be part
        of a predicted path

        number of positions 
        """
        return _modshogun.DynProg_get_num_positions(self)

    def set_content_type_array(self, *args):
        """
        set_content_type_array(self, seg_path)

        set an array of length #(candidate positions) which specifies the
        content type of each pos and a mask that determines to which extend
        the loss should be applied to this position; this is a way to encode
        label confidence via weights between zero and one

        Parameters:
        -----------

        seg_path:  seg path 
        """
        return _modshogun.DynProg_set_content_type_array(self, *args)

    def set_pos(self, *args):
        """
        set_pos(self, pos)

        set best path pos

        Parameters:
        -----------

        pos:  the position vector 
        """
        return _modshogun.DynProg_set_pos(self, *args)

    def set_orf_info(self, *args):
        """
        set_orf_info(self, orf_info)

        set best path orf info only for compute_nbest_paths

        Parameters:
        -----------

        orf_info:  the orf info 
        """
        return _modshogun.DynProg_set_orf_info(self, *args)

    def set_gene_string(self, *args):
        """
        set_gene_string(self, genestr)

        set best path genesstr

        Parameters:
        -----------

        genestr:  gene string 
        """
        return _modshogun.DynProg_set_gene_string(self, *args)

    def set_dict_weights(self, *args):
        """
        set_dict_weights(self, dictionary_weights)

        set best path dict weights

        Parameters:
        -----------

        dictionary_weights:  dictionary weights 
        """
        return _modshogun.DynProg_set_dict_weights(self, *args)

    def best_path_set_segment_loss(self, *args):
        """
        best_path_set_segment_loss(self, segment_loss)

        set best path segment loss

        Parameters:
        -----------

        segment_loss:  segment loss 
        """
        return _modshogun.DynProg_best_path_set_segment_loss(self, *args)

    def best_path_set_segment_ids_mask(self, *args):
        """
        best_path_set_segment_ids_mask(self, segment_ids, segment_mask, m)

        set best path segmend ids mask

        Parameters:
        -----------

        segment_ids:  segment ids

        segment_mask:  segment mask

        m:  dimension m 
        """
        return _modshogun.DynProg_best_path_set_segment_ids_mask(self, *args)

    def set_sparse_features(self, *args):
        """
        set_sparse_features(self, seq_sparse1, seq_sparse2)

        set sparse feature matrices 
        """
        return _modshogun.DynProg_set_sparse_features(self, *args)

    def set_plif_matrices(self, *args):
        """
        set_plif_matrices(self, pm)

        set plif matrices

        Parameters:
        -----------

        pm:  plif matrix object 
        """
        return _modshogun.DynProg_set_plif_matrices(self, *args)

    def get_scores(self):
        """
        get_scores(self) -> RealVector

        best path get scores

        scores scores 
        """
        return _modshogun.DynProg_get_scores(self)

    def get_states(self):
        """
        get_states(self) -> IntMatrix

        best path get states

        states states 
        """
        return _modshogun.DynProg_get_states(self)

    def get_positions(self):
        """
        get_positions(self) -> IntMatrix

        best path get positions

        positions positions 
        """
        return _modshogun.DynProg_get_positions(self)

    def compute_nbest_paths(self, *args):
        """
        compute_nbest_paths(self, max_num_signals, use_orf, nbest, with_loss, with_multiple_sequences)

        run the viterbi algorithm to compute the n best viterbi paths

        Parameters:
        -----------

        max_num_signals:  maximal number of signals for a single state

        use_orf:  whether orf shall be used

        nbest:  number of best paths (n)

        with_loss:  use loss

        with_multiple_sequences:  !!!not functional set to false!!! 
        """
        return _modshogun.DynProg_compute_nbest_paths(self, *args)

    def best_path_trans_deriv(self, *args):
        """
        best_path_trans_deriv(self, my_state_seq, my_pos_seq, my_seq_len, seq_array, max_num_signals)

        given a path though the state model and the corresponding positions
        compute the features. This can be seen as the derivative of the score
        (output of dynamic program) with respect to the parameters

        Parameters:
        -----------

        my_state_seq:  state sequence of the path

        my_pos_seq:  sequence of positions

        my_seq_len:  length of state and position sequences

        seq_array:  array of features

        max_num_signals:  maximal number of signals 
        """
        return _modshogun.DynProg_best_path_trans_deriv(self, *args)

    def set_my_state_seq(self, *args):
        """
        set_my_state_seq(self, my_state_seq)

        set best path my state sequence

        Parameters:
        -----------

        my_state_seq:  my state sequence 
        """
        return _modshogun.DynProg_set_my_state_seq(self, *args)

    def set_my_pos_seq(self, *args):
        """
        set_my_pos_seq(self, my_pos_seq)

        set best path my position sequence

        Parameters:
        -----------

        my_pos_seq:  my position sequence 
        """
        return _modshogun.DynProg_set_my_pos_seq(self, *args)

    def get_path_scores(self, *args):
        """
        get_path_scores(self, my_scores, seq_len)

        get path scores

        best_path_trans_deriv result retrieval functions

        Parameters:
        -----------

        my_scores:  scores

        seq_len:  length of sequence 
        """
        return _modshogun.DynProg_get_path_scores(self, *args)

    def get_path_losses(self, *args):
        """
        get_path_losses(self, my_losses, seq_len)

        get path losses

        best_path_trans_deriv result retrieval functions

        Parameters:
        -----------

        my_losses:  my losses

        seq_len:  length of sequence 
        """
        return _modshogun.DynProg_get_path_losses(self, *args)

    def get_N(self):
        """
        get_N(self) -> T_STATES

        access function for number of states N 
        """
        return _modshogun.DynProg_get_N(self)

    def set_q(self, *args):
        """
        set_q(self, offset, value)

        access function for probability of end states

        Parameters:
        -----------

        offset:  index 0...N-1

        value:  value to be set 
        """
        return _modshogun.DynProg_set_q(self, *args)

    def set_p(self, *args):
        """
        set_p(self, offset, value)

        access function for probability of first state

        Parameters:
        -----------

        offset:  index 0...N-1

        value:  value to be set 
        """
        return _modshogun.DynProg_set_p(self, *args)

    def set_a(self, *args):
        """
        set_a(self, a)
        set_a(self, line_, column, value)

        access function for matrix a

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value:  value to be set 
        """
        return _modshogun.DynProg_set_a(self, *args)

    def get_q(self, *args):
        """
        get_q(self, offset) -> float

        access function for probability of end states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.DynProg_get_q(self, *args)

    def get_q_deriv(self, *args):
        """
        get_q_deriv(self, offset) -> float

        access function for derivated probability of end states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.DynProg_get_q_deriv(self, *args)

    def get_p(self, *args):
        """
        get_p(self, offset) -> float

        access function for probability of initial states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.DynProg_get_p(self, *args)

    def get_p_deriv(self, *args):
        """
        get_p_deriv(self, offset) -> float

        access function for derivated probability of initial states

        Parameters:
        -----------

        offset:  index 0...N-1

        value at offset 
        """
        return _modshogun.DynProg_get_p_deriv(self, *args)

    def precompute_content_values(self):
        """
        precompute_content_values(self)

        create array of precomputed content svm values 
        """
        return _modshogun.DynProg_precompute_content_values(self)

    def get_lin_feat(self, *args):
        """
        get_lin_feat(self, dim1, dim2) -> float

        return array of precomputed linear features like content predictions
        and PLiFed tiling array data Jonas

        lin_feat_array 
        """
        return _modshogun.DynProg_get_lin_feat(self, *args)

    def set_lin_feat(self, *args):
        """
        set_lin_feat(self, p_lin_feat, p_num_svms, p_seq_len)

        set your own array of precomputed linear features like content
        predictions and PLiFed tiling array data Jonas

        Parameters:
        -----------

        p_lin_feat:  array of features

        p_num_svms:  number of tracks

        p_seq_len:  number of candidate positions 
        """
        return _modshogun.DynProg_set_lin_feat(self, *args)

    def create_word_string(self):
        """
        create_word_string(self)

        create word string from str* Jonas 
        """
        return _modshogun.DynProg_create_word_string(self)

    def precompute_stop_codons(self):
        """
        precompute_stop_codons(self)

        precompute stop codons 
        """
        return _modshogun.DynProg_precompute_stop_codons(self)

    def get_a(self, *args):
        """
        get_a(self, line_, column) -> float

        access function for matrix a

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value at position line colum 
        """
        return _modshogun.DynProg_get_a(self, *args)

    def get_a_deriv(self, *args):
        """
        get_a_deriv(self, line_, column) -> float

        access function for matrix a derivated

        Parameters:
        -----------

        line_:  row in matrix 0...N-1

        column:  column in matrix 0...N-1

        value at position line colum 
        """
        return _modshogun.DynProg_get_a_deriv(self, *args)

    def set_intron_list(self, *args):
        """
        set_intron_list(self, intron_list, num_plifs)

        set intron list

        Parameters:
        -----------

        intron_list:

        num_plifs:  number of intron plifs 
        """
        return _modshogun.DynProg_set_intron_list(self, *args)

    def get_segment_loss_object(self):
        """
        get_segment_loss_object(self) -> SegmentLoss

        get the segment loss object 
        """
        return _modshogun.DynProg_get_segment_loss_object(self)

    def long_transition_settings(self, *args):
        """
        long_transition_settings(self, use_long_transitions, threshold, max_len)

        settings for long transition handling

        Parameters:
        -----------

        use_long_transitions:  use the long transition approximation

        threshold:  use long transition for segments larger than

        max_len:  allow transitions up to 
        """
        return _modshogun.DynProg_long_transition_settings(self, *args)

DynProg_swigregister = _modshogun.DynProg_swigregister
DynProg_swigregister(DynProg)

class PlifMatrix(SGObject):
    """
    store plif arrays for all transitions in the model

    C++ includes: PlifMatrix.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PlifMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PlifMatrix, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> PlifMatrix

        constructor 
        """
        this = _modshogun.new_PlifMatrix()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_PlifMatrix
    __del__ = lambda self : None;
    def get_PEN(self):
        """
        get_PEN(self) -> Plif

        get array of all plifs

        plif array 
        """
        return _modshogun.PlifMatrix_get_PEN(self)

    def get_plif_matrix(self):
        """
        get_plif_matrix(self) -> PlifBase

        get plif matrix

        matrix of plifs 
        """
        return _modshogun.PlifMatrix_get_plif_matrix(self)

    def get_num_states(self):
        """
        get_num_states(self) ->  int

        get number of states the number of states determines the size of the
        plif matrix

        number of states 
        """
        return _modshogun.PlifMatrix_get_num_states(self)

    def get_state_signals(self):
        """
        get_state_signals(self) -> PlifBase

        get plifs defining the mapping of signals to states

        plifs 
        """
        return _modshogun.PlifMatrix_get_state_signals(self)

    def get_num_plifs(self):
        """
        get_num_plifs(self) ->  int

        get number of plifs

        number of plifs 
        """
        return _modshogun.PlifMatrix_get_num_plifs(self)

    def get_num_limits(self):
        """
        get_num_limits(self) ->  int

        get number of support points for picewise linear transformations
        (PLiFs)

        number of support points 
        """
        return _modshogun.PlifMatrix_get_num_limits(self)

    def create_plifs(self, *args):
        """
        create_plifs(self, num_plifs, num_limits)

        create an empty plif matrix of size num_plifs * num_limits

        Parameters:
        -----------

        num_plifs:  number of plifs

        num_limits:  number of plif limits 
        """
        return _modshogun.PlifMatrix_create_plifs(self, *args)

    def set_plif_ids(self, *args):
        """
        set_plif_ids(self, ids)

        set plif ids

        Parameters:
        -----------

        ids:  plif ids 
        """
        return _modshogun.PlifMatrix_set_plif_ids(self, *args)

    def set_plif_min_values(self, *args):
        """
        set_plif_min_values(self, min_values)

        set array of min values for all plifs

        Parameters:
        -----------

        min_values:  array of min values 
        """
        return _modshogun.PlifMatrix_set_plif_min_values(self, *args)

    def set_plif_max_values(self, *args):
        """
        set_plif_max_values(self, max_values)

        set array of max values for all plifs

        Parameters:
        -----------

        max_values:  array of max values 
        """
        return _modshogun.PlifMatrix_set_plif_max_values(self, *args)

    def set_plif_use_cache(self, *args):
        """
        set_plif_use_cache(self, use_cache)

        set plif use cache

        Parameters:
        -----------

        use_cache:  set array of bool values 
        """
        return _modshogun.PlifMatrix_set_plif_use_cache(self, *args)

    def set_plif_use_svm(self, *args):
        """
        set_plif_use_svm(self, use_svm)

        set plif use svm

        Parameters:
        -----------

        use_svm:  use svm 
        """
        return _modshogun.PlifMatrix_set_plif_use_svm(self, *args)

    def set_plif_limits(self, *args):
        """
        set_plif_limits(self, limits)

        set all abscissa values of the support points for the for the pice
        wise linear transformations (PLiFs)

        Parameters:
        -----------

        limits:  array of length num_plifs*num_limits 
        """
        return _modshogun.PlifMatrix_set_plif_limits(self, *args)

    def set_plif_penalties(self, *args):
        """
        set_plif_penalties(self, penalties)

        set all ordinate values of the support points for the for the pice
        wise linear transformations (PLiFs)

        Parameters:
        -----------

        penalties:  plif values: array of length num_plifs*num_limits 
        """
        return _modshogun.PlifMatrix_set_plif_penalties(self, *args)

    def set_plif_names(self, *args):
        """
        set_plif_names(self, names, num_values, maxlen = 0)
        set_plif_names(self, names, num_values)

        set names for the PLiFs

        Parameters:
        -----------

        names:  names

        num_values:  number of names

        maxlen:  maximal string len of the names 
        """
        return _modshogun.PlifMatrix_set_plif_names(self, *args)

    def set_plif_transform_type(self, *args):
        """
        set_plif_transform_type(self, transform_type, num_values, maxlen = 0)
        set_plif_transform_type(self, transform_type, num_values)

        set plif transform type; for some features the plifs live in log space
        therefore the input values have to be transformed to log space before
        the transformation can be applied; the transform type is string coded

        Parameters:
        -----------

        transform_type:  transform type (e.g. LOG(x), LOG(x+1), ...)

        num_values:  number of transform strings

        maxlen:  of transform strings 
        """
        return _modshogun.PlifMatrix_set_plif_transform_type(self, *args)

    def get_plif_id(self, *args):
        """
        get_plif_id(self, idx) ->  int

        return plif id for idx

        Parameters:
        -----------

        idx:  idx of plif

        id of plif 
        """
        return _modshogun.PlifMatrix_get_plif_id(self, *args)

    def compute_plif_matrix(self, *args):
        """
        compute_plif_matrix(self, penalties_array) -> bool

        parse an 3D array of plif ids and compute the corresponding 2D plif
        matrix by subsuming the third dim into one PlifArray; Note: the class
        PlifArray is derived from PlifBase. It computes all individual plifs
        and sums them up.

        Parameters:
        -----------

        penalties_array:  3D array of plif ids (nofstates x nofstates x
        nof(features for each transition))

        success 
        """
        return _modshogun.PlifMatrix_compute_plif_matrix(self, *args)

    def compute_signal_plifs(self, *args):
        """
        compute_signal_plifs(self, state_signals) -> bool

        parse an 3D array of plif ids and compute the corresponding 3D plif
        array;

        Parameters:
        -----------

        state_signals:  mapping of features to states

        success 
        """
        return _modshogun.PlifMatrix_compute_signal_plifs(self, *args)

    def set_plif_state_signal_matrix(self, *args):
        """
        set_plif_state_signal_matrix(self, plif_id_matrix, m, n)

        set best path plif state signal matrix

        Parameters:
        -----------

        plif_id_matrix:  plif id matrix

        m:  dimension m of matrix

        n:  dimension n of matrix 
        """
        return _modshogun.PlifMatrix_set_plif_state_signal_matrix(self, *args)

PlifMatrix_swigregister = _modshogun.PlifMatrix_swigregister
PlifMatrix_swigregister(PlifMatrix)

class IntronList(SGObject):
    """
    class IntronList

    C++ includes: IntronList.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntronList, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntronList, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> IntronList

        constructor 
        """
        this = _modshogun.new_IntronList()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_IntronList
    __del__ = lambda self : None;
    def init_list(self, *args):
        """
        init_list(self, all_pos, len)

        initialize all arrays with the number of candidate positions

        Parameters:
        -----------

        all_pos:  list of candidate positions

        len:  number of candidate positions 
        """
        return _modshogun.IntronList_init_list(self, *args)

    def read_introns(self, *args):
        """
        read_introns(self, start_pos, end_pos, quality, len)

        read introns

        Parameters:
        -----------

        start_pos:  array of start positions

        end_pos:  array of end positions

        quality:  quality scores for introns in list

        len:  number of items in all three previous arguments 
        """
        return _modshogun.IntronList_read_introns(self, *args)

    def get_intron_support(self, *args):
        """
        get_intron_support(self, values, from_pos, to_pos)

        get coverage and quality score

        Parameters:
        -----------

        values:  values[0]: coverage of that intron; values[1]: associated
        quality score

        from_pos:  start position of intron

        to_pos:  end position of intron 
        """
        return _modshogun.IntronList_get_intron_support(self, *args)

IntronList_swigregister = _modshogun.IntronList_swigregister
IntronList_swigregister(IntronList)

class SegmentLoss(SGObject):
    """
    class IntronList

    C++ includes: SegmentLoss.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SegmentLoss, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SegmentLoss, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> SegmentLoss

        constructor 
        """
        this = _modshogun.new_SegmentLoss()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _modshogun.delete_SegmentLoss
    __del__ = lambda self : None;
    def get_segment_loss(self, *args):
        """
        get_segment_loss(self, from_pos, to_pos, segment_id) -> float

        get segment loss for a given range

        Parameters:
        -----------

        from_pos:  start position

        to_pos:  end position

        segment_id:  type of the segment 
        """
        return _modshogun.SegmentLoss_get_segment_loss(self, *args)

    def get_segment_loss_extend(self, *args):
        """
        get_segment_loss_extend(self, from_pos, to_pos, segment_id) -> float

        get segment loss for a given range

        Parameters:
        -----------

        from_pos:  start position

        to_pos:  end position

        segment_id:  type of the segment 
        """
        return _modshogun.SegmentLoss_get_segment_loss_extend(self, *args)

    def set_segment_loss(self, *args):
        """
        set_segment_loss(self, segment_loss, m, n)

        set best path segment loss

        Parameters:
        -----------

        segment_loss:  segment loss

        m:  number of segment id1

        n:  number of segment id2 
        """
        return _modshogun.SegmentLoss_set_segment_loss(self, *args)

    def set_segment_ids(self, *args):
        """
        set_segment_ids(self, segment_ids)

        set best path segmend ids

        Parameters:
        -----------

        segment_ids:  segment ids 
        """
        return _modshogun.SegmentLoss_set_segment_ids(self, *args)

    def set_segment_mask(self, *args):
        """
        set_segment_mask(self, segment_mask)

        mask parts of the sequence such that there is no loss incured there;
        this is used if there is uncertainty in the label

        Parameters:
        -----------

        segment_mask:  mask 
        """
        return _modshogun.SegmentLoss_set_segment_mask(self, *args)

    def set_num_segment_types(self, *args):
        """
        set_num_segment_types(self, num_segment_types)

        set num segment types

        Parameters:
        -----------

        num_segment_types:  num segment types 
        """
        return _modshogun.SegmentLoss_set_num_segment_types(self, *args)

    def compute_loss(self, *args):
        """
        compute_loss(self, all_pos, len)

        compute loss

        Parameters:
        -----------

        all_pos:  all candidate positions

        len:  number of positions 
        """
        return _modshogun.SegmentLoss_compute_loss(self, *args)

SegmentLoss_swigregister = _modshogun.SegmentLoss_swigregister
SegmentLoss_swigregister(SegmentLoss)

# This file is compatible with both classic and new-style classes.


